/* Drop Trigger... */
DROP TRIGGER "IntStLoads_BI";


/* Create Table... */
CREATE TABLE "DoubleLines"(GUID "TIntegerIdent",
"Provod" "TIdent",
"LineLength" DECIMAL_9_3_NOT_NULL);


CREATE TABLE "Normativ"("Ident" "TIntegerIdent",
"OwnerGUID" "TIntegerIdent",
"Year" SMALLINT);


CREATE TABLE "Normativ_Data"("Owner" "TIntegerIdent",
"Type" "TIdent",
"750kV" FLOAT,
"500kV" FLOAT,
"330kV" FLOAT,
"220kV" FLOAT,
"110kV" FLOAT,
"35kV" FLOAT,
"10kV" FLOAT,
"04kV" FLOAT,
"Total" FLOAT);


CREATE TABLE "Normativ_Types"("Ident" "TIdent",
"Name" "Name50");


CREATE TABLE "Normativ_UserData"("Owner" "TIntegerIdent",
"Type" "TIdent",
"750kV" FLOAT,
"500kV" FLOAT,
"330kV" FLOAT,
"220kV" FLOAT,
"110kV" FLOAT,
"35kV" FLOAT,
"10kV" FLOAT,
"04kV" FLOAT);


CREATE TABLE "Reactors"("Ident" "TIntegerIdent",
"OwnerGUID" "TIntegerIdent",
"Type" "TIntegerIdent",
"Level" SMALLINT,
RES_GUID INTEGER);


CREATE TABLE "Reactors_Data"("Owner" "TIntegerIdent",
"Date" DATE NOT NULL,
"Qty" SMALLINT,
T DOUBLE PRECISION,
W DOUBLE PRECISION,
"dW" DOUBLE PRECISION,
"Imax" DECIMAL_6_3,
"CosFi" "DECIMAL_CosFi");


CREATE TABLE "Reactors_Ref"("Ident" "TIntegerIdent",
"Name" "Name32_NOT_NULL",
"Snom" "Name20_NOT_NULL",
"Unom" DECIMAL_5_2_NOT_NULL,
"Inom" DECIMAL_5_2_NOT_NULL,
"dP" DECIMAL_9_2_NOT_NULL,
"isDouble" "YesNo",
"Hide" "YesNo");



ALTER TABLE "PResults" ADD "Flags" INTEGER;

ALTER TABLE "WLoads" ADD "Kzap" DECIMAL_5_4;

ALTER TABLE "WLoads" ADD "sqrKfg" DECIMAL_6_4;

ALTER TABLE "WResults" ADD "Flags" INTEGER;

ALTER TABLE "WResultsA" ADD "Flags" INTEGER;

ALTER TABLE "WResultsWN" ADD "sqrKfg" DECIMAL_6_4;

ALTER TABLE "WSamples" ADD "SampleType" "TIdent" DEFAULT 0;

ALTER TABLE "AddEqData" ALTER COLUMN "OwnerGUID" TYPE "TIntegerIdent";

ALTER TABLE "PResultsPL" ALTER COLUMN "Kzag" TYPE DECIMAL_5_4;

ALTER TABLE "PResultsPN" ALTER COLUMN "Kzag" TYPE DECIMAL_5_4;

ALTER TABLE "PResultsPN3" ALTER COLUMN "Kzag" TYPE DECIMAL_5_4;

ALTER TABLE "TransformsIRef" ALTER COLUMN "Unom" TYPE DECIMAL_6_3_NOT_NULL;

ALTER TABLE "WResultsPL" ALTER COLUMN "Kzag" TYPE DECIMAL_5_4;

ALTER TABLE "WResultsPN" ALTER COLUMN "Kzag" TYPE DECIMAL_5_4;

ALTER TABLE "WResultsPN3" ALTER COLUMN "Kzag" TYPE DECIMAL_5_4;

/* Drop table-fields... */
ALTER TABLE "WLoads" DROP "Imin";


/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE "GetNewReactors_RefIdent" RETURNS(IDENT INTEGER)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE "UpdateRelationIDs" AS
 BEGIN EXIT; END
^


/* Create index... */
SET TERM ; ^

CREATE INDEX "IDX_Reactors_Data" ON "Reactors_Data"("Owner");


/* Create generator... */
CREATE GENERATOR "Reactors_RefIdent";


/* Create Primary Key... */
ALTER TABLE "Normativ" ADD CONSTRAINT "PK_Normativ" PRIMARY KEY ("Ident");

ALTER TABLE "Normativ_Data" ADD CONSTRAINT "PK_Normativ_Data" PRIMARY KEY ("Owner", "Type");

ALTER TABLE "Normativ_Types" ADD CONSTRAINT "PK_Normativ_Types" PRIMARY KEY ("Ident");

ALTER TABLE "Normativ_UserData" ADD CONSTRAINT "PK_Normativ_UserData" PRIMARY KEY ("Type", "Owner");

ALTER TABLE "Reactors" ADD CONSTRAINT "PK_Reactors" PRIMARY KEY ("Ident");

ALTER TABLE "Reactors_Data" ADD CONSTRAINT "PK_Reactors_Data" PRIMARY KEY ("Owner", "Date");

ALTER TABLE "Reactors_Ref" ADD CONSTRAINT "PK_Reactors_Ref" PRIMARY KEY ("Ident");

/* Create Foreign Key... */
RECONNECT;

ALTER TABLE "DoubleLines" ADD CONSTRAINT "FK_DoubleLines_GUID" FOREIGN KEY (GUID) REFERENCES "Lines" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "DoubleLines" ADD CONSTRAINT "FK_DoubleLines_Provods" FOREIGN KEY ("Provod") REFERENCES "Provods" ("Ident") ON UPDATE CASCADE;

ALTER TABLE "Normativ_Data" ADD CONSTRAINT "FK_Normativ_Data" FOREIGN KEY ("Owner") REFERENCES "Normativ" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "Normativ_Data" ADD CONSTRAINT "FK_Normativ_Data1" FOREIGN KEY ("Type") REFERENCES "Normativ_Types" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "Normativ_UserData" ADD CONSTRAINT "FK_Normativ_UserData" FOREIGN KEY ("Owner") REFERENCES "Normativ" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "Reactors_Data" ADD CONSTRAINT "FK_Reactors_Data" FOREIGN KEY ("Owner") REFERENCES "Reactors" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "Reactors" ADD CONSTRAINT "FK_Reactors_OwnerGUID" FOREIGN KEY ("OwnerGUID") REFERENCES GUID (GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "Reactors" ADD CONSTRAINT "FK_Reactors_Type" FOREIGN KEY ("Type") REFERENCES "Reactors_Ref" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;

/* Create Check... */
ALTER TABLE "DoubleLines" ADD CONSTRAINT "CHK_DoubleLines" CHECK(exists (select "GUID" from "Lines"
          where "GUID"="DoubleLines"."GUID" and "Provod"=-2));


/* Alter Procedure... */
/* Alter (RoundUnom) */
SET TERM ^ ;

ALTER PROCEDURE "RoundUnom"(AUNOM DECIMAL(5,2))
 RETURNS(UNOM DECIMAL(5,2))
 AS
BEGIN
 IF (AUnom<0.1) THEN Unom=0;    ELSE
 IF (AUnom<0.3) THEN Unom=0.22; ELSE
 IF (AUnom<0.5) THEN Unom=0.38; ELSE
 IF (AUnom<1.0) THEN Unom=0.66; ELSE
 IF (AUnom<4.0) THEN Unom=3;    ELSE
 IF (AUnom<8.0) THEN Unom=6;    ELSE
 IF (AUnom<14.5)  THEN Unom=10; ELSE
 IF (AUnom<19)  THEN Unom=15;   ELSE
 IF (AUnom<27)  THEN Unom=20;   ELSE
 IF (AUnom<31)  THEN Unom=27.5; ELSE
 IF (AUnom<72)  THEN Unom=35;   ELSE
 IF (AUnom<180) THEN Unom=110;   ELSE
 IF (AUnom<300) THEN Unom=220;   ELSE
 Unom=330;
 Suspend;
END
^

/* Restore proc. body: GetNewReactors_RefIdent */
ALTER PROCEDURE "GetNewReactors_RefIdent" RETURNS(IDENT INTEGER)
 AS
BEGIN
  Ident = GEN_ID("Reactors_RefIdent", 1);
  SUSPEND;
END
^

/* Restore proc. body: UpdateRelationIDs */
ALTER PROCEDURE "UpdateRelationIDs" AS
declare variable AGUID integer;
declare variable ARelationID integer;
begin
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='AOEnergo'
 into ARelationID;
 for 
  select "AOEnergo"."GUID" from "AOEnergo"
  inner join "GUID" on ("GUID"."GUID"="AOEnergo"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='PES'
 into ARelationID;
 for 
  select "PES"."GUID" from "PES"
  inner join "GUID" on ("GUID"."GUID"="PES"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='RES'
 into ARelationID;
 for 
  select "RES"."GUID" from "RES"
  inner join "GUID" on ("GUID"."GUID"="RES"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Centers'
 into ARelationID;
 for 
  select "Centers"."GUID" from "Centers"
  inner join "GUID" on ("GUID"."GUID"="Centers"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Sections'
 into ARelationID;
 for 
  select "Sections"."GUID" from "Sections"
  inner join "GUID" on ("GUID"."GUID"="Sections"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Fiders'
 into ARelationID;
 for 
  select "Fiders"."GUID" from "Fiders"
  inner join "GUID" on ("GUID"."GUID"="Fiders"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Nodes'
 into ARelationID;
 for 
  select "Nodes"."GUID" from "Nodes"
  inner join "GUID" on ("GUID"."GUID"="Nodes"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID and "Nodes"."GUID"<>"Nodes"."OwnerGUID"
  into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Nodes3'
 into ARelationID;
 for 
  select "Nodes3"."GUID_CH" from "Nodes3"
  inner join "GUID" on ("GUID"."GUID"="Nodes3"."GUID_CH")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Lines'
 into ARelationID;
 for 
  select "Lines"."GUID" from "Lines"
  inner join "GUID" on ("GUID"."GUID"="Lines"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVFiders'
 into ARelationID;
 for 
  select "LVFiders"."GUID" from "LVFiders"
  inner join "GUID" on ("GUID"."GUID"="LVFiders"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVNodes'
 into ARelationID;
 for 
  select "LVNodes"."GUID" from "LVNodes"
  inner join "GUID" on ("GUID"."GUID"="LVNodes"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID and "LVNodes"."GUID"<>"LVNodes"."OwnerGUID"
  into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVLines'
 into ARelationID;
 for 
  select "LVLines"."GUID" from "LVLines"
  inner join "GUID" on ("GUID"."GUID"="LVLines"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='BalanceObjects'
 into ARelationID;
 for 
  select "BalanceObjects"."GUID" from "BalanceObjects"
  inner join "GUID" on ("GUID"."GUID"="BalanceObjects"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVConsumersA'
 into ARelationID;
 for 
  select "LVConsumersA"."GUID" from "LVConsumersA"
  inner join "GUID" on ("GUID"."GUID"="LVConsumersA"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='IntStLoads'
 into ARelationID;
 for 
  select "IntStLoads"."GUID" from "IntStLoads"
  inner join "GUID" on ("GUID"."GUID"="IntStLoads"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
end
^

/* Create trigger... */
CREATE TRIGGER "IntStLoads_BeforeInsert" FOR "IntStLoads"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
 IF (NEW."GUID" IS NULL OR NEW."GUID"=0) THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 UPDATE "GUID" SET "RELATION_ID"=
  (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='IntStLoads')
 WHERE "GUID"=NEW."GUID";
END
^

CREATE TRIGGER "IntStLoadsAfterDelete" FOR "IntStLoads"
ACTIVE AFTER DELETE POSITION 0 
AS
begin
 delete from "GUID" where "GUID"=OLD."GUID";
end
^

CREATE TRIGGER "LinesAfterUpdate" FOR "Lines"
ACTIVE AFTER UPDATE POSITION 0 
AS
begin
 if (OLD."Provod"=-2 and NEW."Provod"<>-2) then
  delete from "DoubleLines" where "DoubleLines"."GUID"=NEW."GUID";
end
^

CREATE TRIGGER "Reactors_RefBeforeInsert" FOR "Reactors_Ref"
ACTIVE BEFORE INSERT POSITION 0 
AS
BEGIN
  IF (NEW."Ident" IS NULL) THEN
    NEW."Ident" = GEN_ID("Reactors_RefIdent",1);
END
^


/* Alter Procedure... */
SET TERM ; ^

ALTER TABLE "PResults" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "PResults" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "PResults" ALTER COLUMN "Uby" POSITION 3;

ALTER TABLE "PResults" ALTER COLUMN "Pgy" POSITION 4;

ALTER TABLE "PResults" ALTER COLUMN "Qgy" POSITION 5;

ALTER TABLE "PResults" ALTER COLUMN "Wa" POSITION 6;

ALTER TABLE "PResults" ALTER COLUMN "dPnlin_OnBalance" POSITION 7;

ALTER TABLE "PResults" ALTER COLUMN "dPnlin_notBalance" POSITION 8;

ALTER TABLE "PResults" ALTER COLUMN "dPklin_OnBalance" POSITION 9;

ALTER TABLE "PResults" ALTER COLUMN "dPklin_notBalance" POSITION 10;

ALTER TABLE "PResults" ALTER COLUMN "dPcrown_OnBalance" POSITION 11;

ALTER TABLE "PResults" ALTER COLUMN "dPcrown_notBalance" POSITION 12;

ALTER TABLE "PResults" ALTER COLUMN "dQnlin_OnBalance" POSITION 13;

ALTER TABLE "PResults" ALTER COLUMN "dQnlin_notBalance" POSITION 14;

ALTER TABLE "PResults" ALTER COLUMN "dPntr_OnBalance" POSITION 15;

ALTER TABLE "PResults" ALTER COLUMN "dPntr_notBalance" POSITION 16;

ALTER TABLE "PResults" ALTER COLUMN "dQntr_OnBalance" POSITION 17;

ALTER TABLE "PResults" ALTER COLUMN "dQntr_notBalance" POSITION 18;

ALTER TABLE "PResults" ALTER COLUMN "dPxx_OnBalance" POSITION 19;

ALTER TABLE "PResults" ALTER COLUMN "dPxx_notBalance" POSITION 20;

ALTER TABLE "PResults" ALTER COLUMN "dQxx_OnBalance" POSITION 21;

ALTER TABLE "PResults" ALTER COLUMN "dQxx_notBalance" POSITION 22;

ALTER TABLE "PResults" ALTER COLUMN "Ppotr_OnBalance" POSITION 23;

ALTER TABLE "PResults" ALTER COLUMN "Ppotr_notBalance" POSITION 24;

ALTER TABLE "PResults" ALTER COLUMN "Qpotr_OnBalance" POSITION 25;

ALTER TABLE "PResults" ALTER COLUMN "Qpotr_notBalance" POSITION 26;

ALTER TABLE "PResults" ALTER COLUMN "Kzag" POSITION 27;

ALTER TABLE "PResults" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 28;

ALTER TABLE "PResults" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 29;

ALTER TABLE "PResults" ALTER COLUMN "Ntr_OnBalance" POSITION 30;

ALTER TABLE "PResults" ALTER COLUMN "Ntr_NotBalance" POSITION 31;

ALTER TABLE "PResults" ALTER COLUMN "LsumP_OnBalance" POSITION 32;

ALTER TABLE "PResults" ALTER COLUMN "LsumP_NotBalance" POSITION 33;

ALTER TABLE "PResults" ALTER COLUMN "LsumC_OnBalance" POSITION 34;

ALTER TABLE "PResults" ALTER COLUMN "LsumC_NotBalance" POSITION 35;

ALTER TABLE "PResults" ALTER COLUMN "NLineP_OnBalance" POSITION 36;

ALTER TABLE "PResults" ALTER COLUMN "NLineP_NotBalance" POSITION 37;

ALTER TABLE "PResults" ALTER COLUMN "NLineC_OnBalance" POSITION 38;

ALTER TABLE "PResults" ALTER COLUMN "NLineC_NotBalance" POSITION 39;

ALTER TABLE "PResults" ALTER COLUMN "Potb" POSITION 40;

ALTER TABLE "PResults" ALTER COLUMN "Wotb" POSITION 41;

ALTER TABLE "PResults" ALTER COLUMN "Flags" POSITION 42;

ALTER TABLE "WLoads" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "WLoads" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "WLoads" ALTER COLUMN "Wa" POSITION 3;

ALTER TABLE "WLoads" ALTER COLUMN "Wr" POSITION 4;

ALTER TABLE "WLoads" ALTER COLUMN "Imax" POSITION 5;

ALTER TABLE "WLoads" ALTER COLUMN "Kzap" POSITION 6;

ALTER TABLE "WLoads" ALTER COLUMN "sqrKfg" POSITION 7;

ALTER TABLE "WLoads" ALTER COLUMN T POSITION 8;

ALTER TABLE "WResults" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "WResults" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "WResults" ALTER COLUMN "Wa" POSITION 3;

ALTER TABLE "WResults" ALTER COLUMN "Wr" POSITION 4;

ALTER TABLE "WResults" ALTER COLUMN T POSITION 5;

ALTER TABLE "WResults" ALTER COLUMN U POSITION 6;

ALTER TABLE "WResults" ALTER COLUMN "Imax" POSITION 7;

ALTER TABLE "WResults" ALTER COLUMN "Kzap" POSITION 8;

ALTER TABLE "WResults" ALTER COLUMN "sqrKfg" POSITION 9;

ALTER TABLE "WResults" ALTER COLUMN "sqrKfgCalc" POSITION 10;

ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_onBalance" POSITION 11;

ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_notBalance" POSITION 12;

ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_onBalance" POSITION 13;

ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_notBalance" POSITION 14;

ALTER TABLE "WResults" ALTER COLUMN "DWal_cu_onBalance" POSITION 15;

ALTER TABLE "WResults" ALTER COLUMN "DWal_cu_notBalance" POSITION 16;

ALTER TABLE "WResults" ALTER COLUMN "DWal_k_onBalance" POSITION 17;

ALTER TABLE "WResults" ALTER COLUMN "DWal_k_notBalance" POSITION 18;

ALTER TABLE "WResults" ALTER COLUMN "DWal_crown_OnBalance" POSITION 19;

ALTER TABLE "WResults" ALTER COLUMN "DWal_crown_notBalance" POSITION 20;

ALTER TABLE "WResults" ALTER COLUMN "DWrl_cu_onBalance" POSITION 21;

ALTER TABLE "WResults" ALTER COLUMN "DWrl_cu_notBalance" POSITION 22;

ALTER TABLE "WResults" ALTER COLUMN "DWcu_onBalance" POSITION 23;

ALTER TABLE "WResults" ALTER COLUMN "DWcu_notBalance" POSITION 24;

ALTER TABLE "WResults" ALTER COLUMN "DWrcu_onBalance" POSITION 25;

ALTER TABLE "WResults" ALTER COLUMN "DWrcu_notBalance" POSITION 26;

ALTER TABLE "WResults" ALTER COLUMN "DWxx_onBalance" POSITION 27;

ALTER TABLE "WResults" ALTER COLUMN "DWxx_notBalance" POSITION 28;

ALTER TABLE "WResults" ALTER COLUMN "DWrxx_onBalance" POSITION 29;

ALTER TABLE "WResults" ALTER COLUMN "DWrxx_notBalance" POSITION 30;

ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 31;

ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 32;

ALTER TABLE "WResults" ALTER COLUMN "Ntr_OnBalance" POSITION 33;

ALTER TABLE "WResults" ALTER COLUMN "Ntr_NotBalance" POSITION 34;

ALTER TABLE "WResults" ALTER COLUMN "LsumP_OnBalance" POSITION 35;

ALTER TABLE "WResults" ALTER COLUMN "LsumP_NotBalance" POSITION 36;

ALTER TABLE "WResults" ALTER COLUMN "LsumC_OnBalance" POSITION 37;

ALTER TABLE "WResults" ALTER COLUMN "LsumC_NotBalance" POSITION 38;

ALTER TABLE "WResults" ALTER COLUMN "NLineP_OnBalance" POSITION 39;

ALTER TABLE "WResults" ALTER COLUMN "NLineP_NotBalance" POSITION 40;

ALTER TABLE "WResults" ALTER COLUMN "NLineC_OnBalance" POSITION 41;

ALTER TABLE "WResults" ALTER COLUMN "NLineC_NotBalance" POSITION 42;

ALTER TABLE "WResults" ALTER COLUMN "NAbonents_OnBalance" POSITION 43;

ALTER TABLE "WResults" ALTER COLUMN "NAbonents_NotBalance" POSITION 44;

ALTER TABLE "WResults" ALTER COLUMN "Kzag" POSITION 45;

ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 46;

ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 47;

ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 48;

ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 49;

ALTER TABLE "WResults" ALTER COLUMN "dWdop" POSITION 50;

ALTER TABLE "WResults" ALTER COLUMN "Flags" POSITION 51;

ALTER TABLE "WResultsA" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "WResultsA" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "WResultsA" ALTER COLUMN "Wa" POSITION 3;

ALTER TABLE "WResultsA" ALTER COLUMN "Wr" POSITION 4;

ALTER TABLE "WResultsA" ALTER COLUMN T POSITION 5;

ALTER TABLE "WResultsA" ALTER COLUMN U POSITION 6;

ALTER TABLE "WResultsA" ALTER COLUMN "Imax" POSITION 7;

ALTER TABLE "WResultsA" ALTER COLUMN "Kzap" POSITION 8;

ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfg" POSITION 9;

ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfgCalc" POSITION 10;

ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_onBalance" POSITION 11;

ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_notBalance" POSITION 12;

ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_onBalance" POSITION 13;

ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_notBalance" POSITION 14;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_cu_onBalance" POSITION 15;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_cu_notBalance" POSITION 16;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_k_onBalance" POSITION 17;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_k_notBalance" POSITION 18;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_crown_OnBalance" POSITION 19;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_crown_notBalance" POSITION 20;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrl_cu_onBalance" POSITION 21;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrl_cu_notBalance" POSITION 22;

ALTER TABLE "WResultsA" ALTER COLUMN "DWcu_onBalance" POSITION 23;

ALTER TABLE "WResultsA" ALTER COLUMN "DWcu_notBalance" POSITION 24;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrcu_onBalance" POSITION 25;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrcu_notBalance" POSITION 26;

ALTER TABLE "WResultsA" ALTER COLUMN "DWxx_onBalance" POSITION 27;

ALTER TABLE "WResultsA" ALTER COLUMN "DWxx_notBalance" POSITION 28;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrxx_onBalance" POSITION 29;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrxx_notBalance" POSITION 30;

ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 31;

ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 32;

ALTER TABLE "WResultsA" ALTER COLUMN "Ntr_OnBalance" POSITION 33;

ALTER TABLE "WResultsA" ALTER COLUMN "Ntr_NotBalance" POSITION 34;

ALTER TABLE "WResultsA" ALTER COLUMN "LsumP_OnBalance" POSITION 35;

ALTER TABLE "WResultsA" ALTER COLUMN "LsumP_NotBalance" POSITION 36;

ALTER TABLE "WResultsA" ALTER COLUMN "LsumC_OnBalance" POSITION 37;

ALTER TABLE "WResultsA" ALTER COLUMN "LsumC_NotBalance" POSITION 38;

ALTER TABLE "WResultsA" ALTER COLUMN "NLineP_OnBalance" POSITION 39;

ALTER TABLE "WResultsA" ALTER COLUMN "NLineP_NotBalance" POSITION 40;

ALTER TABLE "WResultsA" ALTER COLUMN "NLineC_OnBalance" POSITION 41;

ALTER TABLE "WResultsA" ALTER COLUMN "NLineC_NotBalance" POSITION 42;

ALTER TABLE "WResultsA" ALTER COLUMN "NAbonents_OnBalance" POSITION 43;

ALTER TABLE "WResultsA" ALTER COLUMN "NAbonents_NotBalance" POSITION 44;

ALTER TABLE "WResultsA" ALTER COLUMN "Kzag" POSITION 45;

ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 46;

ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 47;

ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 48;

ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 49;

ALTER TABLE "WResultsA" ALTER COLUMN "dWdop" POSITION 50;

ALTER TABLE "WResultsA" ALTER COLUMN "Flags" POSITION 51;

ALTER TABLE "WResultsWN" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "WResultsWN" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "WResultsWN" ALTER COLUMN "Wa" POSITION 3;

ALTER TABLE "WResultsWN" ALTER COLUMN "Wr" POSITION 4;

ALTER TABLE "WResultsWN" ALTER COLUMN "deltaW_cu" POSITION 5;

ALTER TABLE "WResultsWN" ALTER COLUMN "deltaWr_cu" POSITION 6;

ALTER TABLE "WResultsWN" ALTER COLUMN "deltaW_xx" POSITION 7;

ALTER TABLE "WResultsWN" ALTER COLUMN "deltaWr_xx" POSITION 8;

ALTER TABLE "WResultsWN" ALTER COLUMN "sqrKfg" POSITION 9;

ALTER TABLE "WSamples" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "WSamples" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "WSamples" ALTER COLUMN "SampleType" POSITION 3;

ALTER TABLE "WSamples" ALTER COLUMN "Wa" POSITION 4;

ALTER TABLE "WSamples" ALTER COLUMN "Wr" POSITION 5;

ALTER TABLE "WSamples" ALTER COLUMN T POSITION 6;

ALTER TABLE "WSamples" ALTER COLUMN U POSITION 7;

ALTER TABLE "WSamples" ALTER COLUMN "Imax" POSITION 8;

ALTER TABLE "WSamples" ALTER COLUMN "Kzap" POSITION 9;

ALTER TABLE "WSamples" ALTER COLUMN "sqrKfg" POSITION 10;

/* Create(Add) Crant */
GRANT ALL ON "DoubleLines" TO "rtp3user";

GRANT ALL ON "Normativ" TO "rtp3user";

GRANT ALL ON "Normativ_Data" TO "rtp3user";

GRANT ALL ON "Normativ_Types" TO "rtp3user";

GRANT ALL ON "Normativ_UserData" TO "rtp3user";

GRANT ALL ON "Reactors" TO "rtp3user";

GRANT ALL ON "Reactors_Data" TO "rtp3user";

GRANT ALL ON "Reactors_Ref" TO "rtp3user";

GRANT EXECUTE ON PROCEDURE "GetNewReactors_RefIdent" TO "rtp3user";
/* Additional */

COMMIT WORK;
ALTER TRIGGER "WorkLogWResultsUpdateTrigger" INACTIVE;
COMMIT WORK;

UPDATE "WResults" SET "Kzag"=1.333 WHERE "Kzag" IS NULL;
ALTER TRIGGER "WorkLogWResultsUpdateTrigger" ACTIVE;


COMMIT WORK;
