/* Create Domains... */
CREATE DOMAIN "TSampleDate" AS TIMESTAMP NOT NULL;

DROP TABLE "Version";

CREATE TABLE "Version"("Major" "SmallInt0_NOT_NULL","VersionDate" TIMESTAMP DEFAULT 'NOW');


ALTER TABLE "LVPSamples" ADD "Kdp" DECIMAL_5_2;

ALTER TABLE "LVPTPInfo" ADD "Kdp" DECIMAL_5_2;

ALTER TABLE "LVWSamples" ADD "Kdp" DECIMAL_5_2;

ALTER TABLE "LVWSamples" ADD "Kzap" DECIMAL_5_4;

ALTER TABLE "LVWSamples" ADD "sqrKfg" DECIMAL_6_4;

ALTER TABLE "LVWTPInfo" ADD "Kdp" DECIMAL_5_2;

ALTER TABLE "LVWTPInfo" ADD "Kzap" DECIMAL_5_4;

ALTER TABLE "LVWTPInfo" ADD "sqrKfg" DECIMAL_6_4;

ALTER TABLE "PResults" ADD "Qc_onBalance" DECIMAL_9_3_NOT_NULL;

ALTER TABLE "PResults" ADD "Qc_notBalance" DECIMAL_9_3_NOT_NULL;

ALTER TABLE "PResults" ADD "Wa_potr_onBalance" DECIMAL_9_3_NOT_NULL;

ALTER TABLE "PResults" ADD "Wa_potr_notBalance" DECIMAL_9_3_NOT_NULL;

ALTER TABLE "PResults" ADD "Wr_potr_onBalance" NUMBER_9_3_NOT_NULL;

ALTER TABLE "PResults" ADD "Wr_potr_notBalance" NUMBER_9_3_NOT_NULL;

/*  ALTER TABLE "Version" ADD "Major" "SmallInt0_NOT_NULL"; */

ALTER TABLE "Version" ADD "Minor" "SmallInt0_NOT_NULL";

ALTER TABLE "Version" ADD "Release" "SmallInt0_NOT_NULL";

ALTER TABLE "Version" ADD "Build" "SmallInt0_NOT_NULL";

ALTER TABLE "WResults" ADD "Wrc_onBalance" DECIMAL_10_3_NOT_NULL;

ALTER TABLE "WResults" ADD "Wrc_notBalance" DECIMAL_10_3_NOT_NULL;

ALTER TABLE "WResultsA" ADD "Wrc_onBalance" DECIMAL_10_3_NOT_NULL;

ALTER TABLE "WResultsA" ADD "Wrc_notBalance" DECIMAL_10_3_NOT_NULL;

ALTER TABLE "WResultsWN3" ADD "sqrKfgC" DECIMAL_6_4;

ALTER TABLE "WResultsWN3" ADD "sqrKfgH" DECIMAL_6_4;

ALTER TABLE "AddEqCount" ALTER COLUMN "Qty" TYPE INTEGER;

ALTER TABLE "MeterTotal" ALTER COLUMN "OwnerGUID" TYPE INTEGER;

/* Alter Field (Null / Not Null)... */
UPDATE RDB$RELATION_FIELDS SET RDB$NULL_FLAG = NULL WHERE RDB$FIELD_NAME='SampleDate1' AND RDB$RELATION_NAME='SamplesDates';

ALTER TABLE "SamplesDates" DROP CONSTRAINT "CHK_SamplesDates";

RECONNECT;

/* Drop: idxSamplesDates (TIdxData) */
DROP INDEX "idxSamplesDates";

ALTER TABLE "SamplesDates" ALTER COLUMN "SampleDate1" TYPE "TSampleDate";

/* Alter Field (Null / Not Null)... */
UPDATE RDB$RELATION_FIELDS SET RDB$NULL_FLAG = NULL WHERE RDB$FIELD_NAME='SampleDate2' AND RDB$RELATION_NAME='SamplesDates';

ALTER TABLE "SamplesDates" ALTER COLUMN "SampleDate2" TYPE "TSampleDate";

ALTER TABLE "WResults" ALTER COLUMN "sqrKfg" TYPE DECIMAL_6_4;

ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfg" TYPE DECIMAL_6_4;


/* Drop table-fields... */
/* ALTER TABLE "Version" DROP "VersionHigh"; */

/* ALTER TABLE "Version" DROP "VersionLow"; */


/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE "CheckSavedFiderProc"(AGUID INTEGER)
 AS
 BEGIN EXIT; END
^

CREATE PROCEDURE "LVCheckSavedFiderProc"(AGUID INTEGER)
 AS
 BEGIN EXIT; END
^


/* Create index... */
SET TERM ; ^

CREATE UNIQUE INDEX "idxSamplesDates" ON "SamplesDates"("Period", "SampleDate1", "SampleDate2");


/* Create Exception... */
CREATE EXCEPTION "CheckLVFiderError" '       ';


/* Create Check... */
ALTER TABLE "LVFiders" ADD CONSTRAINT "CHECK_LVFiders_OwnerGUID" CHECK(
 (SELECT "Transfor"."UnomH" FROM "Transfor"
  INNER JOIN "Nodes" ON "Nodes"."Transf"="Transfor"."Ident"
  WHERE "Nodes".GUID="LVFiders"."OwnerGUID")<1);

ALTER TABLE "SamplesDates" ADD CONSTRAINT "CHK_SamplesDates" CHECK("SampleDate2">"SampleDate1" or "Period"=0);


/* Alter Procedure... */
/* Alter (UpdateRelationIDs) */
SET TERM ^ ;

ALTER PROCEDURE "UpdateRelationIDs" AS
declare variable AGUID integer;
declare variable ARelationID integer;
begin
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='AOEnergo'
 into ARelationID;
 for 
  select "AOEnergo"."GUID" from "AOEnergo"
  inner join "GUID" on ("GUID"."GUID"="AOEnergo"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='PES'
 into ARelationID;
 for 
  select "PES"."GUID" from "PES"
  inner join "GUID" on ("GUID"."GUID"="PES"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='RES'
 into ARelationID;
 for 
  select "RES"."GUID" from "RES"
  inner join "GUID" on ("GUID"."GUID"="RES"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Centers'
 into ARelationID;
 for 
  select "Centers"."GUID" from "Centers"
  inner join "GUID" on ("GUID"."GUID"="Centers"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Sections'
 into ARelationID;
 for 
  select "Sections"."GUID" from "Sections"
  inner join "GUID" on ("GUID"."GUID"="Sections"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Fiders'
 into ARelationID;
 for 
  select "Fiders"."GUID" from "Fiders"
  inner join "GUID" on ("GUID"."GUID"="Fiders"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Nodes'
 into ARelationID;
 for 
  select "Nodes"."GUID" from "Nodes"
  inner join "GUID" on ("GUID"."GUID"="Nodes"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID and "Nodes"."GUID"<>"Nodes"."OwnerGUID"
  into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Nodes3'
 into ARelationID;
 for 
  select "Nodes3"."GUID_CH" from "Nodes3"
  inner join "GUID" on ("GUID"."GUID"="Nodes3"."GUID_CH")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='Lines'
 into ARelationID;
 for 
  select "Lines"."GUID" from "Lines"
  inner join "GUID" on ("GUID"."GUID"="Lines"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end

 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVFiders'
 into ARelationID;
 for 
  select "LVFiders"."GUID" from "LVFiders"
  inner join "GUID" on ("GUID"."GUID"="LVFiders"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVNodes'
 into ARelationID;
 for 
  select "LVNodes"."GUID" from "LVNodes"
  inner join "GUID" on ("GUID"."GUID"="LVNodes"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID and "LVNodes"."GUID"<>"LVNodes"."OwnerGUID"
  into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVLines'
 into ARelationID;
 for 
  select "LVLines"."GUID" from "LVLines"
  inner join "GUID" on ("GUID"."GUID"="LVLines"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='BalanceObjects'
 into ARelationID;
 for 
  select "BalanceObjects"."GUID" from "BalanceObjects"
  inner join "GUID" on ("GUID"."GUID"="BalanceObjects"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='LVConsumersA'
 into ARelationID;
 for 
  select "LVConsumersA"."GUID" from "LVConsumersA"
  inner join "GUID" on ("GUID"."GUID"="LVConsumersA"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
 
 select "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='IntStLoads'
 into ARelationID;
 for
  select "IntStLoads"."GUID" from "IntStLoads"
  inner join "GUID" on ("GUID"."GUID"="IntStLoads"."GUID")
  where "GUID"."RELATION_ID"<>:ARelationID into AGUID do
 begin
  update "GUID" set "RELATION_ID"=:ARelationID
  where "GUID"=:AGUID;
 end
end
^

/* Restore proc. body: CheckSavedFiderProc */
ALTER PROCEDURE "CheckSavedFiderProc"(AGUID INTEGER)
 AS
BEGIN
 insert into "GUID" (GUID)
 select L."Node1" from "Lines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "GUID" where "GUID".guid = L."Node1");

 insert into "GUID" (GUID)
 select L."Node2" from "Lines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "GUID" where "GUID".guid = L."Node2");

 insert into "Nodes" ("GUID","FiderIdent")
 select L."Node1",L."FiderIdent" from "Lines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "Nodes" where "Nodes".guid = L."Node1");

 insert into "Nodes" ("GUID","FiderIdent")
 select L."Node2",L."FiderIdent" from "Lines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "Nodes" where "Nodes".guid = L."Node2");
                                              
 insert into "Coors" (guid,x,y)
 select N.GUID, 200,200 from "Nodes" N
 where N."OwnerGUID"=:AGUID and
  not exists (select * from "Coors" C where C.GUID=N.GUID);
END
^

/* Restore proc. body: LVCheckSavedFiderProc */
ALTER PROCEDURE "LVCheckSavedFiderProc"(AGUID INTEGER)
 AS
begin
 insert into "GUID" (GUID)
 select L."Node1" from "LVLines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "GUID" where "GUID".guid = L."Node1");

 insert into "GUID" (GUID)
 select L."Node2" from "LVLines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "GUID" where "GUID".guid = L."Node2");

 insert into "LVNodes" ("GUID","OwnerGUID")
 select L."Node1",L."OwnerGUID" from "LVLines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "LVNodes" where "LVNodes".guid = L."Node1");

 insert into "LVNodes" ("GUID","OwnerGUID")
 select L."Node2",L."OwnerGUID" from "LVLines" L
 where L."OwnerGUID"=:AGUID and
  not exists (select * from "LVNodes" where "LVNodes".guid = L."Node2");

 insert into "Coors" (guid,x,y)
 select N.GUID, 200,200 from "LVNodes" N
 where N."OwnerGUID"=:AGUID and
  not exists (select * from "Coors" C where C.GUID=N.GUID);
end
^

/* Create trigger... */
CREATE TRIGGER "NodesBeforeDeleteTrigger" FOR "Nodes"
ACTIVE BEFORE DELETE POSITION 0 
AS
begin
 if (OLD."Transf">0 and OLD."Transf"<20000 and
     exists (select * from "LVFiders" where "LVFiders"."OwnerGUID"=OLD.guid))
 then EXCEPTION "CheckLVFiderError";
end
^

CREATE TRIGGER "NodesCheckLVLinesTrigger" FOR "Nodes"
ACTIVE BEFORE UPDATE POSITION 0 
AS
DECLARE VARIABLE OLD_UnomH decimal (5,2);
DECLARE VARIABLE NEW_UnomH decimal (5,2);
BEGIN
 IF (OLD."Transf"<>New."Transf" and OLD."Transf">0 and OLD."Transf"<20000) THEN
  IF (exists (select * from "LVFiders" where "LVFiders"."OwnerGUID"=OLD.guid))
  THEN
   BEGIN
    IF (new."Transf"=0 or new."Transf">=20000) THEN
    EXCEPTION "CheckLVFiderError";
    ELSE
     BEGIN
      SELECT "UnomH" FROM "Transfor" WHERE "Ident"=OLD."Transf" INTO :OLD_UnomH;
      SELECT "UnomH" FROM "Transfor" WHERE "Ident"=NEW."Transf" INTO :NEW_UnomH;
      IF (OLD_UnomH<>NEW_UnomH) THEN EXCEPTION "CheckLVFiderError";
   END
 END
END
^

CREATE TRIGGER "NodeWResultsADeleteTrigger" FOR "WResultsA"
ACTIVE AFTER UPDATE OR DELETE POSITION 0 
AS
BEGIN
 DELETE FROM "WResultsPN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "WResultsPN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "WResultsPL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Lines"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Lines"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");

 DELETE FROM "WResultsWN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "WResultsWN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "WResultsWL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Lines"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Lines"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
END
^

CREATE TRIGGER "WorkLogWResultsADeleteTrigger" FOR "WResultsA"
ACTIVE BEFORE DELETE POSITION 0 
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(50);
BEGIN
 IF (OLD."GUID"<>0 and
     exists (select * from "Fiders" where "GUID"=OLD."GUID")) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=OLD."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,11,:ASampleDate);
 END
END
^

CREATE TRIGGER "WorkLogWResultsAInsertTrigger" FOR "WResultsA"
ACTIVE AFTER INSERT POSITION 0 
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(50);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=NEW."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,10,:ASampleDate);
 END
END
^

CREATE TRIGGER "WorkLogWResultsAUpdateTrigger" FOR "WResultsA"
ACTIVE AFTER UPDATE POSITION 0 
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(50);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=NEW."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,10,:ASampleDate);
 END
END
^


/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "LVNodePResultsDeleteTrigger";

SET TERM ^ ;

CREATE TRIGGER "LVNodePResultsDeleteTrigger" FOR "LVPResults"
ACTIVE AFTER UPDATE OR DELETE POSITION 0 
AS
BEGIN
 DELETE FROM "LVPResultsPN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (SELECT "GUID" FROM "LVNodes" WHERE "OwnerGUID"=OLD."GUID");
 DELETE FROM "LVPResultsPL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (SELECT "GUID" FROM "LVLines" WHERE "OwnerGUID"=OLD."GUID");

 DELETE FROM "LVPResultsWN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (SELECT "GUID" FROM "LVNodes" WHERE "OwnerGUID"=OLD."GUID");
 DELETE FROM "LVPResultsWL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (SELECT "GUID" FROM "LVLines" WHERE "OwnerGUID"=OLD."GUID");
END
^

/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "LVNodeWResultsDeleteTrigger";

SET TERM ^ ;

CREATE TRIGGER "LVNodeWResultsDeleteTrigger" FOR "LVWResults"
ACTIVE AFTER UPDATE OR DELETE POSITION 0 
AS
BEGIN
 DELETE FROM "LVWResultsPN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (SELECT "GUID" FROM "LVNodes" WHERE "OwnerGUID"=OLD."GUID");
 DELETE FROM "LVWResultsPL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (SELECT "GUID" FROM "LVLines" WHERE "OwnerGUID"=OLD."GUID");

 DELETE FROM "LVWResultsWN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (SELECT "GUID" FROM "LVNodes" WHERE "OwnerGUID"=OLD."GUID");
 DELETE FROM "LVWResultsWL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (SELECT "GUID" FROM "LVLines" WHERE "OwnerGUID"=OLD."GUID");
END
^

/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "NodePResultsDeleteTrigger";

SET TERM ^ ;

CREATE TRIGGER "NodePResultsDeleteTrigger" FOR "PResults"
ACTIVE AFTER UPDATE OR DELETE POSITION 0 
AS
BEGIN
 DELETE FROM "PResultsPN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "PResultsPN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "PResultsPL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Lines"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Lines"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");

 DELETE FROM "PResultsWN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "PResultsWN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "PResultsWL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Lines"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Lines"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
END
^

/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "NodeWResultsDeleteTrigger";

SET TERM ^ ;

CREATE TRIGGER "NodeWResultsDeleteTrigger" FOR "WResults"
ACTIVE AFTER UPDATE OR DELETE POSITION 0 
AS
BEGIN
 DELETE FROM "WResultsPN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "WResultsPN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "WResultsPL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Lines"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Lines"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");

 DELETE FROM "WResultsWN"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "WResultsWN3"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Nodes"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Nodes"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
 DELETE FROM "WResultsWL"
 WHERE "SampleIdent"=OLD."SampleIdent" AND
  "GUID" IN (
   SELECT "GUID" FROM "Lines"
   INNER JOIN "Fiders" ON ("Fiders"."FiderIdent"="Lines"."FiderIdent")
   WHERE "Fiders"."GUID"=OLD."GUID");
END
^

/* Alter Procedure... */
SET TERM ; ^

ALTER TABLE "LVPSamples" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "LVPSamples" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "LVPSamples" ALTER COLUMN UA POSITION 3;

ALTER TABLE "LVPSamples" ALTER COLUMN UB POSITION 4;

ALTER TABLE "LVPSamples" ALTER COLUMN UC POSITION 5;

ALTER TABLE "LVPSamples" ALTER COLUMN IA POSITION 6;

ALTER TABLE "LVPSamples" ALTER COLUMN IB POSITION 7;

ALTER TABLE "LVPSamples" ALTER COLUMN IC POSITION 8;

ALTER TABLE "LVPSamples" ALTER COLUMN U2A POSITION 9;

ALTER TABLE "LVPSamples" ALTER COLUMN U2B POSITION 10;

ALTER TABLE "LVPSamples" ALTER COLUMN U2C POSITION 11;

ALTER TABLE "LVPSamples" ALTER COLUMN "CosFiA" POSITION 12;

ALTER TABLE "LVPSamples" ALTER COLUMN "CosFiB" POSITION 13;

ALTER TABLE "LVPSamples" ALTER COLUMN "CosFiC" POSITION 14;

ALTER TABLE "LVPSamples" ALTER COLUMN "Wa" POSITION 15;

ALTER TABLE "LVPSamples" ALTER COLUMN "Wr" POSITION 16;

ALTER TABLE "LVPSamples" ALTER COLUMN "Kdp" POSITION 17;

ALTER TABLE "LVPTPInfo" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "LVPTPInfo" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "LVPTPInfo" ALTER COLUMN UA POSITION 3;

ALTER TABLE "LVPTPInfo" ALTER COLUMN UB POSITION 4;

ALTER TABLE "LVPTPInfo" ALTER COLUMN UC POSITION 5;

ALTER TABLE "LVPTPInfo" ALTER COLUMN IA POSITION 6;

ALTER TABLE "LVPTPInfo" ALTER COLUMN IB POSITION 7;

ALTER TABLE "LVPTPInfo" ALTER COLUMN IC POSITION 8;

ALTER TABLE "LVPTPInfo" ALTER COLUMN "CosFiA" POSITION 9;

ALTER TABLE "LVPTPInfo" ALTER COLUMN "CosFiB" POSITION 10;

ALTER TABLE "LVPTPInfo" ALTER COLUMN "CosFiC" POSITION 11;

ALTER TABLE "LVPTPInfo" ALTER COLUMN "Wa" POSITION 12;

ALTER TABLE "LVPTPInfo" ALTER COLUMN "Wr" POSITION 13;

ALTER TABLE "LVPTPInfo" ALTER COLUMN "Kdp" POSITION 14;

ALTER TABLE "LVWSamples" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "LVWSamples" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "LVWSamples" ALTER COLUMN UA POSITION 3;

ALTER TABLE "LVWSamples" ALTER COLUMN UB POSITION 4;

ALTER TABLE "LVWSamples" ALTER COLUMN UC POSITION 5;

ALTER TABLE "LVWSamples" ALTER COLUMN IA POSITION 6;

ALTER TABLE "LVWSamples" ALTER COLUMN IB POSITION 7;

ALTER TABLE "LVWSamples" ALTER COLUMN IC POSITION 8;

ALTER TABLE "LVWSamples" ALTER COLUMN "ImaxA" POSITION 9;

ALTER TABLE "LVWSamples" ALTER COLUMN "ImaxB" POSITION 10;

ALTER TABLE "LVWSamples" ALTER COLUMN "ImaxC" POSITION 11;

ALTER TABLE "LVWSamples" ALTER COLUMN "IminA" POSITION 12;

ALTER TABLE "LVWSamples" ALTER COLUMN "IminB" POSITION 13;

ALTER TABLE "LVWSamples" ALTER COLUMN "IminC" POSITION 14;

ALTER TABLE "LVWSamples" ALTER COLUMN U2A POSITION 15;

ALTER TABLE "LVWSamples" ALTER COLUMN U2B POSITION 16;

ALTER TABLE "LVWSamples" ALTER COLUMN U2C POSITION 17;

ALTER TABLE "LVWSamples" ALTER COLUMN "CosFiA" POSITION 18;

ALTER TABLE "LVWSamples" ALTER COLUMN "CosFiB" POSITION 19;

ALTER TABLE "LVWSamples" ALTER COLUMN "CosFiC" POSITION 20;

ALTER TABLE "LVWSamples" ALTER COLUMN "Wa" POSITION 21;

ALTER TABLE "LVWSamples" ALTER COLUMN "Wr" POSITION 22;

ALTER TABLE "LVWSamples" ALTER COLUMN T POSITION 23;

ALTER TABLE "LVWSamples" ALTER COLUMN "Kdp" POSITION 24;

ALTER TABLE "LVWSamples" ALTER COLUMN "Kzap" POSITION 25;

ALTER TABLE "LVWSamples" ALTER COLUMN "sqrKfg" POSITION 26;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "LVWTPInfo" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "LVWTPInfo" ALTER COLUMN UA POSITION 3;

ALTER TABLE "LVWTPInfo" ALTER COLUMN UB POSITION 4;

ALTER TABLE "LVWTPInfo" ALTER COLUMN UC POSITION 5;

ALTER TABLE "LVWTPInfo" ALTER COLUMN IA POSITION 6;

ALTER TABLE "LVWTPInfo" ALTER COLUMN IB POSITION 7;

ALTER TABLE "LVWTPInfo" ALTER COLUMN IC POSITION 8;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "ImaxA" POSITION 9;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "ImaxB" POSITION 10;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "ImaxC" POSITION 11;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "IminA" POSITION 12;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "IminB" POSITION 13;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "IminC" POSITION 14;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "CosFiA" POSITION 15;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "CosFiB" POSITION 16;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "CosFiC" POSITION 17;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "Kdp" POSITION 18;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "Kzap" POSITION 19;

ALTER TABLE "LVWTPInfo" ALTER COLUMN "sqrKfg" POSITION 20;

ALTER TABLE "PResults" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "PResults" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "PResults" ALTER COLUMN "Uby" POSITION 3;

ALTER TABLE "PResults" ALTER COLUMN "Pgy" POSITION 4;

ALTER TABLE "PResults" ALTER COLUMN "Qgy" POSITION 5;

ALTER TABLE "PResults" ALTER COLUMN "Wa" POSITION 6;

ALTER TABLE "PResults" ALTER COLUMN "dPnlin_OnBalance" POSITION 7;

ALTER TABLE "PResults" ALTER COLUMN "dPnlin_notBalance" POSITION 8;

ALTER TABLE "PResults" ALTER COLUMN "dPklin_OnBalance" POSITION 9;

ALTER TABLE "PResults" ALTER COLUMN "dPklin_notBalance" POSITION 10;

ALTER TABLE "PResults" ALTER COLUMN "dPcrown_OnBalance" POSITION 11;

ALTER TABLE "PResults" ALTER COLUMN "dPcrown_notBalance" POSITION 12;

ALTER TABLE "PResults" ALTER COLUMN "dQnlin_OnBalance" POSITION 13;

ALTER TABLE "PResults" ALTER COLUMN "dQnlin_notBalance" POSITION 14;

ALTER TABLE "PResults" ALTER COLUMN "dPntr_OnBalance" POSITION 15;

ALTER TABLE "PResults" ALTER COLUMN "dPntr_notBalance" POSITION 16;

ALTER TABLE "PResults" ALTER COLUMN "dQntr_OnBalance" POSITION 17;

ALTER TABLE "PResults" ALTER COLUMN "dQntr_notBalance" POSITION 18;

ALTER TABLE "PResults" ALTER COLUMN "dPxx_OnBalance" POSITION 19;

ALTER TABLE "PResults" ALTER COLUMN "dPxx_notBalance" POSITION 20;

ALTER TABLE "PResults" ALTER COLUMN "dQxx_OnBalance" POSITION 21;

ALTER TABLE "PResults" ALTER COLUMN "dQxx_notBalance" POSITION 22;

ALTER TABLE "PResults" ALTER COLUMN "Qc_onBalance" POSITION 23;

ALTER TABLE "PResults" ALTER COLUMN "Qc_notBalance" POSITION 24;

ALTER TABLE "PResults" ALTER COLUMN "Ppotr_OnBalance" POSITION 25;

ALTER TABLE "PResults" ALTER COLUMN "Ppotr_notBalance" POSITION 26;

ALTER TABLE "PResults" ALTER COLUMN "Qpotr_OnBalance" POSITION 27;

ALTER TABLE "PResults" ALTER COLUMN "Qpotr_notBalance" POSITION 28;

ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_onBalance" POSITION 29;

ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_notBalance" POSITION 30;

ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_onBalance" POSITION 31;

ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_notBalance" POSITION 32;

ALTER TABLE "PResults" ALTER COLUMN "Kzag" POSITION 33;

ALTER TABLE "PResults" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 34;

ALTER TABLE "PResults" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 35;

ALTER TABLE "PResults" ALTER COLUMN "Ntr_OnBalance" POSITION 36;

ALTER TABLE "PResults" ALTER COLUMN "Ntr_NotBalance" POSITION 37;

ALTER TABLE "PResults" ALTER COLUMN "LsumP_OnBalance" POSITION 38;

ALTER TABLE "PResults" ALTER COLUMN "LsumP_NotBalance" POSITION 39;

ALTER TABLE "PResults" ALTER COLUMN "LsumC_OnBalance" POSITION 40;

ALTER TABLE "PResults" ALTER COLUMN "LsumC_NotBalance" POSITION 41;

ALTER TABLE "PResults" ALTER COLUMN "NLineP_OnBalance" POSITION 42;

ALTER TABLE "PResults" ALTER COLUMN "NLineP_NotBalance" POSITION 43;

ALTER TABLE "PResults" ALTER COLUMN "NLineC_OnBalance" POSITION 44;

ALTER TABLE "PResults" ALTER COLUMN "NLineC_NotBalance" POSITION 45;

ALTER TABLE "PResults" ALTER COLUMN "Potb" POSITION 46;

ALTER TABLE "PResults" ALTER COLUMN "Wotb" POSITION 47;

ALTER TABLE "PResults" ALTER COLUMN "Flags" POSITION 48;

ALTER TABLE "Version" ALTER COLUMN "Major" POSITION 1;

ALTER TABLE "Version" ALTER COLUMN "Minor" POSITION 2;

ALTER TABLE "Version" ALTER COLUMN "Release" POSITION 3;

ALTER TABLE "Version" ALTER COLUMN "Build" POSITION 4;

ALTER TABLE "Version" ALTER COLUMN "VersionDate" POSITION 5;

ALTER TABLE "WResults" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "WResults" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "WResults" ALTER COLUMN "Wa" POSITION 3;

ALTER TABLE "WResults" ALTER COLUMN "Wr" POSITION 4;

ALTER TABLE "WResults" ALTER COLUMN T POSITION 5;

ALTER TABLE "WResults" ALTER COLUMN U POSITION 6;

ALTER TABLE "WResults" ALTER COLUMN "Imax" POSITION 7;

ALTER TABLE "WResults" ALTER COLUMN "Kzap" POSITION 8;

ALTER TABLE "WResults" ALTER COLUMN "sqrKfg" POSITION 9;

ALTER TABLE "WResults" ALTER COLUMN "sqrKfgCalc" POSITION 10;

ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_onBalance" POSITION 11;

ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_notBalance" POSITION 12;

ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_onBalance" POSITION 13;

ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_notBalance" POSITION 14;

ALTER TABLE "WResults" ALTER COLUMN "DWal_cu_onBalance" POSITION 15;

ALTER TABLE "WResults" ALTER COLUMN "DWal_cu_notBalance" POSITION 16;

ALTER TABLE "WResults" ALTER COLUMN "DWal_k_onBalance" POSITION 17;

ALTER TABLE "WResults" ALTER COLUMN "DWal_k_notBalance" POSITION 18;

ALTER TABLE "WResults" ALTER COLUMN "DWal_crown_OnBalance" POSITION 19;

ALTER TABLE "WResults" ALTER COLUMN "DWal_crown_notBalance" POSITION 20;

ALTER TABLE "WResults" ALTER COLUMN "DWrl_cu_onBalance" POSITION 21;

ALTER TABLE "WResults" ALTER COLUMN "DWrl_cu_notBalance" POSITION 22;

ALTER TABLE "WResults" ALTER COLUMN "DWcu_onBalance" POSITION 23;

ALTER TABLE "WResults" ALTER COLUMN "DWcu_notBalance" POSITION 24;

ALTER TABLE "WResults" ALTER COLUMN "DWrcu_onBalance" POSITION 25;

ALTER TABLE "WResults" ALTER COLUMN "DWrcu_notBalance" POSITION 26;

ALTER TABLE "WResults" ALTER COLUMN "DWxx_onBalance" POSITION 27;

ALTER TABLE "WResults" ALTER COLUMN "DWxx_notBalance" POSITION 28;

ALTER TABLE "WResults" ALTER COLUMN "DWrxx_onBalance" POSITION 29;

ALTER TABLE "WResults" ALTER COLUMN "DWrxx_notBalance" POSITION 30;

ALTER TABLE "WResults" ALTER COLUMN "Wrc_onBalance" POSITION 31;

ALTER TABLE "WResults" ALTER COLUMN "Wrc_notBalance" POSITION 32;

ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 33;

ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 34;

ALTER TABLE "WResults" ALTER COLUMN "Ntr_OnBalance" POSITION 35;

ALTER TABLE "WResults" ALTER COLUMN "Ntr_NotBalance" POSITION 36;

ALTER TABLE "WResults" ALTER COLUMN "LsumP_OnBalance" POSITION 37;

ALTER TABLE "WResults" ALTER COLUMN "LsumP_NotBalance" POSITION 38;

ALTER TABLE "WResults" ALTER COLUMN "LsumC_OnBalance" POSITION 39;

ALTER TABLE "WResults" ALTER COLUMN "LsumC_NotBalance" POSITION 40;

ALTER TABLE "WResults" ALTER COLUMN "NLineP_OnBalance" POSITION 41;

ALTER TABLE "WResults" ALTER COLUMN "NLineP_NotBalance" POSITION 42;

ALTER TABLE "WResults" ALTER COLUMN "NLineC_OnBalance" POSITION 43;

ALTER TABLE "WResults" ALTER COLUMN "NLineC_NotBalance" POSITION 44;

ALTER TABLE "WResults" ALTER COLUMN "NAbonents_OnBalance" POSITION 45;

ALTER TABLE "WResults" ALTER COLUMN "NAbonents_NotBalance" POSITION 46;

ALTER TABLE "WResults" ALTER COLUMN "Kzag" POSITION 47;

ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 48;

ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 49;

ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 50;

ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 51;

ALTER TABLE "WResults" ALTER COLUMN "dWdop" POSITION 52;

ALTER TABLE "WResults" ALTER COLUMN "Flags" POSITION 53;

ALTER TABLE "WResultsA" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "WResultsA" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "WResultsA" ALTER COLUMN "Wa" POSITION 3;

ALTER TABLE "WResultsA" ALTER COLUMN "Wr" POSITION 4;

ALTER TABLE "WResultsA" ALTER COLUMN T POSITION 5;

ALTER TABLE "WResultsA" ALTER COLUMN U POSITION 6;

ALTER TABLE "WResultsA" ALTER COLUMN "Imax" POSITION 7;

ALTER TABLE "WResultsA" ALTER COLUMN "Kzap" POSITION 8;

ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfg" POSITION 9;

ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfgCalc" POSITION 10;

ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_onBalance" POSITION 11;

ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_notBalance" POSITION 12;

ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_onBalance" POSITION 13;

ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_notBalance" POSITION 14;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_cu_onBalance" POSITION 15;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_cu_notBalance" POSITION 16;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_k_onBalance" POSITION 17;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_k_notBalance" POSITION 18;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_crown_OnBalance" POSITION 19;

ALTER TABLE "WResultsA" ALTER COLUMN "DWal_crown_notBalance" POSITION 20;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrl_cu_onBalance" POSITION 21;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrl_cu_notBalance" POSITION 22;

ALTER TABLE "WResultsA" ALTER COLUMN "DWcu_onBalance" POSITION 23;

ALTER TABLE "WResultsA" ALTER COLUMN "DWcu_notBalance" POSITION 24;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrcu_onBalance" POSITION 25;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrcu_notBalance" POSITION 26;

ALTER TABLE "WResultsA" ALTER COLUMN "DWxx_onBalance" POSITION 27;

ALTER TABLE "WResultsA" ALTER COLUMN "DWxx_notBalance" POSITION 28;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrxx_onBalance" POSITION 29;

ALTER TABLE "WResultsA" ALTER COLUMN "DWrxx_notBalance" POSITION 30;

ALTER TABLE "WResultsA" ALTER COLUMN "Wrc_onBalance" POSITION 31;

ALTER TABLE "WResultsA" ALTER COLUMN "Wrc_notBalance" POSITION 32;

ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 33;

ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 34;

ALTER TABLE "WResultsA" ALTER COLUMN "Ntr_OnBalance" POSITION 35;

ALTER TABLE "WResultsA" ALTER COLUMN "Ntr_NotBalance" POSITION 36;

ALTER TABLE "WResultsA" ALTER COLUMN "LsumP_OnBalance" POSITION 37;

ALTER TABLE "WResultsA" ALTER COLUMN "LsumP_NotBalance" POSITION 38;

ALTER TABLE "WResultsA" ALTER COLUMN "LsumC_OnBalance" POSITION 39;

ALTER TABLE "WResultsA" ALTER COLUMN "LsumC_NotBalance" POSITION 40;

ALTER TABLE "WResultsA" ALTER COLUMN "NLineP_OnBalance" POSITION 41;

ALTER TABLE "WResultsA" ALTER COLUMN "NLineP_NotBalance" POSITION 42;

ALTER TABLE "WResultsA" ALTER COLUMN "NLineC_OnBalance" POSITION 43;

ALTER TABLE "WResultsA" ALTER COLUMN "NLineC_NotBalance" POSITION 44;

ALTER TABLE "WResultsA" ALTER COLUMN "NAbonents_OnBalance" POSITION 45;

ALTER TABLE "WResultsA" ALTER COLUMN "NAbonents_NotBalance" POSITION 46;

ALTER TABLE "WResultsA" ALTER COLUMN "Kzag" POSITION 47;

ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 48;

ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 49;

ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 50;

ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 51;

ALTER TABLE "WResultsA" ALTER COLUMN "dWdop" POSITION 52;

ALTER TABLE "WResultsA" ALTER COLUMN "Flags" POSITION 53;

ALTER TABLE "WResultsWN3" ALTER COLUMN "SampleIdent" POSITION 1;

ALTER TABLE "WResultsWN3" ALTER COLUMN GUID POSITION 2;

ALTER TABLE "WResultsWN3" ALTER COLUMN "WCa" POSITION 3;

ALTER TABLE "WResultsWN3" ALTER COLUMN "WCr" POSITION 4;

ALTER TABLE "WResultsWN3" ALTER COLUMN "WHa" POSITION 5;

ALTER TABLE "WResultsWN3" ALTER COLUMN "WHr" POSITION 6;

ALTER TABLE "WResultsWN3" ALTER COLUMN "deltaW_cu" POSITION 7;

ALTER TABLE "WResultsWN3" ALTER COLUMN "deltaWr_cu" POSITION 8;

ALTER TABLE "WResultsWN3" ALTER COLUMN "deltaW_xx" POSITION 9;

ALTER TABLE "WResultsWN3" ALTER COLUMN "deltaWr_xx" POSITION 10;

ALTER TABLE "WResultsWN3" ALTER COLUMN "sqrKfgC" POSITION 11;

ALTER TABLE "WResultsWN3" ALTER COLUMN "sqrKfgH" POSITION 12;

/* Create(Add) Crant */
GRANT EXECUTE ON PROCEDURE "CheckSavedFiderProc" TO "rtp3user";

GRANT EXECUTE ON PROCEDURE "LVCheckSavedFiderProc" TO "rtp3user";

GRANT ALL ON "Version" TO "rtp3user";

/* Additional Updates */

COMMIT WORK;

ALTER TRIGGER "WorkLogPResultsInsertTrigger"INACTIVE;
ALTER TRIGGER "WorkLogPResultsUpdateTrigger"INACTIVE;
ALTER TRIGGER "NodePResultsDeleteTrigger" INACTIVE;
COMMIT WORK;

UPDATE "PResults" SET "Qc_onBalance"=0, "Qc_notBalance"=0,"Wa_potr_onBalance"=0,"Wa_potr_notBalance"=0,
"Wr_potr_onBalance"=0, "Wr_potr_notBalance"=0;
COMMIT WORK;

ALTER TRIGGER "WorkLogPResultsInsertTrigger" ACTIVE;
ALTER TRIGGER "WorkLogPResultsUpdateTrigger"ACTIVE;
ALTER TRIGGER "NodePResultsDeleteTrigger" ACTIVE;
COMMIT WORK;


ALTER TRIGGER "WorkLogWResultsUpdateTrigger" INACTIVE;
ALTER TRIGGER "NodeWResultsDeleteTrigger" INACTIVE;
COMMIT WORK;

UPDATE "WResults" SET "Wrc_notBalance"=0 , "Wrc_onBalance"=0;
COMMIT WORK;
ALTER TRIGGER "WorkLogWResultsUpdateTrigger"ACTIVE;
ALTER TRIGGER "NodeWResultsDeleteTrigger" ACTIVE;
COMMIT WORK;

ALTER TRIGGER "WorkLogWResultsAUpdateTrigger" INACTIVE;
ALTER TRIGGER "NodeWResultsADeleteTrigger" INACTIVE;

COMMIT WORK;
UPDATE "WResultsA" SET "Wrc_notBalance"=0 , "Wrc_onBalance"=0;
COMMIT WORK;
ALTER TRIGGER "WorkLogWResultsAUpdateTrigger" ACTIVE;
ALTER TRIGGER "NodeWResultsADeleteTrigger" ACTIVE;
COMMIT WORK;

UPDATE "Version" SET "Major"=3, "Minor"=0, "Release"=17,"Build"=0, "VersionDate"='NOW';
COMMIT WORK;

