/* Create Table... */
CREATE GENERATOR "ManufacturerIdent";
COMMIT ;

ALTER TABLE "PResults" ADD "Temperature" SMALLINT;
ALTER TABLE "PResults" ADD CRC BLOB SEGMENT SIZE 16;
ALTER TABLE "WResults" ADD "Temperature" SMALLINT;
ALTER TABLE "WResults" ADD CRC BLOB SEGMENT SIZE 16;
ALTER TABLE "WResultsA" ADD "Temperature" SMALLINT;
ALTER TABLE "WResultsA" ADD CRC BLOB SEGMENT SIZE 16;
ALTER TABLE "LVPResults" ADD "Temperature" SMALLINT;
ALTER TABLE "LVPResults" ADD CRC BLOB SEGMENT SIZE 16;
ALTER TABLE "LVWResults" ADD "Temperature" SMALLINT;
ALTER TABLE "LVWResults" ADD CRC BLOB SEGMENT SIZE 16;


COMMIT ;


CREATE TABLE "Manufacturers"("Ident" "TIdent","ReferenceType" "TIdent",
 "Manufacturer" "Name48_NOT_NULL","Address" "Name50","PhoneNumber" "Name40",
 "FaxNumber" "Name40","Email" "Name32","WebPage" "Name32",
 "Memo" BLOB SUB_TYPE 1 SEGMENT SIZE 4096,
CONSTRAINT "PK_Manufacturers" PRIMARY KEY ("Ident"));



CREATE UNIQUE INDEX "idxManufacturers" ON "Manufacturers" ("ReferenceType","Manufacturer") ;
COMMIT ;

SET TERM ^ ;

CREATE PROCEDURE "GetNewManufacturerIdent" RETURNS("Ident" INTEGER)
 AS
BEGIN
 "Ident"= GEN_ID("ManufacturerIdent",1);
END 
^
COMMIT  ^


CREATE TRIGGER "ManufacturersBeforeInsert" FOR "Manufacturers" BEFORE INSERT
AS
BEGIN
 IF (NEW."Ident" IS NULL) THEN
  EXECUTE PROCEDURE "GetNewManufacturerIdent" RETURNING_VALUES NEW."Ident";
END 
^
COMMIT  ^


CREATE PROCEDURE "InsertManufacturer"(
 Manufacturer VARCHAR(48),ReferenceType SMALLINT,
 Address VARCHAR(50),PhoneNumber VARCHAR(40),FaxNumber VARCHAR(40),
 Email VARCHAR(32),WebPage VARCHAR(32),
 Memo BLOB SUB_TYPE 1 SEGMENT SIZE 4096)
 RETURNS(Ident SMALLINT)
 AS
begin
  Ident=GEN_ID("ManufacturerIdent",1);
  INSERT INTO "Manufacturers"
  ("Ident", "Manufacturer", "Address", "PhoneNumber", "FaxNumber", "Email", "WebPage", "ReferenceType", "Memo")
  VALUES (:Ident,:Manufacturer,:Address,:PhoneNumber,:FaxNumber,:Email,:WebPage,:ReferenceType,:Memo);
end 
^
COMMIT  ^

/* Empty InsertMeterRef for drop MetersRef(Manufacturer) */


ALTER PROCEDURE "InsertMeterRef"(INDICATION VARCHAR(40),
POWER SMALLINT,
REVERSE SMALLINT,
ACCURACYCLASS SMALLINT,
REVOCOUNT SMALLINT,
NUMBERCOUNT SMALLINT,
CALIBRATIONINTERVAL SMALLINT,
SERVICELIFE SMALLINT,
MANUFACTURER VARCHAR(20),
INOM SMALLINT,
UNOM VARCHAR(12),
TARIFFCOUNT SMALLINT,
WORKTEMPERATURELOW SMALLINT,
WORKTEMPERATUREHIGH SMALLINT,
SENSITIVITY DECIMAL(10,3),
CAPACITY DECIMAL(10,2),
PU DECIMAL(10,2),
SI DECIMAL(10,2),
PREFAILURELIFE INTEGER,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
 BEGIN EXIT; END
^
COMMIT  ^

/*SET TERM ^ ;*/


/* Empty InsertTransformIRef for drop TransformsIRef(Manufacturer) */
ALTER PROCEDURE "InsertTransformIRef"(INDICATION VARCHAR(40),
ACCURACYCLASS SMALLINT,
I1NOM SMALLINT,
I2NOM SMALLINT,
UNOM DECIMAL(10,3),
RATEDLOAD DECIMAL(10,2),
MANUFACTURER VARCHAR(20),
PREFAILURELIFE INTEGER,
WORKTEMPERATURELOW SMALLINT,
WORKTEMPERATUREHIGH SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
 BEGIN EXIT; END
^
COMMIT  ^



/* Empty InsertTransformVRef for drop TransformsVRef(Manufacturer) */
ALTER PROCEDURE "InsertTransformVRef"(INDICATION VARCHAR(40),
ACCURACYCLASS SMALLINT,
UNOM DECIMAL(10,2),
UNOMB SMALLINT,
UNOMH DECIMAL(10,2),
VOLTAGEDROP DECIMAL(10,2),
MANUFACTURER VARCHAR(20),
PREFAILURELIFE INTEGER,
WORKTEMPERATURELOW SMALLINT,
WORKTEMPERATUREHIGH SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
 BEGIN EXIT; END;
^

COMMIT  ^

/*^*/

SET TERM ; ^

ALTER TABLE "AsynchronousMotors" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "Busbars" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "CapacitorBanks" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "CurrentLimitReactorsRef" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "ExcessVoltageSuppressors" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "Provods" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "ShuntReactorsRef" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "SwitchGR" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "SynchronousCondensers" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "SynchronousMotors" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "TiristorCondensers" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "Transforms2" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "Transforms3" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "TransformsA" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "TransformsSS" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "ValveArresters" ADD "Manufacturer" "SmallInt0";

ALTER TABLE "MetersRef" ALTER COLUMN "Manufacturer" TO "AddStr";
ALTER TABLE "MetersRef" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "TransformsIRef" ALTER COLUMN "Manufacturer" TO "AddStr";
ALTER TABLE "TransformsIRef" ADD "Manufacturer" "SmallInt0";
ALTER TABLE "TransformsVRef" ALTER COLUMN "Manufacturer" TO "AddStr";
ALTER TABLE "TransformsVRef" ADD "Manufacturer" "SmallInt0";

ALTER TABLE "AsynchronousMotors" ADD CONSTRAINT "FK_AsynchronousMotors_Mf" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "Busbars" ADD CONSTRAINT "FK_Busbars_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "CapacitorBanks" ADD CONSTRAINT "FK_CapacitorBanks_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "CurrentLimitReactorsRef" ADD CONSTRAINT "FK_CurrentLimitReactor_Mf" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "ExcessVoltageSuppressors" ADD CONSTRAINT "FK_ExcessVoltageSuppressors_Mf" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "MetersRef" ADD CONSTRAINT "FK_MetersRef_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "Provods" ADD CONSTRAINT "FK_Provods_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "ShuntReactorsRef" ADD CONSTRAINT "FK_ShuntReactor_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "SwitchGR" ADD CONSTRAINT "FK_SwitchGR_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "SynchronousCondensers" ADD CONSTRAINT "FK_SynchronousCondensers_Mf" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "SynchronousMotors" ADD CONSTRAINT "FK_SynchronousMotors_Mf" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "TiristorCondensers" ADD CONSTRAINT "FK_TiristorCondensers_Mf" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "Transforms2" ADD CONSTRAINT "FK_Transforms2_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "Transforms3" ADD CONSTRAINT "FK_Transforms3_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "TransformsA" ADD CONSTRAINT "FK_TransformsA_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "TransformsIRef" ADD CONSTRAINT "FK_TransformsIRef_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "TransformsSS" ADD CONSTRAINT "FK_TransformsSS_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "TransformsVRef" ADD CONSTRAINT "FK_TransformsVRef_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;
ALTER TABLE "ValveArresters" ADD CONSTRAINT "FK_ValveArresters_Manufacturer" FOREIGN KEY ("Manufacturer") REFERENCES "Manufacturers" ("Ident") ON UPDATE CASCADE ON DELETE SET NULL;

COMMIT;
/* Alter Procedure... */
/* Alter (InsertAsynchronousMotor) */

SET TERM ^ ;

ALTER PROCEDURE "InsertAsynchronousMotor"(MARKA VARCHAR(32),
UNOM DECIMAL(10,2),
PNOM DECIMAL(10,2),
PERFORMANCE DECIMAL(10,4),
COSFI DECIMAL(10,3),
N SMALLINT,
SLIP DECIMAL(10,4),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "AsynchronousMotors"
  ("Ident","Marka","Unom","Pnom","Performance","CosFi","n","Slip","Manufacturer","Hide")
  VALUES (:Ident,:Marka,:Unom,:Pnom,:Performance,:CosFi,:n,:Slip,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertBusbar) */
ALTER PROCEDURE "InsertBusbar"(MARKA VARCHAR(32),
UNOM DECIMAL(10,2),
R DECIMAL(10,4),
X DECIMAL(10,4),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "Busbars" ("Ident","Marka","Unom","R","X","Manufacturer","Hide")
 VALUES (:Ident,:Marka,:Unom,:R,:X,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertCapacitorBank) */
ALTER PROCEDURE "InsertCapacitorBank"(MARKA VARCHAR(32),
UNOM DECIMAL(10,2),
SNOM DECIMAL(10,4),
DP DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "CapacitorBanks" ("Ident","Marka","Unom","Snom","dP","Manufacturer","Hide")
  VALUES (:Ident,:Marka,:Unom,:Snom,:dP,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertCurrentLimitReactorRef) */
ALTER PROCEDURE "InsertCurrentLimitReactorRef"(MARKA VARCHAR(32),
SNOM VARCHAR(20),
UNOM DECIMAL(10,2),
INOM DECIMAL(10,2),
DP DECIMAL(10,2),
ISDOUBLE SMALLINT,
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "CurrentLimitReactorsRef"
  ("Ident","Marka","Snom","Unom","Inom","dP","isDouble","Manufacturer","Hide")
 VALUES (:Ident,:Marka,:Snom,:Unom,:Inom,:dP,:isDouble,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertExcessVoltageSuppressor) */
ALTER PROCEDURE "InsertExcessVoltageSuppressor"(MARKA VARCHAR(32),
UNOM DECIMAL(10,2),
DP DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "ExcessVoltageSuppressors" ("Ident","Marka","Unom","dP","Manufacturer","Hide")
  VALUES (:Ident,:Marka,:Unom,:dP,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertMeterRef) */
ALTER PROCEDURE "InsertMeterRef"(INDICATION VARCHAR(40),
POWER SMALLINT,
REVERSE SMALLINT,
ACCURACYCLASS SMALLINT,
REVOCOUNT SMALLINT,
NUMBERCOUNT SMALLINT,
CALIBRATIONINTERVAL SMALLINT,
SERVICELIFE SMALLINT,
INOM SMALLINT,
UNOM VARCHAR(12),
TARIFFCOUNT SMALLINT,
WORKTEMPERATURELOW SMALLINT,
WORKTEMPERATUREHIGH SMALLINT,
SENSITIVITY DECIMAL(10,3),
CAPACITY DECIMAL(10,2),
PU DECIMAL(10,2),
SI DECIMAL(10,2),
PREFAILURELIFE INTEGER,
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "MetersRef"
  ("Ident","Indication","Power","Reverse","AccuracyClass","RevoCount",
   "NumberCount","CalibrationInterval","ServiceLife","Inom",
   "Unom","TariffCount","WorkTemperatureLow","WorkTemperatureHigh",
   "Sensitivity","Capacity","Pu","Si","PrefailureLife","Manufacturer","Hide")
  VALUES (:Ident,:Indication,:Power,:Reverse,:AccuracyClass,:RevoCount,
   :NumberCount,:CalibrationInterval,:ServiceLife,:Inom,
   :Unom,:TariffCount,:WorkTemperatureLow,:WorkTemperatureHigh,
   :Sensitivity,:Capacity,:Pu,:Si,:PrefailureLife,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertProvod) */
ALTER PROCEDURE "InsertProvod"(PROVODTYPE SMALLINT,
MARKA VARCHAR(8),
F DECIMAL(10,2),
ADDSTR VARCHAR(48),
R0 DECIMAL(10,3),
X0 DECIMAL(10,3),
B0 DECIMAL(10,3),
IDOP SMALLINT,
G0 DECIMAL(10,3),
TGDELTA DECIMAL(10,4),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "Provods" ("Ident","ProvodType","Marka","F","AddStr","R0","X0",
  "B0","Idop","G0","TgDelta","Manufacturer","Hide")
 VALUES (:Ident,:ProvodType,:Marka,:F,:AddStr,:R0,:X0,
  :B0,:Idop,:G0,:TgDelta,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertShuntReactorRef) */
ALTER PROCEDURE "InsertShuntReactorRef"(MARKA VARCHAR(32),
UNOM DECIMAL(10,2),
SNOM DECIMAL(10,4),
INOM DECIMAL(10,3),
DP DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "ShuntReactorsRef"
  ("Ident","Marka","Unom","Snom","Inom","dP","Manufacturer","Hide")
  VALUES (:Ident,:Marka,:Unom,:Snom,:Inom,:dP,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertSwitchGR) */
ALTER PROCEDURE "InsertSwitchGR"(UNOM DECIMAL(10,2),
SWITCHGTYPE SMALLINT,
MARKA VARCHAR(20),
ADDSTR VARCHAR(8),
INOM DECIMAL(10,3),
IOFF DECIMAL(10,3),
ID DECIMAL(10,3),
IT DECIMAL(10,3),
TOFF DECIMAL(10,2),
TON DECIMAL(10,2),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "SwitchGR"("Ident","Unom","SwitchGType","Marka","AddStr","Inom",
  "Ioff","Id","It","Toff","Ton","Manufacturer","Hide")
 VALUES(:Ident,:Unom,:SwitchGType,:Marka,:AddStr,:Inom,
  :Ioff,:Id,:It,:Toff,:Ton,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertSynchronousCondenser) */
ALTER PROCEDURE "InsertSynchronousCondenser"(MARKA VARCHAR(32),
UNOM DECIMAL(10,2),
SNOM DECIMAL(10,4),
DP DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "SynchronousCondensers"
  ("Ident","Marka","Unom","Snom","dP","Manufacturer","Hide")
  VALUES (:Ident,:Marka,:Unom,:Snom,:dP,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertSynchronousMotor) */
ALTER PROCEDURE "InsertSynchronousMotor"(MARKA VARCHAR(32),
UNOM DECIMAL(10,2),
PNOM DECIMAL(10,2),
PERFORMANCE DECIMAL(10,4),
COSFI DECIMAL(10,3),
N SMALLINT,
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "SynchronousMotors"
  ("Ident","Marka","Unom","Pnom","Performance","CosFi","n","Manufacturer","Hide")
  VALUES (:Ident,:Marka,:Unom,:Pnom,:Performance,:CosFi,:n,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertTiristorCondenser) */
ALTER PROCEDURE "InsertTiristorCondenser"(MARKA VARCHAR(32),
UNOM DECIMAL(10,2),
SNOM DECIMAL(10,4),
DP DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "TiristorCondensers" ("Ident","Marka","Unom","Snom","dP","Manufacturer","Hide")
  VALUES (:Ident,:Marka,:Unom,:Snom,:dP,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertTransform2) */
ALTER PROCEDURE "InsertTransform2"(UNOM DECIMAL(10,2),
TYPETR VARCHAR(8),
SNOM DECIMAL(10,2),
ADDSTR VARCHAR(48),
UK DECIMAL(10,2),
PXX DECIMAL(10,3),
PKZ DECIMAL(10,3),
IXX DECIMAL(10,2),
UNOMB DECIMAL(10,2),
UNOMH DECIMAL(10,2),
NUMBEROTP SMALLINT,
DELTAUOTP DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "Transforms2" ("Ident","Unom","TypeTR","Snom","AddStr","Uk","Pxx",
  "Pkz","Ixx","UnomB","UnomH","NumberOtp","DeltaUotp","Manufacturer","Hide")
 VALUES (:Ident,:Unom,:TypeTR,:Snom,:AddStr,:Uk,:Pxx,
  :Pkz,:Ixx,:UnomB,:UnomH,:NumberOtp,:DeltaUotp,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertTransform3) */
ALTER PROCEDURE "InsertTransform3"(UNOM DECIMAL(10,2),
TYPETR VARCHAR(8),
SNOM DECIMAL(10,2),
ADDSTR VARCHAR(48),
UNOMB DECIMAL(10,2),
UNOMC DECIMAL(10,2),
UNOMH DECIMAL(10,2),
PXX DECIMAL(10,3),
IXX DECIMAL(10,2),
PKZBC DECIMAL(10,3),
PKZBH DECIMAL(10,3),
PKZCH DECIMAL(10,3),
UKBC DECIMAL(10,2),
UKBH DECIMAL(10,2),
UKCH DECIMAL(10,2),
NUMBEROTPB SMALLINT,
DELTAUOTPB DECIMAL(10,3),
NUMBEROTPC SMALLINT,
DELTAUOTPC DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "Transforms3" ("Ident","Unom","TypeTR","Snom","AddStr","UnomB",
  "UnomC","UnomH","Pxx","Ixx","PkzBC","PkzBH","PkzCH","UkBC","UkBH","UkCH",
  "NumberOtpB","DeltaUotpB","NumberOtpC","DeltaUotpC","Manufacturer","Hide")
 VALUES (:Ident,:Unom,:TypeTR,:Snom,:AddStr,:UnomB,:UnomC,:UnomH,:Pxx,:Ixx,
  :PkzBC,:PkzBH,:PkzCH,:UkBC,:UkBH,:UkCH,:NumberOtpB,:DeltaUotpB,:NumberOtpC,
  :DeltaUotpC,:Manufacturer,:Hide);
END
^
COMMIT  ^

/* Alter (InsertTransformA) */
ALTER PROCEDURE "InsertTransformA"(UNOM DECIMAL(10,2),
TYPETR VARCHAR(8),
SNOM DECIMAL(10,2),
ADDSTR VARCHAR(48),
UNOMB DECIMAL(10,2),
UNOMC DECIMAL(10,2),
UNOMH DECIMAL(10,2),
PXX DECIMAL(10,3),
IXX DECIMAL(10,2),
PKZBC DECIMAL(10,3),
PKZBH DECIMAL(10,3),
PKZCH DECIMAL(10,3),
UKBC DECIMAL(10,2),
UKBH DECIMAL(10,2),
UKCH DECIMAL(10,2),
NUMBEROTPB SMALLINT,
DELTAUOTPB DECIMAL(10,3),
NUMBEROTPC SMALLINT,
DELTAUOTPC DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "TransformsA" ("Ident","Unom","TypeTR","Snom","AddStr","UnomB",
  "UnomC","UnomH","Pxx","Ixx","PkzBC","PkzBH","PkzCH","UkBC","UkBH","UkCH",
  "NumberOtpB","DeltaUotpB","NumberOtpC","DeltaUotpC","Manufacturer","Hide")
 VALUES (:Ident,:Unom,:TypeTR,:Snom,:AddStr,:UnomB,:UnomC,:UnomH,:Pxx,:Ixx,
  :PkzBC,:PkzBH,:PkzCH,:UkBC,:UkBH,:UkCH,:NumberOtpB,:DeltaUotpB,:NumberOtpC,
  :DeltaUotpC,:Manufacturer,:Hide);
END
^

/* Alter (InsertTransformIRef) */
ALTER PROCEDURE "InsertTransformIRef"(INDICATION VARCHAR(40),
ACCURACYCLASS SMALLINT,
I1NOM SMALLINT,
I2NOM SMALLINT,
UNOM DECIMAL(10,3),
RATEDLOAD DECIMAL(10,2),
PREFAILURELIFE INTEGER,
WORKTEMPERATURELOW SMALLINT,
WORKTEMPERATUREHIGH SMALLINT,
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "TransformsIRef"
  ("Ident","Indication","AccuracyClass","I1nom","I2nom","Unom","RatedLoad",
   "PrefailureLife","WorkTemperatureLow","WorkTemperatureHigh",
   "Manufacturer","Hide")
 VALUES (:Ident,:Indication,:AccuracyClass,:I1nom,:I2nom,:Unom,:RatedLoad,
  :PrefailureLife,:WorkTemperatureLow,:WorkTemperatureHigh,:Manufacturer,:Hide);
END
^

/* Alter (InsertTransformSS) */
ALTER PROCEDURE "InsertTransformSS"(UNOM DECIMAL(10,2),
TYPETR VARCHAR(8),
SNOM DECIMAL(10,2),
ADDSTR VARCHAR(48),
UKBH DECIMAL(10,2),
UKHH DECIMAL(10,2),
PXX DECIMAL(10,3),
PKZ DECIMAL(10,3),
IXX DECIMAL(10,2),
UNOMB DECIMAL(10,2),
UNOMH1 DECIMAL(10,2),
UNOMH2 DECIMAL(10,2),
NUMBEROTP SMALLINT,
DELTAUOTP DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "TransformsSS" ("Ident","Unom","TypeTR","Snom","AddStr",
  "UkBH","UkHH","Pxx","Pkz","Ixx","UnomB","UnomH1","UnomH2",
  "NumberOtp","DeltaUotp","Manufacturer","Hide")
  VALUES (:Ident,:Unom,:TypeTR,:Snom,:AddStr,:UkBH,:UkHH,:Pxx,:Pkz,:Ixx,
    :UnomB,:UnomH1,:UnomH2,:NumberOtp,:DeltaUotp,:Manufacturer,:Hide);
END
^

/* Alter (InsertTransformVRef) */
ALTER PROCEDURE "InsertTransformVRef"(INDICATION VARCHAR(40),
ACCURACYCLASS SMALLINT,
UNOM DECIMAL(10,2),
UNOMB SMALLINT,
UNOMH DECIMAL(10,2),
VOLTAGEDROP DECIMAL(10,2),
PREFAILURELIFE INTEGER,
WORKTEMPERATURELOW SMALLINT,
WORKTEMPERATUREHIGH SMALLINT,
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "TransformsVRef"
  ("Ident","Indication","AccuracyClass","Unom","UnomB","UnomH","VoltageDrop",
   "PrefailureLife","WorkTemperatureLow","WorkTemperatureHigh",
   "Manufacturer","Hide")
  VALUES (:Ident,:Indication,:AccuracyClass,:Unom,:UnomB,:UnomH,:VoltageDrop,
   :PrefailureLife,:WorkTemperatureLow,:WorkTemperatureHigh,
   :Manufacturer,:Hide);
END
^

/* Alter (InsertValveArrester) */
ALTER PROCEDURE "InsertValveArrester"(MARKA VARCHAR(32),
UNOM DECIMAL(10,2),
DP DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "ValveArresters" ("Ident","Marka","Unom","dP","Manufacturer","Hide")
  VALUES (:Ident,:Marka,:Unom,:dP,:Manufacturer,:Hide);
END
^

/* Alter exist trigger... */
ALTER TRIGGER "NodesBeforeUpdateTrigger"
AS
DECLARE VARIABLE ReferenceType Smallint;
DECLARE VARIABLE MaxPositionOtp Smallint;
DECLARE VARIABLE MaxPositionOtpC Smallint;
BEGIN
 MaxPositionOtp=0;
 IF (NEW."Transf"<>OLD."Transf") THEN
  IF (NEW."Transf"<=0) THEN NEW."PositionOtp"=0;
  ELSE
   BEGIN
    SELECT "ReferenceType" FROM "References" WHERE "Ident"=OLD."Transf"
    INTO :ReferenceType;
    IF (ReferenceType IN (6,7)) THEN
     BEGIN
      IF (ReferenceType=6) THEN
       SELECT "NumberOtpB","NumberOtpC" FROM "Transforms3" WHERE "Ident"=NEW."Transf"
       INTO :MaxPositionOtp,:MaxPositionOtpC;  ELSE
      IF (ReferenceType=7) THEN
       SELECT "NumberOtpB","NumberOtpC" FROM "TransformsA" WHERE "Ident"=NEW."Transf"
       INTO :MaxPositionOtp,:MaxPositionOtpC;

      IF ("Mask"(NEW."PositionOtp",127)>MaxPositionOtp)
       THEN NEW."PositionOtp"="Mask"(NEW."PositionOtp",65408)+MaxPositionOtp;
      IF ("Mask"("ShiftR"(NEW."PositionOtp",8),127)>MaxPositionOtpC)
       THEN NEW."PositionOtp"="Mask"(NEW."PositionOtp",-32513)+"ShiftL"(MaxPositionOtp,8);
     END
    ELSE
     BEGIN
      IF (ReferenceType=4) THEN
       SELECT "NumberOtp" FROM "Transforms2" WHERE "Ident"=NEW."Transf" INTO :MaxPositionOtp;
      ELSE
       SELECT "NumberOtp" FROM "TransformsSS" WHERE "Ident"=NEW."Transf" INTO :MaxPositionOtp;
      IF (NEW."PositionOtp">MaxPositionOtp) THEN NEW."PositionOtp"=MaxPositionOtp; ELSE
      IF (NEW."PositionOtp"<-MaxPositionOtp) THEN NEW."PositionOtp"=-MaxPositionOtp;
    END
 END
 IF (NEW."FiderIdent"<>OLD."FiderIdent") THEN
 SELECT "GUID" FROM "Fiders" WHERE "Fiders"."FiderIdent"=New."FiderIdent"
 INTO NEW."OwnerGUID";
END
^
insert into "Manufacturers" ("ReferenceType","Manufacturer")
select distinct 19,"AddStr" from "MetersRef"
where not "AddStr" is null and "AddStr"<>'' ^

insert into "Manufacturers" ("ReferenceType","Manufacturer")
select distinct 20,"AddStr" from "TransformsIRef"
where not "AddStr" is null and "AddStr"<>'' ^

insert into "Manufacturers" ("ReferenceType","Manufacturer")
select distinct 21,"AddStr" from "TransformsVRef"
where not "AddStr" is null and "AddStr"<>'' ^

update "MetersRef" R set "Manufacturer"=
 (select MF."Ident" from "Manufacturers" MF
  where R."AddStr"=MF."Manufacturer" and MF."ReferenceType"=19)
where not R."AddStr" is null and R."AddStr"<>'' ^

update "TransformsIRef" R set "Manufacturer"=
 (select MF."Ident" from "Manufacturers" MF
  where R."AddStr"=MF."Manufacturer" and MF."ReferenceType"=20)
where not R."AddStr" is null and R."AddStr"<>'' ^

update "TransformsVRef" R set "Manufacturer"=
 (select MF."Ident" from "Manufacturers" MF
  where R."AddStr"=MF."Manufacturer" and MF."ReferenceType"=21)
where not R."AddStr" is null and R."AddStr"<>'' ^

COMMIT  ^


DROP PROCEDURE "ChildrenGUIDs";
^
COMMIT  ^

CREATE PROCEDURE "ChildrenGUIDs"(ITEM INTEGER,
"LevelBegin" SMALLINT,"LevelEnd" SMALLINT,"ShowTree" SMALLINT)
RETURNS(GUID INTEGER)
AS
begin
if ("LevelBegin" is null or "LevelBegin"<1 or "LevelBegin">9) then
begin
if (exists(select * from "AOEnergo" where "GUID"=:Item)) then "LevelBegin"=1;else
if (exists(select * from "PES" where "GUID"=:Item)) then "LevelBegin"=2;else
if (exists(select * from "RES" where "GUID"=:Item)) then "LevelBegin"=3;else
if (exists(select * from "Centers" where "GUID"=:Item)) then "LevelBegin"=4;else
if (exists(select * from "Sections" where "GUID"=:Item)) then "LevelBegin"=5;else
if (exists(select * from "Fiders" where "GUID"=:Item)) then "LevelBegin"=6;else
if (exists(select * from "Nodes" where "GUID"=:Item)) then "LevelBegin"=7;else
if (exists(select * from "LVFiders" where "GUID"=:Item)) then "LevelBegin"=8;else
if (exists(select * from "LVNodes" where "GUID"=:Item)) then "LevelBegin"=9;
else exit;
end
if ("LevelBegin">"LevelEnd") then exit;
GUID=Item;
if ("ShowTree"<>0 or "LevelBegin"="LevelEnd") then suspend;
if ("LevelBegin"<"LevelEnd") then
if ("LevelBegin"=1) then
begin
for select "GUID" from "PES" where "OwnerGUID"=:Item into GUID do
begin
for select "GUID" from "ChildrenGUIDs"(:GUID,2,:"LevelEnd",:"ShowTree") into GUID do
suspend;
end
end else
if ("LevelBegin"=2) then
begin
for select "GUID" from "RES" where "OwnerGUID"=:Item into GUID do
begin
for select "GUID" from "ChildrenGUIDs"(:GUID,3,:"LevelEnd",:"ShowTree") into GUID do 
suspend;
end
end else
if ("LevelBegin"=3) then
begin
for select "GUID" from "Centers" where "OwnerGUID"=:Item into GUID do
begin
for select "GUID" from "ChildrenGUIDs"(:GUID,4,:"LevelEnd",:"ShowTree") into GUID do 
suspend;
end
end else
if ("LevelBegin"=4) then
begin
for select "GUID" from "Sections" where "OwnerGUID"=:Item into GUID do
begin
for select "GUID" from "ChildrenGUIDs"(:GUID,5,:"LevelEnd",:"ShowTree") into GUID do 
suspend;
end
end else
if ("LevelBegin"=5) then
begin
for select "GUID" from "Fiders" where "OwnerGUID"=:Item into GUID do
begin
for select "GUID" from "ChildrenGUIDs"(:GUID,6,:"LevelEnd",:"ShowTree") into GUID do 
suspend;
end
end else
if ("LevelBegin"=6) then
begin
for select "GUID" from "Nodes" where "OwnerGUID"=:Item into GUID do
begin
for select "GUID" from "ChildrenGUIDs"(:GUID,7,:"LevelEnd",:"ShowTree") into GUID do 
suspend;
end
end else
if ("LevelBegin"=7) then
begin
for select "GUID" from "LVFiders" where "OwnerGUID"=:Item into GUID do
begin
for select "GUID" from "ChildrenGUIDs"(:GUID,8,:"LevelEnd",:"ShowTree") into GUID do 
suspend;
end
end else
if ("LevelBegin"=8) then
begin
for select "GUID" from "LVNodes" where "OwnerGUID"=:Item into GUID do
begin
for select "GUID" from "ChildrenGUIDs"(:GUID,9,:"LevelEnd",:"ShowTree") into GUID do 
suspend;
end
end
end
^
COMMIT  ^


SET TERM ; ^

/* Drop table-fields... */
ALTER TABLE "MetersRef" DROP "AddStr";
ALTER TABLE "TransformsIRef" DROP "AddStr";
ALTER TABLE "TransformsVRef" DROP "AddStr";

ALTER TABLE "AsynchronousMotors" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "AsynchronousMotors" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "AsynchronousMotors" ALTER COLUMN "Unom" POSITION 3;
ALTER TABLE "AsynchronousMotors" ALTER COLUMN "Pnom" POSITION 4;
ALTER TABLE "AsynchronousMotors" ALTER COLUMN "Performance" POSITION 5;
ALTER TABLE "AsynchronousMotors" ALTER COLUMN "CosFi" POSITION 6;
ALTER TABLE "AsynchronousMotors" ALTER COLUMN "n" POSITION 7;
ALTER TABLE "AsynchronousMotors" ALTER COLUMN "Slip" POSITION 8;
ALTER TABLE "AsynchronousMotors" ALTER COLUMN "Manufacturer" POSITION 9;
ALTER TABLE "AsynchronousMotors" ALTER COLUMN "Hide" POSITION 10;
ALTER TABLE "Busbars" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "Busbars" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "Busbars" ALTER COLUMN "Unom" POSITION 3;
ALTER TABLE "Busbars" ALTER COLUMN R POSITION 4;
ALTER TABLE "Busbars" ALTER COLUMN X POSITION 5;
ALTER TABLE "Busbars" ALTER COLUMN "Manufacturer" POSITION 6;
ALTER TABLE "Busbars" ALTER COLUMN "Hide" POSITION 7;
ALTER TABLE "CapacitorBanks" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "CapacitorBanks" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "CapacitorBanks" ALTER COLUMN "Unom" POSITION 3;
ALTER TABLE "CapacitorBanks" ALTER COLUMN "Snom" POSITION 4;
ALTER TABLE "CapacitorBanks" ALTER COLUMN "dP" POSITION 5;
ALTER TABLE "CapacitorBanks" ALTER COLUMN "Manufacturer" POSITION 6;
ALTER TABLE "CapacitorBanks" ALTER COLUMN "Hide" POSITION 7;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Snom" POSITION 3;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Unom" POSITION 4;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Inom" POSITION 5;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "dP" POSITION 6;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "isDouble" POSITION 7;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Manufacturer" POSITION 8;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Hide" POSITION 9;
ALTER TABLE "ExcessVoltageSuppressors" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "ExcessVoltageSuppressors" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "ExcessVoltageSuppressors" ALTER COLUMN "Unom" POSITION 3;
ALTER TABLE "ExcessVoltageSuppressors" ALTER COLUMN "dP" POSITION 4;
ALTER TABLE "ExcessVoltageSuppressors" ALTER COLUMN "Manufacturer" POSITION 5;
ALTER TABLE "ExcessVoltageSuppressors" ALTER COLUMN "Hide" POSITION 6;
ALTER TABLE "MetersRef" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "MetersRef" ALTER COLUMN "Indication" POSITION 2;
ALTER TABLE "MetersRef" ALTER COLUMN "Power" POSITION 3;
ALTER TABLE "MetersRef" ALTER COLUMN "Reverse" POSITION 4;
ALTER TABLE "MetersRef" ALTER COLUMN "AccuracyClass" POSITION 5;
ALTER TABLE "MetersRef" ALTER COLUMN "RevoCount" POSITION 6;
ALTER TABLE "MetersRef" ALTER COLUMN "NumberCount" POSITION 7;
ALTER TABLE "MetersRef" ALTER COLUMN "CalibrationInterval" POSITION 8;
ALTER TABLE "MetersRef" ALTER COLUMN "ServiceLife" POSITION 9;
ALTER TABLE "MetersRef" ALTER COLUMN "Inom" POSITION 10;
ALTER TABLE "MetersRef" ALTER COLUMN "Unom" POSITION 11;
ALTER TABLE "MetersRef" ALTER COLUMN "TariffCount" POSITION 12;
ALTER TABLE "MetersRef" ALTER COLUMN "WorkTemperatureLow" POSITION 13;
ALTER TABLE "MetersRef" ALTER COLUMN "WorkTemperatureHigh" POSITION 14;
ALTER TABLE "MetersRef" ALTER COLUMN "Sensitivity" POSITION 15;
ALTER TABLE "MetersRef" ALTER COLUMN "Capacity" POSITION 16;
ALTER TABLE "MetersRef" ALTER COLUMN "Pu" POSITION 17;
ALTER TABLE "MetersRef" ALTER COLUMN "Si" POSITION 18;
ALTER TABLE "MetersRef" ALTER COLUMN "PrefailureLife" POSITION 19;
ALTER TABLE "MetersRef" ALTER COLUMN "Manufacturer" POSITION 20;
ALTER TABLE "MetersRef" ALTER COLUMN "Hide" POSITION 21;
ALTER TABLE "Provods" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "Provods" ALTER COLUMN "ProvodType" POSITION 2;
ALTER TABLE "Provods" ALTER COLUMN "Marka" POSITION 3;
ALTER TABLE "Provods" ALTER COLUMN F POSITION 4;
ALTER TABLE "Provods" ALTER COLUMN "AddStr" POSITION 5;
ALTER TABLE "Provods" ALTER COLUMN R0 POSITION 6;
ALTER TABLE "Provods" ALTER COLUMN X0 POSITION 7;
ALTER TABLE "Provods" ALTER COLUMN B0 POSITION 8;
ALTER TABLE "Provods" ALTER COLUMN "Idop" POSITION 9;
ALTER TABLE "Provods" ALTER COLUMN G0 POSITION 10;
ALTER TABLE "Provods" ALTER COLUMN "TgDelta" POSITION 11;
ALTER TABLE "Provods" ALTER COLUMN "Manufacturer" POSITION 12;
ALTER TABLE "Provods" ALTER COLUMN "Hide" POSITION 13;
ALTER TABLE "ShuntReactorsRef" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "ShuntReactorsRef" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "ShuntReactorsRef" ALTER COLUMN "Unom" POSITION 3;
ALTER TABLE "ShuntReactorsRef" ALTER COLUMN "Snom" POSITION 4;
ALTER TABLE "ShuntReactorsRef" ALTER COLUMN "Inom" POSITION 5;
ALTER TABLE "ShuntReactorsRef" ALTER COLUMN "dP" POSITION 6;
ALTER TABLE "ShuntReactorsRef" ALTER COLUMN "Manufacturer" POSITION 7;
ALTER TABLE "ShuntReactorsRef" ALTER COLUMN "Hide" POSITION 8;
ALTER TABLE "SwitchGR" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "SwitchGR" ALTER COLUMN "Unom" POSITION 2;
ALTER TABLE "SwitchGR" ALTER COLUMN "SwitchGType" POSITION 3;
ALTER TABLE "SwitchGR" ALTER COLUMN "Marka" POSITION 4;
ALTER TABLE "SwitchGR" ALTER COLUMN "AddStr" POSITION 5;
ALTER TABLE "SwitchGR" ALTER COLUMN "Inom" POSITION 6;
ALTER TABLE "SwitchGR" ALTER COLUMN "Ioff" POSITION 7;
ALTER TABLE "SwitchGR" ALTER COLUMN "Id" POSITION 8;
ALTER TABLE "SwitchGR" ALTER COLUMN "It" POSITION 9;
ALTER TABLE "SwitchGR" ALTER COLUMN "Toff" POSITION 10;
ALTER TABLE "SwitchGR" ALTER COLUMN "Ton" POSITION 11;
ALTER TABLE "SwitchGR" ALTER COLUMN "Manufacturer" POSITION 12;
ALTER TABLE "SwitchGR" ALTER COLUMN "Hide" POSITION 13;
ALTER TABLE "SynchronousCondensers" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "SynchronousCondensers" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "SynchronousCondensers" ALTER COLUMN "Unom" POSITION 3;
ALTER TABLE "SynchronousCondensers" ALTER COLUMN "Snom" POSITION 4;
ALTER TABLE "SynchronousCondensers" ALTER COLUMN "dP" POSITION 5;
ALTER TABLE "SynchronousCondensers" ALTER COLUMN "Manufacturer" POSITION 6;
ALTER TABLE "SynchronousCondensers" ALTER COLUMN "Hide" POSITION 7;
ALTER TABLE "SynchronousMotors" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "SynchronousMotors" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "SynchronousMotors" ALTER COLUMN "Unom" POSITION 3;
ALTER TABLE "SynchronousMotors" ALTER COLUMN "Pnom" POSITION 4;
ALTER TABLE "SynchronousMotors" ALTER COLUMN "Performance" POSITION 5;
ALTER TABLE "SynchronousMotors" ALTER COLUMN "CosFi" POSITION 6;
ALTER TABLE "SynchronousMotors" ALTER COLUMN "n" POSITION 7;
ALTER TABLE "SynchronousMotors" ALTER COLUMN "Manufacturer" POSITION 8;
ALTER TABLE "SynchronousMotors" ALTER COLUMN "Hide" POSITION 9;
ALTER TABLE "TiristorCondensers" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "TiristorCondensers" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "TiristorCondensers" ALTER COLUMN "Unom" POSITION 3;
ALTER TABLE "TiristorCondensers" ALTER COLUMN "Snom" POSITION 4;
ALTER TABLE "TiristorCondensers" ALTER COLUMN "dP" POSITION 5;
ALTER TABLE "TiristorCondensers" ALTER COLUMN "Manufacturer" POSITION 6;
ALTER TABLE "TiristorCondensers" ALTER COLUMN "Hide" POSITION 7;
ALTER TABLE "Transforms2" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "Transforms2" ALTER COLUMN "Unom" POSITION 2;
ALTER TABLE "Transforms2" ALTER COLUMN "TypeTR" POSITION 3;
ALTER TABLE "Transforms2" ALTER COLUMN "Snom" POSITION 4;
ALTER TABLE "Transforms2" ALTER COLUMN "AddStr" POSITION 5;
ALTER TABLE "Transforms2" ALTER COLUMN "Uk" POSITION 6;
ALTER TABLE "Transforms2" ALTER COLUMN "Pxx" POSITION 7;
ALTER TABLE "Transforms2" ALTER COLUMN "Pkz" POSITION 8;
ALTER TABLE "Transforms2" ALTER COLUMN "Ixx" POSITION 9;
ALTER TABLE "Transforms2" ALTER COLUMN "UnomB" POSITION 10;
ALTER TABLE "Transforms2" ALTER COLUMN "UnomH" POSITION 11;
ALTER TABLE "Transforms2" ALTER COLUMN "NumberOtp" POSITION 12;
ALTER TABLE "Transforms2" ALTER COLUMN "DeltaUotp" POSITION 13;
ALTER TABLE "Transforms2" ALTER COLUMN "Manufacturer" POSITION 14;
ALTER TABLE "Transforms2" ALTER COLUMN "Hide" POSITION 15;
ALTER TABLE "Transforms3" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "Transforms3" ALTER COLUMN "Unom" POSITION 2;
ALTER TABLE "Transforms3" ALTER COLUMN "TypeTR" POSITION 3;
ALTER TABLE "Transforms3" ALTER COLUMN "Snom" POSITION 4;
ALTER TABLE "Transforms3" ALTER COLUMN "AddStr" POSITION 5;
ALTER TABLE "Transforms3" ALTER COLUMN "UnomB" POSITION 6;
ALTER TABLE "Transforms3" ALTER COLUMN "UnomC" POSITION 7;
ALTER TABLE "Transforms3" ALTER COLUMN "UnomH" POSITION 8;
ALTER TABLE "Transforms3" ALTER COLUMN "Pxx" POSITION 9;
ALTER TABLE "Transforms3" ALTER COLUMN "Ixx" POSITION 10;
ALTER TABLE "Transforms3" ALTER COLUMN "PkzBC" POSITION 11;
ALTER TABLE "Transforms3" ALTER COLUMN "PkzBH" POSITION 12;
ALTER TABLE "Transforms3" ALTER COLUMN "PkzCH" POSITION 13;
ALTER TABLE "Transforms3" ALTER COLUMN "UkBC" POSITION 14;
ALTER TABLE "Transforms3" ALTER COLUMN "UkBH" POSITION 15;
ALTER TABLE "Transforms3" ALTER COLUMN "UkCH" POSITION 16;
ALTER TABLE "Transforms3" ALTER COLUMN "SobmB" POSITION 17;
ALTER TABLE "Transforms3" ALTER COLUMN "SobmC" POSITION 18;
ALTER TABLE "Transforms3" ALTER COLUMN "SobmH" POSITION 19;
ALTER TABLE "Transforms3" ALTER COLUMN "NumberOtpB" POSITION 20;
ALTER TABLE "Transforms3" ALTER COLUMN "DeltaUotpB" POSITION 21;
ALTER TABLE "Transforms3" ALTER COLUMN "NumberOtpC" POSITION 22;
ALTER TABLE "Transforms3" ALTER COLUMN "DeltaUotpC" POSITION 23;
ALTER TABLE "Transforms3" ALTER COLUMN "Manufacturer" POSITION 24;
ALTER TABLE "Transforms3" ALTER COLUMN "Hide" POSITION 25;
ALTER TABLE "TransformsA" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "TransformsA" ALTER COLUMN "Unom" POSITION 2;
ALTER TABLE "TransformsA" ALTER COLUMN "TypeTR" POSITION 3;
ALTER TABLE "TransformsA" ALTER COLUMN "Snom" POSITION 4;
ALTER TABLE "TransformsA" ALTER COLUMN "AddStr" POSITION 5;
ALTER TABLE "TransformsA" ALTER COLUMN "UnomB" POSITION 6;
ALTER TABLE "TransformsA" ALTER COLUMN "UnomC" POSITION 7;
ALTER TABLE "TransformsA" ALTER COLUMN "UnomH" POSITION 8;
ALTER TABLE "TransformsA" ALTER COLUMN "Pxx" POSITION 9;
ALTER TABLE "TransformsA" ALTER COLUMN "Ixx" POSITION 10;
ALTER TABLE "TransformsA" ALTER COLUMN "PkzBC" POSITION 11;
ALTER TABLE "TransformsA" ALTER COLUMN "PkzBH" POSITION 12;
ALTER TABLE "TransformsA" ALTER COLUMN "PkzCH" POSITION 13;
ALTER TABLE "TransformsA" ALTER COLUMN "UkBC" POSITION 14;
ALTER TABLE "TransformsA" ALTER COLUMN "UkBH" POSITION 15;
ALTER TABLE "TransformsA" ALTER COLUMN "UkCH" POSITION 16;
ALTER TABLE "TransformsA" ALTER COLUMN "SobmB" POSITION 17;
ALTER TABLE "TransformsA" ALTER COLUMN "SobmC" POSITION 18;
ALTER TABLE "TransformsA" ALTER COLUMN "SobmH" POSITION 19;
ALTER TABLE "TransformsA" ALTER COLUMN "NumberOtpB" POSITION 20;
ALTER TABLE "TransformsA" ALTER COLUMN "DeltaUotpB" POSITION 21;
ALTER TABLE "TransformsA" ALTER COLUMN "NumberOtpC" POSITION 22;
ALTER TABLE "TransformsA" ALTER COLUMN "DeltaUotpC" POSITION 23;
ALTER TABLE "TransformsA" ALTER COLUMN "Manufacturer" POSITION 24;
ALTER TABLE "TransformsA" ALTER COLUMN "Hide" POSITION 25;
ALTER TABLE "TransformsIRef" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "TransformsIRef" ALTER COLUMN "Indication" POSITION 2;
ALTER TABLE "TransformsIRef" ALTER COLUMN "AccuracyClass" POSITION 3;
ALTER TABLE "TransformsIRef" ALTER COLUMN "I1nom" POSITION 4;
ALTER TABLE "TransformsIRef" ALTER COLUMN "I2nom" POSITION 5;
ALTER TABLE "TransformsIRef" ALTER COLUMN "Unom" POSITION 6;
ALTER TABLE "TransformsIRef" ALTER COLUMN "RatedLoad" POSITION 7;
ALTER TABLE "TransformsIRef" ALTER COLUMN "PrefailureLife" POSITION 8;
ALTER TABLE "TransformsIRef" ALTER COLUMN "WorkTemperatureLow" POSITION 9;
ALTER TABLE "TransformsIRef" ALTER COLUMN "WorkTemperatureHigh" POSITION 10;
ALTER TABLE "TransformsIRef" ALTER COLUMN "Manufacturer" POSITION 11;
ALTER TABLE "TransformsIRef" ALTER COLUMN "Hide" POSITION 12;
ALTER TABLE "TransformsSS" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "TransformsSS" ALTER COLUMN "Unom" POSITION 2;
ALTER TABLE "TransformsSS" ALTER COLUMN "TypeTR" POSITION 3;
ALTER TABLE "TransformsSS" ALTER COLUMN "Snom" POSITION 4;
ALTER TABLE "TransformsSS" ALTER COLUMN "AddStr" POSITION 5;
ALTER TABLE "TransformsSS" ALTER COLUMN "UkBH" POSITION 6;
ALTER TABLE "TransformsSS" ALTER COLUMN "UkHH" POSITION 7;
ALTER TABLE "TransformsSS" ALTER COLUMN "Pxx" POSITION 8;
ALTER TABLE "TransformsSS" ALTER COLUMN "Pkz" POSITION 9;
ALTER TABLE "TransformsSS" ALTER COLUMN "Ixx" POSITION 10;
ALTER TABLE "TransformsSS" ALTER COLUMN "UnomB" POSITION 11;
ALTER TABLE "TransformsSS" ALTER COLUMN "UnomH1" POSITION 12;
ALTER TABLE "TransformsSS" ALTER COLUMN "UnomH2" POSITION 13;
ALTER TABLE "TransformsSS" ALTER COLUMN "NumberOtp" POSITION 14;
ALTER TABLE "TransformsSS" ALTER COLUMN "DeltaUotp" POSITION 15;
ALTER TABLE "TransformsSS" ALTER COLUMN "Manufacturer" POSITION 16;
ALTER TABLE "TransformsSS" ALTER COLUMN "Hide" POSITION 17;
ALTER TABLE "TransformsVRef" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "TransformsVRef" ALTER COLUMN "Indication" POSITION 2;
ALTER TABLE "TransformsVRef" ALTER COLUMN "AccuracyClass" POSITION 3;
ALTER TABLE "TransformsVRef" ALTER COLUMN "Unom" POSITION 4;
ALTER TABLE "TransformsVRef" ALTER COLUMN "UnomB" POSITION 5;
ALTER TABLE "TransformsVRef" ALTER COLUMN "UnomH" POSITION 6;
ALTER TABLE "TransformsVRef" ALTER COLUMN "VoltageDrop" POSITION 7;
ALTER TABLE "TransformsVRef" ALTER COLUMN "PrefailureLife" POSITION 8;
ALTER TABLE "TransformsVRef" ALTER COLUMN "WorkTemperatureLow" POSITION 9;
ALTER TABLE "TransformsVRef" ALTER COLUMN "WorkTemperatureHigh" POSITION 10;
ALTER TABLE "TransformsVRef" ALTER COLUMN "Manufacturer" POSITION 11;
ALTER TABLE "TransformsVRef" ALTER COLUMN "Hide" POSITION 12;
ALTER TABLE "ValveArresters" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "ValveArresters" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "ValveArresters" ALTER COLUMN "Unom" POSITION 3;
ALTER TABLE "ValveArresters" ALTER COLUMN "dP" POSITION 4;
ALTER TABLE "ValveArresters" ALTER COLUMN "Manufacturer" POSITION 5;
ALTER TABLE "ValveArresters" ALTER COLUMN "Hide" POSITION 6;

update "Provods" set "AddStr"='' where "AddStr" is null;
update "Transforms2" set "AddStr"='' where "AddStr" is null;
update "Transforms3" set "AddStr"='' where "AddStr" is null;
update "SwitchGR" set "AddStr"='' where "AddStr" is null;


COMMIT ;

UPDATE "Version" SET "Major"=3, "Minor"=0, "Release"=18,"Build"=3, "VersionDate"='NOW';
COMMIT ;
