
/* Drop Constraints... */
RECONNECT;

ALTER TABLE "TotalReportSettings" DROP CONSTRAINT "PK_TotalReportSettings";

COMMIT;


/* Create Domain... */
CREATE DOMAIN "DECIMAL_Temperature" AS DECIMAL(5,2) CHECK(VALUE IS NULL OR (Value>=-70) AND (Value<=70));

COMMIT;
ALTER TABLE "LVFidersB" ADD "dn" DECIMAL_6_4;

COMMIT;
ALTER TABLE "LVPSamples" ADD "Temperature" "DECIMAL_Temperature";

COMMIT;
ALTER TABLE "LVPTPInfo" ADD "Temperature" "DECIMAL_Temperature";

COMMIT;
ALTER TABLE "LVWSamples" ADD "Temperature" "DECIMAL_Temperature";

COMMIT;
ALTER TABLE "LVWTPInfo" ADD "Temperature" "DECIMAL_Temperature";

COMMIT;
ALTER TABLE "PSamples" ADD "Temperature" "DECIMAL_Temperature";

COMMIT;
ALTER TABLE "TotalReportSettings" ADD HV "SmallInt0";

COMMIT;
ALTER TABLE "TotalReportSettings" ADD LV1 "SmallInt0";

COMMIT;
ALTER TABLE "TotalReportSettings" ADD LV2 "SmallInt0";

COMMIT;
ALTER TABLE "TotalReportSettings" ADD INTLOADS "SmallInt0";

COMMIT;
ALTER TABLE "TotalReportSettings" ADD BALANCE "SmallInt0";

COMMIT;
ALTER TABLE "TotalReportSettings" ADD PERIOD1 "SmallInt0";

COMMIT;
ALTER TABLE "TotalReportSettings" ADD PERIOD2 "TIdent";

COMMIT;
ALTER TABLE "TotalReportSettings" ADD SYEAR "SmallInt0";

COMMIT;
ALTER TABLE "WSamples" ADD "Temperature" "DECIMAL_Temperature";

COMMIT;
/* Drop Fields on Table... */
ALTER TABLE "TotalReportSettings" DROP GUID;

COMMIT;
ALTER TABLE "TotalReportSettings" DROP "SampleInfo";

COMMIT;
ALTER TABLE "TotalReportSettings" DROP "Param1";

COMMIT;
ALTER TABLE "TotalReportSettings" DROP "Param2";

COMMIT;
ALTER TABLE "TotalReportSettings" DROP "Param3";

COMMIT;
ALTER TABLE "TotalReportSettings" DROP "Param4";

COMMIT;
ALTER TABLE "TotalReportSettings" DROP "param5";

COMMIT;

/* Create Table... */
CREATE TABLE "InitParams"("Key" "TIntegerIdent",
"Param" DECIMAL_10_3_NOT_NULL,
"Value" NUMBER_10_3_NOT_NULL);

COMMIT;


/* Create Procedure... */
SET TERM ^ ;

CREATE PROCEDURE "InsertCenter"("OwnerGUID" INTEGER,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS(GUID INTEGER)
 AS
 BEGIN EXIT; END
^

COMMIT ^
CREATE PROCEDURE "InsertFider"("OwnerGUID" INTEGER,
"Name" VARCHAR(8) CHARACTER SET WIN1251)
 RETURNS(GUID INTEGER)
 AS
 BEGIN EXIT; END
^

COMMIT ^
CREATE PROCEDURE "InsertPES"("OwnerGUID" INTEGER,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS(GUID INTEGER)
 AS
 BEGIN EXIT; END
^

COMMIT ^
CREATE PROCEDURE "InsertRES"("OwnerGUID" INTEGER,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS(GUID INTEGER)
 AS
 BEGIN EXIT; END
^

COMMIT ^
CREATE PROCEDURE "InsertSection"("OwnerGUID" INTEGER,
"Name" VARCHAR(8) CHARACTER SET WIN1251,
"Unom" NUMERIC(10,2),
"Rc" NUMERIC(10,2),
"Xc" NUMERIC(10,2))
 RETURNS(GUID INTEGER)
 AS
 BEGIN EXIT; END
^

COMMIT ^

/* Create Primary Key... */
SET TERM ; ^

ALTER TABLE "InitParams" ADD CONSTRAINT "PK_Init" PRIMARY KEY ("Key","Param");

COMMIT;
/* Create Check... */
ALTER TABLE "InitParams" ADD CONSTRAINT "CHK_InitParams_Param" CHECK(("Key"=1) and ("Value" between 0 and 1) or /* smCosFi */
 ("Key"=2 or "Key"=3) and ("Value" between "Param"*0.8 and "Param"*1.2) or /* smUcp, smUdop*/
 ("Key"=4) and ("Value" between 1/13 and 1) or /* smKzap */

 ("Key" in (100,108,109,110,111) and "Value" between -2147483647 and 2147483647) or /*(smAOEnergoGUID,smVNCalc,smNNCalc,smStLoads,smMetrolog */
 ("Key"=101 and "Value" between 1 and 7) or /*smRegionIdent */
 ("Key"=102 and "Value" between 1 and 3) or /* smKdp */
 ("Key" in (103,105,112,113) and ("Value"=0 or "Value"=1)) or /* (smUseTemperature,smKuntp,smDotDisableLine,smShowPhases */
 ("Key"=104 and "Value" between -70 and 70) or /* smTemperature */
 ("Key"=106 or "Key"=107) and ("Value" between 0 and 2)  or /* smSaveDetailed,smSaveDetailedHH */
("Key"=5 or "Key"=200 or "Key"=201) and ("Value" between -2147483.648 and 2147483.647) /* Colors */);

COMMIT;

/* Alter Procedure... */
/* Alter (InsertCenter) */
SET TERM ^ ;

ALTER PROCEDURE "InsertCenter"("OwnerGUID" INTEGER,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS(GUID INTEGER)
 AS
BEGIN
 EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES :"GUID";
 INSERT INTO "Centers" ("OwnerGUID","GUID","Name")
 VALUES (:"OwnerGUID",:"GUID",:"Name");
END
^

COMMIT ^
/* Alter (InsertFider) */
ALTER PROCEDURE "InsertFider"("OwnerGUID" INTEGER,
"Name" VARCHAR(8) CHARACTER SET WIN1251)
 RETURNS(GUID INTEGER)
 AS
BEGIN
 EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES :"GUID";
 INSERT INTO "Fiders" ("OwnerGUID","GUID","Name")
 VALUES (:"OwnerGUID",:"GUID",:"Name");
END
^

COMMIT ^
/* Alter (InsertPES) */
ALTER PROCEDURE "InsertPES"("OwnerGUID" INTEGER,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS(GUID INTEGER)
 AS
BEGIN
 EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES :"GUID";
 INSERT INTO "PES" ("OwnerGUID","GUID","Name")
 VALUES (:"OwnerGUID",:"GUID",:"Name");
END
^

COMMIT ^
/* Alter (InsertRES) */
ALTER PROCEDURE "InsertRES"("OwnerGUID" INTEGER,
"Name" VARCHAR(50) CHARACTER SET WIN1251)
 RETURNS(GUID INTEGER)
 AS
BEGIN
 EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES :"GUID";
 INSERT INTO "RES" ("OwnerGUID","GUID","Name")
 VALUES (:"OwnerGUID",:"GUID",:"Name");
END
^

COMMIT ^
/* Alter (InsertSection) */
ALTER PROCEDURE "InsertSection"("OwnerGUID" INTEGER,
"Name" VARCHAR(8) CHARACTER SET WIN1251,
"Unom" NUMERIC(10,2),
"Rc" NUMERIC(10,2),
"Xc" NUMERIC(10,2))
 RETURNS(GUID INTEGER)
 AS
BEGIN
 EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES :"GUID";
 INSERT INTO "Sections" ("OwnerGUID","GUID","Name","Unom","Rc","Xc")
 VALUES (:"OwnerGUID",:"GUID",:"Name",:"Unom",:"Rc",:"Xc");
END
^

COMMIT ^
/* Create Trigger... */
CREATE TRIGGER "UnomAfterDelete_InitParams" FOR "Unom"
ACTIVE AFTER DELETE POSITION 0 
AS
BEGIN
 DELETE FROM "InitParams"
 WHERE ("Key" between 1 and 99) and ("Param"=OLD."Unom");
END
^

COMMIT ^
CREATE TRIGGER "UnomAfterUpdate_InitParams" FOR "Unom"
ACTIVE AFTER UPDATE POSITION 0 
AS
BEGIN
 update "InitParams" set "Param"=NEW."Unom"
 where ("Key" between 1 and 99) and ("Param"=OLD."Unom");
END
^

COMMIT ^

/* Alter exist trigger... */
SET TERM ; ^

DROP TRIGGER "FiderBeforeUpdateTriggerTrigger";

COMMIT;
SET TERM ^ ;

CREATE TRIGGER "FiderBeforeUpdateTriggerTrigger" FOR "Fiders"
ACTIVE BEFORE UPDATE POSITION 0 
AS
BEGIN
 IF (NEW."OwnerGUID"<>OLD."OwnerGUID") THEN
  BEGIN
   SELECT "AOEnergo","PES","RES","Center","Ident" FROM "Sections"
   WHERE "GUID"=NEW."OwnerGUID"
   INTO NEW."AOEnergo",NEW."PES",NEW."RES",New."Center",New."Center";
   EXECUTE PROCEDURE "GetNewFiderIdent" NEW."AOEnergo",NEW."PES",NEW."RES",NEW."Center",NEW."Section"
    RETURNING_VALUES NEW."Ident";
   NEW."FiderIdent"="GetFiderIdent"(NEW."AOEnergo",NEW."PES",NEW."RES",NEW."Center",NEW."Section",NEW."Ident");
 END
 ELSE
 IF (NEW."FiderIdent"<>OLD."FiderIdent") THEN
  BEGIN
   NEW."AOEnergo"="GetidAOEnergo"(NEW."FiderIdent");
   NEW."PES"="GetidPes"(NEW."FiderIdent");
   NEW."RES"="GetidRes"(NEW."FiderIdent");
   NEW."Center"="GetidCenter"(NEW."FiderIdent");
   NEW."Section"="GetidSection"(NEW."FiderIdent");
   NEW."Ident"="GetidFider"(NEW."FiderIdent");
 END ELSE
 IF (NEW."AOEnergo"<>OLD."AOEnergo" OR NEW."PES"<>OLD."PES" OR NEW."RES"<>OLD."RES" OR
     NEW."Center"<>OLD."Center" OR NEW."Section"<>OLD."Section" OR NEW."Ident"<>OLD."Ident")
  THEN NEW."FiderIdent"="GetFiderIdent"(NEW."AOEnergo",NEW."PES",NEW."RES",NEW."Center",NEW."Section",NEW."Ident");
 if (OLD."AOEnergo"<>NEW."AOEnergo" or OLD."PES"<>NEW."PES" or
     OLD."RES"<>NEW."RES" or OLD."Center"<>NEW."Center" or
     OLD."Ident"<>NEW."Section")
 then
  select "GUID" from "Sections"
  where "Sections"."AOEnergo"=NEW."AOEnergo" and "Sections"."PES"=NEW."PES" and
        "Sections"."RES"=NEW."RES" and "Sections"."Center"=NEW."Center" and
        "Sections"."Ident"=NEW."Section"
  into NEW."OwnerGUID";
END
^

COMMIT ^
/* DROP: -- GRANT DELETE, INSERT, SELECT, UPDATE, REFERENCES ON "TotalReportSettings" TO "rtp3user" */
SET TERM ; ^

COMMIT;

 Delete From "Normativ" ;
 
 Delete From "Normativ_Types" ;
 
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (1, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (2, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (3, ' -');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (4, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (5, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (7, '   ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (8, ' ,  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (9, '-');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (10, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (11, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (39, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (14, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-1, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-2, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-3, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-4, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-5, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-6, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-7, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-8, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-9, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-10, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-11, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-12, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-13, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-14, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-15, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-16, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-17, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-18, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-19, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-20, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-21, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-22, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-23, '');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-24, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (-25, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (15, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (16, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (17, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (18, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (19, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (20, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (21, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (22, '   ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (23, '   1');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (24, '   2');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (25, '   ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (34, ' ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (27, '  500');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (28, '  330');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (29, '  220');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (30, '  110');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (31, '  35');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (32, ' 10');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (35, '  ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (36, '    ');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (37, '    1');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (38, '    2');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (33, '  0,4');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (40, '    %');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (41, '    %');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (42, '   1 %');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (43, '   2 %');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (44, '    %');
INSERT INTO "Normativ_Types" ("Ident", "Name") VALUES (45, '  %');

COMMIT ;
UPDATE "Version" SET "Major"=3, "Minor"=0, "Release"=18,"Build"=10, "VersionDate"='NOW';
COMMIT ;
