CREATE DOMAIN DOUBLE_ABOVE_0 AS DOUBLE PRECISION CHECK(Value IS NULL or Value>=0);
CREATE DOMAIN DOUBLE_NOT_NULL AS DOUBLE PRECISION NOT NULL;
CREATE DOMAIN DOUBLE_NOT_NULL_ABOVE_0 AS DOUBLE PRECISION NOT NULL CHECK(Value>=0);

ALTER TABLE "PResults" ADD "Wr" DOUBLE_NOT_NULL;

ALTER TABLE "PResults" ADD "DWal_cu_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWal_cu_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWal_k_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWal_k_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWal_crown_OnBalance" DOUBLE_ABOVE_0;
ALTER TABLE "PResults" ADD "DWal_crown_notBalance" DOUBLE_ABOVE_0;
ALTER TABLE "PResults" ADD "DWrl_cu_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWrl_cu_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWcu_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWcu_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWrcu_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWrcu_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWxx_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWxx_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWrxx_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWrxx_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "Wrc_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "Wrc_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "Wa_potr_onBalance_fact" DOUBLE_ABOVE_0;
ALTER TABLE "PResults" ADD "Wa_potr_notBalance_fact" DOUBLE_ABOVE_0;
ALTER TABLE "PResults" ADD "Wr_potr_onBalance_fact" DOUBLE PRECISION;
ALTER TABLE "PResults" ADD "Wr_potr_notBalance_fact" DOUBLE PRECISION;
ALTER TABLE "PResults" ADD "Ppotr_OnBalance_fact" DOUBLE_ABOVE_0;
ALTER TABLE "PResults" ADD "Ppotr_notBalance_fact" DOUBLE_ABOVE_0;
ALTER TABLE "PResults" ADD "Qpotr_OnBalance_fact" DOUBLE PRECISION;
ALTER TABLE "PResults" ADD "Qpotr_notBalance_fact" DOUBLE PRECISION;

ALTER TABLE "PResults" ADD "Kzag_notBalance" DOUBLE_NOT_NULL_ABOVE_0;

ALTER TABLE "WResults" ADD "Kzag_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Kzag_notBalance" DOUBLE_NOT_NULL_ABOVE_0;

ALTER TABLE "PResults" ALTER "Uby" TO "U";
ALTER TABLE "PResults" ALTER COLUMN "U" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER "Kzag" TO "Kzag_OnBalance";
ALTER TABLE "PResults" ALTER COLUMN "Kzag_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ALTER "Kzag" TO "Kzag_OnBalance";
ALTER TABLE "WResults" ALTER COLUMN "Kzag_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ALTER "Kzag" TO "Kzag_OnBalance";
ALTER TABLE "WResultsA" ALTER COLUMN "Kzag_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;

/* - ---------------------------------------------*/
/* - ---------------------------------------------*/
ALTER TABLE "PResults" ADD "WaTemp" DOUBLE_NOT_NULL_ABOVE_0;
Commit;
Update "PResults" Set "Temperature"=-70,"T"=0,"dU"=0,"Wr"=0,"U"=0,
"DWal_cu_onBalance"=0, "DWal_cu_notBalance" =0, "DWal_k_onBalance"=0,
"DWal_k_notBalance"=0, "DWrl_cu_onBalance"=0, "DWrl_cu_notBalance"=0,
"DWcu_onBalance"=0, "DWcu_notBalance" =0, "DWrcu_onBalance" =0,
"DWrcu_notBalance" =0,  "DWxx_onBalance"=0,  "DWxx_notBalance"=0,
"DWrxx_onBalance"=0, "DWrxx_notBalance"=0, "Wrc_onBalance"=0,
"Wrc_notBalance"=0 , "Kzag_OnBalance"   =0 , "Kzag_notBalance" = 0,
"WaTemp" ="Wa";
Commit;
ALTER TABLE "PResults" DROP "Wa";
ALTER TABLE "PResults" DROP "Potb"  ;
ALTER TABLE "PResults" DROP "Wotb"  ;
Commit;
ALTER TABLE "PResults" ALTER "WaTemp" TO "Wa"  ;
Commit;
/* - ---------------------------------------------*/
/* - ---------------------------------------------*/
ALTER TABLE "PResults" ALTER COLUMN T TYPE DECIMAL_7_3;
ALTER TABLE "PResults" ALTER COLUMN "Pgy" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "Qgy" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_onBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_onBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_notBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "PResults" ALTER COLUMN "dPnlin_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dPnlin_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dPklin_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dPklin_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dPcrown_OnBalance" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dPcrown_notBalance" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dQnlin_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dQnlin_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dPntr_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dPntr_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dQntr_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dQntr_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dPxx_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dPxx_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dQxx_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "dQxx_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "Qc_onBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "Qc_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "Ppotr_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "Ppotr_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ALTER COLUMN "Qpotr_OnBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "PResults" ALTER COLUMN "Qpotr_notBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "PResults" ALTER COLUMN "dU" TYPE DOUBLE_NOT_NULL_ABOVE_0;


/* - ---------------------------------------------*/
/* - ---------------------------------------------*/
update "WResults" set "Temperature"=COALESCE("Temperature",-70),
"DWrl_cu_onBalance"=COALESCE("DWrl_cu_onBalance",0),
"DWal_crown_notBalance"=COALESCE("DWal_crown_notBalance",0),
"DWal_k_onBalance"=COALESCE("DWal_k_onBalance",0),
"DWal_k_notBalance"=COALESCE("DWal_k_notBalance",0),
"DWcu_onBalance"=COALESCE("DWcu_onBalance",0),
"DWcu_notBalance"=COALESCE("DWcu_notBalance",0),
"DWrcu_onBalance"=COALESCE("DWrcu_onBalance",0),
"DWrcu_notBalance"=COALESCE("DWrcu_notBalance",0),
"DWxx_onBalance"=COALESCE("DWxx_onBalance",0),
"DWxx_notBalance"=COALESCE("DWxx_notBalance",0),
"DWrxx_onBalance"=COALESCE("DWrxx_onBalance",0),
"DWrxx_notBalance"=COALESCE("DWrxx_notBalance",0),
"Wrc_onBalance"=COALESCE("Wrc_onBalance",0),
"Wrc_notBalance"=COALESCE("Wrc_notBalance",0),
"Wa_potr_onBalance"=COALESCE("Wa_potr_onBalance",0),
"Wa_potr_notBalance"=COALESCE("Wa_potr_notBalance",0),
"Wr_potr_onBalance"=COALESCE("Wr_potr_onBalance",0),
"Wr_potr_notBalance"=COALESCE("Wr_potr_notBalance",0),
"Wa_potr_onBalance_fact"=COALESCE("Wa_potr_onBalance_fact",0),
"Wa_potr_notBalance_fact"=COALESCE("Wa_potr_notBalance_fact",0),
"Wr_potr_onBalance_fact"=COALESCE("Wr_potr_onBalance_fact",0),
"Wr_potr_notBalance_fact"=COALESCE("Wr_potr_notBalance_fact",0),
"dPnlin_OnBalance"=COALESCE("dPnlin_OnBalance",0),
"dPnlin_notBalance"=COALESCE("dPnlin_notBalance",0),
"dPklin_OnBalance"=COALESCE("dPklin_OnBalance",0),
"dPklin_notBalance"=COALESCE("dPklin_notBalance",0),
"dPcrown_OnBalance"=COALESCE("dPcrown_OnBalance",0),
"dPcrown_notBalance"=COALESCE("dPcrown_notBalance",0),
"dQnlin_OnBalance"=COALESCE("dQnlin_OnBalance",0),
"dQnlin_notBalance"=COALESCE("dQnlin_notBalance",0),
"dPntr_OnBalance"=COALESCE("dPntr_OnBalance",0),
"dPntr_notBalance"=COALESCE("dPntr_notBalance",0),
"dQntr_OnBalance"=COALESCE("dQntr_OnBalance",0),
"dQntr_notBalance"=COALESCE("dQntr_notBalance",0),
"dPxx_OnBalance"=COALESCE("dPxx_OnBalance",0),
"dPxx_notBalance"=COALESCE("dPxx_notBalance",0),
"dQxx_OnBalance"=COALESCE("dQxx_OnBalance",0),
"dQxx_notBalance"=COALESCE("dQxx_notBalance",0),
"Qc_onBalance"=COALESCE("Qc_onBalance",0),
"Qc_notBalance"=COALESCE("Qc_notBalance",0),
"Ppotr_OnBalance"=COALESCE("Ppotr_OnBalance",0),
"Ppotr_notBalance"=COALESCE("Ppotr_notBalance",0),
"Qpotr_OnBalance"=COALESCE("Qpotr_OnBalance",0),
"Qpotr_notBalance"=COALESCE("Qpotr_notBalance",0),
"Ppotr_OnBalance_fact"=COALESCE("Ppotr_OnBalance_fact",0),
"Ppotr_notBalance_fact"=COALESCE("Ppotr_notBalance_fact",0),
"Qpotr_OnBalance_fact"=COALESCE("Qpotr_OnBalance_fact",0),
"Qpotr_notBalance_fact"=COALESCE("Qpotr_notBalance_fact",0),
"dU"=COALESCE("dU",0),
"Kzag_notBalance"=COALESCE("Kzag_notBalance",0),
"DWrl_cu_notBalance"=COALESCE("DWrl_cu_notBalance",0);

COMMIT;

ALTER TABLE "WResults" Add "WaTemp" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "WrTemp"  DOUBLE_NOT_NULL;
ALTER TABLE "WResults" ADD "DWal_cu_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWal_cu_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWal_k_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWal_k_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWal_crown_OnBalanceT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ADD "DWal_crown_notBalanceT" DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ADD "DWrl_cu_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWrl_cu_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;

ALTER TABLE "WResults" ADD "DWcu_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWcu_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWrcu_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWrcu_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWxx_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWxx_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWrxx_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWrxx_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "Wrc_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "Wrc_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "Wa_potr_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "Wa_potr_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "Wr_potr_onBalanceT"  DOUBLE_NOT_NULL;
ALTER TABLE "WResults" ADD "Wr_potr_notBalanceT"  DOUBLE_NOT_NULL;
ALTER TABLE "WResults" ADD "Wa_potr_onBalance_factT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ADD "Wa_potr_notBalance_factT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ADD "Wr_potr_onBalance_factT" DOUBLE PRECISION;
ALTER TABLE "WResults" ADD "Wr_potr_notBalance_factT" DOUBLE PRECISION;
ALTER TABLE "WResults" ADD "dPnlin_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dPnlin_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dPklin_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dPklin_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dPcrown_OnBalanceT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ADD "dPcrown_notBalanceT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ADD "dQnlin_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dQnlin_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dPntr_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dPntr_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dQntr_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dQntr_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dPxx_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dPxx_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dQxx_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dQxx_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "Qc_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "Qc_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "Ppotr_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "Ppotr_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "Qpotr_OnBalanceT"  DOUBLE_NOT_NULL;
ALTER TABLE "WResults" ADD "Qpotr_notBalanceT"  DOUBLE_NOT_NULL;
ALTER TABLE "WResults" ADD "Ppotr_OnBalance_factT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ADD "Ppotr_notBalance_factT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ADD "Qpotr_OnBalance_factT"   DOUBLE PRECISION;
ALTER TABLE "WResults" ADD "Qpotr_notBalance_factT"   DOUBLE PRECISION;

COMMIT;
Update "WResults" Set "Temperature"=-70, "WaTemp" ="Wa",
"WrTemp"="Wr","DWal_cu_onBalanceT"="DWal_cu_onBalance",
"DWal_cu_notBalanceT"="DWal_cu_notBalance",
"DWal_crown_OnBalanceT"="DWal_crown_OnBalance",
"DWal_crown_notBalanceT"="DWal_crown_notBalance",
"DWal_k_onBalanceT" ="DWal_k_onBalance",
"DWal_k_notBalanceT" ="DWal_k_notBalance",
"DWcu_onBalanceT"  ="DWcu_onBalance",
"DWcu_notBalanceT" ="DWcu_notBalance",
"DWrcu_onBalanceT"="DWrcu_onBalance",
"DWrcu_notBalanceT"="DWrcu_notBalance",
"DWrl_cu_onBalanceT"="DWrl_cu_onBalance",
"DWrl_cu_notBalanceT"="DWrl_cu_notBalance",
"DWxx_onBalanceT"="DWxx_onBalance",
"DWxx_notBalanceT"= "DWxx_notBalance",
"DWrxx_onBalanceT"="DWrxx_onBalance",
"DWrxx_notBalanceT"= "DWrxx_notBalance",
"Wrc_onBalanceT"= "Wrc_onBalance",
"Wrc_notBalanceT"="Wrc_notBalance",
"Wa_potr_onBalanceT"="Wa_potr_onBalance",
"Wa_potr_notBalanceT"="Wa_potr_notBalance",
"Wr_potr_onBalanceT"="Wr_potr_onBalance",
"Wr_potr_notBalanceT"= "Wr_potr_notBalance",
"Wa_potr_onBalance_factT"= "Wa_potr_onBalance_fact",
"Wa_potr_notBalance_factT"="Wa_potr_notBalance_fact",
"Wr_potr_onBalance_factT"= "Wr_potr_onBalance_fact",
"Wr_potr_notBalance_factT"="Wr_potr_notBalance_fact",
"dPnlin_OnBalanceT"="dPnlin_OnBalance",
"dPnlin_notBalanceT"="dPnlin_notBalance",
"dPklin_OnBalanceT"="dPklin_OnBalance",
"dPklin_notBalanceT"="dPklin_notBalance",
"dPcrown_OnBalanceT"="dPcrown_OnBalance",
"dPcrown_notBalanceT"="dPcrown_notBalance",
"dQnlin_OnBalanceT"="dQnlin_OnBalance",
"dQnlin_notBalanceT"="dQnlin_notBalance" ,
"dPntr_OnBalanceT"="dPntr_OnBalance",
"dPntr_notBalanceT"="dPntr_notBalance",
"dQntr_OnBalanceT"="dQntr_OnBalance",
"dQntr_notBalanceT"="dQntr_notBalance",
"dPxx_OnBalanceT"="dPxx_OnBalance",
"dPxx_notBalanceT"="dPxx_notBalance",
 "dQxx_OnBalanceT"="dQxx_OnBalance" ,
"dQxx_notBalanceT"="dQxx_notBalance",
 "Qc_onBalanceT"="Qc_onBalance",
 "Qc_notBalanceT"="Qc_notBalance",
 "Ppotr_OnBalanceT"="Ppotr_OnBalance",
 "Ppotr_notBalanceT" ="Ppotr_notBalance",
 "Qpotr_OnBalanceT"="Qpotr_OnBalance",
 "Qpotr_notBalanceT"="Qpotr_notBalance",
 "Ppotr_OnBalance_factT"="Ppotr_OnBalance_fact" ,
 "Ppotr_notBalance_factT"= "Ppotr_notBalance_fact",
 "Qpotr_OnBalance_factT"="Qpotr_OnBalance_fact" ,
 "Qpotr_notBalance_factT"= "Qpotr_notBalance_fact";

Commit;
ALTER TABLE "WResults" DROP "Wa";
ALTER TABLE "WResults" DROP "Wr" ;
ALTER TABLE "WResults" DROP "DWal_cu_notBalance";
ALTER TABLE "WResults" DROP "DWal_cu_onBalance" ;
ALTER TABLE "WResults" DROP "DWal_k_onBalance";
ALTER TABLE "WResults" DROP "DWal_k_notBalance" ;
ALTER TABLE "WResults" DROP "DWal_crown_OnBalance";
ALTER TABLE "WResults" DROP "DWal_crown_notBalance" ;
ALTER TABLE "WResults" DROP "DWcu_onBalance";
ALTER TABLE "WResults" DROP "DWcu_notBalance";
ALTER TABLE "WResults" DROP "DWrcu_onBalance";
ALTER TABLE "WResults" DROP "DWrcu_notBalance";
ALTER TABLE "WResults" DROP "DWxx_onBalance";
ALTER TABLE "WResults" DROP  "DWxx_notBalance";
ALTER TABLE "WResults" DROP "DWrxx_onBalance";
ALTER TABLE "WResults" DROP  "DWrxx_notBalance";
ALTER TABLE "WResults" DROP  "Wrc_onBalance";
ALTER TABLE "WResults" DROP "Wrc_notBalance";
ALTER TABLE "WResults" DROP "Wa_potr_onBalance";
ALTER TABLE "WResults" DROP "Wa_potr_notBalance";
ALTER TABLE "WResults" DROP "Wr_potr_onBalance";
ALTER TABLE "WResults" DROP "Wr_potr_notBalance";
ALTER TABLE "WResults" DROP "Wa_potr_onBalance_fact";
ALTER TABLE "WResults" DROP "Wa_potr_notBalance_fact";
ALTER TABLE "WResults" DROP "Wr_potr_onBalance_fact";
ALTER TABLE "WResults" DROP "Wr_potr_notBalance_fact";
ALTER TABLE "WResults" DROP "dPnlin_OnBalance";
ALTER TABLE "WResults" DROP "dPnlin_notBalance";
ALTER TABLE "WResults" DROP "dPklin_OnBalance";
ALTER TABLE "WResults" DROP "dPklin_notBalance";
ALTER TABLE "WResults" DROP "dPcrown_OnBalance";
ALTER TABLE "WResults" DROP "dPcrown_notBalance";
ALTER TABLE "WResults" DROP "dQnlin_OnBalance";
ALTER TABLE "WResults" DROP "dQnlin_notBalance" ;
ALTER TABLE "WResults" DROP "dPntr_OnBalance";
ALTER TABLE "WResults" DROP "dPntr_notBalance";
ALTER TABLE "WResults" DROP "dQntr_OnBalance";
ALTER TABLE "WResults" DROP "dQntr_notBalance";
ALTER TABLE "WResults" DROP "dPxx_OnBalance";
ALTER TABLE "WResults" DROP "dPxx_notBalance";
ALTER TABLE "WResults" DROP "dQxx_OnBalance" ;
ALTER TABLE "WResults" DROP "dQxx_notBalance";
ALTER TABLE "WResults" DROP "Qc_onBalance";
ALTER TABLE "WResults" DROP "Qc_notBalance";
ALTER TABLE "WResults" DROP "Ppotr_OnBalance";
ALTER TABLE "WResults" DROP "Ppotr_notBalance";
ALTER TABLE "WResults" DROP "Qpotr_OnBalance";
ALTER TABLE "WResults" DROP "Qpotr_notBalance";
ALTER TABLE "WResults" DROP "Ppotr_OnBalance_fact" ;
ALTER TABLE "WResults" DROP  "Ppotr_notBalance_fact";
ALTER TABLE "WResults" DROP "Qpotr_OnBalance_fact" ;
ALTER TABLE "WResults" DROP  "Qpotr_notBalance_fact";

ALTER TABLE "WResults" DROP "DWrl_cu_onBalance";
ALTER TABLE "WResults" DROP "DWrl_cu_notBalance";

Commit;
ALTER TABLE "WResults" ALTER "WaTemp" TO "Wa"  ;
ALTER TABLE "WResults" ALTER "WrTemp" TO "Wr"  ;
ALTER TABLE "WResults" ALTER "DWal_cu_notBalanceT" TO "DWal_cu_notBalance"  ;
ALTER TABLE "WResults" ALTER "DWal_cu_onBalanceT" TO "DWal_cu_onBalance"  ;
ALTER TABLE "WResults" ALTER "DWal_k_notBalanceT" TO "DWal_k_notBalance"  ;
ALTER TABLE "WResults" ALTER "DWal_k_onBalanceT" TO "DWal_k_onBalance"  ;
ALTER TABLE "WResults" ALTER "DWal_crown_OnBalanceT" TO "DWal_crown_OnBalance"  ;
ALTER TABLE "WResults" ALTER "DWal_crown_notBalanceT" TO "DWal_crown_notBalance"  ;


ALTER TABLE "WResults" ALTER "DWcu_onBalanceT" TO "DWcu_onBalance";
ALTER TABLE "WResults" ALTER "DWcu_notBalanceT" TO "DWcu_notBalance";
ALTER TABLE "WResults" ALTER "DWrcu_onBalanceT" TO "DWrcu_onBalance";
ALTER TABLE "WResults" ALTER "DWrcu_notBalanceT" TO "DWrcu_notBalance";
ALTER TABLE "WResults" ALTER "DWxx_onBalanceT" TO "DWxx_onBalance";
ALTER TABLE "WResults" ALTER "DWxx_notBalanceT" TO "DWxx_notBalance";
ALTER TABLE "WResults" ALTER "DWrxx_onBalanceT" TO "DWrxx_onBalance";
ALTER TABLE "WResults" ALTER "DWrxx_notBalanceT" TO "DWrxx_notBalance";
ALTER TABLE "WResults" ALTER "Wrc_onBalanceT" TO "Wrc_onBalance";
ALTER TABLE "WResults" ALTER "Wrc_notBalanceT" TO "Wrc_notBalance";
ALTER TABLE "WResults" ALTER "Wa_potr_onBalanceT" TO "Wa_potr_onBalance";
ALTER TABLE "WResults" ALTER "Wa_potr_notBalanceT" TO "Wa_potr_notBalance";
ALTER TABLE "WResults" ALTER "Wr_potr_onBalanceT" TO "Wr_potr_onBalance";
ALTER TABLE "WResults" ALTER "Wr_potr_notBalanceT" TO "Wr_potr_notBalance";
ALTER TABLE "WResults" ALTER "Wa_potr_onBalance_factT" TO "Wa_potr_onBalance_fact";
ALTER TABLE "WResults" ALTER "Wa_potr_notBalance_factT" TO "Wa_potr_notBalance_fact";
ALTER TABLE "WResults" ALTER "Wr_potr_onBalance_factT" TO "Wr_potr_onBalance_fact";
ALTER TABLE "WResults" ALTER "Wr_potr_notBalance_factT" TO "Wr_potr_notBalance_fact";
ALTER TABLE "WResults" ALTER "dPnlin_OnBalanceT" TO "dPnlin_OnBalance";
ALTER TABLE "WResults" ALTER "dPnlin_notBalanceT" TO "dPnlin_notBalance";
ALTER TABLE "WResults" ALTER "dPklin_OnBalanceT" TO "dPklin_OnBalance";
ALTER TABLE "WResults" ALTER "dPklin_notBalanceT" TO "dPklin_notBalance" ;
ALTER TABLE "WResults" ALTER "dPcrown_OnBalanceT" TO "dPcrown_OnBalance";
ALTER TABLE "WResults" ALTER "dPcrown_notBalanceT" TO "dPcrown_notBalance";
ALTER TABLE "WResults" ALTER "dQnlin_OnBalanceT" TO "dQnlin_OnBalance";
ALTER TABLE "WResults" ALTER "dQnlin_notBalanceT" TO "dQnlin_notBalance";
ALTER TABLE "WResults" ALTER "dPntr_OnBalanceT" TO "dPntr_OnBalance";
ALTER TABLE "WResults" ALTER "dPntr_notBalanceT" TO "dPntr_notBalance";
ALTER TABLE "WResults" ALTER "dQntr_OnBalanceT" TO "dQntr_OnBalance";
ALTER TABLE "WResults" ALTER "dQntr_notBalanceT" TO "dQntr_notBalance";
ALTER TABLE "WResults" ALTER "dPxx_OnBalanceT" TO "dPxx_OnBalance";
ALTER TABLE "WResults" ALTER "dPxx_notBalanceT" TO "dPxx_notBalance";
ALTER TABLE "WResults" ALTER "dQxx_OnBalanceT" TO "dQxx_OnBalance";
ALTER TABLE "WResults" ALTER "dQxx_notBalanceT" TO "dQxx_notBalance";
ALTER TABLE "WResults" ALTER "Qc_onBalanceT" TO "Qc_onBalance";
ALTER TABLE "WResults" ALTER "Qc_notBalanceT" TO "Qc_notBalance";
ALTER TABLE "WResults" ALTER "Ppotr_OnBalanceT" TO "Ppotr_OnBalance";
ALTER TABLE "WResults" ALTER "Ppotr_notBalanceT" TO "Ppotr_notBalance";
ALTER TABLE "WResults" ALTER "Qpotr_OnBalanceT" TO "Qpotr_OnBalance";
ALTER TABLE "WResults" ALTER "Qpotr_notBalanceT" TO "Qpotr_notBalance";
ALTER TABLE "WResults" ALTER "Ppotr_OnBalance_factT" TO "Ppotr_OnBalance_fact";
ALTER TABLE "WResults" ALTER "Ppotr_notBalance_factT" TO "Ppotr_notBalance_fact";
ALTER TABLE "WResults" ALTER "Qpotr_OnBalance_factT" TO "Qpotr_OnBalance_fact";
ALTER TABLE "WResults" ALTER "Qpotr_notBalance_factT" TO "Qpotr_notBalance_fact";
ALTER TABLE "WResults" ALTER "DWrl_cu_onBalanceT" TO "DWrl_cu_onBalance";
ALTER TABLE "WResults" ALTER "DWrl_cu_notBalanceT" TO "DWrl_cu_notBalance";

Commit;
/* - ---------------------------------------------*/
/* - ---------------------------------------------*/

ALTER TABLE "WResults" ALTER COLUMN U TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ALTER COLUMN "Pgy" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ALTER COLUMN "Qgy" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "WResults" ALTER COLUMN "Imax" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ALTER COLUMN "Kzap" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ALTER COLUMN "sqrKfg" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "WResults" ALTER COLUMN "sqrKfgCalc" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ALTER COLUMN "dU" TYPE DOUBLE_NOT_NULL_ABOVE_0;
/* - ---------------------------------------------*/
/* - ---------------------------------------------*/
update "WResultsA" set
"Temperature"=COALESCE("Temperature",-70),
"U"=COALESCE("U",0),
"dU"=COALESCE("dU",0),
"Pgy"=COALESCE("Pgy",0),
"Qgy"=COALESCE("Qgy",0),
"Imax"=COALESCE("Imax",0),
"Kzap"=COALESCE("Kzap",0),
"sqrKfg"=COALESCE("sqrKfg",0),
"sqrKfgCalc"=COALESCE("sqrKfgCalc",0),
"DWal_cu_onBalance"=COALESCE("DWal_cu_onBalance",0),
"DWal_cu_notBalance"=COALESCE("DWal_cu_notBalance",0),
"DWal_k_onBalance"=COALESCE("DWal_k_onBalance",0),
"DWal_k_notBalance"=COALESCE("DWal_k_notBalance",0),

"DWal_crown_OnBalance"=COALESCE("DWal_crown_OnBalance",0),
"DWal_crown_notBalance"=COALESCE("DWal_crown_notBalance",0),

"DWrl_cu_onBalance"=COALESCE("DWrl_cu_onBalance",0),
"DWrl_cu_notBalance"=COALESCE("DWrl_cu_notBalance",0),
"DWcu_onBalance"=COALESCE("DWcu_onBalance",0),
"DWcu_notBalance"=COALESCE("DWcu_notBalance",0),
"DWrcu_onBalance"=COALESCE("DWrcu_onBalance",0),
"DWrcu_notBalance"=COALESCE("DWrcu_notBalance",0),
"DWxx_onBalance"=COALESCE("DWxx_onBalance",0),
"DWxx_notBalance"=COALESCE("DWxx_notBalance",0),
"DWrxx_onBalance"=COALESCE("DWrxx_onBalance",0),
"DWrxx_notBalance"=COALESCE("DWrxx_notBalance",0),
"Wrc_onBalance"=COALESCE("Wrc_onBalance",0),
"Wrc_notBalance"=COALESCE("Wrc_notBalance",0),
"Wa_potr_onBalance"=COALESCE("Wa_potr_onBalance",0),
"Wa_potr_notBalance"=COALESCE("Wa_potr_notBalance",0),
"Wr_potr_onBalance"=COALESCE("Wr_potr_onBalance",0),
"Wr_potr_notBalance"=COALESCE("Wr_potr_notBalance",0),
"Wa_potr_onBalance_fact"=COALESCE("Wa_potr_onBalance_fact",0),
"Wa_potr_notBalance_fact"=COALESCE("Wa_potr_notBalance_fact",0),
"Wr_potr_onBalance_fact"=COALESCE("Wr_potr_onBalance_fact",0),
"Wr_potr_notBalance_fact"=COALESCE("Wr_potr_notBalance_fact",0),
"dPnlin_OnBalance"=COALESCE("dPnlin_OnBalance",0),
"dPnlin_notBalance"=COALESCE("dPnlin_notBalance",0),
"dPklin_OnBalance"=COALESCE("dPklin_OnBalance",0),
"dPklin_notBalance"=COALESCE("dPklin_notBalance",0),
"dPcrown_OnBalance"=COALESCE("dPcrown_OnBalance",0),
"dPcrown_notBalance"=COALESCE("dPcrown_notBalance",0),
"dQnlin_OnBalance"=COALESCE("dQnlin_OnBalance",0),
"dQnlin_notBalance"=COALESCE("dQnlin_notBalance",0),
"dPntr_OnBalance"=COALESCE("dPntr_OnBalance",0),
"dPntr_notBalance"=COALESCE("dPntr_notBalance",0),
"dQntr_OnBalance"=COALESCE("dQntr_OnBalance",0),
"dQntr_notBalance"=COALESCE("dQntr_notBalance",0),
"dPxx_OnBalance"=COALESCE("dPxx_OnBalance",0),
"dPxx_notBalance"=COALESCE("dPxx_notBalance",0),
"dQxx_OnBalance"=COALESCE("dQxx_OnBalance",0),
"dQxx_notBalance"=COALESCE("dQxx_notBalance",0),
"Qc_onBalance"=COALESCE("Qc_onBalance",0),
"Qc_notBalance"=COALESCE("Qc_notBalance",0),
"Ppotr_OnBalance"=COALESCE("Ppotr_OnBalance",0),
"Ppotr_notBalance"=COALESCE("Ppotr_notBalance",0),
"Qpotr_OnBalance"=COALESCE("Qpotr_OnBalance",0),
"Qpotr_notBalance"=COALESCE("Qpotr_notBalance",0),
"Ppotr_OnBalance_fact"=COALESCE("Ppotr_OnBalance_fact",0),
"Ppotr_notBalance_fact"=COALESCE("Ppotr_notBalance_fact",0),
"Qpotr_OnBalance_fact"=COALESCE("Qpotr_OnBalance_fact",0),
"Qpotr_notBalance_fact"=COALESCE("Qpotr_notBalance_fact",0),
"Kzag_notBalance"=COALESCE("Kzag_notBalance",0);
COMMIT;

ALTER TABLE "WResultsA" ADD "WaTemp" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "WrTemp" DOUBLE_NOT_NULL;
ALTER TABLE "WResultsA" ADD UT  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "PgyT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "QgyT"  DOUBLE_NOT_NULL;
ALTER TABLE "WResultsA" ADD "ImaxT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "KzapT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "sqrKfgT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "sqrKfgCalcT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWal_cu_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWal_cu_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWal_k_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWal_k_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWal_crown_OnBalanceT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWal_crown_notBalanceT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWrl_cu_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWrl_cu_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWcu_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWcu_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWrcu_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWrcu_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWxx_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWxx_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWrxx_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWrxx_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Wrc_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Wrc_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Wa_potr_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Wa_potr_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Wr_potr_onBalanceT"  DOUBLE_NOT_NULL;
ALTER TABLE "WResultsA" ADD "Wr_potr_notBalanceT"  DOUBLE_NOT_NULL;
ALTER TABLE "WResultsA" ADD "Wa_potr_onBalance_factT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Wa_potr_notBalance_factT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Wr_potr_onBalance_factT"   DOUBLE PRECISION;
ALTER TABLE "WResultsA" ADD "Wr_potr_notBalance_factT"   DOUBLE PRECISION;
ALTER TABLE "WResultsA" ADD "dPnlin_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPnlin_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPklin_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPklin_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPcrown_OnBalanceT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPcrown_notBalanceT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dQnlin_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dQnlin_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPntr_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPntr_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dQntr_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dQntr_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPxx_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPxx_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dQxx_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dQxx_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Qc_onBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Qc_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Ppotr_OnBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Ppotr_notBalanceT"  DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Qpotr_OnBalanceT"  DOUBLE_NOT_NULL;
ALTER TABLE "WResultsA" ADD "Qpotr_notBalanceT"  DOUBLE_NOT_NULL;
ALTER TABLE "WResultsA" ADD "Ppotr_OnBalance_factT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Ppotr_notBalance_factT"  DOUBLE_ABOVE_0;
ALTER TABLE "WResultsA" ADD "Qpotr_OnBalance_factT"  DOUBLE precision;
ALTER TABLE "WResultsA" ADD "Qpotr_notBalance_factT"  DOUBLE precision;
ALTER TABLE "WResultsA" ADD "dUT"  DOUBLE_NOT_NULL_ABOVE_0;
COMMIT;

Update "WResultsA" Set
 "WaTemp" ="Wa","WrTemp" ="Wr",
 UT=  U ,
"PgyT"= "Pgy" ,
"QgyT"=  "Qgy",
"ImaxT"= "Imax" ,
"KzapT"= "Kzap",
"sqrKfgT" = "sqrKfg",
"sqrKfgCalcT" = "sqrKfgCalc"  ,
"DWal_cu_onBalanceT" = "DWal_cu_onBalance" ,
 "DWal_cu_notBalanceT"  ="DWal_cu_notBalance"  ,
"DWal_k_onBalanceT" ="DWal_k_onBalance" ,
"DWal_k_notBalanceT"=  "DWal_k_notBalance" ,
"DWal_crown_notBalanceT" = "DWal_crown_notBalance" ,
"DWrl_cu_onBalanceT"= "DWrl_cu_onBalance" ,
 "DWrl_cu_notBalanceT" =  "DWrl_cu_notBalance" ,
"DWcu_onBalanceT" = "DWcu_onBalance" ,
"DWcu_notBalanceT"=  "DWcu_notBalance" ,
"DWrcu_onBalanceT" = "DWrcu_onBalance" ,
"DWrcu_notBalanceT"= "DWrcu_notBalance" ,
"DWxx_onBalanceT"= "DWxx_onBalance"  ,
 "DWxx_notBalanceT" =  "DWxx_notBalance" ,
 "DWrxx_onBalanceT" =  "DWrxx_onBalance" ,
"DWrxx_notBalanceT" = "DWrxx_notBalance" ,
 "Wrc_onBalanceT" = "Wrc_onBalance" ,
"Wrc_notBalanceT" = "Wrc_notBalance" ,
 "Wa_potr_onBalanceT" =  "Wa_potr_onBalance" ,
 "Wa_potr_notBalanceT" =  "Wa_potr_notBalance" ,
 "Wr_potr_onBalanceT" = "Wr_potr_onBalance" ,
 "Wr_potr_notBalanceT" =  "Wr_potr_notBalance"   ,
 "Wa_potr_onBalance_factT"  = "Wa_potr_onBalance_fact" ,
 "Wa_potr_notBalance_factT"   ="Wa_potr_notBalance_fact",
 "Wr_potr_onBalance_factT"  = "Wr_potr_onBalance_fact" ,
 "Wr_potr_notBalance_factT"   ="Wr_potr_notBalance_fact",
 "dPnlin_OnBalanceT"=  "dPnlin_OnBalance" ,
 "dPnlin_notBalanceT" = "dPnlin_notBalance" ,
 "dPklin_OnBalanceT" = "dPklin_OnBalance" ,
 "dPklin_notBalanceT"=  "dPklin_notBalance",
 "dPcrown_OnBalanceT" = "dPcrown_OnBalance"  ,
 "dPcrown_notBalanceT" =  "dPcrown_notBalance" ,
 "dQnlin_OnBalanceT" =  "dQnlin_OnBalance",
 "dQnlin_notBalanceT"=  "dQnlin_notBalance" ,
 "dPntr_OnBalanceT" =  "dPntr_OnBalance",
 "dPntr_notBalanceT" = "dPntr_notBalance" ,
 "dQntr_OnBalanceT" =  "dQntr_OnBalance" ,
 "dQntr_notBalanceT" = "dQntr_notBalance" ,
 "dPxx_OnBalanceT" =  "dPxx_OnBalance",
 "dPxx_notBalanceT" = "dPxx_notBalance"  ,
 "dQxx_OnBalanceT" = "dQxx_OnBalance",
"dQxx_notBalanceT" = "dQxx_notBalance" ,
 "Qc_onBalanceT" =  "Qc_onBalance"  ,
 "Qc_notBalanceT"  = "Qc_notBalance" ,
"Ppotr_OnBalanceT" =  "Ppotr_OnBalance" ,
 "Ppotr_notBalanceT" =  "Ppotr_notBalance" ,
 "Qpotr_OnBalanceT" =  "Qpotr_OnBalance",
"Qpotr_notBalanceT" = "Qpotr_notBalance" ,
 "Ppotr_OnBalance_factT" =  "Ppotr_OnBalance_fact" ,
"Ppotr_notBalance_factT" = "Ppotr_notBalance_fact" ,
 "Qpotr_OnBalance_factT" =  "Qpotr_OnBalance_fact" ,
"Qpotr_notBalance_factT" = "Qpotr_notBalance_fact" ,
 "dUT" =  "dU" ;

Commit;
ALTER TABLE "WResultsA" DROP "Wa" ;
ALTER TABLE "WResultsA" DROP "Wr" ;
ALTER TABLE "WResultsA" DROP U  ;
ALTER TABLE "WResultsA" DROP "Pgy"  ;
ALTER TABLE "WResultsA" DROP "Qgy"  ;
ALTER TABLE "WResultsA" DROP "Imax"  ;
ALTER TABLE "WResultsA" DROP "Kzap"  ;
ALTER TABLE "WResultsA" DROP "sqrKfg"  ;
ALTER TABLE "WResultsA" DROP "sqrKfgCalc"  ;
ALTER TABLE "WResultsA" DROP "DWal_cu_onBalance"  ;
ALTER TABLE "WResultsA" DROP "DWal_cu_notBalance" ;
ALTER TABLE "WResultsA" DROP "DWal_k_onBalance"  ;
ALTER TABLE "WResultsA" DROP "DWal_k_notBalance"  ;
ALTER TABLE "WResultsA" DROP "DWal_crown_OnBalance" ;
ALTER TABLE "WResultsA" DROP "DWal_crown_notBalance"  ;
ALTER TABLE "WResultsA" DROP "DWrl_cu_onBalance"  ;
ALTER TABLE "WResultsA" DROP "DWrl_cu_notBalance"  ;
ALTER TABLE "WResultsA" DROP "DWcu_onBalance"  ;
ALTER TABLE "WResultsA" DROP "DWcu_notBalance" ;
ALTER TABLE "WResultsA" DROP "DWrcu_onBalance" ;
ALTER TABLE "WResultsA" DROP "DWrcu_notBalance" ;
ALTER TABLE "WResultsA" DROP "DWxx_onBalance"  ;
ALTER TABLE "WResultsA" DROP "DWxx_notBalance" ;
ALTER TABLE "WResultsA" DROP "DWrxx_onBalance"  ;
ALTER TABLE "WResultsA" DROP "DWrxx_notBalance"  ;
ALTER TABLE "WResultsA" DROP "Wrc_onBalance"  ;
ALTER TABLE "WResultsA" DROP "Wrc_notBalance"  ;
ALTER TABLE "WResultsA" DROP "Wa_potr_onBalance"  ;
ALTER TABLE "WResultsA" DROP "Wa_potr_notBalance"  ;
ALTER TABLE "WResultsA" DROP "Wr_potr_onBalance" ;
ALTER TABLE "WResultsA" DROP "Wr_potr_notBalance"  ;
ALTER TABLE "WResultsA" DROP "Wa_potr_onBalance_fact"  ;
ALTER TABLE "WResultsA" DROP "Wa_potr_notBalance_fact"  ;
ALTER TABLE "WResultsA" DROP "Wr_potr_onBalance_fact"  ;
ALTER TABLE "WResultsA" DROP "Wr_potr_notBalance_fact"  ;
ALTER TABLE "WResultsA" DROP "dPnlin_OnBalance"  ;
ALTER TABLE "WResultsA" DROP "dPnlin_notBalance" ;
ALTER TABLE "WResultsA" DROP "dPklin_OnBalance"  ;
ALTER TABLE "WResultsA" DROP "dPklin_notBalance"  ;
ALTER TABLE "WResultsA" DROP "dPcrown_OnBalance"  ;
ALTER TABLE "WResultsA" DROP "dPcrown_notBalance"  ;
ALTER TABLE "WResultsA" DROP "dQnlin_OnBalance"  ;
ALTER TABLE "WResultsA" DROP "dQnlin_notBalance"  ;
ALTER TABLE "WResultsA" DROP "dPntr_OnBalance"  ;
ALTER TABLE "WResultsA" DROP "dPntr_notBalance"  ;
ALTER TABLE "WResultsA" DROP "dQntr_OnBalance"  ;
ALTER TABLE "WResultsA" DROP "dQntr_notBalance"  ;
ALTER TABLE "WResultsA" DROP "dPxx_OnBalance" ;
ALTER TABLE "WResultsA" DROP "dPxx_notBalance"  ;
ALTER TABLE "WResultsA" DROP "dQxx_OnBalance"  ;
ALTER TABLE "WResultsA" DROP "dQxx_notBalance"  ;
ALTER TABLE "WResultsA" DROP "Qc_onBalance"  ;
ALTER TABLE "WResultsA" DROP "Qc_notBalance" ;
ALTER TABLE "WResultsA" DROP "Ppotr_OnBalance"  ;
ALTER TABLE "WResultsA" DROP "Ppotr_notBalance"  ;
ALTER TABLE "WResultsA" DROP "Qpotr_OnBalance"  ;
ALTER TABLE "WResultsA" DROP "Qpotr_notBalance"  ;
ALTER TABLE "WResultsA" DROP "Ppotr_OnBalance_fact" ;
ALTER TABLE "WResultsA" DROP "Ppotr_notBalance_fact"  ;
ALTER TABLE "WResultsA" DROP "Qpotr_OnBalance_fact" ;
ALTER TABLE "WResultsA" DROP "Qpotr_notBalance_fact"  ;
ALTER TABLE "WResultsA" DROP "dU"  ;
Commit;
ALTER TABLE "WResultsA" ALTER "WaTemp" TO "Wa"  ;
ALTER TABLE "WResultsA" ALTER "WrTemp" TO "Wr"  ;
ALTER TABLE "WResultsA" ALTER UT  TO U ;
ALTER TABLE "WResultsA" ALTER "PgyT"  TO   "Pgy"  ;
ALTER TABLE "WResultsA" ALTER "QgyT" TO   "Qgy" ;
ALTER TABLE "WResultsA" ALTER "ImaxT" TO   "Imax";
ALTER TABLE "WResultsA" ALTER "KzapT" TO   "Kzap";
ALTER TABLE "WResultsA" ALTER "sqrKfgT"  TO  "sqrKfg";
ALTER TABLE "WResultsA" ALTER "sqrKfgCalcT"  TO  "sqrKfgCalc";
ALTER TABLE "WResultsA" ALTER "DWal_cu_onBalanceT"  TO  "DWal_cu_onBalance";
ALTER TABLE "WResultsA" ALTER "DWal_cu_notBalanceT" TO  "DWal_cu_notBalance";
ALTER TABLE "WResultsA" ALTER "DWal_k_onBalanceT"  TO  "DWal_k_onBalance";
ALTER TABLE "WResultsA" ALTER "DWal_k_notBalanceT"  TO  "DWal_k_notBalance";
ALTER TABLE "WResultsA" ALTER "DWal_crown_OnBalanceT" TO  "DWal_crown_OnBalance";
ALTER TABLE "WResultsA" ALTER "DWal_crown_notBalanceT" TO   "DWal_crown_notBalance";
ALTER TABLE "WResultsA" ALTER "DWrl_cu_onBalanceT"  TO  "DWrl_cu_onBalance";
ALTER TABLE "WResultsA" ALTER "DWrl_cu_notBalanceT" TO   "DWrl_cu_notBalance";
ALTER TABLE "WResultsA" ALTER "DWcu_onBalanceT" TO  "DWcu_onBalance" ;
ALTER TABLE "WResultsA" ALTER "DWcu_notBalanceT" TO  "DWcu_notBalance";
ALTER TABLE "WResultsA" ALTER "DWrcu_onBalanceT" TO  "DWrcu_onBalance";
ALTER TABLE "WResultsA" ALTER "DWrcu_notBalanceT"  TO "DWrcu_notBalance";
ALTER TABLE "WResultsA" ALTER "DWxx_onBalanceT"  TO  "DWxx_onBalance";
ALTER TABLE "WResultsA" ALTER "DWxx_notBalanceT"  TO "DWxx_notBalance";
ALTER TABLE "WResultsA" ALTER "DWrxx_onBalanceT" TO   "DWrxx_onBalance";
ALTER TABLE "WResultsA" ALTER "DWrxx_notBalanceT" TO  "DWrxx_notBalance" ;
ALTER TABLE "WResultsA" ALTER "Wrc_onBalanceT" TO   "Wrc_onBalance";
ALTER TABLE "WResultsA" ALTER "Wrc_notBalanceT" TO   "Wrc_notBalance";
ALTER TABLE "WResultsA" ALTER "Wa_potr_onBalanceT"  TO  "Wa_potr_onBalance";
ALTER TABLE "WResultsA" ALTER "Wa_potr_notBalanceT"  TO "Wa_potr_notBalance" ;
ALTER TABLE "WResultsA" ALTER "Wr_potr_onBalanceT" TO  "Wr_potr_onBalance";
ALTER TABLE "WResultsA" ALTER "Wr_potr_notBalanceT" TO  "Wr_potr_notBalance" ;
ALTER TABLE "WResultsA" ALTER "Wa_potr_onBalance_factT" TO  "Wa_potr_onBalance_fact" ;
ALTER TABLE "WResultsA" ALTER "Wa_potr_notBalance_factT"  TO "Wa_potr_notBalance_fact" ;
ALTER TABLE "WResultsA" ALTER "Wr_potr_onBalance_factT" TO  "Wr_potr_onBalance_fact" ;
ALTER TABLE "WResultsA" ALTER "Wr_potr_notBalance_factT"  TO "Wr_potr_notBalance_fact" ;
ALTER TABLE "WResultsA" ALTER "dPnlin_OnBalanceT"  TO  "dPnlin_OnBalance";
ALTER TABLE "WResultsA" ALTER "dPnlin_notBalanceT" TO  "dPnlin_notBalance";
ALTER TABLE "WResultsA" ALTER "dPklin_OnBalanceT"  TO  "dPklin_OnBalance";
ALTER TABLE "WResultsA" ALTER "dPklin_notBalanceT" TO   "dPklin_notBalance";
ALTER TABLE "WResultsA" ALTER "dPcrown_OnBalanceT" TO  "dPcrown_OnBalance" ;
ALTER TABLE "WResultsA" ALTER "dPcrown_notBalanceT"  TO  "dPcrown_notBalance";
ALTER TABLE "WResultsA" ALTER "dQnlin_OnBalanceT"  TO  "dQnlin_OnBalance" ;
ALTER TABLE "WResultsA" ALTER "dQnlin_notBalanceT" TO  "dQnlin_notBalance" ;
ALTER TABLE "WResultsA" ALTER "dPntr_OnBalanceT" TO   "dPntr_OnBalance";
ALTER TABLE "WResultsA" ALTER "dPntr_notBalanceT"  TO "dPntr_notBalance" ;
ALTER TABLE "WResultsA" ALTER "dQntr_OnBalanceT"   TO "dQntr_OnBalance";
ALTER TABLE "WResultsA" ALTER "dQntr_notBalanceT"  TO "dQntr_notBalance"  ;
ALTER TABLE "WResultsA" ALTER "dPxx_OnBalanceT" TO  "dPxx_OnBalance";
ALTER TABLE "WResultsA" ALTER "dPxx_notBalanceT" TO  "dPxx_notBalance"  ;
ALTER TABLE "WResultsA" ALTER "dQxx_OnBalanceT" TO  "dQxx_OnBalance" ;
ALTER TABLE "WResultsA" ALTER "dQxx_notBalanceT"  TO  "dQxx_notBalance";
ALTER TABLE "WResultsA" ALTER "Qc_onBalanceT"  TO  "Qc_onBalance";
ALTER TABLE "WResultsA" ALTER "Qc_notBalanceT"  TO "Qc_notBalance" ;
ALTER TABLE "WResultsA" ALTER "Ppotr_OnBalanceT"  TO "Ppotr_OnBalance" ;
ALTER TABLE "WResultsA" ALTER "Ppotr_notBalanceT"  TO "Ppotr_notBalance" ;
ALTER TABLE "WResultsA" ALTER "Qpotr_OnBalanceT"  TO  "Qpotr_OnBalance";
ALTER TABLE "WResultsA" ALTER "Qpotr_notBalanceT" TO "Qpotr_notBalance" ;
ALTER TABLE "WResultsA" ALTER "Ppotr_OnBalance_factT" TO "Ppotr_OnBalance_fact";
ALTER TABLE "WResultsA" ALTER "Ppotr_notBalance_factT" TO "Ppotr_notBalance_fact";
ALTER TABLE "WResultsA" ALTER "Qpotr_OnBalance_factT" TO "Qpotr_OnBalance_fact";
ALTER TABLE "WResultsA" ALTER "Qpotr_notBalance_factT" TO "Qpotr_notBalance_fact";
ALTER TABLE "WResultsA" ALTER "dUT" TO "dU";
Commit;


/* - ---------------------------------------------*/
/* - ---------------------------------------------*/

/* Drop table-fields... */
ALTER TABLE "LVPResults" DROP "Tmax";

ALTER TABLE "LVPResults" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "LVPResults" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "LVPResults" ALTER COLUMN UA POSITION 3;
ALTER TABLE "LVPResults" ALTER COLUMN UB POSITION 4;
ALTER TABLE "LVPResults" ALTER COLUMN UC POSITION 5;
ALTER TABLE "LVPResults" ALTER COLUMN IA POSITION 6;
ALTER TABLE "LVPResults" ALTER COLUMN IB POSITION 7;
ALTER TABLE "LVPResults" ALTER COLUMN IC POSITION 8;
ALTER TABLE "LVPResults" ALTER COLUMN U2A POSITION 9;
ALTER TABLE "LVPResults" ALTER COLUMN U2B POSITION 10;
ALTER TABLE "LVPResults" ALTER COLUMN U2C POSITION 11;
ALTER TABLE "LVPResults" ALTER COLUMN "CosFiA" POSITION 12;
ALTER TABLE "LVPResults" ALTER COLUMN "CosFiB" POSITION 13;
ALTER TABLE "LVPResults" ALTER COLUMN "CosFiC" POSITION 14;
ALTER TABLE "LVPResults" ALTER COLUMN "Wa" POSITION 15;
ALTER TABLE "LVPResults" ALTER COLUMN "Wr" POSITION 16;
ALTER TABLE "LVPResults" ALTER COLUMN T POSITION 17;
ALTER TABLE "LVPResults" ALTER COLUMN P POSITION 18;
ALTER TABLE "LVPResults" ALTER COLUMN Q POSITION 19;
ALTER TABLE "LVPResults" ALTER COLUMN "dP_OnBalance" POSITION 20;
ALTER TABLE "LVPResults" ALTER COLUMN "dP_notBalance" POSITION 21;
ALTER TABLE "LVPResults" ALTER COLUMN "dPk_OnBalance" POSITION 22;
ALTER TABLE "LVPResults" ALTER COLUMN "dPk_notBalance" POSITION 23;
ALTER TABLE "LVPResults" ALTER COLUMN "dQ_OnBalance" POSITION 24;
ALTER TABLE "LVPResults" ALTER COLUMN "dQ_notBalance" POSITION 25;
ALTER TABLE "LVPResults" ALTER COLUMN "dWa_OnBalance" POSITION 26;
ALTER TABLE "LVPResults" ALTER COLUMN "dWa_notBalance" POSITION 27;
ALTER TABLE "LVPResults" ALTER COLUMN "dWak_OnBalance" POSITION 28;
ALTER TABLE "LVPResults" ALTER COLUMN "dWak_notBalance" POSITION 29;
ALTER TABLE "LVPResults" ALTER COLUMN "dWr_OnBalance" POSITION 30;
ALTER TABLE "LVPResults" ALTER COLUMN "dWr_notBalance" POSITION 31;
ALTER TABLE "LVPResults" ALTER COLUMN "Pcalc_OnBalance" POSITION 32;
ALTER TABLE "LVPResults" ALTER COLUMN "Pcalc_notBalance" POSITION 33;
ALTER TABLE "LVPResults" ALTER COLUMN "Qcalc_OnBalance" POSITION 34;
ALTER TABLE "LVPResults" ALTER COLUMN "Qcalc_notBalance" POSITION 35;
ALTER TABLE "LVPResults" ALTER COLUMN "Pfakt_OnBalance" POSITION 36;
ALTER TABLE "LVPResults" ALTER COLUMN "Pfakt_notBalance" POSITION 37;
ALTER TABLE "LVPResults" ALTER COLUMN "Qfakt_OnBalance" POSITION 38;
ALTER TABLE "LVPResults" ALTER COLUMN "Qfakt_notBalance" POSITION 39;
ALTER TABLE "LVPResults" ALTER COLUMN "Wacalc_OnBalance" POSITION 40;
ALTER TABLE "LVPResults" ALTER COLUMN "Wacalc_notBalance" POSITION 41;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrcalc_OnBalance" POSITION 42;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrcalc_notBalance" POSITION 43;
ALTER TABLE "LVPResults" ALTER COLUMN "Wafakt_OnBalance" POSITION 44;
ALTER TABLE "LVPResults" ALTER COLUMN "Wafakt_notBalance" POSITION 45;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrfakt_OnBalance" POSITION 46;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrfakt_notBalance" POSITION 47;
ALTER TABLE "LVPResults" ALTER COLUMN "NAbonents_OnBalance" POSITION 48;
ALTER TABLE "LVPResults" ALTER COLUMN "NAbonents_NotBalance" POSITION 49;
ALTER TABLE "LVPResults" ALTER COLUMN "LsumP_OnBalance" POSITION 50;
ALTER TABLE "LVPResults" ALTER COLUMN "LsumP_NotBalance" POSITION 51;
ALTER TABLE "LVPResults" ALTER COLUMN "LsumC_OnBalance" POSITION 52;
ALTER TABLE "LVPResults" ALTER COLUMN "LsumC_NotBalance" POSITION 53;
ALTER TABLE "LVPResults" ALTER COLUMN "NLineP_OnBalance" POSITION 54;
ALTER TABLE "LVPResults" ALTER COLUMN "NLineP_NotBalance" POSITION 55;
ALTER TABLE "LVPResults" ALTER COLUMN "NLineC_OnBalance" POSITION 56;
ALTER TABLE "LVPResults" ALTER COLUMN "NLineC_NotBalance" POSITION 57;
ALTER TABLE "LVPResults" ALTER COLUMN "Lm" POSITION 58;
ALTER TABLE "LVPResults" ALTER COLUMN L23 POSITION 59;
ALTER TABLE "LVPResults" ALTER COLUMN L1 POSITION 60;
ALTER TABLE "LVPResults" ALTER COLUMN "Kdp" POSITION 61;
ALTER TABLE "LVPResults" ALTER COLUMN "Krazv" POSITION 62;
ALTER TABLE "LVPResults" ALTER COLUMN "Temperature" POSITION 63;
ALTER TABLE "LVPResults" ALTER COLUMN CRC POSITION 64;
ALTER TABLE "PResults" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "PResults" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "PResults" ALTER COLUMN "Wa" POSITION 3;
ALTER TABLE "PResults" ALTER COLUMN "Wr" POSITION 4;
ALTER TABLE "PResults" ALTER COLUMN T POSITION 5;
ALTER TABLE "PResults" ALTER COLUMN U POSITION 6;
ALTER TABLE "PResults" ALTER COLUMN "Pgy" POSITION 7;
ALTER TABLE "PResults" ALTER COLUMN "Qgy" POSITION 8;
ALTER TABLE "PResults" ALTER COLUMN "DWal_cu_onBalance" POSITION 9;
ALTER TABLE "PResults" ALTER COLUMN "DWal_cu_notBalance" POSITION 10;
ALTER TABLE "PResults" ALTER COLUMN "DWal_k_onBalance" POSITION 11;
ALTER TABLE "PResults" ALTER COLUMN "DWal_k_notBalance" POSITION 12;
ALTER TABLE "PResults" ALTER COLUMN "DWal_crown_OnBalance" POSITION 13;
ALTER TABLE "PResults" ALTER COLUMN "DWal_crown_notBalance" POSITION 14;
ALTER TABLE "PResults" ALTER COLUMN "DWrl_cu_onBalance" POSITION 15;
ALTER TABLE "PResults" ALTER COLUMN "DWrl_cu_notBalance" POSITION 16;
ALTER TABLE "PResults" ALTER COLUMN "DWcu_onBalance" POSITION 17;
ALTER TABLE "PResults" ALTER COLUMN "DWcu_notBalance" POSITION 18;
ALTER TABLE "PResults" ALTER COLUMN "DWrcu_onBalance" POSITION 19;
ALTER TABLE "PResults" ALTER COLUMN "DWrcu_notBalance" POSITION 20;
ALTER TABLE "PResults" ALTER COLUMN "DWxx_onBalance" POSITION 21;
ALTER TABLE "PResults" ALTER COLUMN "DWxx_notBalance" POSITION 22;
ALTER TABLE "PResults" ALTER COLUMN "DWrxx_onBalance" POSITION 23;
ALTER TABLE "PResults" ALTER COLUMN "DWrxx_notBalance" POSITION 24;
ALTER TABLE "PResults" ALTER COLUMN "Wrc_onBalance" POSITION 25;
ALTER TABLE "PResults" ALTER COLUMN "Wrc_notBalance" POSITION 26;
ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_onBalance" POSITION 27;
ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_notBalance" POSITION 28;
ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_onBalance" POSITION 29;
ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_notBalance" POSITION 30;
ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 31;
ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 32;
ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 33;
ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 34;
ALTER TABLE "PResults" ALTER COLUMN "dPnlin_OnBalance" POSITION 35;
ALTER TABLE "PResults" ALTER COLUMN "dPnlin_notBalance" POSITION 36;
ALTER TABLE "PResults" ALTER COLUMN "dPklin_OnBalance" POSITION 37;
ALTER TABLE "PResults" ALTER COLUMN "dPklin_notBalance" POSITION 38;
ALTER TABLE "PResults" ALTER COLUMN "dPcrown_OnBalance" POSITION 39;
ALTER TABLE "PResults" ALTER COLUMN "dPcrown_notBalance" POSITION 40;
ALTER TABLE "PResults" ALTER COLUMN "dQnlin_OnBalance" POSITION 41;
ALTER TABLE "PResults" ALTER COLUMN "dQnlin_notBalance" POSITION 42;
ALTER TABLE "PResults" ALTER COLUMN "dPntr_OnBalance" POSITION 43;
ALTER TABLE "PResults" ALTER COLUMN "dPntr_notBalance" POSITION 44;
ALTER TABLE "PResults" ALTER COLUMN "dQntr_OnBalance" POSITION 45;
ALTER TABLE "PResults" ALTER COLUMN "dQntr_notBalance" POSITION 46;
ALTER TABLE "PResults" ALTER COLUMN "dPxx_OnBalance" POSITION 47;
ALTER TABLE "PResults" ALTER COLUMN "dPxx_notBalance" POSITION 48;
ALTER TABLE "PResults" ALTER COLUMN "dQxx_OnBalance" POSITION 49;
ALTER TABLE "PResults" ALTER COLUMN "dQxx_notBalance" POSITION 50;
ALTER TABLE "PResults" ALTER COLUMN "Qc_onBalance" POSITION 51;
ALTER TABLE "PResults" ALTER COLUMN "Qc_notBalance" POSITION 52;
ALTER TABLE "PResults" ALTER COLUMN "Ppotr_OnBalance" POSITION 53;
ALTER TABLE "PResults" ALTER COLUMN "Ppotr_notBalance" POSITION 54;
ALTER TABLE "PResults" ALTER COLUMN "Qpotr_OnBalance" POSITION 55;
ALTER TABLE "PResults" ALTER COLUMN "Qpotr_notBalance" POSITION 56;
ALTER TABLE "PResults" ALTER COLUMN "Ppotr_OnBalance_fact" POSITION 57;
ALTER TABLE "PResults" ALTER COLUMN "Ppotr_notBalance_fact" POSITION 58;
ALTER TABLE "PResults" ALTER COLUMN "Qpotr_OnBalance_fact" POSITION 59;
ALTER TABLE "PResults" ALTER COLUMN "Qpotr_notBalance_fact" POSITION 60;
ALTER TABLE "PResults" ALTER COLUMN "Kzag_OnBalance" POSITION 61;
ALTER TABLE "PResults" ALTER COLUMN "Kzag_notBalance" POSITION 62;
ALTER TABLE "PResults" ALTER COLUMN "dU" POSITION 63;
ALTER TABLE "PResults" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 64;
ALTER TABLE "PResults" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 65;
ALTER TABLE "PResults" ALTER COLUMN "Ntr_OnBalance" POSITION 66;
ALTER TABLE "PResults" ALTER COLUMN "Ntr_NotBalance" POSITION 67;
ALTER TABLE "PResults" ALTER COLUMN "LsumP_OnBalance" POSITION 68;
ALTER TABLE "PResults" ALTER COLUMN "LsumP_NotBalance" POSITION 69;
ALTER TABLE "PResults" ALTER COLUMN "LsumC_OnBalance" POSITION 70;
ALTER TABLE "PResults" ALTER COLUMN "LsumC_NotBalance" POSITION 71;
ALTER TABLE "PResults" ALTER COLUMN "NLineP_OnBalance" POSITION 72;
ALTER TABLE "PResults" ALTER COLUMN "NLineP_NotBalance" POSITION 73;
ALTER TABLE "PResults" ALTER COLUMN "NLineC_OnBalance" POSITION 74;
ALTER TABLE "PResults" ALTER COLUMN "NLineC_NotBalance" POSITION 75;
ALTER TABLE "PResults" ALTER COLUMN "WeatherConditions" POSITION 76;
ALTER TABLE "PResults" ALTER COLUMN "Temperature" POSITION 77;
ALTER TABLE "PResults" ALTER COLUMN "Flags" POSITION 78;
ALTER TABLE "PResults" ALTER COLUMN CRC POSITION 79;
ALTER TABLE "WResults" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "WResults" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "WResults" ALTER COLUMN "Wa" POSITION 3;
ALTER TABLE "WResults" ALTER COLUMN "Wr" POSITION 4;
ALTER TABLE "WResults" ALTER COLUMN T POSITION 5;
ALTER TABLE "WResults" ALTER COLUMN U POSITION 6;
ALTER TABLE "WResults" ALTER COLUMN "Pgy" POSITION 7;
ALTER TABLE "WResults" ALTER COLUMN "Qgy" POSITION 8;
ALTER TABLE "WResults" ALTER COLUMN "Imax" POSITION 9;
ALTER TABLE "WResults" ALTER COLUMN "Kzap" POSITION 10;
ALTER TABLE "WResults" ALTER COLUMN "sqrKfg" POSITION 11;
ALTER TABLE "WResults" ALTER COLUMN "sqrKfgCalc" POSITION 12;
ALTER TABLE "WResults" ALTER COLUMN "DWal_cu_onBalance" POSITION 13;
ALTER TABLE "WResults" ALTER COLUMN "DWal_cu_notBalance" POSITION 14;
ALTER TABLE "WResults" ALTER COLUMN "DWal_k_onBalance" POSITION 15;
ALTER TABLE "WResults" ALTER COLUMN "DWal_k_notBalance" POSITION 16;
ALTER TABLE "WResults" ALTER COLUMN "DWal_crown_OnBalance" POSITION 17;
ALTER TABLE "WResults" ALTER COLUMN "DWal_crown_notBalance" POSITION 18;
ALTER TABLE "WResults" ALTER COLUMN "DWrl_cu_onBalance" POSITION 19;
ALTER TABLE "WResults" ALTER COLUMN "DWrl_cu_notBalance" POSITION 20;
ALTER TABLE "WResults" ALTER COLUMN "DWcu_onBalance" POSITION 21;
ALTER TABLE "WResults" ALTER COLUMN "DWcu_notBalance" POSITION 22;
ALTER TABLE "WResults" ALTER COLUMN "DWrcu_onBalance" POSITION 23;
ALTER TABLE "WResults" ALTER COLUMN "DWrcu_notBalance" POSITION 24;
ALTER TABLE "WResults" ALTER COLUMN "DWxx_onBalance" POSITION 25;
ALTER TABLE "WResults" ALTER COLUMN "DWxx_notBalance" POSITION 26;
ALTER TABLE "WResults" ALTER COLUMN "DWrxx_onBalance" POSITION 27;
ALTER TABLE "WResults" ALTER COLUMN "DWrxx_notBalance" POSITION 28;
ALTER TABLE "WResults" ALTER COLUMN "Wrc_onBalance" POSITION 29;
ALTER TABLE "WResults" ALTER COLUMN "Wrc_notBalance" POSITION 30;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_onBalance" POSITION 31;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_notBalance" POSITION 32;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_onBalance" POSITION 33;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_notBalance" POSITION 34;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 35;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 36;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 37;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 38;
ALTER TABLE "WResults" ALTER COLUMN "dPnlin_OnBalance" POSITION 39;
ALTER TABLE "WResults" ALTER COLUMN "dPnlin_notBalance" POSITION 40;
ALTER TABLE "WResults" ALTER COLUMN "dPklin_OnBalance" POSITION 41;
ALTER TABLE "WResults" ALTER COLUMN "dPklin_notBalance" POSITION 42;
ALTER TABLE "WResults" ALTER COLUMN "dPcrown_OnBalance" POSITION 43;
ALTER TABLE "WResults" ALTER COLUMN "dPcrown_notBalance" POSITION 44;
ALTER TABLE "WResults" ALTER COLUMN "dQnlin_OnBalance" POSITION 45;
ALTER TABLE "WResults" ALTER COLUMN "dQnlin_notBalance" POSITION 46;
ALTER TABLE "WResults" ALTER COLUMN "dPntr_OnBalance" POSITION 47;
ALTER TABLE "WResults" ALTER COLUMN "dPntr_notBalance" POSITION 48;
ALTER TABLE "WResults" ALTER COLUMN "dQntr_OnBalance" POSITION 49;
ALTER TABLE "WResults" ALTER COLUMN "dQntr_notBalance" POSITION 50;
ALTER TABLE "WResults" ALTER COLUMN "dPxx_OnBalance" POSITION 51;
ALTER TABLE "WResults" ALTER COLUMN "dPxx_notBalance" POSITION 52;
ALTER TABLE "WResults" ALTER COLUMN "dQxx_OnBalance" POSITION 53;
ALTER TABLE "WResults" ALTER COLUMN "dQxx_notBalance" POSITION 54;
ALTER TABLE "WResults" ALTER COLUMN "Qc_onBalance" POSITION 55;
ALTER TABLE "WResults" ALTER COLUMN "Qc_notBalance" POSITION 56;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_OnBalance" POSITION 57;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_notBalance" POSITION 58;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_OnBalance" POSITION 59;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_notBalance" POSITION 60;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_OnBalance_fact" POSITION 61;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_notBalance_fact" POSITION 62;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_OnBalance_fact" POSITION 63;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_notBalance_fact" POSITION 64;
ALTER TABLE "WResults" ALTER COLUMN "Kzag_OnBalance" POSITION 65;
ALTER TABLE "WResults" ALTER COLUMN "Kzag_notBalance" POSITION 66;
ALTER TABLE "WResults" ALTER COLUMN "dU" POSITION 67;
ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 68;
ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 69;
ALTER TABLE "WResults" ALTER COLUMN "Ntr_OnBalance" POSITION 70;
ALTER TABLE "WResults" ALTER COLUMN "Ntr_NotBalance" POSITION 71;
ALTER TABLE "WResults" ALTER COLUMN "LsumP_OnBalance" POSITION 72;
ALTER TABLE "WResults" ALTER COLUMN "LsumP_NotBalance" POSITION 73;
ALTER TABLE "WResults" ALTER COLUMN "LsumC_OnBalance" POSITION 74;
ALTER TABLE "WResults" ALTER COLUMN "LsumC_NotBalance" POSITION 75;
ALTER TABLE "WResults" ALTER COLUMN "NLineP_OnBalance" POSITION 76;
ALTER TABLE "WResults" ALTER COLUMN "NLineP_NotBalance" POSITION 77;
ALTER TABLE "WResults" ALTER COLUMN "NLineC_OnBalance" POSITION 78;
ALTER TABLE "WResults" ALTER COLUMN "NLineC_NotBalance" POSITION 79;
ALTER TABLE "WResults" ALTER COLUMN "NAbonents_OnBalance" POSITION 80;
ALTER TABLE "WResults" ALTER COLUMN "NAbonents_NotBalance" POSITION 81;
ALTER TABLE "WResults" ALTER COLUMN "dWdop" POSITION 82;
ALTER TABLE "WResults" ALTER COLUMN "WeatherConditions" POSITION 83;
ALTER TABLE "WResults" ALTER COLUMN "Temperature" POSITION 84;
ALTER TABLE "WResults" ALTER COLUMN "Flags" POSITION 85;
ALTER TABLE "WResults" ALTER COLUMN CRC POSITION 86;
ALTER TABLE "WResultsA" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "WResultsA" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa" POSITION 3;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr" POSITION 4;
ALTER TABLE "WResultsA" ALTER COLUMN T POSITION 5;
ALTER TABLE "WResultsA" ALTER COLUMN U POSITION 6;
ALTER TABLE "WResultsA" ALTER COLUMN "Pgy" POSITION 7;
ALTER TABLE "WResultsA" ALTER COLUMN "Qgy" POSITION 8;
ALTER TABLE "WResultsA" ALTER COLUMN "Imax" POSITION 9;
ALTER TABLE "WResultsA" ALTER COLUMN "Kzap" POSITION 10;
ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfg" POSITION 11;
ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfgCalc" POSITION 12;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_cu_onBalance" POSITION 13;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_cu_notBalance" POSITION 14;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_k_onBalance" POSITION 15;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_k_notBalance" POSITION 16;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_crown_OnBalance" POSITION 17;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_crown_notBalance" POSITION 18;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrl_cu_onBalance" POSITION 19;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrl_cu_notBalance" POSITION 20;
ALTER TABLE "WResultsA" ALTER COLUMN "DWcu_onBalance" POSITION 21;
ALTER TABLE "WResultsA" ALTER COLUMN "DWcu_notBalance" POSITION 22;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrcu_onBalance" POSITION 23;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrcu_notBalance" POSITION 24;
ALTER TABLE "WResultsA" ALTER COLUMN "DWxx_onBalance" POSITION 25;
ALTER TABLE "WResultsA" ALTER COLUMN "DWxx_notBalance" POSITION 26;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrxx_onBalance" POSITION 27;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrxx_notBalance" POSITION 28;
ALTER TABLE "WResultsA" ALTER COLUMN "Wrc_onBalance" POSITION 29;
ALTER TABLE "WResultsA" ALTER COLUMN "Wrc_notBalance" POSITION 30;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_onBalance" POSITION 31;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_notBalance" POSITION 32;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_onBalance" POSITION 33;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_notBalance" POSITION 34;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 35;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 36;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 37;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 38;
ALTER TABLE "WResultsA" ALTER COLUMN "dPnlin_OnBalance" POSITION 39;
ALTER TABLE "WResultsA" ALTER COLUMN "dPnlin_notBalance" POSITION 40;
ALTER TABLE "WResultsA" ALTER COLUMN "dPklin_OnBalance" POSITION 41;
ALTER TABLE "WResultsA" ALTER COLUMN "dPklin_notBalance" POSITION 42;
ALTER TABLE "WResultsA" ALTER COLUMN "dPcrown_OnBalance" POSITION 43;
ALTER TABLE "WResultsA" ALTER COLUMN "dPcrown_notBalance" POSITION 44;
ALTER TABLE "WResultsA" ALTER COLUMN "dQnlin_OnBalance" POSITION 45;
ALTER TABLE "WResultsA" ALTER COLUMN "dQnlin_notBalance" POSITION 46;
ALTER TABLE "WResultsA" ALTER COLUMN "dPntr_OnBalance" POSITION 47;
ALTER TABLE "WResultsA" ALTER COLUMN "dPntr_notBalance" POSITION 48;
ALTER TABLE "WResultsA" ALTER COLUMN "dQntr_OnBalance" POSITION 49;
ALTER TABLE "WResultsA" ALTER COLUMN "dQntr_notBalance" POSITION 50;
ALTER TABLE "WResultsA" ALTER COLUMN "dPxx_OnBalance" POSITION 51;
ALTER TABLE "WResultsA" ALTER COLUMN "dPxx_notBalance" POSITION 52;
ALTER TABLE "WResultsA" ALTER COLUMN "dQxx_OnBalance" POSITION 53;
ALTER TABLE "WResultsA" ALTER COLUMN "dQxx_notBalance" POSITION 54;
ALTER TABLE "WResultsA" ALTER COLUMN "Qc_onBalance" POSITION 55;
ALTER TABLE "WResultsA" ALTER COLUMN "Qc_notBalance" POSITION 56;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_OnBalance" POSITION 57;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_notBalance" POSITION 58;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_OnBalance" POSITION 59;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_notBalance" POSITION 60;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_OnBalance_fact" POSITION 61;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_notBalance_fact" POSITION 62;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_OnBalance_fact" POSITION 63;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_notBalance_fact" POSITION 64;
ALTER TABLE "WResultsA" ALTER COLUMN "Kzag_OnBalance" POSITION 65;
ALTER TABLE "WResultsA" ALTER COLUMN "Kzag_notBalance" POSITION 66;
ALTER TABLE "WResultsA" ALTER COLUMN "dU" POSITION 67;
ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 68;
ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 69;
ALTER TABLE "WResultsA" ALTER COLUMN "Ntr_OnBalance" POSITION 70;
ALTER TABLE "WResultsA" ALTER COLUMN "Ntr_NotBalance" POSITION 71;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumP_OnBalance" POSITION 72;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumP_NotBalance" POSITION 73;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumC_OnBalance" POSITION 74;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumC_NotBalance" POSITION 75;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineP_OnBalance" POSITION 76;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineP_NotBalance" POSITION 77;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineC_OnBalance" POSITION 78;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineC_NotBalance" POSITION 79;
ALTER TABLE "WResultsA" ALTER COLUMN "NAbonents_OnBalance" POSITION 80;
ALTER TABLE "WResultsA" ALTER COLUMN "NAbonents_NotBalance" POSITION 81;
ALTER TABLE "WResultsA" ALTER COLUMN "dWdop" POSITION 82;
ALTER TABLE "WResultsA" ALTER COLUMN "WeatherConditions" POSITION 83;
ALTER TABLE "WResultsA" ALTER COLUMN "Temperature" POSITION 84;
ALTER TABLE "WResultsA" ALTER COLUMN "Flags" POSITION 85;
ALTER TABLE "WResultsA" ALTER COLUMN CRC POSITION 86;

CREATE DOMAIN DECIMAL_8_3 AS DECIMAL(8,3) CHECK(Value IS NULL or Value>=0 and Value<10000);
CREATE DOMAIN DECIMAL_8_3_NOT_NULL AS DECIMAL(8,3) NOT NULL CHECK(Value>=0 and Value<10000);

ALTER TABLE "LVPResults" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "LVPSamples" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "LVPTPInfo" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "LVWResults" ALTER COLUMN T TYPE DECIMAL_8_3;
/*ALTER TABLE "LVWResultsB" DROP CONSTRAINT "CHECK_LVWResultsB_T"; */
ALTER TABLE "LVWResultsB" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "LVWResultsB" ADD CONSTRAINT "CHECK_LVWResultsB_T" CHECK((T IS NULL) OR (T>0));
ALTER TABLE "LVWSamples" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "MainsWLoads" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "PResults" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "PSamples" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "WLoads" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "WResults" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "WResultsA" ALTER COLUMN T TYPE DECIMAL_8_3;
ALTER TABLE "WSamples" ALTER COLUMN T TYPE DECIMAL_8_3;

ALTER TABLE "InitParams" DROP CONSTRAINT "CHK_InitParams_Values";
alter table "InitParams"
add constraint "CHK_InitParams_Values"
check (("Key"=1) and ("Value" between 0 and 1) or /* smCosFi */
 ("Key"=2 or "Key"=3) and ("Value" between "Param"*0.8 and "Param"*1.2) or /* smUcp, smUdop*/
 ("Key"=4) and ("Value" between 1/13 and 1) or /* smKzap */
 ("Key"=6) and ("Value" between 0.04 and 1) or /* smTau */
 
 ("Key" in (100,108,109,110,111) and "Value" between -2147483647 and 2147483647) or /*(smAOEnergoGUID,smVNCalc,smNNCalc,smStLoads,smMetrolog */
 ("Key"=101 and "Value" between 1 and 7) or /*smRegionIdent */
 ("Key"=102 and "Value" between 1 and 3) or /* smKdp */
 ("Key" in (103,105,112,113) and ("Value"=0 or "Value"=1)) or /* (smUseTemperature,smKuntp,smDotDisableLine,smShowPhases */
 ("Key"=104 and "Value" between -70 and 70) or /* smTemperature */
 ("Key"=106 or "Key"=107) and ("Value" between 0 and 2)  or /* smSaveDetailed,smSaveDetailedHH */
 ("Key"=5 or "Key"=200 or "Key"=201) and ("Value" between -2147483.648 and 2147483.647) /* Colors */);

COMMIT;
 UPDATE "Version" SET "Major"=3, "Minor"=0, "Release"=20,"Build"=0, "VersionDate"='NOW';
COMMIT;
