DROP PROCEDURE "InsertSynchronousMotor";
CREATE PROCEDURE "InsertSynchronousMotor" (
 Marka VARCHAR(32),Unom DECIMAL(10,2),Pnom DECIMAL(10,2),
 Performance DECIMAL(10,4),CosFi DECIMAL(10,3),n Smallint,
 Manufacturer Smallint,Hide Smallint)
RETURNS (Ident INTEGER)
AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "SynchronousMotors"
  ("Ident","Marka","Unom","Pnom","Performance","CosFi","n","Manufacturer","Hide")
  VALUES (:Ident,:Marka,:Unom,:Pnom,:Performance,:CosFi,:n,:Manufacturer,:Hide);
END ;
GRANT EXECUTE ON PROCEDURE "InsertSynchronousMotor" TO "rtp3user" ;

update "Transforms3" set "PkzBH"="PkzBC", "PkzCH"="PkzBC"
where "PkzBH"=0 and "PkzCH"=0;
update "TransformsA" set "PkzBH"="PkzBC", "PkzCH"="PkzBC"
where "PkzBH"=0 and "PkzCH"=0;
COMMIT;

/* Version 3.0.20.7 */

CREATE DOMAIN DECIMAL_6_4_NOT_NULL AS DECIMAL(6,4) NOT NULL CHECK(Value>=0 and Value<100);

ALTER TABLE "CurrentLimitReactorsRef" ADD X DECIMAL_6_4_NOT_NULL;
ALTER TABLE "CurrentLimitReactorsRef" ADD "Ksv" DECIMAL_5_4_1;
COMMIT;
/* Empty InsertTransformSS for drop TransformsSS(UkHH) */
SET TERM ^ ;
ALTER PROCEDURE "InsertTransformSS"
AS
 BEGIN EXIT; END^
COMMIT ^

SET TERM ; ^

ALTER TABLE "TransformsSS" ALTER COLUMN "UkHH" TYPE DECIMAL_6_2;
ALTER TABLE "Transforms3" ADD CONSTRAINT "CHK_Transforms3_Pkz" CHECK(("PkzBC"<"PkzBH"+"PkzCH") and ("PkzBH"<"PkzBC"+"PkzCH") and
   ("PkzCH"<"PkzBH"+"PkzBC"));
ALTER TABLE "TransformsA" ADD CONSTRAINT "CHK_TransformsA_Pkz" CHECK(("PkzBC"<"PkzBH"+"PkzCH") and ("PkzBH"<"PkzBC"+"PkzCH") and
   ("PkzCH"<"PkzBH"+"PkzBC"));
COMMIT;
/* Alter Procedure... */
/* Alter (InsertCurrentLimitReactorRef) */

SET TERM ^ ;

ALTER PROCEDURE "InsertCurrentLimitReactorRef"(MARKA VARCHAR(32),SNOM VARCHAR(20),
UNOM DECIMAL(10,2),INOM DECIMAL(10,2),DP DECIMAL(10,2),X DECIMAL(10,4),ISDOUBLE SMALLINT,
KSV DECIMAL(10,3),MANUFACTURER SMALLINT,HIDE SMALLINT) RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "CurrentLimitReactorsRef"
  ("Ident","Marka","Snom","Unom","Inom","dP","X","isDouble","Ksv","Manufacturer","Hide")
 VALUES (:Ident,:Marka,:Snom,:Unom,:Inom,:dP,:X,:isDouble,:Ksv,:Manufacturer,:Hide);
END
^
COMMIT ^

/* Alter (InsertTransformSS) */
ALTER PROCEDURE "InsertTransformSS"(UNOM DECIMAL(10,2),TYPETR VARCHAR(8),
SNOM DECIMAL(10,2),ADDSTR VARCHAR(48),UKBH DECIMAL(10,2),UKHH DECIMAL(10,2),
PXX DECIMAL(10,3),PKZ DECIMAL(10,3),IXX DECIMAL(10,2),UNOMB DECIMAL(10,2),
UNOMH1 DECIMAL(10,2),UNOMH2 DECIMAL(10,2),NUMBEROTP SMALLINT,
DELTAUOTP DECIMAL(10,3),MANUFACTURER SMALLINT,HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "TransformsSS" ("Ident","Unom","TypeTR","Snom","AddStr",
  "UkBH","UkHH","Pxx","Pkz","Ixx","UnomB","UnomH1","UnomH2",
  "NumberOtp","DeltaUotp","Manufacturer","Hide")
  VALUES (:Ident,:Unom,:TypeTR,:Snom,:AddStr,:UkBH,:UkHH,:Pxx,:Pkz,:Ixx,
    :UnomB,:UnomH1,:UnomH2,:NumberOtp,:DeltaUotp,:Manufacturer,:Hide);
END
^
COMMIT ^

/* Alter (RoundUnom) */
ALTER PROCEDURE "RoundUnom"(AUNOM DECIMAL(6,2))
 RETURNS(UNOM DECIMAL(6,2))
 AS
BEGIN
 IF (AUnom<0.1) THEN Unom=0;    ELSE
 IF (AUnom<0.3) THEN Unom=0.22; ELSE
 IF (AUnom<0.5) THEN Unom=0.38; ELSE
 IF (AUnom<1.0) THEN Unom=0.66; ELSE
 IF (AUnom<4.0) THEN Unom=3;    ELSE
 IF (AUnom<8.0) THEN Unom=6;    ELSE
 IF (AUnom<14.5)  THEN Unom=10; ELSE
 IF (AUnom<19)  THEN Unom=15;   ELSE
 IF (AUnom<27)  THEN Unom=20;   ELSE
 IF (AUnom<31)  THEN Unom=27.5; ELSE
 IF (AUnom<50)  THEN Unom=35;   ELSE
 IF (AUnom<80)  THEN Unom=60;   ELSE
 IF (AUnom<130) THEN Unom=110;   ELSE
 IF (AUnom<200) THEN Unom=150;   ELSE
 IF (AUnom<300) THEN Unom=220;   ELSE
 IF (AUnom<400) THEN Unom=330;   ELSE
 IF (AUnom<650) THEN Unom=500;   ELSE
 IF (AUnom<1000) THEN Unom=750;   ELSE
 Unom=1150;
 Suspend;
END
^
COMMIT ^

SET TERM ; ^

ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Snom" POSITION 3;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Unom" POSITION 4;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Inom" POSITION 5;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "dP" POSITION 6;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN X POSITION 7;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "isDouble" POSITION 8;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Ksv" POSITION 9;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Manufacturer" POSITION 10;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Hide" POSITION 11;

COMMIT;

 UPDATE "Version" SET "Major"=3, "Minor"=0, "Release"=20,"Build"=7, "VersionDate"='NOW';
COMMIT;
