ALTER TABLE "PLoads" DROP CONSTRAINT "CHECK_PLoads_LoadType";
ALTER TABLE "PLoads" ADD CONSTRAINT "CHECK_PLoads_LoadType"
 CHECK("LoadType" BETWEEN 1 AND 7);

/* Create Domains... */
CREATE DOMAIN DECIMAL_6_4_NOT_NULL AS DECIMAL(6,4) NOT NULL CHECK(Value>=0 and Value<100);
CREATE DOMAIN NUMBER_11_6 AS DECIMAL(11,6) CHECK(Value IS NULL or Value>-100000 and Value<100000);

/* Create Table... */

ALTER TABLE "CurrentLimitReactorsRef" ADD X DECIMAL_6_4_NOT_NULL;
ALTER TABLE "CurrentLimitReactorsRef" ADD "Ksv" DECIMAL_5_4_1;

ALTER TABLE "PResults" ADD "DWaclr_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWaclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWrclr_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "DWrclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "dPclr_OnBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "dPclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "dQclr_OnBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResults" ADD "dQclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;

Commit;
update "PResults" set
 "dPclr_OnBalance"=0, "dPclr_notBalance"=0,
 "dQclr_OnBalance"=0, "dQclr_notBalance"=0,
 "DWaclr_onBalance"=0,"DWrclr_onBalance"=0,
 "DWaclr_notBalance"=0,"DWrclr_notBalance"=0;


ALTER TABLE "WResults" ADD "DWaclr_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWaclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWrclr_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "DWrclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dPclr_OnBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dPclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dQclr_OnBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResults" ADD "dQclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
Commit;
/*
update "WResults" set "Pgy"=COALESCE("Pgy",0),
"Qgy"=COALESCE("Qgy",0)   ;

Commit;     */

update "WResults" set
 "Pgy"=COALESCE("Pgy",0), "Qgy"=COALESCE("Qgy",0),
 "dPclr_OnBalance"=0, "dPclr_notBalance"=0,
 "dQclr_OnBalance"=0, "dQclr_notBalance"=0,
 "DWaclr_onBalance"=0,"DWrclr_onBalance"=0,
 "DWaclr_notBalance"=0,"DWrclr_notBalance"=0;

ALTER TABLE "WResultsA" ADD "DWaclr_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWaclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWrclr_onBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "DWrclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPclr_OnBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dPclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dQclr_OnBalance" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsA" ADD "dQclr_notBalance" DOUBLE_NOT_NULL_ABOVE_0;

Commit;

update "WResultsA" set
 "dPclr_OnBalance"=0, "dPclr_notBalance"=0,
 "dQclr_OnBalance"=0, "dQclr_notBalance"=0,
 "DWaclr_onBalance"=0,"DWrclr_onBalance"=0,
 "DWaclr_notBalance"=0,"DWrclr_notBalance"=0;
commit;

RECONNECT;

Drop PROCEDURE "InsertTransformSS";
Commit;

ALTER TABLE "TransformsSS" ALTER COLUMN "UkHH" TYPE DECIMAL_6_2;


SET TERM ^ ;

create or alter procedure "InsertTransformSS" (
    UNOM decimal(10,2),
    TYPETR varchar(8),
    SNOM decimal(10,2),
    ADDSTR varchar(48),
    UKBH decimal(10,2),
    UKHH decimal(10,2),
    PXX decimal(10,3),
    PKZ decimal(10,3),
    IXX decimal(10,2),
    UNOMB decimal(10,2),
    UNOMH1 decimal(10,2),
    UNOMH2 decimal(10,2),
    NUMBEROTP smallint,
    DELTAUOTP decimal(10,3),
    MANUFACTURER smallint,
    HIDE smallint) 
returns (
    IDENT integer) 
as
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "TransformsSS" ("Ident","Unom","TypeTR","Snom","AddStr",
  "UkBH","UkHH","Pxx","Pkz","Ixx","UnomB","UnomH1","UnomH2",
  "NumberOtp","DeltaUotp","Manufacturer","Hide")
  VALUES (:Ident,:Unom,:TypeTR,:Snom,:AddStr,:UkBH,:UkHH,:Pxx,:Pkz,:Ixx,
    :UnomB,:UnomH1,:UnomH2,:NumberOtp,:DeltaUotp,:Manufacturer,:Hide);
END^
Commit ^
SET TERM ; ^

GRANT INSERT ON "TransformsSS" TO PROCEDURE "InsertTransformSS";

GRANT EXECUTE ON PROCEDURE "InsertTransformSS" TO SYSDBA;
GRANT EXECUTE ON PROCEDURE "InsertTransformSS" TO "rtp3user";

/* Create Primary Key... */

ALTER TABLE "Transforms3" ADD CONSTRAINT "CHK_Transforms3_Pkz" CHECK(("PkzBC"<"PkzBH"+"PkzCH") and ("PkzBH"<"PkzBC"+"PkzCH") and
   ("PkzCH"<"PkzBH"+"PkzBC"));
ALTER TABLE "TransformsA" ADD CONSTRAINT "CHK_TransformsA_Pkz" CHECK(("PkzBC"<"PkzBH"+"PkzCH") and ("PkzBH"<"PkzBC"+"PkzCH") and
   ("PkzCH"<"PkzBH"+"PkzBC"));

/* Alter Procedure... */
/* Alter (InsertCurrentLimitReactorRef) */
SET TERM ^ ;

ALTER PROCEDURE "InsertCurrentLimitReactorRef"(MARKA VARCHAR(32),
SNOM VARCHAR(20),
UNOM DECIMAL(10,2),
INOM DECIMAL(10,2),
DP DECIMAL(10,2),
X DECIMAL(10,4),
ISDOUBLE SMALLINT,
KSV DECIMAL(10,3),
MANUFACTURER SMALLINT,
HIDE SMALLINT)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 Ident=GEN_ID("ReferenceIdent",1);
 INSERT INTO "CurrentLimitReactorsRef"
  ("Ident","Marka","Snom","Unom","Inom","dP","X","isDouble","Ksv","Manufacturer","Hide")
 VALUES (:Ident,:Marka,:Snom,:Unom,:Inom,:dP,:X,:isDouble,:Ksv,:Manufacturer,:Hide);
END
^

/* Alter (RoundUnom) */
ALTER PROCEDURE "RoundUnom"(AUNOM DECIMAL(6,2))
 RETURNS(UNOM DECIMAL(6,2))
 AS
BEGIN
 IF (AUnom<0.1) THEN Unom=0;    ELSE
 IF (AUnom<0.3) THEN Unom=0.22; ELSE
 IF (AUnom<0.5) THEN Unom=0.38; ELSE
 IF (AUnom<1.0) THEN Unom=0.66; ELSE
 IF (AUnom<4.0) THEN Unom=3;    ELSE
 IF (AUnom<8.0) THEN Unom=6;    ELSE
 IF (AUnom<14.5)  THEN Unom=10; ELSE
 IF (AUnom<19)  THEN Unom=15;   ELSE
 IF (AUnom<27)  THEN Unom=20;   ELSE
 IF (AUnom<31)  THEN Unom=27.5; ELSE
 IF (AUnom<50)  THEN Unom=35;   ELSE
 IF (AUnom<80)  THEN Unom=60;   ELSE
 IF (AUnom<130) THEN Unom=110;   ELSE
 IF (AUnom<200) THEN Unom=150;   ELSE
 IF (AUnom<300) THEN Unom=220;   ELSE
 IF (AUnom<400) THEN Unom=330;   ELSE
 IF (AUnom<650) THEN Unom=500;   ELSE
 IF (AUnom<1000) THEN Unom=750;   ELSE
 Unom=1150;
 Suspend;
END
^

/* Create trigger... */

SET TERM ; ^

ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Marka" POSITION 2;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Snom" POSITION 3;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Unom" POSITION 4;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Inom" POSITION 5;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "dP" POSITION 6;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN X POSITION 7;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "isDouble" POSITION 8;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Ksv" POSITION 9;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Manufacturer" POSITION 10;
ALTER TABLE "CurrentLimitReactorsRef" ALTER COLUMN "Hide" POSITION 11;

ALTER TABLE "PResults" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "PResults" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "PResults" ALTER COLUMN "Wa" POSITION 3;
ALTER TABLE "PResults" ALTER COLUMN "Wr" POSITION 4;
ALTER TABLE "PResults" ALTER COLUMN T POSITION 5;
ALTER TABLE "PResults" ALTER COLUMN U POSITION 6;
ALTER TABLE "PResults" ALTER COLUMN "Pgy" POSITION 7;
ALTER TABLE "PResults" ALTER COLUMN "Qgy" POSITION 8;
ALTER TABLE "PResults" ALTER COLUMN "DWal_cu_onBalance" POSITION 9;
ALTER TABLE "PResults" ALTER COLUMN "DWal_cu_notBalance" POSITION 10;
ALTER TABLE "PResults" ALTER COLUMN "DWal_k_onBalance" POSITION 11;
ALTER TABLE "PResults" ALTER COLUMN "DWal_k_notBalance" POSITION 12;
ALTER TABLE "PResults" ALTER COLUMN "DWal_crown_OnBalance" POSITION 13;
ALTER TABLE "PResults" ALTER COLUMN "DWal_crown_notBalance" POSITION 14;
ALTER TABLE "PResults" ALTER COLUMN "DWrl_cu_onBalance" POSITION 15;
ALTER TABLE "PResults" ALTER COLUMN "DWrl_cu_notBalance" POSITION 16;
ALTER TABLE "PResults" ALTER COLUMN "DWcu_onBalance" POSITION 17;
ALTER TABLE "PResults" ALTER COLUMN "DWcu_notBalance" POSITION 18;
ALTER TABLE "PResults" ALTER COLUMN "DWrcu_onBalance" POSITION 19;
ALTER TABLE "PResults" ALTER COLUMN "DWrcu_notBalance" POSITION 20;
ALTER TABLE "PResults" ALTER COLUMN "DWxx_onBalance" POSITION 21;
ALTER TABLE "PResults" ALTER COLUMN "DWxx_notBalance" POSITION 22;
ALTER TABLE "PResults" ALTER COLUMN "DWrxx_onBalance" POSITION 23;
ALTER TABLE "PResults" ALTER COLUMN "DWrxx_notBalance" POSITION 24;
ALTER TABLE "PResults" ALTER COLUMN "DWaclr_onBalance" POSITION 25;
ALTER TABLE "PResults" ALTER COLUMN "DWaclr_notBalance" POSITION 26;
ALTER TABLE "PResults" ALTER COLUMN "DWrclr_onBalance" POSITION 27;
ALTER TABLE "PResults" ALTER COLUMN "DWrclr_notBalance" POSITION 28;
ALTER TABLE "PResults" ALTER COLUMN "Wrc_onBalance" POSITION 29;
ALTER TABLE "PResults" ALTER COLUMN "Wrc_notBalance" POSITION 30;
ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_onBalance" POSITION 31;
ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_notBalance" POSITION 32;
ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_onBalance" POSITION 33;
ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_notBalance" POSITION 34;
ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 35;
ALTER TABLE "PResults" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 36;
ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 37;
ALTER TABLE "PResults" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 38;
ALTER TABLE "PResults" ALTER COLUMN "dPnlin_OnBalance" POSITION 39;
ALTER TABLE "PResults" ALTER COLUMN "dPnlin_notBalance" POSITION 40;
ALTER TABLE "PResults" ALTER COLUMN "dPklin_OnBalance" POSITION 41;
ALTER TABLE "PResults" ALTER COLUMN "dPklin_notBalance" POSITION 42;
ALTER TABLE "PResults" ALTER COLUMN "dPcrown_OnBalance" POSITION 43;
ALTER TABLE "PResults" ALTER COLUMN "dPcrown_notBalance" POSITION 44;
ALTER TABLE "PResults" ALTER COLUMN "dQnlin_OnBalance" POSITION 45;
ALTER TABLE "PResults" ALTER COLUMN "dQnlin_notBalance" POSITION 46;
ALTER TABLE "PResults" ALTER COLUMN "dPntr_OnBalance" POSITION 47;
ALTER TABLE "PResults" ALTER COLUMN "dPntr_notBalance" POSITION 48;
ALTER TABLE "PResults" ALTER COLUMN "dQntr_OnBalance" POSITION 49;
ALTER TABLE "PResults" ALTER COLUMN "dQntr_notBalance" POSITION 50;
ALTER TABLE "PResults" ALTER COLUMN "dPxx_OnBalance" POSITION 51;
ALTER TABLE "PResults" ALTER COLUMN "dPxx_notBalance" POSITION 52;
ALTER TABLE "PResults" ALTER COLUMN "dQxx_OnBalance" POSITION 53;
ALTER TABLE "PResults" ALTER COLUMN "dQxx_notBalance" POSITION 54;
ALTER TABLE "PResults" ALTER COLUMN "dPclr_OnBalance" POSITION 55;
ALTER TABLE "PResults" ALTER COLUMN "dPclr_notBalance" POSITION 56;
ALTER TABLE "PResults" ALTER COLUMN "dQclr_OnBalance" POSITION 57;
ALTER TABLE "PResults" ALTER COLUMN "dQclr_notBalance" POSITION 58;
ALTER TABLE "PResults" ALTER COLUMN "Qc_onBalance" POSITION 59;
ALTER TABLE "PResults" ALTER COLUMN "Qc_notBalance" POSITION 60;
ALTER TABLE "PResults" ALTER COLUMN "Ppotr_OnBalance" POSITION 61;
ALTER TABLE "PResults" ALTER COLUMN "Ppotr_notBalance" POSITION 62;
ALTER TABLE "PResults" ALTER COLUMN "Qpotr_OnBalance" POSITION 63;
ALTER TABLE "PResults" ALTER COLUMN "Qpotr_notBalance" POSITION 64;
ALTER TABLE "PResults" ALTER COLUMN "Ppotr_OnBalance_fact" POSITION 65;
ALTER TABLE "PResults" ALTER COLUMN "Ppotr_notBalance_fact" POSITION 66;
ALTER TABLE "PResults" ALTER COLUMN "Qpotr_OnBalance_fact" POSITION 67;
ALTER TABLE "PResults" ALTER COLUMN "Qpotr_notBalance_fact" POSITION 68;
ALTER TABLE "PResults" ALTER COLUMN "Kzag_OnBalance" POSITION 69;
ALTER TABLE "PResults" ALTER COLUMN "Kzag_notBalance" POSITION 70;
ALTER TABLE "PResults" ALTER COLUMN "dU" POSITION 71;
ALTER TABLE "PResults" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 72;
ALTER TABLE "PResults" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 73;
ALTER TABLE "PResults" ALTER COLUMN "Ntr_OnBalance" POSITION 74;
ALTER TABLE "PResults" ALTER COLUMN "Ntr_NotBalance" POSITION 75;
ALTER TABLE "PResults" ALTER COLUMN "LsumP_OnBalance" POSITION 76;
ALTER TABLE "PResults" ALTER COLUMN "LsumP_NotBalance" POSITION 77;
ALTER TABLE "PResults" ALTER COLUMN "LsumC_OnBalance" POSITION 78;
ALTER TABLE "PResults" ALTER COLUMN "LsumC_NotBalance" POSITION 79;
ALTER TABLE "PResults" ALTER COLUMN "NLineP_OnBalance" POSITION 80;
ALTER TABLE "PResults" ALTER COLUMN "NLineP_NotBalance" POSITION 81;
ALTER TABLE "PResults" ALTER COLUMN "NLineC_OnBalance" POSITION 82;
ALTER TABLE "PResults" ALTER COLUMN "NLineC_NotBalance" POSITION 83;
ALTER TABLE "PResults" ALTER COLUMN "WeatherConditions" POSITION 84;
ALTER TABLE "PResults" ALTER COLUMN "Temperature" POSITION 85;
ALTER TABLE "PResults" ALTER COLUMN "Flags" POSITION 86;
ALTER TABLE "PResults" ALTER COLUMN CRC POSITION 87;

ALTER TABLE "WResults" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "WResults" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "WResults" ALTER COLUMN "Wa" POSITION 3;
ALTER TABLE "WResults" ALTER COLUMN "Wr" POSITION 4;
ALTER TABLE "WResults" ALTER COLUMN T POSITION 5;
ALTER TABLE "WResults" ALTER COLUMN U POSITION 6;
ALTER TABLE "WResults" ALTER COLUMN "Pgy" POSITION 7;
ALTER TABLE "WResults" ALTER COLUMN "Qgy" POSITION 8;
ALTER TABLE "WResults" ALTER COLUMN "Imax" POSITION 9;
ALTER TABLE "WResults" ALTER COLUMN "Kzap" POSITION 10;
ALTER TABLE "WResults" ALTER COLUMN "sqrKfg" POSITION 11;
ALTER TABLE "WResults" ALTER COLUMN "sqrKfgCalc" POSITION 12;
ALTER TABLE "WResults" ALTER COLUMN "DWal_cu_onBalance" POSITION 13;
ALTER TABLE "WResults" ALTER COLUMN "DWal_cu_notBalance" POSITION 14;
ALTER TABLE "WResults" ALTER COLUMN "DWal_k_onBalance" POSITION 15;
ALTER TABLE "WResults" ALTER COLUMN "DWal_k_notBalance" POSITION 16;
ALTER TABLE "WResults" ALTER COLUMN "DWal_crown_OnBalance" POSITION 17;
ALTER TABLE "WResults" ALTER COLUMN "DWal_crown_notBalance" POSITION 18;
ALTER TABLE "WResults" ALTER COLUMN "DWrl_cu_onBalance" POSITION 19;
ALTER TABLE "WResults" ALTER COLUMN "DWrl_cu_notBalance" POSITION 20;
ALTER TABLE "WResults" ALTER COLUMN "DWcu_onBalance" POSITION 21;
ALTER TABLE "WResults" ALTER COLUMN "DWcu_notBalance" POSITION 22;
ALTER TABLE "WResults" ALTER COLUMN "DWrcu_onBalance" POSITION 23;
ALTER TABLE "WResults" ALTER COLUMN "DWrcu_notBalance" POSITION 24;
ALTER TABLE "WResults" ALTER COLUMN "DWxx_onBalance" POSITION 25;
ALTER TABLE "WResults" ALTER COLUMN "DWxx_notBalance" POSITION 26;
ALTER TABLE "WResults" ALTER COLUMN "DWrxx_onBalance" POSITION 27;
ALTER TABLE "WResults" ALTER COLUMN "DWrxx_notBalance" POSITION 28;
ALTER TABLE "WResults" ALTER COLUMN "DWaclr_onBalance" POSITION 29;
ALTER TABLE "WResults" ALTER COLUMN "DWaclr_notBalance" POSITION 30;
ALTER TABLE "WResults" ALTER COLUMN "DWrclr_onBalance" POSITION 31;
ALTER TABLE "WResults" ALTER COLUMN "DWrclr_notBalance" POSITION 32;
ALTER TABLE "WResults" ALTER COLUMN "Wrc_onBalance" POSITION 33;
ALTER TABLE "WResults" ALTER COLUMN "Wrc_notBalance" POSITION 34;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_onBalance" POSITION 35;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_notBalance" POSITION 36;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_onBalance" POSITION 37;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_notBalance" POSITION 38;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 39;
ALTER TABLE "WResults" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 40;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 41;
ALTER TABLE "WResults" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 42;
ALTER TABLE "WResults" ALTER COLUMN "dPnlin_OnBalance" POSITION 43;
ALTER TABLE "WResults" ALTER COLUMN "dPnlin_notBalance" POSITION 44;
ALTER TABLE "WResults" ALTER COLUMN "dPklin_OnBalance" POSITION 45;
ALTER TABLE "WResults" ALTER COLUMN "dPklin_notBalance" POSITION 46;
ALTER TABLE "WResults" ALTER COLUMN "dPcrown_OnBalance" POSITION 47;
ALTER TABLE "WResults" ALTER COLUMN "dPcrown_notBalance" POSITION 48;
ALTER TABLE "WResults" ALTER COLUMN "dQnlin_OnBalance" POSITION 49;
ALTER TABLE "WResults" ALTER COLUMN "dQnlin_notBalance" POSITION 50;
ALTER TABLE "WResults" ALTER COLUMN "dPntr_OnBalance" POSITION 51;
ALTER TABLE "WResults" ALTER COLUMN "dPntr_notBalance" POSITION 52;
ALTER TABLE "WResults" ALTER COLUMN "dQntr_OnBalance" POSITION 53;
ALTER TABLE "WResults" ALTER COLUMN "dQntr_notBalance" POSITION 54;
ALTER TABLE "WResults" ALTER COLUMN "dPxx_OnBalance" POSITION 55;
ALTER TABLE "WResults" ALTER COLUMN "dPxx_notBalance" POSITION 56;
ALTER TABLE "WResults" ALTER COLUMN "dQxx_OnBalance" POSITION 57;
ALTER TABLE "WResults" ALTER COLUMN "dQxx_notBalance" POSITION 58;
ALTER TABLE "WResults" ALTER COLUMN "dPclr_OnBalance" POSITION 59;
ALTER TABLE "WResults" ALTER COLUMN "dPclr_notBalance" POSITION 60;
ALTER TABLE "WResults" ALTER COLUMN "dQclr_OnBalance" POSITION 61;
ALTER TABLE "WResults" ALTER COLUMN "dQclr_notBalance" POSITION 62;
ALTER TABLE "WResults" ALTER COLUMN "Qc_onBalance" POSITION 63;
ALTER TABLE "WResults" ALTER COLUMN "Qc_notBalance" POSITION 64;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_OnBalance" POSITION 65;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_notBalance" POSITION 66;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_OnBalance" POSITION 67;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_notBalance" POSITION 68;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_OnBalance_fact" POSITION 69;
ALTER TABLE "WResults" ALTER COLUMN "Ppotr_notBalance_fact" POSITION 70;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_OnBalance_fact" POSITION 71;
ALTER TABLE "WResults" ALTER COLUMN "Qpotr_notBalance_fact" POSITION 72;
ALTER TABLE "WResults" ALTER COLUMN "Kzag_OnBalance" POSITION 73;
ALTER TABLE "WResults" ALTER COLUMN "Kzag_notBalance" POSITION 74;
ALTER TABLE "WResults" ALTER COLUMN "dU" POSITION 75;
ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 76;
ALTER TABLE "WResults" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 77;
ALTER TABLE "WResults" ALTER COLUMN "Ntr_OnBalance" POSITION 78;
ALTER TABLE "WResults" ALTER COLUMN "Ntr_NotBalance" POSITION 79;
ALTER TABLE "WResults" ALTER COLUMN "LsumP_OnBalance" POSITION 80;
ALTER TABLE "WResults" ALTER COLUMN "LsumP_NotBalance" POSITION 81;
ALTER TABLE "WResults" ALTER COLUMN "LsumC_OnBalance" POSITION 82;
ALTER TABLE "WResults" ALTER COLUMN "LsumC_NotBalance" POSITION 83;
ALTER TABLE "WResults" ALTER COLUMN "NLineP_OnBalance" POSITION 84;
ALTER TABLE "WResults" ALTER COLUMN "NLineP_NotBalance" POSITION 85;
ALTER TABLE "WResults" ALTER COLUMN "NLineC_OnBalance" POSITION 86;
ALTER TABLE "WResults" ALTER COLUMN "NLineC_NotBalance" POSITION 87;
ALTER TABLE "WResults" ALTER COLUMN "NAbonents_OnBalance" POSITION 88;
ALTER TABLE "WResults" ALTER COLUMN "NAbonents_NotBalance" POSITION 89;
ALTER TABLE "WResults" ALTER COLUMN "dWdop" POSITION 90;
ALTER TABLE "WResults" ALTER COLUMN "WeatherConditions" POSITION 91;
ALTER TABLE "WResults" ALTER COLUMN "Temperature" POSITION 92;
ALTER TABLE "WResults" ALTER COLUMN "Flags" POSITION 93;
ALTER TABLE "WResults" ALTER COLUMN CRC POSITION 94;

ALTER TABLE "WResultsA" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "WResultsA" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa" POSITION 3;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr" POSITION 4;
ALTER TABLE "WResultsA" ALTER COLUMN T POSITION 5;
ALTER TABLE "WResultsA" ALTER COLUMN U POSITION 6;
ALTER TABLE "WResultsA" ALTER COLUMN "Pgy" POSITION 7;
ALTER TABLE "WResultsA" ALTER COLUMN "Qgy" POSITION 8;
ALTER TABLE "WResultsA" ALTER COLUMN "Imax" POSITION 9;
ALTER TABLE "WResultsA" ALTER COLUMN "Kzap" POSITION 10;
ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfg" POSITION 11;
ALTER TABLE "WResultsA" ALTER COLUMN "sqrKfgCalc" POSITION 12;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_cu_onBalance" POSITION 13;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_cu_notBalance" POSITION 14;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_k_onBalance" POSITION 15;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_k_notBalance" POSITION 16;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_crown_OnBalance" POSITION 17;
ALTER TABLE "WResultsA" ALTER COLUMN "DWal_crown_notBalance" POSITION 18;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrl_cu_onBalance" POSITION 19;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrl_cu_notBalance" POSITION 20;
ALTER TABLE "WResultsA" ALTER COLUMN "DWcu_onBalance" POSITION 21;
ALTER TABLE "WResultsA" ALTER COLUMN "DWcu_notBalance" POSITION 22;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrcu_onBalance" POSITION 23;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrcu_notBalance" POSITION 24;
ALTER TABLE "WResultsA" ALTER COLUMN "DWxx_onBalance" POSITION 25;
ALTER TABLE "WResultsA" ALTER COLUMN "DWxx_notBalance" POSITION 26;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrxx_onBalance" POSITION 27;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrxx_notBalance" POSITION 28;
ALTER TABLE "WResultsA" ALTER COLUMN "DWaclr_onBalance" POSITION 29;
ALTER TABLE "WResultsA" ALTER COLUMN "DWaclr_notBalance" POSITION 30;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrclr_onBalance" POSITION 31;
ALTER TABLE "WResultsA" ALTER COLUMN "DWrclr_notBalance" POSITION 32;
ALTER TABLE "WResultsA" ALTER COLUMN "Wrc_onBalance" POSITION 33;
ALTER TABLE "WResultsA" ALTER COLUMN "Wrc_notBalance" POSITION 34;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_onBalance" POSITION 35;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_notBalance" POSITION 36;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_onBalance" POSITION 37;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_notBalance" POSITION 38;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_onBalance_fact" POSITION 39;
ALTER TABLE "WResultsA" ALTER COLUMN "Wa_potr_notBalance_fact" POSITION 40;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_onBalance_fact" POSITION 41;
ALTER TABLE "WResultsA" ALTER COLUMN "Wr_potr_notBalance_fact" POSITION 42;
ALTER TABLE "WResultsA" ALTER COLUMN "dPnlin_OnBalance" POSITION 43;
ALTER TABLE "WResultsA" ALTER COLUMN "dPnlin_notBalance" POSITION 44;
ALTER TABLE "WResultsA" ALTER COLUMN "dPklin_OnBalance" POSITION 45;
ALTER TABLE "WResultsA" ALTER COLUMN "dPklin_notBalance" POSITION 46;
ALTER TABLE "WResultsA" ALTER COLUMN "dPcrown_OnBalance" POSITION 47;
ALTER TABLE "WResultsA" ALTER COLUMN "dPcrown_notBalance" POSITION 48;
ALTER TABLE "WResultsA" ALTER COLUMN "dQnlin_OnBalance" POSITION 49;
ALTER TABLE "WResultsA" ALTER COLUMN "dQnlin_notBalance" POSITION 50;
ALTER TABLE "WResultsA" ALTER COLUMN "dPntr_OnBalance" POSITION 51;
ALTER TABLE "WResultsA" ALTER COLUMN "dPntr_notBalance" POSITION 52;
ALTER TABLE "WResultsA" ALTER COLUMN "dQntr_OnBalance" POSITION 53;
ALTER TABLE "WResultsA" ALTER COLUMN "dQntr_notBalance" POSITION 54;
ALTER TABLE "WResultsA" ALTER COLUMN "dPxx_OnBalance" POSITION 55;
ALTER TABLE "WResultsA" ALTER COLUMN "dPxx_notBalance" POSITION 56;
ALTER TABLE "WResultsA" ALTER COLUMN "dQxx_OnBalance" POSITION 57;
ALTER TABLE "WResultsA" ALTER COLUMN "dQxx_notBalance" POSITION 58;
ALTER TABLE "WResultsA" ALTER COLUMN "dPclr_OnBalance" POSITION 59;
ALTER TABLE "WResultsA" ALTER COLUMN "dPclr_notBalance" POSITION 60;
ALTER TABLE "WResultsA" ALTER COLUMN "dQclr_OnBalance" POSITION 61;
ALTER TABLE "WResultsA" ALTER COLUMN "dQclr_notBalance" POSITION 62;
ALTER TABLE "WResultsA" ALTER COLUMN "Qc_onBalance" POSITION 63;
ALTER TABLE "WResultsA" ALTER COLUMN "Qc_notBalance" POSITION 64;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_OnBalance" POSITION 65;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_notBalance" POSITION 66;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_OnBalance" POSITION 67;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_notBalance" POSITION 68;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_OnBalance_fact" POSITION 69;
ALTER TABLE "WResultsA" ALTER COLUMN "Ppotr_notBalance_fact" POSITION 70;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_OnBalance_fact" POSITION 71;
ALTER TABLE "WResultsA" ALTER COLUMN "Qpotr_notBalance_fact" POSITION 72;
ALTER TABLE "WResultsA" ALTER COLUMN "Kzag_OnBalance" POSITION 73;
ALTER TABLE "WResultsA" ALTER COLUMN "Kzag_notBalance" POSITION 74;
ALTER TABLE "WResultsA" ALTER COLUMN "dU" POSITION 75;
ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_OnBalance" POSITION 76;
ALTER TABLE "WResultsA" ALTER COLUMN "Ssum_tr_NotBalance" POSITION 77;
ALTER TABLE "WResultsA" ALTER COLUMN "Ntr_OnBalance" POSITION 78;
ALTER TABLE "WResultsA" ALTER COLUMN "Ntr_NotBalance" POSITION 79;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumP_OnBalance" POSITION 80;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumP_NotBalance" POSITION 81;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumC_OnBalance" POSITION 82;
ALTER TABLE "WResultsA" ALTER COLUMN "LsumC_NotBalance" POSITION 83;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineP_OnBalance" POSITION 84;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineP_NotBalance" POSITION 85;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineC_OnBalance" POSITION 86;
ALTER TABLE "WResultsA" ALTER COLUMN "NLineC_NotBalance" POSITION 87;
ALTER TABLE "WResultsA" ALTER COLUMN "NAbonents_OnBalance" POSITION 88;
ALTER TABLE "WResultsA" ALTER COLUMN "NAbonents_NotBalance" POSITION 89;
ALTER TABLE "WResultsA" ALTER COLUMN "dWdop" POSITION 90;
ALTER TABLE "WResultsA" ALTER COLUMN "WeatherConditions" POSITION 91;
ALTER TABLE "WResultsA" ALTER COLUMN "Temperature" POSITION 92;
ALTER TABLE "WResultsA" ALTER COLUMN "Flags" POSITION 93;
ALTER TABLE "WResultsA" ALTER COLUMN CRC POSITION 94;

COMMIT ;

SET TERM ^ ;

CREATE GENERATOR "CN_Areas2Ident"^

CREATE GENERATOR "CN_AreasIdent"^

CREATE GENERATOR LOADGRAFSGEN^


COMMIT ^





COMMIT ^

SET TERM ; ^

CREATE TABLE "CN_Areas" (
       "Ident" "TIntegerIdent" /*Integer NOT NULL*/ NOT NULL,
       "Name" "AName" /*Varchar(84) */,
       "BaseShema" "TIntegerIdent" /*Integer NOT NULL*/,
       "RastrIdent" "TIntegerIdent",
       "TargetPES" Integer,
       CONSTRAINT "PK_CN_Areas" PRIMARY KEY ("Ident")
);



CREATE TABLE "CN_Areas2" (
       "Ident" "TIntegerIdent" NOT NULL,
       "Name" Varchar(84) NOT NULL,
       "BaseShema" "TIntegerIdent" NOT NULL,
       "RastrIdent" "TIntegerIdent",
       CONSTRAINT "PK_CN_Areas2_1" PRIMARY KEY ("Ident")
);



CREATE TABLE "CN_BaseShemas" (
       GUID "TIntegerIdent",
       "Name" "AName" COLLATE PXW_CYRL,
       "NodesCount" "TIntegerIdent",
       "LinesCount" "TIntegerIdent",
       "AreasCount" "TIntegerIdent",
       "OwnerGUID" "TIntegerIdent",
       CONSTRAINT "PK_CN_BaseShemas" PRIMARY KEY (GUID)
);



CREATE TABLE "CN_CalcList" (
       GUID "TIntegerIdent",
       "Name" "AName" COLLATE PXW_CYRL,
       "SampleIdent" "TIntegerIdent",
       CALCTYPE "TIdent",    /* 
0-   
1 -  */
       "Tau" DECIMAL_7_3,
       "Tmax" DECIMAL_7_3,
       "klow" DECIMAL_5_3,
       CONSTRAINT "PK_CN_CalcList" PRIMARY KEY (GUID)
);



CREATE TABLE "CN_DayResults" (
       "RegimDate" "TSampleDate" NOT NULL,
       "CalcFlag" Smallint NOT NULL,
       "Area" "TIntegerIdent",
       "Unom" DECIMAL_6_2_NOT_NULL NOT NULL,
       "Wgen" NUMBER_11_3,
       "Wqgen" NUMBER_11_3,
       "Wload" NUMBER_11_3,
       "Wqload" NUMBER_11_3,
       "dWlines" NUMBER_11_3,
       "dWqlines" NUMBER_11_3,
       "dWtr" NUMBER_11_3,
       "dWqtr" NUMBER_11_3,
       "dWcrown" NUMBER_11_3,
       "dWisol" NUMBER_11_3,
       "dWXX" NUMBER_11_3,
       CONSTRAINT "PK_CN_DayResults" PRIMARY KEY ("RegimDate","CalcFlag","Area","Unom")
);



CREATE TABLE "CN_LineStates" (
       GUID "TIntegerIdent",
       "State" "TIdent",
       "SampleDate" "TSampleDate" NOT NULL,
       "ktr" DECIMAL_6_3_NOT_NULL DEFAULT 1
);



CREATE TABLE "CN_Lines" (
       "OwnerGUID" "TIntegerIdent" /*Integer NOT NULL*/,
       GUID "TIntegerIdent" /*Integer NOT NULL*/,
       "Node1" "TIntegerIdent" /*Integer NOT NULL*/,
       "Node2" "TIntegerIdent" /*Integer NOT NULL*/,
       "Area" "TIntegerIdent",
       "State" Smallint DEFAULT 0 NOT NULL,
       "ktr_a" DECIMAL_6_3_NOT_NULL /*Decimal(6,3) NOT NULL*/,
       "ktr_r" DECIMAL_6_3_NOT_NULL /*Decimal(6,3) NOT NULL*/,
       "nParallel" Integer DEFAULT 0 NOT NULL,
       R DECIMAL_6_3 /*Decimal(6,3) */,
       X NUMBER_6_3 /*NUMBER(6,3) */,
       B Float,
       G Float,
       "kdp" DECIMAL_5_3 /*Decimal(5,3) */,
       "kdp2" DECIMAL_5_3 /*Decimal(5,3) */,
       "Area2" Integer,
       CONSTRAINT "PK_CN_Lines" PRIMARY KEY (GUID)
);



CREATE TABLE "CN_LoadGraphs" (
       GUID "TIntegerIdent" NOT NULL,
       "Graph" "TIntegerIdent",
       "GraphDate" "TSampleDate",
       "Period" "TIdent",
       CONSTRAINT PK_CN_LOADGRAPHS PRIMARY KEY (GUID,"GraphDate","Period")
);



CREATE TABLE "CN_NamedLines" (
       GUID "TIntegerIdent",
       "Provod" "TIntegerIdent",
       L Float NOT NULL,
       "Info" Varchar(50),
       "Basement" Smallint,
       F Integer,
       "nparallel" Smallint,
       CONSTRAINT "PK_NamedLines" PRIMARY KEY (GUID)
);



CREATE TABLE "CN_NamedTransfors" (
       GUID "TIntegerIdent",
       "Transfor" Integer,
       "dPxx" DECIMAL_10_3,
       CONSTRAINT "PK_NamedTransfors" PRIMARY KEY (GUID)
);



CREATE TABLE "CN_Nodes" (
       "OwnerGUID" "TIntegerIdent" /*Integer NOT NULL*/,
       GUID "TIntegerIdent" /*Integer NOT NULL*/,
       "RastrIdent" Integer NOT NULL,
       "Name" "AName" /*Varchar(84) */,
       "Area" Integer NOT NULL,
       "Unom" DECIMAL_6_2_NOT_NULL /*Decimal(6,2) NOT NULL*/,
       "NodeType" Smallint,
       "State" "TIdent",
       "Bshunt" Float,
       "Gshunt" Float,
       "Umin" DECIMAL_6_3 /*Decimal(6,3) */,
       "Umax" DECIMAL_6_3 /*Decimal(6,3) */,
       "Qmin" NUMBER_11_3_NOT_NULL /*Decimal(11,3) NOT NULL*/,
       "Qmax" NUMBER_11_3_NOT_NULL /*Decimal(11,3) NOT NULL*/,
       "Area2" Integer,
       CONSTRAINT "PK_CN_Nodes" PRIMARY KEY (GUID)
);



CREATE TABLE "CN_PeriodResults" (
       "OwnerGUID" "TIntegerIdent",
       "CalcFlag" "TIdent",
       "Area" "TIntegerIdent",
       "Unom" DECIMAL_6_2_NOT_NULL,
       "Wgen" NUMBER_11_3,
       "Wqgen" NUMBER_11_3,
       "Wload" DECIMAL_11_3,
       "Wqload" DECIMAL_11_3,
       "dWlines" DECIMAL_11_3,
       "dWqlines" DECIMAL_11_3,
       "dWtr" DECIMAL_11_3,
       "dWqtr" DECIMAL_11_3,
       "dWcrown" DECIMAL_11_3,
       "dWisol" DECIMAL_11_3,
       "dWXX" DECIMAL_11_3,
       CONSTRAINT "PK_CN_PeriodResults" PRIMARY KEY ("OwnerGUID","CalcFlag","Area","Unom")
);



CREATE TABLE "CN_Regims" (
       "DateTime" "TSampleDate" /*TIMESTAMP NOT NULL*/ NOT NULL,
       "Info" "AName" /*Varchar(84) */,
       "BaseGUID" "TIntegerIdent" /*Integer NOT NULL*/,
       "Pgen" DECIMAL_9_4 /*Decimal(9,4) */,
       "Pload" DECIMAL_9_4 /*Decimal(9,4) */,
       "dP" DECIMAL_9_4 /*Decimal(9,4) */,
       "tau" DECIMAL_7_3 /*Decimal(7,3) */,
       "Tmax" DECIMAL_7_3 /*Decimal(7,3) */,
       "OwnerGUID" "TIntegerIdent" /*Integer NOT NULL*/ NOT NULL,
       CONSTRAINT "PK_CN_Regims" PRIMARY KEY ("BaseGUID","DateTime")
);



CREATE TABLE "CN_Results" (
       "OwnerGUID" "TIntegerIdent",
       "SampleDate" "TSampleDate",
       U1 NUMBER_9_5,
       U2 NUMBER_9_5,
       P1 NUMBER_11_6,
       Q1 NUMBER_11_6,
       P2 NUMBER_11_6,
       Q2 NUMBER_11_6,
       "delta1" NUMBER_6_3,
       "delta2" NUMBER_6_3,
       "Pshunt" NUMBER_11_6,
       "Qshunt" NUMBER_11_6,
       CONSTRAINT "PK_CN_Results" PRIMARY KEY ("OwnerGUID","SampleDate")
);



CREATE TABLE "CN_Samples" (
       GUID "TIntegerIdent",
       "SampleDate" "TSampleDate",
       "Pg" NUMBER_11_6,
       "Qg" NUMBER_11_6,
       "Pn" NUMBER_11_6,
       "Qn" NUMBER_11_6,
       "Uz" DECIMAL_9_4,
       "Pshunt" NUMBER_11_6,
       "Qshunt" NUMBER_11_6,
       CONSTRAINT "PK_CN_Samples" PRIMARY KEY (GUID,"SampleDate")
);



CREATE TABLE "LoadGraphs" (
       GUID "TIntegerIdent",
       "Name" "AName",
       "Unom" DECIMAL_6_2,
       "Type" "TIntegerIdent",
       "Kz" DECIMAL_5_4,
       "Kfg2" DECIMAL_5_4,
       "StartDate" TIMESTAMP,
       "Named" "YesNo",
       "DateConnected" "YesNo",
       CONSTRAINT "PK_LoadGraphs_1" PRIMARY KEY (GUID)
);



CREATE TABLE "LoadGraphs_Data" (
       "Owner" "TIntegerIdent",
       "Step" "TIdent",
       P NUMBER_10_3,
       Q NUMBER_10_3,
       CONSTRAINT PK_LOADGRAPHS_DATA PRIMARY KEY ("Owner","Step")
);



CREATE TABLE "LoadGraphs_Types" (
       "Ident" "TIntegerIdent",
       "Name" "AName",
       "Interval" DECIMAL_11_3,
       "Count" "TIdent",
       CONSTRAINT "PK_LoadGraphs_Types_1" PRIMARY KEY ("Ident")
);



ALTER TABLE "CN_Areas" ADD CONSTRAINT "FK_CN_Areas_1" FOREIGN KEY ("BaseShema") REFERENCES "CN_BaseShemas"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;


ALTER TABLE "CN_BaseShemas" ADD CONSTRAINT "FK_CN_BaseShemas_2" FOREIGN KEY ("OwnerGUID") REFERENCES "CN_CalcList"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "CN_CalcList" ADD CONSTRAINT "FK_CN_CalcList_2" FOREIGN KEY ("SampleIdent") REFERENCES "SamplesDates"("Ident") ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "CN_DayResults" ADD CONSTRAINT "FK_CN_DayResults_1" FOREIGN KEY ("Area") REFERENCES "CN_Areas"("Ident") ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "CN_LineStates" ADD CONSTRAINT "FK_CN_LineStates_1" FOREIGN KEY (GUID) REFERENCES "CN_Lines"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "CN_Lines" ADD CONSTRAINT "FK_CN_Lines_1" FOREIGN KEY ("OwnerGUID") REFERENCES "CN_BaseShemas"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "CN_Lines" ADD CONSTRAINT "FK_CN_Lines_2" FOREIGN KEY ("Node1") REFERENCES "CN_Nodes"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "CN_Lines" ADD CONSTRAINT "FK_CN_Lines_3" FOREIGN KEY ("Node2") REFERENCES "CN_Nodes"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "CN_LoadGraphs" ADD CONSTRAINT "FK_CN_LoadGraphs_1" FOREIGN KEY (GUID) REFERENCES "CN_CalcList"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "CN_LoadGraphs" ADD CONSTRAINT "FK_CN_LoadGraphs_2" FOREIGN KEY ("Graph") REFERENCES "LoadGraphs"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "CN_NamedLines" ADD CONSTRAINT "FK_NamedLines_1" FOREIGN KEY (GUID) REFERENCES "CN_Lines"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;


ALTER TABLE "CN_Nodes" ADD CONSTRAINT "FK_CN_Nodes_2" FOREIGN KEY ("OwnerGUID") REFERENCES "CN_BaseShemas"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "CN_PeriodResults" ADD CONSTRAINT "FK_CN_PeriodResults_1" FOREIGN KEY ("OwnerGUID") REFERENCES "CN_CalcList"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "CN_Regims" ADD CONSTRAINT "FK_CN_Regims_1" FOREIGN KEY ("BaseGUID") REFERENCES "CN_BaseShemas"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "CN_Results" ADD CONSTRAINT "FK_CN_Results_1" FOREIGN KEY ("OwnerGUID") REFERENCES "CN_Lines"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "CN_Samples" ADD CONSTRAINT "FK_CN_Samples_1" FOREIGN KEY (GUID) REFERENCES "CN_Nodes"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "LoadGraphs" ADD CONSTRAINT "FK_LoadGraphs_1" FOREIGN KEY ("Type") REFERENCES "LoadGraphs_Types"("Ident") ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE "LoadGraphs_Data" ADD CONSTRAINT FK_LOADGRAPHS_DATA_1 FOREIGN KEY ("Owner") REFERENCES "LoadGraphs"(GUID) ON UPDATE CASCADE ON DELETE CASCADE;

INSERT INTO "LoadGraphs_Types" ("Ident", "Name", "Interval", "Count") VALUES (1, ' (365 )', 2000, 8760);
INSERT INTO "LoadGraphs_Types" ("Ident", "Name", "Interval", "Count") VALUES (2, ' (366 )', 2000, 8784);
INSERT INTO "LoadGraphs_Types" ("Ident", "Name", "Interval", "Count") VALUES (3, '', 1440, 168);
INSERT INTO "LoadGraphs_Types" ("Ident", "Name", "Interval", "Count") VALUES (4, ' (31 )', 1440, 744);
INSERT INTO "LoadGraphs_Types" ("Ident", "Name", "Interval", "Count") VALUES (5, '', 60, 24);
INSERT INTO "LoadGraphs_Types" ("Ident", "Name", "Interval", "Count") VALUES (6, ' (0,5 )', 30, 24);
INSERT INTO "LoadGraphs_Types" ("Ident", "Name", "Interval", "Count") VALUES (7, ' (30 )', 1440, 720);
INSERT INTO "LoadGraphs_Types" ("Ident", "Name", "Interval", "Count") VALUES (8, ' (28 )', 1440, 672);
INSERT INTO "LoadGraphs_Types" ("Ident", "Name", "Interval", "Count") VALUES (9, ' (29 )', 1440, 696);

SET TERM ^ ;

COMMIT ^


CREATE OR ALTER TRIGGER "TR_CN_Lines_BI" FOR "CN_Lines"
ACTIVE BEFORE  INSERT POSITION 0
AS

begin
IF (NEW."GUID" IS NULL OR NEW."GUID"=0) THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 IF (NEW."GUID"<>NEW."OwnerGUID") THEN
  UPDATE "GUID" SET "RELATION_ID"=
   (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='CN_Lines')
 WHERE "GUID"=NEW."GUID";
end^

CREATE OR ALTER TRIGGER "TR_CN_Nodes_BI" FOR "CN_Nodes"
ACTIVE BEFORE  INSERT POSITION 0
AS

begin
IF (NEW."GUID" IS NULL OR NEW."GUID"=0) THEN
  EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES NEW."GUID";
 IF (NEW."GUID"<>NEW."OwnerGUID") THEN
  UPDATE "GUID" SET "RELATION_ID"=
   (SELECT "RDB$RELATION_ID" from "RDB$RELATIONS" where "RDB$RELATION_NAME"='CN_Nodes')
 WHERE "GUID"=NEW."GUID";
end^

CREATE OR ALTER TRIGGER "TR_CN_Regims_BD" FOR "CN_Regims"
ACTIVE BEFORE  DELETE POSITION 0
AS

begin
delete from "CN_Samples" Where
 "SampleDate"=OLD."DateTime" and
 "GUID" in (Select "GUID" from "CN_Nodes" Where "OwnerGUID"=OLD."BaseGUID" ) ;

 delete from "CN_Results" Where
 "SampleDate"=OLD."DateTime" and
 "OwnerGUID" in (Select "GUID" from "CN_Lines" Where "OwnerGUID"=OLD."BaseGUID" ) ;
end^

CREATE OR ALTER TRIGGER "TR_CN_Areas2_BI" FOR "CN_Areas2"
ACTIVE BEFORE  INSERT POSITION 0
AS

begin
IF (NEW."Ident" IS NULL)  THEN
   NEW."Ident"= GEN_ID("CN_Areas2Ident",1);
end^

CREATE OR ALTER TRIGGER "TR_CN_Areas_BI" FOR "CN_Areas"
ACTIVE BEFORE  INSERT POSITION 0
AS

begin
IF (NEW."Ident" IS NULL)  THEN
   NEW."Ident"= GEN_ID("CN_AreasIdent",1);
end^

COMMIT^


SET TERM ; ^

COMMIT;

 UPDATE "Version" SET "Major"=3, "Minor"=0, "Release"=21,"Build"=0, "VersionDate"='NOW';
COMMIT;
