ALTER TABLE "LVFidersB" ALTER COLUMN "Lma" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "Lms" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "Lmm" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23a" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23s" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23m" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1a" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1s" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1m" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1ia" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1is" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1im" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23ia" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23is" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23im" TYPE DOUBLE_ABOVE_0;


ALTER TABLE "LVWResultsB" ADD "Wa_" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResultsB" ADD "deltaWa_" DOUBLE_ABOVE_0;
COMMIT;

update "LVWResultsB" set "deltaWa_"="deltaWa","Wa_"="Wa";

COMMIT;
ALTER TABLE "LVWResultsB" DROP "Wa";
ALTER TABLE "LVWResultsB" DROP "deltaWa";
ALTER TABLE "LVWResultsB" ALTER COLUMN "Wa_" TO "Wa";
ALTER TABLE "LVWResultsB" ALTER COLUMN "deltaWa_" TO "deltaWa";
ALTER TABLE "LVWResultsB" ALTER COLUMN "Lekv" TYPE DOUBLE_ABOVE_0;

CREATE PROCEDURE "InsertUsersInfo"(COMPUTERNAME VARCHAR(20),
COMPUTERUSERNAME VARCHAR(50),
CONNECTEDTIME TIMESTAMP,
DISCONNECTEDTIME TIMESTAMP)
 RETURNS(IDENT INTEGER)
 AS
BEGIN
 EXECUTE PROCEDURE "GetUserIdent" RETURNING_VALUES :Ident;
 IF (ConnectedTime IS NULL) THEN ConnectedTime='NOW';
 INSERT INTO "UsersInfo"
  ("Ident","ComputerName","ComputerUserName","ConnectedTime","DisconnectedTime")
 VALUES (:Ident,:ComputerName,:ComputerUserName,:ConnectedTime,:DisconnectedTime);
END;

ALTER TRIGGER "NodesAfterUpdateTrigger"
AS
DECLARE VARIABLE newReferenceType SMALLINT;
DECLARE VARIABLE oldReferenceType SMALLINT;
BEGIN
 IF (NEW."Transf"<>OLD."Transf") THEN BEGIN
  SELECT "ReferenceType" FROM "References" WHERE "Ident"=NEW."Transf"
  INTO :newReferenceType;
  SELECT "ReferenceType" FROM "References" WHERE "Ident"=OLD."Transf"
  INTO :oldReferenceType;
  IF (newReferenceType<>oldReferenceType) THEN BEGIN
   IF (newReferenceType=0) THEN
    DELETE FROM "LVWResultsB" WHERE "GUID"=OLD."GUID";
   IF (not newReferenceType IN (5,6,7)) THEN
    DELETE FROM "Nodes3" WHERE "GUID_HH"=OLD."GUID";
   ELSE
    IF (not oldReferenceType IN (5,6,7)) THEN
     INSERT INTO "Nodes3" ("GUID_HH") VALUES (NEW."GUID");
  END
 END
END;

ALTER TRIGGER "TransformsSSUpdateTrigger"
AS
DECLARE VARIABLE TransfUnom DECIMAL(6,2) ;
DECLARE VARIABLE TransfUnom2 DECIMAL(6,2) ;
BEGIN
 IF (exists (select * from "Nodes" where "Transf"=OLD."Ident") OR
     exists (select * from "MainsNodes" where "Transf"=OLD."Ident")) THEN
  begin
   IF (OLD."Unom"<>NEW."Unom") THEN EXCEPTION "TransfUnomError2";
   IF (OLD."UnomH1"<>NEW."UnomH1") THEN
    begin
     EXECUTE PROCEDURE "RoundUnom" New."UnomH1" RETURNING_VALUES :TransfUnom;
     EXECUTE PROCEDURE "RoundUnom" OLD."UnomH1" RETURNING_VALUES :TransfUnom2;
     IF (:TransfUnom<>:TransfUnom2) THEN EXCEPTION "TransfUnomError2";
   end
   if (OLD."UnomH2"<>NEW."UnomH2") then
    begin
     EXECUTE PROCEDURE "RoundUnom" New."UnomH2" RETURNING_VALUES :TransfUnom;
     EXECUTE PROCEDURE "RoundUnom" OLD."UnomH2" RETURNING_VALUES :TransfUnom2;
     IF (:TransfUnom<>:TransfUnom2) THEN EXCEPTION "TransfUnomError2";
   end
 end

 IF (OLD."Unom"<>NEW."Unom" or NEW."UnomB"<>OLD."UnomB") THEN
  EXECUTE PROCEDURE "RoundUnom" New."UnomB" RETURNING_VALUES :TransfUnom;
  IF (New."Unom"<>TransfUnom) THEN EXCEPTION "TransfUnomError";
END;

COMMIT;

CREATE PROCEDURE "InsertSamplesDates"(
  Name varchar(50),
  Period smallint,
  SampleDate1 TIMESTAMP,
  SampleDate2 TIMESTAMP,
  Temperature DECIMAL(5,2),
  WeatherConditions INTEGER)
RETURNS (Ident Integer)
AS
BEGIN
  Ident=GEN_ID("SamplesDateIdent",1);
 INSERT INTO "SamplesDates" 
  ("Ident","Name","Period","SampleDate1","SampleDate2","Temperature","WeatherConditions") 
 VALUES (:Ident,:Name,:Period,:SampleDate1,:SampleDate2,:Temperature,:WeatherConditions);
END;


COMMIT;

 UPDATE "Version" SET "Major"=3, "Minor"=0, "Release"=21,"Build"=4, "VersionDate"='NOW';
COMMIT;
