Update Rdb$Fields set Rdb$Null_Flag = 1
where Rdb$Field_Name='DECIMAL_Temperature_NOT_NULL';

CREATE DOMAIN "Name52" AS VARCHAR(52) COLLATE PXW_CYRL;
COMMIT;

ALTER TABLE "LVWSamples" ALTER COLUMN "Wa" TYPE NUMBER_9_3;
ALTER TABLE "WSamples" ALTER COLUMN "Wa" TYPE NUMBER_11_3;
ALTER TABLE "LVWLoads" ALTER COLUMN "Wa" TYPE DECIMAL_11_3;
ALTER TABLE "LVWLoads" ALTER COLUMN "Wr" TYPE NUMBER_11_3;
ALTER TABLE "Owners" ALTER COLUMN "Name" TYPE "Name50_NOT_NULL";
ALTER TABLE "TPType" ALTER COLUMN "Name" TYPE "Name50_NOT_NULL";
ALTER TABLE "WorkLog" ALTER COLUMN "SampleDate" TYPE "Name52";

ALTER TABLE "MeterTypes" DROP DP;
ALTER TABLE "MeterTypes" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "MeterTypes" ALTER COLUMN "Name" POSITION 2;

ALTER TABLE "InitParams" DROP CONSTRAINT "CHK_InitParams_Values";
ALTER TABLE "InitParams" ADD CONSTRAINT "CHK_InitParams_Values" CHECK(("Key"=1) and ("Value" between 0 and 1) or /* smCosFi */
 ("Key"=2 or "Key"=3) and ("Value" between "Param"*0.8 and "Param"*1.2) or /* smUcp, smUdop*/
 ("Key"=4) and ("Value" between 1/13 and 1) or /* smKzap */
 ("Key"=6) and ("Value" between 0.04 and 1) or /* smTau */
 ("Key"=7) and ("Value">0) or /* smCurrentDensityLimit */

 ("Key" in (100,108,109,110,111,121,122,123,124) and "Value" between -2147483647 and 2147483647) or
 /*(smAOEnergoGUID,smVNCalc,smNNCalc,smStLoads,smMetrolog,smAutoSaveFider,smAutoDeleteLog,smAutoBackup */
 ("Key"=101 and "Value" between 1 and 7) or /*smRegionIdent */
 ("Key"=102 and "Value" between 1 and 3) or /* smKdp */
 ("Key" in (103,105,112,113,114,115,125) and ("Value"=0 or "Value"=1)) or
 /* (smUseTemperature,smKuntp,smDotDisableLine,smShowPhases,smSaveResultsConfirmation,smTgDelta,smCheckBackup */
 ("Key"=104 and "Value" between -70 and 70) or /* smTemperature */
 ("Key" in (106,107,116,117,118,119,120) and ("Value" between 0 and 2)  or
 /* smSaveDetailed,smSaveDetailedHH,smShowArrowDirection,smAddEqLevel_InsulatorsLeakage,
    smAddEqLevel_MeteringDevice,smAddEqLevel_Additionals,smAddEqLevel_VARCompensators */
 ("Key"=5 or "Key"=200 or "Key"=201) and ("Value" between -2147483.648 and 2147483.647) /* Colors */));
COMMIT;

ALTER PROCEDURE "InsertFider"("OwnerGUID" INTEGER,"Name" VARCHAR(32))
 RETURNS(GUID INTEGER)
 AS
BEGIN
 EXECUTE PROCEDURE "GetNewGUID" RETURNING_VALUES :"GUID";
 INSERT INTO "Fiders" ("OwnerGUID","GUID","Name")
 VALUES (:"OwnerGUID",:"GUID",:"Name");
END;
COMMIT;

ALTER PROCEDURE "RoundUnom"(AUNOM DECIMAL(6,2))
 RETURNS(UNOM DECIMAL(6,2))
 AS
BEGIN
 IF (AUnom<0.1) THEN Unom=0;    ELSE
 IF (AUnom<0.3) THEN Unom=0.22; ELSE
 IF (AUnom<0.5) THEN Unom=0.38; ELSE
 IF (AUnom<1.0) THEN Unom=0.66; ELSE
 IF (AUnom<4.0) THEN Unom=3;    ELSE
 IF (AUnom<8.0) THEN Unom=6;    ELSE
 IF (AUnom<14.249)  THEN Unom=10; ELSE
 IF (AUnom<18.99)  THEN Unom=15;   ELSE
 IF (AUnom<26.1249)  THEN Unom=20;   ELSE
 IF (AUnom<31)  THEN Unom=27.5; ELSE
 IF (AUnom<50)  THEN Unom=35;   ELSE
 IF (AUnom<80)  THEN Unom=60;   ELSE
 IF (AUnom<130) THEN Unom=110;   ELSE
 IF (AUnom<200) THEN Unom=150;   ELSE
 IF (AUnom<300) THEN Unom=220;   ELSE
 IF (AUnom<400) THEN Unom=330;   ELSE
 IF (AUnom<650) THEN Unom=500;   ELSE
 IF (AUnom<1000) THEN Unom=750;   ELSE
 Unom=1150;
 Suspend;
END;
COMMIT;

ALTER TRIGGER "NodesBeforeUpdateTrigger" 
AS
DECLARE VARIABLE ReferenceType Smallint;
DECLARE VARIABLE MaxPositionOtp Smallint;
DECLARE VARIABLE MaxPositionOtpC Smallint;
BEGIN
 MaxPositionOtp=0;
 IF (NEW."Transf"<>OLD."Transf") THEN
  BEGIN
   IF (OLD."Transf"=-1) THEN
    DELETE FROM "Generators" WHERE "GUID"=OLD."GUID";
   IF (NEW."Transf"<=0) THEN NEW."PositionOtp"=0;
   ELSE
    BEGIN
     SELECT "ReferenceType" FROM "References" WHERE "Ident"=OLD."Transf"
     INTO :ReferenceType;
     IF (ReferenceType IN (6,7)) THEN
      BEGIN
       IF (ReferenceType=6) THEN
        SELECT "NumberOtpB","NumberOtpC" FROM "Transforms3" WHERE "Ident"=NEW."Transf"
        INTO :MaxPositionOtp,:MaxPositionOtpC;  ELSE
       /* IF (ReferenceType=7) THEN */
        SELECT "NumberOtpB","NumberOtpC" FROM "TransformsA" WHERE "Ident"=NEW."Transf"
        INTO :MaxPositionOtp,:MaxPositionOtpC;

       IF ("Mask"(NEW."PositionOtp",127)>MaxPositionOtp)
        THEN NEW."PositionOtp"="Mask"(NEW."PositionOtp",65408)+MaxPositionOtp;
       IF ("Mask"(NEW."PositionOtp"/256,127)>MaxPositionOtpC)
        THEN NEW."PositionOtp"="Mask"(NEW."PositionOtp",-32513)+MaxPositionOtpC*256;
      END
     ELSE
      BEGIN
       IF (ReferenceType=4) THEN
        SELECT "NumberOtp" FROM "Transforms2" WHERE "Ident"=NEW."Transf" INTO :MaxPositionOtp;
       ELSE
        SELECT "NumberOtp" FROM "TransformsSS" WHERE "Ident"=NEW."Transf" INTO :MaxPositionOtp;
       IF (NEW."PositionOtp">MaxPositionOtp) THEN NEW."PositionOtp"=MaxPositionOtp; ELSE
       IF (NEW."PositionOtp"<-MaxPositionOtp) THEN NEW."PositionOtp"=-MaxPositionOtp;
     END
   END
 END
END;
COMMIT;


DROP VIEW "PResults";
DROP VIEW "PResultsPL";
DROP VIEW "PResultsPN";
DROP VIEW "PResultsPN3";
DROP VIEW "PResultsWL";
DROP VIEW "PResultsWN";
DROP VIEW "PResultsWN3";
DROP VIEW "WResults";
DROP VIEW "WResultsA";
DROP VIEW "WResultsPL";
DROP VIEW "WResultsPN";
DROP VIEW "WResultsPN3";
DROP VIEW "WResultsWL";
DROP VIEW "WResultsWN";
DROP VIEW "WResultsWN3";
COMMIT;

ALTER TABLE "PResultsAdd" ADD "Pgen" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResultsAdd" ADD "Qgen" DOUBLE_NOT_NULL;
ALTER TABLE "PResultsAdd" ADD "Ssum_tr_off" DECIMAL_10_3_NOT_NULL;
ALTER TABLE "PResultsAdd" ADD "Ntr_off" "SmallInt0_NOT_NULL";
ALTER TABLE "PResultsAdd" ADD "Psum_motor_off" DECIMAL_10_3_NOT_NULL;
ALTER TABLE "PResultsAdd" ADD "Nmotor_off" "SmallInt0_NOT_NULL";
ALTER TABLE "PResultsAdd" ADD "Ssum_clr_off" DECIMAL_10_3_NOT_NULL;
ALTER TABLE "PResultsAdd" ADD "Nclr_off" "SmallInt0_NOT_NULL";
ALTER TABLE "PResultsAdd" ADD "LsumP_off" DECIMAL_9_3_NOT_NULL;
ALTER TABLE "PResultsAdd" ADD "LsumC_off" DECIMAL_9_3_NOT_NULL;
ALTER TABLE "PResultsAdd" ADD "NLineP_off" "SmallInt0_NOT_NULL";
ALTER TABLE "PResultsAdd" ADD "NLineC_off" "SmallInt0_NOT_NULL";
ALTER TABLE "WResultsAdd" ADD "Wa_gen" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsAdd" ADD "Wr_gen" DOUBLE_NOT_NULL;

DROP PROCEDURE "InsertMVResults" ;
DROP TRIGGER "PResultsAddBeforeUpdate";
DROP TRIGGER "WResultsAddBeforeUpdate";
COMMIT;

update "PResultsAdd" R set 
"Pgen"=(select "Pgy" from "MVResults" where "Ident"=R."Ident"),
"Qgen"=(select "Qgy" from "MVResults" where "Ident"=R."Ident"),
"Ssum_tr_off"=0,"Ntr_off"=0,"Psum_motor_off"=0,"Nmotor_off"=0,
"Ssum_clr_off"=0,"Nclr_off"=0,"LsumP_off"=0,"LsumC_off"=0,
"NLineP_off"=0,"NLineC_off"=0
where "Balance"=0;

update "PResultsAdd" R set 
"Pgen"=0,"Qgen"=0,
"Ssum_tr_off"=0,"Ntr_off"=0,"Psum_motor_off"=0,"Nmotor_off"=0,
"Ssum_clr_off"=0,"Nclr_off"=0,"LsumP_off"=0,"LsumC_off"=0,
"NLineP_off"=0,"NLineC_off"=0
where "Balance"<>0;

update "WResultsAdd" R set 
"Wa_gen"=(select "Wa" from "MVResults" where "Ident"=R."Ident"),
"Wr_gen"=(select "Wr" from "MVResults" where "Ident"=R."Ident")
where "Balance"=0;

update "WResultsAdd" R set "Wa_gen"=0,"Wr_gen"=0
where "Balance"<>0;
COMMIT;

ALTER TABLE "MVResults" DROP "Wa";
ALTER TABLE "MVResults" DROP "Wr";
ALTER TABLE "MVResults" DROP "Pgy";
ALTER TABLE "MVResults" DROP "Qgy";
COMMIT;

ALTER TRIGGER "MVResultsBeforeUpdate"
AS
BEGIN
 IF (NEW."CalcType"<>OLD."CalcType" OR
     NEW."T"<>NEW."T" OR
     NEW."U"<>NEW."U" OR
     NEW."Imax"<>NEW."Imax" OR
     NEW."Kzap"<>NEW."Kzap" OR
     NEW."sqrKfg"<>NEW."sqrKfg" OR
     NEW."sqrKfgCalc"<>NEW."sqrKfgCalc" OR
     NEW."dUmax"<>NEW."dUmax" OR
     NEW."dWdop"<>NEW."dWdop" OR
     NEW."Temperature"<>NEW."Temperature" OR
     NEW."Flags"<>NEW."Flags" OR
     NEW."CRC"<>NEW.crc)
 THEN EXCEPTION "NoRelease";
END;

CREATE PROCEDURE "InsertMVResults" (CalcType smallint,
 SampleIdent integer,GUID integer,
 T double precision,U double precision,Imax double precision,
 Kzap double precision,sqrKfg double precision,sqrKfgCalc double precision,
 dUmax double precision,dWdop double precision,
 WeatherConditions integer,Temperature double precision,
 Flags integer,
 CRC blob sub_type 0 segment size 48)
RETURNS (Ident integer)
AS
BEGIN
 DELETE FROM "MVResults"
 WHERE "CalcType"=:CalcType and "SampleIdent"=:SampleIdent and "GUID"=:GUID;
 Ident=GEN_ID("MVResultsIdent",1);
 INSERT INTO "MVResults" ("Ident","CalcType","SampleIdent","GUID",
  "T","U","Imax","Kzap","sqrKfg","sqrKfgCalc","dUmax","dWdop",
  "WeatherConditions","Temperature","Flags","CRC")
 VALUES (:Ident,:CalcType,:SampleIdent,:GUID,:T,:U,
  :Imax,:Kzap,:sqrKfg,:sqrKfgCalc,:dUmax,:dWdop,
  :WeatherConditions,:Temperature,:Flags,:CRC);
END ;
GRANT EXECUTE ON PROCEDURE "InsertMVResults" TO "rtp3user" ;

ALTER TRIGGER "WorkLogMVResultsDeleteTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(50);
DECLARE VARIABLE AEvent Smallint;
BEGIN
 IF (OLD."GUID"<>0 and
     exists (select * from "Fiders" where "GUID"=OLD."GUID")) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=OLD."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   IF (OLD."CalcType"=0) THEN AEvent=11; ELSE
   IF (OLD."CalcType"=1) THEN AEvent=15; ELSE
   IF (OLD."CalcType"=1) THEN AEvent=7;
   ELSE AEvent=17;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,:AEvent,:ASampleDate);
 END
END ;

ALTER TRIGGER "WorkLogMVResultsInsertTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(50);
DECLARE VARIABLE AEvent Smallint;
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=NEW."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   IF (New."CalcType"=0) THEN AEvent=10; ELSE
   IF (New."CalcType"=1) THEN AEvent=14; ELSE
   IF (New."CalcType"=2) THEN AEvent=6;
   ELSE AEvent=16;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,:AEvent,:ASampleDate);
 END
END ;

CREATE TRIGGER "PResultsAddBeforeUpdate" FOR "PResultsAdd" BEFORE UPDATE
AS
BEGIN
 IF (NEW."Pgen"<>OLD."Pgen" OR
     NEW."Qgen"<>OLD."Qgen" OR
     NEW."dP_line_cu"<>OLD."dP_line_cu" OR
     NEW."dP_line_k"<>OLD."dP_line_k" OR
     NEW."dP_line_crown"<>OLD."dP_line_crown" OR
     NEW."dQ_line_cu"<>OLD."dQ_line_cu" OR
     NEW."dP_tr_cu"<>OLD."dP_tr_cu" OR
     NEW."dQ_tr_cu"<>OLD."dQ_tr_cu" OR
     NEW."dP_tr_xx"<>OLD."dP_tr_xx" OR
     NEW."dQ_tr_xx"<>OLD."dQ_tr_xx" OR
     NEW."dP_clr"<>OLD."dP_clr" OR
     NEW."dQ_clr"<>OLD."dQ_clr" OR
     NEW."Qc"<>OLD."Qc" OR
     NEW."Ptrans"<>OLD."Ptrans" OR
     NEW."Qtrans"<>OLD."Qtrans" OR
     NEW."Pnagr"<>OLD."Pnagr" OR
     NEW."Qnagr"<>OLD."Qnagr" OR
     NEW."Ptrans_fact"<>OLD."Ptrans_fact" OR
     NEW."Qtrans_fact"<>OLD."Qtrans_fact" OR
     NEW."Pnagr_fact"<>OLD."Pnagr_fact" OR
     NEW."Qnagr_fact"<>OLD."Qnagr_fact" OR
     NEW."Kzagr"<>OLD."Kzagr" OR
     NEW."Ssum_tr"<>OLD."Ssum_tr" OR
     NEW."Ntr"<>OLD."Ntr" OR
     NEW."Psum_motor"<>OLD."Psum_motor" OR
     NEW."Nmotor"<>OLD."Nmotor" OR
     NEW."Ssum_clr"<>OLD."Ssum_clr" OR
     NEW."Nclr"<>OLD."Nclr" OR
     NEW."LsumP"<>OLD."LsumP" OR
     NEW."LsumC"<>OLD."LsumC" OR
     NEW."NLineP"<>OLD."NLineP" OR
     NEW."NLineC"<>OLD."NLineC" OR
     NEW."NAbonents"<>OLD."NAbonents" OR
     NEW."Ssum_tr_off"<>OLD."Ssum_tr_off" OR
     NEW."Ntr_off"<>OLD."Ntr_off" OR
     NEW."Psum_motor_off"<>OLD."Psum_motor_off" OR
     NEW."Nmotor_off"<>OLD."Nmotor_off" OR
     NEW."Ssum_clr_off"<>OLD."Ssum_clr_off" OR
     NEW."Nclr_off"<>OLD."Nclr_off" OR
     NEW."LsumP_off"<>OLD."LsumP_off" OR
     NEW."LsumC_off"<>OLD."LsumC_off" OR
     NEW."NLineP_off"<>OLD."NLineP_off" OR
     NEW."NLineC_off"<>OLD."NLineC_off" OR
     NEW."Balance"<>OLD."Balance")
 THEN EXCEPTION "NoRelease";
END;

CREATE TRIGGER "WResultsAddBeforeUpdate" FOR "WResultsAdd" BEFORE UPDATE
AS
BEGIN
 IF (NEW."Wa_gen"<>OLD."Wa_gen" OR
     NEW."Wr_gen"<>OLD."Wr_gen" OR
     NEW."DWa_line_cu"<>OLD."DWa_line_cu" OR
     NEW."DWa_line_k"<>OLD."DWa_line_k" OR
     NEW."DWa_line_crown"<>OLD."DWa_line_crown" OR
     NEW."DWr_line_cu"<>OLD."DWr_line_cu" OR
     NEW."DWa_tr_cu"<>OLD."DWa_tr_cu" OR
     NEW."DWr_tr_cu"<>OLD."DWr_tr_cu" OR
     NEW."DWa_tr_xx"<>OLD."DWa_tr_xx" OR
     NEW."DWr_tr_xx"<>OLD."DWr_tr_xx" OR
     NEW."DWa_clr"<>OLD."DWa_clr" OR
     NEW."DWr_clr"<>OLD."DWr_clr" OR
     NEW."Wrc"<>OLD."Wrc" OR
     NEW."Wa_trans"<>OLD."Wa_trans" OR
     NEW."Wr_trans"<>OLD."Wr_trans" OR
     NEW."Wa_potr"<>OLD."Wa_potr" OR
     NEW."Wr_potr"<>OLD."Wr_potr" OR
     NEW."Wa_trans_fact"<>OLD."Wa_trans_fact" OR
     NEW."Wr_trans_fact"<>OLD."Wr_trans_fact" OR
     NEW."Wa_potr_fact"<>OLD."Wa_potr_fact" OR
     NEW."Wr_potr_fact"<>OLD."Wr_potr_fact" OR
     NEW."Balance"<>OLD."Balance")
 THEN EXCEPTION "NoRelease";
END;

CREATE TABLE "Transformation" ("Ident"  "TIntegerIdent",
  "Unom" "DECIMAL_6_2_NOT_NULL","Wa" "DOUBLE_NOT_NULL_ABOVE_0",
  "Ssum_tr" "DECIMAL_10_3_NOT_NULL","Ntr" "SmallInt0_NOT_NULL",
 CONSTRAINT "PK_Transformation" PRIMARY KEY ("Ident", "Unom"),
 CONSTRAINT "FK_TransformationIdent" FOREIGN KEY ("Ident")
  REFERENCES "MVResults" ("Ident") ON DELETE CASCADE ON UPDATE CASCADE,
 CONSTRAINT "FK_TransformationUnom" FOREIGN KEY ("Unom")
  REFERENCES "Unom" ("Unom"));
GRANT ALL ON "Transformation" TO "rtp3user" ;

CREATE TRIGGER "TransformationBeforeUpdate" FOR "Transformation" BEFORE UPDATE
AS
BEGIN
 IF (NEW."Wa"<>OLD."Wa" OR
     NEW."Ssum_tr"<>OLD."Ssum_tr" OR
     NEW."Ntr"<>OLD."Ntr" OR
     NEW."Unom"<>OLD."Unom")
 THEN EXCEPTION "NoRelease";
END;

CREATE TABLE "ChainLength" ("Ident" "TIntegerIdent","Balance" "TIdent",
 "LsumP" "DECIMAL_9_3_NOT_NULL","LsumC" "DECIMAL_9_3_NOT_NULL",
 "NLineP" "SmallInt0_NOT_NULL","NLineC" "SmallInt0_NOT_NULL",
 "LsumP_off" DECIMAL_9_3_NOT_NULL,"LsumC_off" DECIMAL_9_3_NOT_NULL,
 "NLineP_off" "SmallInt0_NOT_NULL","NLineC_off" "SmallInt0_NOT_NULL",
CONSTRAINT "PK_ChainLength" PRIMARY KEY ("Ident", "Balance"),
CONSTRAINT "FK_ChainLengthMVResults" FOREIGN KEY ("Ident")
 REFERENCES "MVResults" ("Ident") ON DELETE CASCADE ON UPDATE CASCADE,
CONSTRAINT "FK_ChainLengthBalance" FOREIGN KEY ("Balance")
 REFERENCES "Owners" ("Ident"));
GRANT ALL ON "ChainLength" TO "rtp3user" ;

CREATE TRIGGER "ChainLengthBeforeUpdate" FOR "ChainLength" BEFORE UPDATE
AS
BEGIN
 IF (NEW."LsumP"<>OLD."LsumP" OR
     NEW."LsumC"<>OLD."LsumC" OR
     NEW."NLineP"<>OLD."NLineP" OR
     NEW."NLineC"<>OLD."NLineC" OR
     NEW."LsumP_off"<>OLD."LsumP_off" OR
     NEW."LsumC_off"<>OLD."LsumC_off" OR
     NEW."NLineP_off"<>OLD."NLineP_off" OR
     NEW."NLineC_off"<>OLD."NLineC_off" OR
     NEW."Balance"<>OLD."Balance")
 THEN EXCEPTION "NoRelease";
END;
COMMIT;

ALTER TABLE "PResultsAdd" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Balance" POSITION 2;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Pgen" POSITION 3;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Qgen" POSITION 4;
ALTER TABLE "PResultsAdd" ALTER COLUMN "dP_line_cu" POSITION 5;
ALTER TABLE "PResultsAdd" ALTER COLUMN "dP_line_k" POSITION 6;
ALTER TABLE "PResultsAdd" ALTER COLUMN "dP_line_crown" POSITION 7;
ALTER TABLE "PResultsAdd" ALTER COLUMN "dQ_line_cu" POSITION 8;
ALTER TABLE "PResultsAdd" ALTER COLUMN "dP_tr_cu" POSITION 9;
ALTER TABLE "PResultsAdd" ALTER COLUMN "dQ_tr_cu" POSITION 10;
ALTER TABLE "PResultsAdd" ALTER COLUMN "dP_tr_xx" POSITION 11;
ALTER TABLE "PResultsAdd" ALTER COLUMN "dQ_tr_xx" POSITION 12;
ALTER TABLE "PResultsAdd" ALTER COLUMN "dP_clr" POSITION 13;
ALTER TABLE "PResultsAdd" ALTER COLUMN "dQ_clr" POSITION 14;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Qc" POSITION 15;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Ptrans" POSITION 16;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Qtrans" POSITION 17;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Pnagr" POSITION 18;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Qnagr" POSITION 19;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Ptrans_fact" POSITION 20;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Qtrans_fact" POSITION 21;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Pnagr_fact" POSITION 22;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Qnagr_fact" POSITION 23;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Kzagr" POSITION 24;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Ssum_tr" POSITION 25;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Ntr" POSITION 26;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Psum_motor" POSITION 27;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Nmotor" POSITION 28;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Ssum_clr" POSITION 29;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Nclr" POSITION 30;
ALTER TABLE "PResultsAdd" ALTER COLUMN "LsumP" POSITION 31;
ALTER TABLE "PResultsAdd" ALTER COLUMN "LsumC" POSITION 32;
ALTER TABLE "PResultsAdd" ALTER COLUMN "NLineP" POSITION 33;
ALTER TABLE "PResultsAdd" ALTER COLUMN "NLineC" POSITION 34;
ALTER TABLE "PResultsAdd" ALTER COLUMN "NAbonents" POSITION 35;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Ssum_tr_off" POSITION 36;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Ntr_off" POSITION 37;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Psum_motor_off" POSITION 38;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Nmotor_off" POSITION 39;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Ssum_clr_off" POSITION 40;
ALTER TABLE "PResultsAdd" ALTER COLUMN "Nclr_off" POSITION 41;
ALTER TABLE "PResultsAdd" ALTER COLUMN "LsumP_off" POSITION 42;
ALTER TABLE "PResultsAdd" ALTER COLUMN "LsumC_off" POSITION 43;
ALTER TABLE "PResultsAdd" ALTER COLUMN "NLineP_off" POSITION 44;
ALTER TABLE "PResultsAdd" ALTER COLUMN "NLineC_off" POSITION 45;

ALTER TABLE "WResultsAdd" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Balance" POSITION 2;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wa_gen" POSITION 3;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wr_gen" POSITION 4;
ALTER TABLE "WResultsAdd" ALTER COLUMN "DWa_line_cu" POSITION 5;
ALTER TABLE "WResultsAdd" ALTER COLUMN "DWa_line_k" POSITION 6;
ALTER TABLE "WResultsAdd" ALTER COLUMN "DWa_line_crown" POSITION 7;
ALTER TABLE "WResultsAdd" ALTER COLUMN "DWr_line_cu" POSITION 8;
ALTER TABLE "WResultsAdd" ALTER COLUMN "DWa_tr_cu" POSITION 9;
ALTER TABLE "WResultsAdd" ALTER COLUMN "DWr_tr_cu" POSITION 10;
ALTER TABLE "WResultsAdd" ALTER COLUMN "DWa_tr_xx" POSITION 11;
ALTER TABLE "WResultsAdd" ALTER COLUMN "DWr_tr_xx" POSITION 12;
ALTER TABLE "WResultsAdd" ALTER COLUMN "DWa_clr" POSITION 13;
ALTER TABLE "WResultsAdd" ALTER COLUMN "DWr_clr" POSITION 14;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wrc" POSITION 15;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wa_trans" POSITION 16;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wr_trans" POSITION 17;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wa_potr" POSITION 18;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wr_potr" POSITION 19;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wa_trans_fact" POSITION 20;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wr_trans_fact" POSITION 21;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wa_potr_fact" POSITION 22;
ALTER TABLE "WResultsAdd" ALTER COLUMN "Wr_potr_fact" POSITION 23;
COMMIT;

/******************************************************************************/

ALTER TABLE "PResultsLCAdd" ADD "Pgen" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "PResultsLCAdd" ADD "Qgen" DOUBLE_NOT_NULL;
ALTER TABLE "PResultsLCAdd" ADD "Ssum_tr_off" DECIMAL_10_3_NOT_NULL;
ALTER TABLE "PResultsLCAdd" ADD "Ntr_off" "SmallInt0_NOT_NULL";
ALTER TABLE "PResultsLCAdd" ADD "Psum_motor_off" DECIMAL_10_3_NOT_NULL;
ALTER TABLE "PResultsLCAdd" ADD "Nmotor_off" "SmallInt0_NOT_NULL";
ALTER TABLE "PResultsLCAdd" ADD "Ssum_clr_off" DECIMAL_10_3_NOT_NULL;
ALTER TABLE "PResultsLCAdd" ADD "Nclr_off" "SmallInt0_NOT_NULL";
ALTER TABLE "PResultsLCAdd" ADD "LsumP_off" DECIMAL_9_3_NOT_NULL;
ALTER TABLE "PResultsLCAdd" ADD "LsumC_off" DECIMAL_9_3_NOT_NULL;
ALTER TABLE "PResultsLCAdd" ADD "NLineP_off" "SmallInt0_NOT_NULL";
ALTER TABLE "PResultsLCAdd" ADD "NLineC_off" "SmallInt0_NOT_NULL";
ALTER TABLE "WResultsLCAdd" ADD "Wa_gen" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "WResultsLCAdd" ADD "Wr_gen" DOUBLE_NOT_NULL;
ALTER TABLE "WResultsLCAdd" ADD "Ssum_tr_off" DECIMAL_10_3_NOT_NULL;
ALTER TABLE "WResultsLCAdd" ADD "Ntr_off" "SmallInt0_NOT_NULL";
ALTER TABLE "WResultsLCAdd" ADD "Psum_motor_off" DECIMAL_10_3_NOT_NULL;
ALTER TABLE "WResultsLCAdd" ADD "Nmotor_off" "SmallInt0_NOT_NULL";
ALTER TABLE "WResultsLCAdd" ADD "Nclr_off" "SmallInt0_NOT_NULL";
ALTER TABLE "WResultsLCAdd" ADD "Ssum_clr_off" DECIMAL_10_3_NOT_NULL;
ALTER TABLE "WResultsLCAdd" ADD "LsumC_off" DECIMAL_9_3_NOT_NULL;
ALTER TABLE "WResultsLCAdd" ADD "LsumP_off" DECIMAL_9_3_NOT_NULL;
ALTER TABLE "WResultsLCAdd" ADD "NLineP_off" "SmallInt0_NOT_NULL";
ALTER TABLE "WResultsLCAdd" ADD "NLineC_off" "SmallInt0_NOT_NULL";

DROP PROCEDURE "InsertPResultsLC" ;
DROP PROCEDURE "InsertWResultsLC" ;
DROP TRIGGER "PResultsLCBeforeUpdate";
DROP TRIGGER "PResultsLCAddBeforeUpdate";
DROP TRIGGER "WResultsLCBeforeUpdate";
DROP TRIGGER "WResultsLCAddBeforeUpdate";
COMMIT;

update "PResultsLCAdd" R set
"Pgen"=(select "P" from "PResultsLC" where "Ident"=R."Ident"),
"Qgen"=(select "Q" from "PResultsLC" where "Ident"=R."Ident"),
"Ssum_tr_off"=0,"Ntr_off"=0,"Psum_motor_off"=0,"Nmotor_off"=0,
"Ssum_clr_off"=0,"Nclr_off"=0,"LsumP_off"=0,"LsumC_off"=0,
"NLineP_off"=0,"NLineC_off"=0
where "Balance"=0;

update "PResultsLCAdd" R set
"Pgen"=0,"Qgen"=0,
"Ssum_tr_off"=0,"Ntr_off"=0,"Psum_motor_off"=0,"Nmotor_off"=0,
"Ssum_clr_off"=0,"Nclr_off"=0,"LsumP_off"=0,"LsumC_off"=0,
"NLineP_off"=0,"NLineC_off"=0
where "Balance"<>0;

update "WResultsLCAdd" R set 
"Wa_gen"=(select "Wa" from "WResultsLC" where "Ident"=R."Ident"),
"Wr_gen"=(select "Wr" from "WResultsLC" where "Ident"=R."Ident"),
"Ssum_tr_off"=0,"Ntr_off"=0,"Psum_motor_off"=0,"Nmotor_off"=0,
"Ssum_clr_off"=0,"Nclr_off"=0,"LsumP_off"=0,"LsumC_off"=0,
"NLineP_off"=0,"NLineC_off"=0
where "Balance"=0;

update "WResultsLCAdd" R set 
"Wa_gen"=0,"Wr_gen"=0,
"Ssum_tr_off"=0,"Ntr_off"=0,"Psum_motor_off"=0,"Nmotor_off"=0,
"Ssum_clr_off"=0,"Nclr_off"=0,"LsumP_off"=0,"LsumC_off"=0,
"NLineP_off"=0,"NLineC_off"=0
where "Balance"<>0;
COMMIT;

ALTER TABLE "PResultsLC" DROP P;
ALTER TABLE "PResultsLC" DROP Q;
ALTER TABLE "WResultsLC" DROP "Wa";
ALTER TABLE "WResultsLC" DROP "Wr";

CREATE TABLE "ChainLengthLC" ("Ident" "TIntegerIdent","Balance" "TIdent",
 "LsumP" "DECIMAL_9_3_NOT_NULL","LsumC" "DECIMAL_9_3_NOT_NULL",
 "NLineP" "SmallInt0_NOT_NULL","NLineC" "SmallInt0_NOT_NULL",
 "LsumP_off" DECIMAL_9_3_NOT_NULL,"LsumC_off" DECIMAL_9_3_NOT_NULL,
 "NLineP_off" "SmallInt0_NOT_NULL","NLineC_off" "SmallInt0_NOT_NULL",
CONSTRAINT "PK_ChainLengthLC" PRIMARY KEY ("Ident", "Balance"),
CONSTRAINT "FK_ChainLengthLCResults" FOREIGN KEY ("Ident")
 REFERENCES "PResultsLC" ("Ident") ON DELETE CASCADE ON UPDATE CASCADE,
CONSTRAINT "FK_ChainLengthLCBalance" FOREIGN KEY ("Balance")
 REFERENCES "Owners" ("Ident"));
GRANT ALL ON "ChainLengthLC" TO "rtp3user" ;

CREATE TRIGGER "ChainLengthLCBeforeUpdate" FOR "ChainLengthLC"
ACTIVE BEFORE UPDATE POSITION 0 
AS
BEGIN
 IF (NEW."LsumP"<>OLD."LsumP" OR
     NEW."LsumC"<>OLD."LsumC" OR
     NEW."NLineP"<>OLD."NLineP" OR
     NEW."NLineC"<>OLD."NLineC" OR
     NEW."LsumP_off"<>OLD."LsumP_off" OR
     NEW."LsumC_off"<>OLD."LsumC_off" OR
     NEW."NLineP_off"<>OLD."NLineP_off" OR
     NEW."NLineC_off"<>OLD."NLineC_off" OR
     NEW."Balance"<>OLD."Balance")
 THEN EXCEPTION "NoRelease";
END;

COMMIT;

CREATE PROCEDURE "InsertPResultsLC" (SampleTime TIMESTAMP,GUID INTEGER,
 U DOUBLE PRECISION,dUmax DOUBLE PRECISION,Temperature DOUBLE PRECISION,
 Flags INTEGER,CRC BLOB SUB_TYPE 0 SEGMENT SIZE 48)
RETURNS (Ident integer)
AS
BEGIN
 DELETE FROM "PResultsLC"
 WHERE "SampleTime"=:SampleTime and "GUID"=:GUID;
 Ident=GEN_ID("PResultsLCIdent",1);
 INSERT INTO "PResultsLC" ("Ident","SampleTime","GUID",
  "U","dUmax","Temperature","Flags","CRC")
 VALUES (:Ident,:SampleTime,:GUID,:U,:dUmax,:Temperature,:Flags,:CRC);
END ;
GRANT EXECUTE ON PROCEDURE "InsertPResultsLC" TO "rtp3user" ;

CREATE TRIGGER "PResultsLCBeforeUpdate" FOR "PResultsLC" BEFORE UPDATE
AS
BEGIN
 IF (NEW."U"<>OLD."U" OR NEW."dUmax"<>OLD."dUmax" OR
     NEW."Temperature"<>OLD."Temperature" OR NEW."Flags"<>OLD."Flags")
 THEN EXCEPTION "NoRelease";
END;

CREATE TRIGGER "PResultsLCAddBeforeUpdate" FOR "PResultsLCAdd" BEFORE UPDATE
AS
BEGIN
 IF (NEW."Pgen"<>OLD."Pgen" OR
     NEW."Qgen"<>OLD."Qgen" OR
     NEW."dP_line_cu"<>OLD."dP_line_cu" OR
     NEW."dP_line_k"<>OLD."dP_line_k" OR
     NEW."dP_line_crown"<>OLD."dP_line_crown" OR
     NEW."dQ_line_cu"<>OLD."dQ_line_cu" OR
     NEW."dP_tr_cu"<>OLD."dP_tr_cu" OR
     NEW."dQ_tr_cu"<>OLD."dQ_tr_cu" OR
     NEW."dP_tr_xx"<>OLD."dP_tr_xx" OR
     NEW."dQ_tr_xx"<>OLD."dQ_tr_xx" OR
     NEW."dP_clr"<>OLD."dP_clr" OR
     NEW."dQ_clr"<>OLD."dQ_clr" OR
     NEW."Qc"<>OLD."Qc" OR
     NEW."Ptrans"<>OLD."Ptrans" OR
     NEW."Qtrans"<>OLD."Qtrans" OR
     NEW."Pnagr"<>OLD."Pnagr" OR
     NEW."Qnagr"<>OLD."Qnagr" OR
     NEW."Ptrans_fact"<>OLD."Ptrans_fact" OR
     NEW."Qtrans_fact"<>OLD."Qtrans_fact" OR
     NEW."Pnagr_fact"<>OLD."Pnagr_fact" OR
     NEW."Qnagr_fact"<>OLD."Qnagr_fact" OR
     NEW."Kzagr"<>OLD."Kzagr" OR
     NEW."Ssum_tr"<>OLD."Ssum_tr" OR
     NEW."Ntr"<>OLD."Ntr" OR
     NEW."Psum_motor"<>OLD."Psum_motor" OR
     NEW."Nmotor"<>OLD."Nmotor" OR
     NEW."Ssum_clr"<>OLD."Ssum_clr" OR
     NEW."Nclr"<>OLD."Nclr" OR
     NEW."LsumP"<>OLD."LsumP" OR
     NEW."LsumC"<>OLD."LsumC" OR
     NEW."NLineP"<>OLD."NLineP" OR
     NEW."NLineC"<>OLD."NLineC" OR
     NEW."NAbonents"<>OLD."NAbonents" OR
     NEW."Ssum_tr_off"<>OLD."Ssum_tr_off" OR
     NEW."Ntr_off"<>OLD."Ntr_off" OR
     NEW."Psum_motor_off"<>OLD."Psum_motor_off" OR
     NEW."Nmotor_off"<>OLD."Nmotor_off" OR
     NEW."Ssum_clr_off"<>OLD."Ssum_clr_off" OR
     NEW."Nclr_off"<>OLD."Nclr_off" OR
     NEW."LsumP_off"<>OLD."LsumP_off" OR
     NEW."LsumC_off"<>OLD."LsumC_off" OR
     NEW."NLineP_off"<>OLD."NLineP_off" OR
     NEW."NLineC_off"<>OLD."NLineC_off" OR
     NEW."Balance"<>OLD."Balance")
 THEN EXCEPTION "NoRelease";
END;

CREATE PROCEDURE "InsertWResultsLC" (SampleIdent INTEGER,GUID INTEGER,
 U DOUBLE PRECISION,T DOUBLE PRECISION,
 Kzap DOUBLE PRECISION,sqrKfg DOUBLE PRECISION,
 dUmax DOUBLE PRECISION,dWdop DOUBLE PRECISION,
 Temperature DOUBLE PRECISION,Flags INTEGER,
 CRC BLOB SUB_TYPE 0 SEGMENT SIZE 48)
RETURNS (Ident INTEGER)
AS
BEGIN
 DELETE FROM "WResultsLC"
 WHERE "SampleIdent"=:SampleIdent and "GUID"=:GUID;
 Ident=GEN_ID("WResultsLCIdent",1);
 INSERT INTO "WResultsLC" ("Ident","SampleIdent","GUID","U",
  "T","Kzap","sqrKfg","dUmax","dWdop",
  "Temperature","Flags","CRC")
 VALUES (:Ident,:SampleIdent,:GUID,:U,:T,:Kzap,:sqrKfg,:dUmax,:dWdop,
  :Temperature,:Flags,:CRC);
END ;
GRANT EXECUTE ON PROCEDURE "InsertWResultsLC" TO "rtp3user" ;

CREATE TRIGGER "WResultsLCBeforeUpdate" FOR "WResultsLC" BEFORE UPDATE
AS
BEGIN
 IF (OLD."U"<>NEW."U" OR OLD."T"<>NEW."T" OR
     OLD."Kzap"<>NEW."Kzap" OR OLD."sqrKfg"<>NEW."sqrKfg" OR
     OLD."dUmax"<>NEW."dUmax" OR OLD."dWdop"<>NEW."dWdop" OR
     OLD."Temperature"<>NEW."Temperature" OR OLD."Flags"<>NEW."Flags")
 THEN EXCEPTION "NoRelease";
END;

CREATE TRIGGER "WResultsLCAddBeforeUpdate" FOR "WResultsLCAdd" BEFORE UPDATE
AS
BEGIN
 IF (NEW."Wa_gen"<>OLD."Wa_gen" OR
     NEW."Wr_gen"<>OLD."Wr_gen" OR
     NEW."DWa_line_cu"<>OLD."DWa_line_cu" OR
     NEW."DWa_line_k"<>OLD."DWa_line_k" OR
     NEW."DWa_line_crown"<>OLD."DWa_line_crown" OR
     NEW."DWr_line_cu"<>OLD."DWr_line_cu" OR
     NEW."DWa_tr_cu"<>OLD."DWa_tr_cu" OR
     NEW."DWr_tr_cu"<>OLD."DWr_tr_cu" OR
     NEW."DWa_tr_xx"<>OLD."DWa_tr_xx" OR
     NEW."DWr_tr_xx"<>OLD."DWr_tr_xx" OR
     NEW."DWa_clr"<>OLD."DWa_clr" OR
     NEW."DWr_clr"<>OLD."DWr_clr" OR
     NEW."Wrc"<>OLD."Wrc" OR
     NEW."Wa_trans"<>OLD."Wa_trans" OR
     NEW."Wr_trans"<>OLD."Wr_trans" OR
     NEW."Wa_potr"<>OLD."Wa_potr" OR
     NEW."Wr_potr"<>OLD."Wr_potr" OR
     NEW."Wa_trans_fact"<>OLD."Wa_trans_fact" OR
     NEW."Wr_trans_fact"<>OLD."Wr_trans_fact" OR
     NEW."Wa_potr_fact"<>OLD."Wa_potr_fact" OR
     NEW."Wr_potr_fact"<>OLD."Wr_potr_fact" OR
     NEW."Kzagr"<>OLD."Kzagr" OR
     NEW."Ssum_tr"<>OLD."Ssum_tr" OR
     NEW."Ntr"<>OLD."Ntr" OR
     NEW."Psum_motor"<>OLD."Psum_motor" OR
     NEW."Nmotor"<>OLD."Nmotor" OR
     NEW."Ssum_clr"<>OLD."Ssum_clr" OR
     NEW."Nclr"<>OLD."Nclr" OR
     NEW."LsumP"<>OLD."LsumP" OR
     NEW."LsumC"<>OLD."LsumC" OR
     NEW."NLineP"<>OLD."NLineP" OR
     NEW."NLineC"<>OLD."NLineC" OR
     NEW."NAbonents"<>OLD."NAbonents" OR
     NEW."Ssum_tr_off"<>OLD."Ssum_tr_off" OR
     NEW."Ntr_off"<>OLD."Ntr_off" OR
     NEW."Psum_motor_off"<>OLD."Psum_motor_off" OR
     NEW."Nmotor_off"<>OLD."Nmotor_off" OR
     NEW."Ssum_clr_off"<>OLD."Ssum_clr_off" OR
     NEW."Nclr_off"<>OLD."Nclr_off" OR
     NEW."LsumP_off"<>OLD."LsumP_off" OR
     NEW."LsumC_off"<>OLD."LsumC_off" OR
     NEW."NLineP_off"<>OLD."NLineP_off" OR
     NEW."NLineC_off"<>OLD."NLineC_off" OR
     NEW."Balance"<>OLD."Balance")
 THEN EXCEPTION "NoRelease";
END;

COMMIT;

ALTER TABLE "PResultsLC" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "PResultsLC" ALTER COLUMN "SampleTime" POSITION 2;
ALTER TABLE "PResultsLC" ALTER COLUMN GUID POSITION 3;
ALTER TABLE "PResultsLC" ALTER COLUMN U POSITION 4;
ALTER TABLE "PResultsLC" ALTER COLUMN "dUmax" POSITION 5;
ALTER TABLE "PResultsLC" ALTER COLUMN "Temperature" POSITION 6;
ALTER TABLE "PResultsLC" ALTER COLUMN "Flags" POSITION 7;
ALTER TABLE "PResultsLC" ALTER COLUMN CRC POSITION 8;

ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Balance" POSITION 2;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Pgen" POSITION 3;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Qgen" POSITION 4;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "dP_line_cu" POSITION 5;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "dP_line_k" POSITION 6;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "dP_line_crown" POSITION 7;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "dQ_line_cu" POSITION 8;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "dP_tr_cu" POSITION 9;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "dQ_tr_cu" POSITION 10;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "dP_tr_xx" POSITION 11;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "dQ_tr_xx" POSITION 12;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "dP_clr" POSITION 13;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "dQ_clr" POSITION 14;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Qc" POSITION 15;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Ptrans" POSITION 16;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Qtrans" POSITION 17;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Pnagr" POSITION 18;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Qnagr" POSITION 19;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Ptrans_fact" POSITION 20;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Qtrans_fact" POSITION 21;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Pnagr_fact" POSITION 22;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Qnagr_fact" POSITION 23;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Kzagr" POSITION 24;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Ssum_tr" POSITION 25;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Ntr" POSITION 26;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Psum_motor" POSITION 27;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Nmotor" POSITION 28;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Ssum_clr" POSITION 29;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Nclr" POSITION 30;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "LsumP" POSITION 31;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "LsumC" POSITION 32;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "NLineP" POSITION 33;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "NLineC" POSITION 34;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "NAbonents" POSITION 35;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Ssum_tr_off" POSITION 36;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Ntr_off" POSITION 37;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Psum_motor_off" POSITION 38;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Nmotor_off" POSITION 39;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Ssum_clr_off" POSITION 40;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "Nclr_off" POSITION 41;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "LsumP_off" POSITION 42;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "LsumC_off" POSITION 43;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "NLineP_off" POSITION 44;
ALTER TABLE "PResultsLCAdd" ALTER COLUMN "NLineC_off" POSITION 45;

ALTER TABLE "WResultsLC" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "WResultsLC" ALTER COLUMN "SampleIdent" POSITION 2;
ALTER TABLE "WResultsLC" ALTER COLUMN GUID POSITION 3;
ALTER TABLE "WResultsLC" ALTER COLUMN T POSITION 4;
ALTER TABLE "WResultsLC" ALTER COLUMN U POSITION 5;
ALTER TABLE "WResultsLC" ALTER COLUMN "Kzap" POSITION 6;
ALTER TABLE "WResultsLC" ALTER COLUMN "sqrKfg" POSITION 7;
ALTER TABLE "WResultsLC" ALTER COLUMN "dUmax" POSITION 8;
ALTER TABLE "WResultsLC" ALTER COLUMN "dWdop" POSITION 9;
ALTER TABLE "WResultsLC" ALTER COLUMN "Temperature" POSITION 10;
ALTER TABLE "WResultsLC" ALTER COLUMN "Flags" POSITION 11;
ALTER TABLE "WResultsLC" ALTER COLUMN CRC POSITION 12;

ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Balance" POSITION 2;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wa_gen" POSITION 3;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wr_gen" POSITION 4;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "DWa_line_cu" POSITION 5;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "DWa_line_k" POSITION 6;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "DWa_line_crown" POSITION 7;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "DWr_line_cu" POSITION 8;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "DWa_tr_cu" POSITION 9;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "DWr_tr_cu" POSITION 10;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "DWa_tr_xx" POSITION 11;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "DWr_tr_xx" POSITION 12;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "DWa_clr" POSITION 13;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "DWr_clr" POSITION 14;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wrc" POSITION 15;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wa_trans" POSITION 16;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wr_trans" POSITION 17;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wa_potr" POSITION 18;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wr_potr" POSITION 19;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wa_trans_fact" POSITION 20;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wr_trans_fact" POSITION 21;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wa_potr_fact" POSITION 22;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Wr_potr_fact" POSITION 23;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Kzagr" POSITION 24;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Ssum_tr" POSITION 25;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Ntr" POSITION 26;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Psum_motor" POSITION 27;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Nmotor" POSITION 28;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Ssum_clr" POSITION 29;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Nclr" POSITION 30;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "LsumP" POSITION 31;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "LsumC" POSITION 32;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "NLineP" POSITION 33;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "NLineC" POSITION 34;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "NAbonents" POSITION 35;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Ssum_tr_off" POSITION 36;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Ntr_off" POSITION 37;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Psum_motor_off" POSITION 38;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Nmotor_off" POSITION 39;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Nclr_off" POSITION 40;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "Ssum_clr_off" POSITION 41;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "LsumC_off" POSITION 42;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "LsumP_off" POSITION 43;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "NLineP_off" POSITION 44;
ALTER TABLE "WResultsLCAdd" ALTER COLUMN "NLineC_off" POSITION 45;

COMMIT;

/******************************************************************************/

CREATE GENERATOR "LVFidersBFIdent";
CREATE TABLE "LVFidersBF" ("Ident" "TIntegerIdent","F" "TIntegerIdent",
 "LsumP" INTEGER,"LsumC" INTEGER,
CONSTRAINT "PK_LVFidersBF" PRIMARY KEY ("Ident","F"),
CONSTRAINT "CHK_LVFidersBF_Lsum" CHECK
 (("LsumP" is null or "LsumP">=0) and ("LsumC" is null or "LsumC">=0)));
GRANT ALL ON "LVFidersBF" TO "rtp3user" ;

ALTER TABLE "LVFidersB" ADD "FsIdent" INTEGER;
ALTER TABLE "LVFidersB" ADD CONSTRAINT "CHECK_LVFidersB_FsIdent"
CHECK("FsIdent" is null or exists (select * from "LVFidersBF" BF where BF."Ident"="FsIdent"));

CREATE TRIGGER "LVFidersBAfterDeleteOrUpdate" FOR "LVFidersB"
ACTIVE AFTER UPDATE OR DELETE POSITION 0
AS
BEGIN
 delete from "LVFidersBF" BF
 where BF."Ident"=OLD."FsIdent" and
 not exists
  (select * from "LVFidersB" B
   where B."FsIdent"=OLD."FsIdent");
END;
COMMIT;

ALTER TABLE "LVFidersB" ALTER COLUMN "Ident" POSITION 1;
ALTER TABLE "LVFidersB" ALTER COLUMN "CosFi" POSITION 2;
ALTER TABLE "LVFidersB" ALTER COLUMN "Unom" POSITION 3;
ALTER TABLE "LVFidersB" ALTER COLUMN F POSITION 4;
ALTER TABLE "LVFidersB" ALTER COLUMN "FsIdent" POSITION 5;
ALTER TABLE "LVFidersB" ALTER COLUMN "NLines" POSITION 6;
ALTER TABLE "LVFidersB" ALTER COLUMN "dp" POSITION 7;
ALTER TABLE "LVFidersB" ALTER COLUMN "kzap" POSITION 8;
ALTER TABLE "LVFidersB" ALTER COLUMN "dn" POSITION 9;
ALTER TABLE "LVFidersB" ALTER COLUMN "Lma" POSITION 10;
ALTER TABLE "LVFidersB" ALTER COLUMN "Lms" POSITION 11;
ALTER TABLE "LVFidersB" ALTER COLUMN "Lmm" POSITION 12;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23a" POSITION 13;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23s" POSITION 14;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23m" POSITION 15;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1a" POSITION 16;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1s" POSITION 17;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1m" POSITION 18;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1ia" POSITION 19;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1is" POSITION 20;
ALTER TABLE "LVFidersB" ALTER COLUMN "L1im" POSITION 21;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23ia" POSITION 22;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23is" POSITION 23;
ALTER TABLE "LVFidersB" ALTER COLUMN "L23im" POSITION 24;
COMMIT;

CREATE GENERATOR "LVResultsIdent";
CREATE TABLE "LVResults" ("Ident" "TIntegerIdent","CalcType" "TIdent",
   "SampleIdent" "TIntegerIdent","GUID" "TIntegerIdent",
   "UA" "DECIMAL_6_3","UB" "DECIMAL_6_3","UC" "DECIMAL_6_3",
   "IA" "DECIMAL_6_3","IB" "DECIMAL_6_3","IC" "DECIMAL_6_3",
   "ImaxA" "DECIMAL_6_3","ImaxB" "DECIMAL_6_3","ImaxC" "DECIMAL_6_3",
   "CosFiA" "DECIMAL_CosFi","CosFiB" "DECIMAL_CosFi","CosFiC" "DECIMAL_CosFi",
   "T" "DOUBLE_NOT_NULL_ABOVE_0","Temperature" "DECIMAL_Temperature_NOT_NULL",

   "U2A" "DOUBLE_NOT_NULL_ABOVE_0","U2B" "DOUBLE_NOT_NULL_ABOVE_0",
   "U2C" "DOUBLE_NOT_NULL_ABOVE_0",
   "Lm" "DECIMAL_9_3","L23" "DECIMAL_9_3","L1" "DECIMAL_9_3",
   "Kdp" "DOUBLE_NOT_NULL_ABOVE_0","sqrKfg" "DOUBLE_NOT_NULL_ABOVE_0" default 1,
   "Krazv" "DOUBLE_NOT_NULL_ABOVE_0",
   "HeadEndSize" "DOUBLE_NOT_NULL_ABOVE_0","HeadEndLength" "DOUBLE_NOT_NULL_ABOVE_0",
   "dWdop" "DOUBLE_ABOVE_0",
   "CRC" BLOB SEGMENT SIZE 16,
 CONSTRAINT "PK_LVResults" PRIMARY KEY ("Ident"),
 CONSTRAINT "FK_LVResults_SampleIdent" FOREIGN KEY ("SampleIdent")
  REFERENCES "SamplesDates" ("Ident") ON DELETE CASCADE ON UPDATE CASCADE,
 CONSTRAINT "FK_LVResults_GUID"  FOREIGN KEY ("GUID") REFERENCES "LVFiders" ("GUID")
  ON UPDATE CASCADE ON DELETE CASCADE,
 CONSTRAINT "CHK_LVResults_CalcType" CHECK ("CalcType" BETWEEN 0 AND 3));
CREATE UNIQUE INDEX "idxLVResults" ON "LVResults" ("CalcType", "SampleIdent","GUID");
GRANT ALL ON "LVResults" TO "rtp3user" ;

CREATE TRIGGER "LVResultsBeforeUpdate" FOR "LVResults" BEFORE UPDATE
AS
BEGIN
 IF (NEW."CalcType"<>OLD."CalcType" OR
     NEW."UA"<>OLD."UA" OR
     NEW."UB"<>OLD."UB" OR
     NEW."UC"<>OLD."UC" OR
     NEW."IA"<>OLD."IA" OR
     NEW."IB"<>OLD."IB" OR
     NEW."IC"<>OLD."IC" OR
     NEW."ImaxA"<>OLD."ImaxA" OR
     NEW."ImaxB"<>OLD."ImaxB" OR
     NEW."ImaxC"<>OLD."ImaxC" OR
     NEW."CosFiA"<>OLD."CosFiA" OR
     NEW."CosFiB"<>OLD."CosFiB" OR
     NEW."CosFiC"<>OLD."CosFiC" OR
     NEW."T"<>OLD."T" OR
     NEW."Temperature"<>OLD."Temperature" OR
     NEW."U2A"<>OLD."U2A" OR
     NEW."U2B"<>OLD."U2B" OR
     NEW."U2C"<>OLD."U2C" OR
     NEW."Lm"<>OLD."Lm" OR
     NEW."L23"<>OLD."L23" OR
     NEW."L1"<>OLD."L1" OR
     NEW."Kdp"<>OLD."Kdp" OR
     NEW."sqrKfg"<>OLD."sqrKfg" OR
     NEW."Krazv"<>OLD."Krazv" OR
     NEW."HeadEndSize"<>OLD."HeadEndSize" OR
     NEW."HeadEndLength"<>OLD."HeadEndLength" OR
     NEW."dWdop"<>OLD."dWdop" OR
     NEW."CRC"<>OLD."CRC")
 THEN EXCEPTION "NoRelease";
END;

CREATE PROCEDURE "InsertLVResults" (CalcType smallint,
 SampleIdent integer,GUID integer,
 UA DECIMAL(10,3),UB DECIMAL(10,3),UC DECIMAL(10,3),
 IA DECIMAL(10,3),IB DECIMAL(10,3),IC DECIMAL(10,3),
 ImaxA DECIMAL(10,3),ImaxB DECIMAL(10,3),ImaxC DECIMAL(10,3),
 CosFiA DECIMAL(10,3),CosFiB DECIMAL(10,3),CosFiC DECIMAL(10,3),
 T double precision,Temperature DECIMAL(10,3),
 U2A double precision,U2B double precision,U2C double precision,
 Lm DECIMAL(10,3),L23 DECIMAL(10,3),L1 DECIMAL(10,3),
 Kdp double precision,sqrKfg double precision,Krazv double precision,
 HeadEndSize double precision,HeadEndLength double precision,
 dWdop double precision,
 CRC blob sub_type 0 segment size 48)
RETURNS (Ident integer)
AS
BEGIN
 DELETE FROM "LVResults"
 WHERE "CalcType"=:CalcType and "SampleIdent"=:SampleIdent and "GUID"=:GUID;
 Ident=GEN_ID("LVResultsIdent",1);
 INSERT INTO "LVResults" ("Ident","CalcType","SampleIdent","GUID",
  "UA","UB","UC","IA","IB","IC","ImaxA","ImaxB","ImaxC",
  "CosFiA","CosFiB","CosFiC","T","Temperature",
  "U2A","U2B","U2C","Lm","L23","L1","Kdp","sqrKfg","Krazv",
  "HeadEndSize","HeadEndLength","dWdop","CRC")
 VALUES (:Ident,:CalcType,:SampleIdent,:GUID,:UA,:UB,:UC,:IA,:IB,:IC,
  :ImaxA,:ImaxB,:ImaxC,:CosFiA,:CosFiB,:CosFiC,:T,:Temperature,
  :U2A,:U2B,:U2C,:Lm,:L23,:L1,:Kdp,:sqrKfg,:Krazv,
  :HeadEndSize,:HeadEndLength,:dWdop,:CRC);
END ;
GRANT EXECUTE ON PROCEDURE "InsertLVResults" TO "rtp3user" ;

CREATE TABLE "LVPResultsAdd" ("Ident" "TIntegerIdent","Balance" "TIdent",
 "Pgen" "DOUBLE_NOT_NULL_ABOVE_0","Qgen" "DOUBLE_NOT_NULL",
 "dP" "DOUBLE_NOT_NULL_ABOVE_0","dQ" "DOUBLE_NOT_NULL_ABOVE_0",
 "Pcalc" "DOUBLE_NOT_NULL_ABOVE_0","Qcalc" "DOUBLE_NOT_NULL",
 "Pfakt" "DOUBLE_ABOVE_0","Qfakt" DOUBLE PRECISION,
 "NAbonents" "SmallInt0",
 "LsumP" "DECIMAL_9_3","LsumC" "DECIMAL_9_3",
 "NLineP" "SmallInt0","NLineC" "SmallInt0",
 "LsumP_off" "DECIMAL_9_3","LsumC_off" "DECIMAL_9_3",
 "NLineP_off" "SmallInt0","NLineC_off" "SmallInt0",
 CONSTRAINT "PK_LVPResultsAdd" PRIMARY KEY ("Ident","Balance"),
 CONSTRAINT "FK_LVPResultsAdd" FOREIGN KEY ("Ident")
  REFERENCES "LVResults" ("Ident") ON DELETE CASCADE ON UPDATE CASCADE,
 CONSTRAINT "FK_LVPResultsAddBalance" FOREIGN KEY ("Balance")
  REFERENCES "Owners" ("Ident"));
GRANT ALL ON "LVPResultsAdd" TO "rtp3user" ;

CREATE TRIGGER "LVPResultsAddBeforeUpdate" FOR "LVPResultsAdd" BEFORE UPDATE
AS
BEGIN
 IF (NEW."Pgen"<>OLD."Pgen" OR
     NEW."Qgen"<>OLD."Qgen" OR
     NEW."dP"<>OLD."dP" OR
     NEW."dQ"<>OLD."dQ" OR
     NEW."Pcalc"<>OLD."Pcalc" OR
     NEW."Qcalc"<>OLD."Qcalc" OR
     NEW."Pfakt"<>OLD."Pfakt" OR
     NEW."Qfakt"<>OLD."Qfakt" OR
     NEW."NAbonents"<>OLD."NAbonents" OR
     NEW."LsumP"<>OLD."LsumP" OR
     NEW."LsumC"<>OLD."LsumC" OR
     NEW."NLineP"<>OLD."NLineP" OR
     NEW."NLineC"<>OLD."NLineC" OR
     NEW."LsumP_off"<>OLD."LsumP_off" OR
     NEW."LsumC_off"<>OLD."LsumC_off" OR
     NEW."NLineP_off"<>OLD."NLineP_off" OR
     NEW."NLineC_off"<>OLD."NLineC_off" OR
     NEW."Balance"<>OLD."Balance")
 THEN EXCEPTION "NoRelease";
END;

CREATE TABLE "LVWResultsAdd" ("Ident" "TIntegerIdent","Balance" "TIdent",
 "Wa_gen" "DOUBLE_NOT_NULL_ABOVE_0","Wr_gen" "DOUBLE_NOT_NULL",
 "dWa" "DOUBLE_NOT_NULL_ABOVE_0","dWr" "DOUBLE_NOT_NULL_ABOVE_0",
 "Wacalc" "DOUBLE_NOT_NULL_ABOVE_0","Wrcalc" "DOUBLE_NOT_NULL",
 "Wafakt" "DOUBLE_ABOVE_0","Wrfakt" DOUBLE PRECISION,
 CONSTRAINT "PK_LVWResultsAdd" PRIMARY KEY ("Ident","Balance"),
 CONSTRAINT "FK_LVWResultsAddIdent" FOREIGN KEY ("Ident")
  REFERENCES "LVResults" ("Ident") ON DELETE CASCADE ON UPDATE CASCADE,
 CONSTRAINT "FK_LVWResultsAddBalance" FOREIGN KEY ("Balance")
  REFERENCES "Owners" ("Ident") ON UPDATE CASCADE);
GRANT ALL ON "LVWResultsAdd" TO "rtp3user" ;

CREATE TRIGGER "LVWResultsAddBeforeUpdate" FOR "LVWResultsAdd" BEFORE UPDATE
AS
BEGIN
 IF (NEW."Wa_gen"<>OLD."Wa_gen" OR
     NEW."Wr_gen"<>OLD."Wr_gen" OR
     NEW."dWa"<>OLD."dWa" OR
     NEW."dWr"<>OLD."dWr" OR
     NEW."Wacalc"<>OLD."Wacalc" OR
     NEW."Wrcalc"<>OLD."Wrcalc" OR
     NEW."Wafakt"<>OLD."Wafakt" OR
     NEW."Wrfakt"<>OLD."Wrfakt" OR
     NEW."Balance"<>OLD."Balance")
 THEN EXCEPTION "NoRelease";
END;

CREATE TABLE "LVChainLength" ("Ident" "TIntegerIdent","Balance" "TIdent",
 "LsumP" "DECIMAL_9_3_NOT_NULL","LsumC" "DECIMAL_9_3_NOT_NULL",
 "NLineP" "SmallInt0_NOT_NULL","NLineC" "SmallInt0_NOT_NULL",
 "LsumP_off" DECIMAL_9_3_NOT_NULL,"LsumC_off" DECIMAL_9_3_NOT_NULL,
 "NLineP_off" "SmallInt0_NOT_NULL","NLineC_off" "SmallInt0_NOT_NULL",
CONSTRAINT "PK_LVChainLength" PRIMARY KEY ("Ident", "Balance"),
CONSTRAINT "FK_LVChainLengthLVResults" FOREIGN KEY ("Ident")
 REFERENCES "LVResults" ("Ident") ON DELETE CASCADE ON UPDATE CASCADE,
CONSTRAINT "FK_LVChainLengthBalance" FOREIGN KEY ("Balance")
 REFERENCES "Owners" ("Ident"));
GRANT ALL ON "LVChainLength" TO "rtp3user" ;

CREATE TRIGGER "LVChainLengthBeforeUpdate" FOR "LVChainLength" BEFORE UPDATE
AS
BEGIN
 IF (NEW."LsumP"<>OLD."LsumP" OR
     NEW."LsumC"<>OLD."LsumC" OR
     NEW."NLineP"<>OLD."NLineP" OR
     NEW."NLineC"<>OLD."NLineC" OR
     NEW."LsumP_off"<>OLD."LsumP_off" OR
     NEW."LsumC_off"<>OLD."LsumC_off" OR
     NEW."NLineP_off"<>OLD."NLineP_off" OR
     NEW."NLineC_off"<>OLD."NLineC_off" OR
     NEW."Balance"<>OLD."Balance")
 THEN EXCEPTION "NoRelease";
END;

CREATE TABLE "LVPResultsN" ("Ident" "TIntegerIdent","GUID" "TIntegerIdent",
   "Pn" "DECIMAL_9_3","Qn" "NUMBER_9_3","U" "DECIMAL_6_3",
 CONSTRAINT "PK_LVPResultsN" PRIMARY KEY ("Ident","GUID"),
 CONSTRAINT "FK_LVPResultsN_Ident" FOREIGN KEY ("Ident")
  REFERENCES "LVResults" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE,
 CONSTRAINT "FK_LVPResultsN_GUID" FOREIGN KEY ("GUID")
  REFERENCES "LVNodes" ("GUID") ON UPDATE CASCADE ON DELETE CASCADE) ;
GRANT ALL ON "LVPResultsN" TO "rtp3user" ;

CREATE TABLE "LVPResultsL" ("Ident" "TIntegerIdent","GUID" "TIntegerIdent",
   "P" "DECIMAL_9_3","Q" "NUMBER_9_3","I" "DECIMAL_9_3",
   "deltaP" "DECIMAL_9_3","deltaQ" "DECIMAL_9_3","Kzag" "DECIMAL_5_3",
 CONSTRAINT "PK_LVPResultsL" PRIMARY KEY ("Ident","GUID"),
 CONSTRAINT "FK_LVPResultsL_Ident" FOREIGN KEY ("Ident")
  REFERENCES "LVResults" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE,
 CONSTRAINT "FK_LVPResultsL_GUID" FOREIGN KEY ("GUID") REFERENCES "LVLines" ("GUID")
  ON UPDATE CASCADE ON DELETE CASCADE) ;
GRANT ALL ON "LVPResultsL" TO "rtp3user" ;

CREATE TABLE "LVWResultsN" ("Ident" "TIntegerIdent","GUID" "TIntegerIdent",
   "Wa" "DECIMAL_9_3","Wr" "NUMBER_9_3",
 CONSTRAINT "PK_LVWResultsN" PRIMARY KEY ("Ident","GUID"),
 CONSTRAINT "FK_LVWResultsN_Ident" FOREIGN KEY ("Ident")
  REFERENCES "LVResults" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE,
 CONSTRAINT "FK_LVWResultsN_GUID" FOREIGN KEY ("GUID")
  REFERENCES "LVNodes" ("GUID") ON UPDATE CASCADE ON DELETE CASCADE) ;
GRANT ALL ON "LVWResultsN" TO "rtp3user" ;

CREATE TABLE "LVWResultsL" ("Ident" "TIntegerIdent","GUID" "TIntegerIdent",
   "Wa" "DECIMAL_9_3","Wr" "NUMBER_9_3",
   "deltaWa" "DECIMAL_9_3","deltaWr" "DECIMAL_9_3",
 CONSTRAINT "PK_LVWResultsL" PRIMARY KEY ("Ident","GUID"),
 CONSTRAINT "FK_LVWResultsL_Ident" FOREIGN KEY ("Ident")
  REFERENCES "LVResults" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE,
 CONSTRAINT "FK_LVWResultsL_GUID" FOREIGN KEY ("GUID")
  REFERENCES "LVLines" ("GUID") ON UPDATE CASCADE ON DELETE CASCADE) ;
GRANT ALL ON "LVWResultsL" TO "rtp3user" ;
COMMIT;

insert into "LVResults" ("Ident","CalcType", "SampleIdent", GUID, 
 "UA","UB","UC","IA","IB","IC",
 "ImaxA", "ImaxB", "ImaxC", "CosFiA", "CosFiB", "CosFiC", T, "Temperature", 
 "U2A","U2B","U2C","Lm","L23","L1","Kdp","sqrKfg","Krazv",
 "HeadEndSize","HeadEndLength","dWdop","CRC")
select GEN_ID("LVResultsIdent",1),1,"SampleIdent","GUID",
 "UA","UB","UC","IA","IB","IC",
 "ImaxA","ImaxB","ImaxC","CosFiA","CosFiB","CosFiC","T",COALESCE("Temperature",-70),
 "U2A","U2B","U2C","Lm","L23","L1","Kdp","sqrKfg","Krazv",
 0,0,"dWdop","CRC"     
from "LVWResults";

insert into "LVPResultsAdd" ("Ident", "Balance", 
 "Pgen", "Qgen", "dP", "dQ", 
 "Pcalc", "Qcalc", "Pfakt", "Qfakt", 
 "NAbonents", "LsumP", "LsumC", "NLineP", "NLineC", 
 "LsumP_off", "LsumC_off", "NLineP_off", "NLineC_off")
select R."Ident",0,WR."P",WR."Q",WR."dP_OnBalance",WR."dQ_OnBalance",
 WR."Pcalc_OnBalance",WR."Qcalc_OnBalance",WR."Pfakt_OnBalance",WR."Qfakt_OnBalance",
 WR."NAbonents_OnBalance",WR."LsumP_OnBalance",WR."LsumC_OnBalance",
 WR."NLineP_OnBalance",WR."NLineC_OnBalance",0,0,0,0
from "LVWResults" WR
inner join "LVResults" R on R."SampleIdent"=WR."SampleIdent" and 
 R."GUID"=WR."GUID"
where R."CalcType"=1;

insert into "LVPResultsAdd" ("Ident", "Balance", 
 "Pgen", "Qgen", "dP", "dQ", 
 "Pcalc", "Qcalc", "Pfakt", "Qfakt", 
 "NAbonents", "LsumP", "LsumC", "NLineP", "NLineC", 
 "LsumP_off", "LsumC_off", "NLineP_off", "NLineC_off")
select R."Ident",1,0,0,WR."dP_notBalance",WR."dQ_notBalance",
 WR."Pcalc_notBalance",WR."Qcalc_notBalance",WR."Pfakt_notBalance",WR."Qfakt_notBalance",
 WR."NAbonents_NotBalance",WR."LsumP_NotBalance",WR."LsumC_NotBalance",
 WR."NLineP_NotBalance",WR."NLineC_NotBalance",0,0,0,0 from "LVWResults" WR
inner join "LVResults" R on R."SampleIdent"=WR."SampleIdent" and 
 R."GUID"=WR."GUID"
where R."CalcType"=1;

insert into "LVWResultsAdd" ("Ident", "Balance", 
 "Wa_gen", "Wr_gen", "dWa", "dWr", "Wacalc", "Wrcalc", "Wafakt", "Wrfakt")
select R."Ident",0,WR."Wa",WR."Wr",WR."dWa_OnBalance",WR."dWr_OnBalance",
 WR."Wacalc_OnBalance",WR."Wrcalc_OnBalance",WR."Wafakt_OnBalance",WR."Wrfakt_OnBalance" 
from "LVWResults" WR
inner join "LVResults" R on R."SampleIdent"=WR."SampleIdent" and 
 R."GUID"=WR."GUID"
where R."CalcType"=1;
 
insert into "LVWResultsAdd" ("Ident", "Balance", 
 "Wa_gen", "Wr_gen", "dWa", "dWr", "Wacalc", "Wrcalc", "Wafakt", "Wrfakt")
select R."Ident",1,0,0,WR."dWa_notBalance",WR."dWr_notBalance",
 WR."Wacalc_notBalance",WR."Wrcalc_notBalance",
 WR."Wafakt_notBalance",WR."Wrfakt_notBalance" 
from "LVWResults" WR
inner join "LVResults" R on R."SampleIdent"=WR."SampleIdent" and 
 R."GUID"=WR."GUID"
where R."CalcType"=1;
 
insert into "LVResults" ("Ident","CalcType", "SampleIdent", GUID, 
 "UA","UB","UC","IA","IB","IC",
 "ImaxA", "ImaxB", "ImaxC", "CosFiA", "CosFiB", "CosFiC", T, "Temperature", 
 "U2A","U2B","U2C","Lm","L23","L1","Kdp","sqrKfg","Krazv",
 "HeadEndSize","HeadEndLength","dWdop","CRC")
select GEN_ID("LVResultsIdent",1),2,"SampleIdent","GUID",
 "UA","UB","UC","IA","IB","IC",
 null,null,null,"CosFiA","CosFiB","CosFiC","T",COALESCE("Temperature",-70),
 "U2A","U2B","U2C","Lm","L23","L1","Kdp",0,"Krazv",
 0,0,null,"CRC"     
from "LVPResults";

insert into "LVPResultsAdd" ("Ident", "Balance", 
 "Pgen", "Qgen", "dP", "dQ", 
 "Pcalc", "Qcalc", "Pfakt", "Qfakt", 
 "NAbonents", "LsumP", "LsumC", "NLineP", "NLineC", 
 "LsumP_off", "LsumC_off", "NLineP_off", "NLineC_off")
select R."Ident",0,WR."P",WR."Q",WR."dP_OnBalance",WR."dQ_OnBalance",
 WR."Pcalc_OnBalance",WR."Qcalc_OnBalance",WR."Pfakt_OnBalance",WR."Qfakt_OnBalance",
 WR."NAbonents_OnBalance",WR."LsumP_OnBalance",WR."LsumC_OnBalance",
 WR."NLineP_OnBalance",WR."NLineC_OnBalance",0,0,0,0 
from "LVPResults" WR
inner join "LVResults" R on R."SampleIdent"=WR."SampleIdent" and 
 R."GUID"=WR."GUID"
where R."CalcType"=2;

insert into "LVPResultsAdd" ("Ident", "Balance", 
 "Pgen", "Qgen", "dP", "dQ", 
 "Pcalc", "Qcalc", "Pfakt", "Qfakt", 
 "NAbonents", "LsumP", "LsumC", "NLineP", "NLineC", 
 "LsumP_off", "LsumC_off", "NLineP_off", "NLineC_off")
select R."Ident",1,0,0,WR."dP_notBalance",WR."dQ_notBalance",
 WR."Pcalc_notBalance",WR."Qcalc_notBalance",WR."Pfakt_notBalance",WR."Qfakt_notBalance",
 WR."NAbonents_NotBalance",WR."LsumP_NotBalance",WR."LsumC_NotBalance",
 WR."NLineP_NotBalance",WR."NLineC_NotBalance",0,0,0,0 from "LVPResults" WR
inner join "LVResults" R on R."SampleIdent"=WR."SampleIdent" and 
 R."GUID"=WR."GUID"
where R."CalcType"=2;

insert into "LVWResultsAdd" ("Ident", "Balance", 
 "Wa_gen", "Wr_gen", "dWa", "dWr", "Wacalc", "Wrcalc", "Wafakt", "Wrfakt")
select R."Ident",0,WR."Wa",WR."Wr",WR."dWa_OnBalance",WR."dWr_OnBalance",
 WR."Wacalc_OnBalance",WR."Wrcalc_OnBalance",WR."Wafakt_OnBalance",WR."Wrfakt_OnBalance" 
from "LVPResults" WR
inner join "LVResults" R on R."SampleIdent"=WR."SampleIdent" and 
 R."GUID"=WR."GUID"
where R."CalcType"=2;

insert into "LVWResultsAdd" ("Ident", "Balance", 
 "Wa_gen", "Wr_gen", "dWa", "dWr", "Wacalc", "Wrcalc", "Wafakt", "Wrfakt")
select R."Ident",1,0,0,WR."dWa_notBalance",WR."dWr_notBalance",
 WR."Wacalc_notBalance",WR."Wrcalc_notBalance",
 WR."Wafakt_notBalance",WR."Wrfakt_notBalance" 
from "LVPResults" WR
inner join "LVResults" R on R."SampleIdent"=WR."SampleIdent" and 
 R."GUID"=WR."GUID"
where R."CalcType"=2;

insert into "LVPResultsN" ("Ident", "GUID", "Pn", "Qn", "U")
select R."Ident",RN."GUID",RN."Pn",RN."Qn",RN."U" from "LVWResultsPN" RN
inner join "LVNodes" N on N."GUID"=RN."GUID"
inner join "LVResults" R on RN."SampleIdent"=R."SampleIdent" 
 and N."OwnerGUID"=R."GUID"
where R."CalcType"=1;

insert into "LVPResultsL" ("Ident", "GUID", "P", "Q", "I", "deltaP", "deltaQ", "Kzag")
select R."Ident",RN."GUID",RN."P",RN."Q",RN."I",RN."deltaP",RN."deltaQ",RN."Kzag"
from "LVWResultsPL" RN
inner join "LVLines" N on N."GUID"=RN."GUID"
inner join "LVResults" R on RN."SampleIdent"=R."SampleIdent" 
 and N."OwnerGUID"=R."GUID"
where R."CalcType"=1;

insert into "LVWResultsN" ("Ident", "GUID", "Wa", "Wr")
select R."Ident",RN."GUID",RN."Wa",RN."Wr" from "LVWResultsWN" RN
inner join "LVNodes" N on N."GUID"=RN."GUID"
inner join "LVResults" R on RN."SampleIdent"=R."SampleIdent" 
 and N."OwnerGUID"=R."GUID"
where R."CalcType"=1;

insert into "LVWResultsL" ("Ident", "GUID", "Wa", "Wr", "deltaWa", "deltaWr")
select R."Ident",RN."GUID",RN."Wa",RN."Wr",RN."deltaWa",RN."deltaWr" 
from "LVWResultsWL" RN
inner join "LVLines" N on N."GUID"=RN."GUID"
inner join "LVResults" R on RN."SampleIdent"=R."SampleIdent" 
 and N."OwnerGUID"=R."GUID"
where R."CalcType"=1;

insert into "LVPResultsN" ("Ident", "GUID", "Pn", "Qn", "U")
select R."Ident",RN."GUID",RN."Pn",RN."Qn",RN."U" from "LVPResultsPN" RN
inner join "LVNodes" N on N."GUID"=RN."GUID"
inner join "LVResults" R on RN."SampleIdent"=R."SampleIdent" 
 and N."OwnerGUID"=R."GUID"
where R."CalcType"=2;

insert into "LVPResultsL" ("Ident", "GUID", "P", "Q", "I", "deltaP", "deltaQ", "Kzag")
select R."Ident",RN."GUID",RN."P",RN."Q",RN."I",RN."deltaP",RN."deltaQ",RN."Kzag"
from "LVPResultsPL" RN
inner join "LVLines" N on N."GUID"=RN."GUID"
inner join "LVResults" R on RN."SampleIdent"=R."SampleIdent" 
 and N."OwnerGUID"=R."GUID"
where R."CalcType"=2;

insert into "LVWResultsN" ("Ident", "GUID", "Wa", "Wr")
select R."Ident",RN."GUID",RN."Wa",RN."Wr" from "LVPResultsWN" RN
inner join "LVNodes" N on N."GUID"=RN."GUID"
inner join "LVResults" R on RN."SampleIdent"=R."SampleIdent" 
 and N."OwnerGUID"=R."GUID"
where R."CalcType"=2;

insert into "LVWResultsL" ("Ident", "GUID", "Wa", "Wr", "deltaWa", "deltaWr")
select R."Ident",RN."GUID",RN."Wa",RN."Wr",RN."deltaWa",RN."deltaWr" 
from "LVPResultsWL" RN
inner join "LVLines" N on N."GUID"=RN."GUID"
inner join "LVResults" R on RN."SampleIdent"=R."SampleIdent" 
 and N."OwnerGUID"=R."GUID"
where R."CalcType"=2;

COMMIT;

RECONNECT;

DROP TABLE "LVPResults";
COMMIT;

DROP TABLE "LVPResultsPL";
DROP TABLE "LVPResultsPN";
COMMIT;

DROP TABLE "LVPResultsWL";
DROP TABLE "LVPResultsWN";
COMMIT;

DROP TABLE "LVWResults";
COMMIT;

DROP TABLE "LVWResultsPL";
DROP TABLE "LVWResultsPN";
COMMIT;

DROP TABLE "LVWResultsWL";
DROP TABLE "LVWResultsWN";

COMMIT;

CREATE TRIGGER "WorkLogLVResultsInsertTrigger" FOR "LVResults" AFTER INSERT
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(50);
DECLARE VARIABLE AEvent Smallint;
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Fiders"."Name"||' :'||"Nodes"."Info" ||' :'||"LVFiders"."Name"
   FROM "LVFiders"
   INNER JOIN "Nodes" ON ("LVFiders"."OwnerGUID" = "Nodes".GUID)
   INNER JOIN "Fiders" ON ("Nodes"."OwnerGUID" = "Fiders".GUID)
   WHERE ("LVFiders".GUID = NEW.GUID)
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   IF (New."CalcType"=1) THEN AEvent=110; ELSE
   IF (New."CalcType"=2) THEN AEvent=106;
   ELSE AEvent=112;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,:AEvent,:ASampleDate);
 END
END ;

CREATE TRIGGER "WorkLogLVResultsDeleteTrigger" FOR "LVResults" BEFORE DELETE
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(50);
DECLARE VARIABLE AEvent Smallint;
BEGIN
 IF (OLD."GUID"<>0 and
     exists (select * from "Fiders" where "GUID"=OLD."GUID")) THEN
  BEGIN
   SELECT ': '||"Fiders"."Name"||' :'||"Nodes"."Info" ||' :'||"LVFiders"."Name"
   FROM "LVFiders"
   INNER JOIN "Nodes" ON ("LVFiders"."OwnerGUID" = "Nodes".GUID)
   INNER JOIN "Fiders" ON ("Nodes"."OwnerGUID" = "Fiders".GUID)
   WHERE ("LVFiders".GUID = OLD.GUID)
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   IF (OLD."CalcType"=1) THEN AEvent=111; ELSE
   IF (OLD."CalcType"=2) THEN AEvent=107;
   ELSE AEvent=113;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,:AEvent,:ASampleDate);
 END
END ;

COMMIT;

CREATE TABLE "AddEqReferences" ("Ident" "TIdent","TypeEq" "TIdent",
 "Param" "DECIMAL_6_2_NOT_NULL","dW" "DOUBLE_NOT_NULL_ABOVE_0",
CONSTRAINT "PK_AddEqReferences" PRIMARY KEY ("Ident"));
CREATE UNIQUE INDEX "idxAddEqReferences" ON "AddEqReferences" ("TypeEq","Param");
GRANT ALL ON "AddEqReferences" TO "rtp3user";

CREATE TABLE "AddEqIsolatorsRef"("Region" "TIdent","Unom" "DECIMAL_6_2_NOT_NULL",
 "dW" "DECIMAL_5_2",
CONSTRAINT "PK_AddEqIsolatorsRef" PRIMARY KEY ("Region","Unom"));
GRANT ALL ON "AddEqIsolatorsRef" TO "rtp3user" ;

CREATE TABLE "AddEqNumbers" ("SampleDate" DATE NOT NULL,"GUID" "TIntegerIdent",
 "AddEqType" "TIdent","Value" "DECIMAL_18_3_NOT_NULL",
CONSTRAINT "PK_AddEqNumbers" PRIMARY KEY ("SampleDate","GUID","AddEqType"),
CONSTRAINT "FK_AddEqNumbers_GUID" FOREIGN KEY ("GUID")
 REFERENCES "GUID" ("GUID") ON DELETE CASCADE ON UPDATE CASCADE,
CONSTRAINT "FK_AddEqNumbers_MeterType" FOREIGN KEY ("AddEqType")
 REFERENCES "AddEqReferences" ("Ident") ON UPDATE CASCADE);
GRANT ALL ON "AddEqNumbers" TO "rtp3user";

CREATE TABLE "AddEqSynchCondensers" ("SampleDate" DATE NOT NULL,
 "GUID" "TIntegerIdent",
 "Unom" "DECIMAL_6_2_NOT_NULL","Power" "DECIMAL_6_2_NOT_NULL",
 "Value" "DECIMAL_18_3_NOT_NULL",
 CONSTRAINT "PK_AddEqSynchCondensers" PRIMARY KEY ("SampleDate","GUID","Unom","Power"),
 CONSTRAINT "FK_AddEqSynchCondensers_GUID" FOREIGN KEY ("GUID")
  REFERENCES "GUID" ("GUID") ON DELETE CASCADE ON UPDATE CASCADE,
 CONSTRAINT "FK_AddEqSynchCondensers_Unom" FOREIGN KEY ("Unom")
  REFERENCES "Unom" ("Unom"));
GRANT ALL ON "AddEqSynchCondensers" TO "rtp3user";

COMMIT;

INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (1,-3, 6, 1.54);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (2,-3, 10, 1.9);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (3,-3, 15, 2.35);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (4,-3, 20, 2.7);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (5,-3, 35, 3.6);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (6,-3, 110, 11);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (7,-3, 220, 13.1);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (8,-2, 0.38, cast(0.05 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (9,-2, 6, cast(0.06 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (10,-2, 10, cast(0.1 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (11,-2, 15, cast(0.15 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (12,-2, 20, cast(0.2 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (13,-2, 35, cast(0.4 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (14,-2, 110, cast(1.1 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (15,-2, 220, cast(2.2 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (16,-1, 6, cast(1.54 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (17,-1, 10, cast(1.9 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (18,-1, 15, cast(2.35 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (19,-1, 20, cast(2.7 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (20,-1, 35, cast(3.6 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (21,-1, 110, cast(11 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (22,-1, 220, cast(13 as DOUBLE PRECISION)/3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (23,1, 0, 0.0184);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (24,2, 0, 0.0219);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (25,3, 0, 0.0920);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (26,4, 0, 0.0736);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (27,6, 6, 84);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (28,6, 10, 84);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (29,-6, 15, 74);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (30,-6, 20, 65);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (31,6, 35, 36);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (32,6, 110, 32);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (33,6, 220, 29);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (34,7, 6, 1.3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (35,7, 10, 1.3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (36,7, 15, 1.3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (37,7, 20, 1.3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (38,7, 35, 3);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (39,7, 110, 11);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (40,7, 220, 31);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (41,8, 5, 400);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (42,8, 7.5, 540);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (43,8, 10, 675);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (44,8, 15, 970);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (45,8, 30, 1570);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (46,8, 50, 2160);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (47,8, 100, 3645);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (48,8, 160, 4725);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (49,8, 320, 10260);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (50,9, 6, 0.009);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (51,9, 10, 0.021);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (52,9, 15, 0.033);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (53,9, 20, 0.047);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (54,9, 35, 0.091);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (55,9, 110, 0.6);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (56,9, 220, 1.59);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (57,10, 6, 0.001);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (58,10, 10, 0.001);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (59,10, 15, 0.002);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (60,10, 20, 0.004);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (61,10, 35, 0.013);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (62,10, 110, 0.22);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (63,10, 220, 0.74);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (64,11, 6, 0.01);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (65,11, 10, 0.01);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (66,11, 15, 0.01);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (67,11, 20, 0.02);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (68,11, 35, 0.02);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (69,11, 110, 0.22);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (70,11, 220, 0.43);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (71,12, 6, 0);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (72,12, 10, 0);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (73,12, 15, 0);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (74,12, 20, 0);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (75,12, 35, 0);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (76,12, 110, 0);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (77,12, 220, 0);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (78,13, 0.38, 0.003);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (79,13, 6, 0.003);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (80,13, 10, 0.003);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (81,13, 15, 0.003);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (82,13, 20, 0.003);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (83,13, 35, 0.003);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (84,13, 110, 0.003);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (85,13, 220, 0.003);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (86,14, 0.38, 0.006);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (87,14, 6, 0.006);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (88,14, 10, 0.006);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (89,14, 15, 0.006);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (90,14, 20, 0.006);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (91,14, 35, 0.006);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (92,14, 110, 0.006);
INSERT INTO "AddEqReferences" ("Ident","TypeEq", "Param", "dW")
VALUES (93,14, 220, 0.006);

INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (1,6,0.21);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (1,10,0.33);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (1,15,0.48);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (1,20,0.64);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (1,35,0.69);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (1,110,1.08);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (1,220,1.35);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (2,6,0.22);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (2,10,0.35);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (2,15,0.52);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (2,20,0.69);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (2,35,0.73);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (2,110,1.15);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (2,220,1.44);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (3,6,0.28);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (3,10,0.45);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (3,15,0.67);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (3,20,0.88);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (3,35,0.95);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (3,110,1.15);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (3,220,1.86);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (4,6,0.31);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (4,10,0.51);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (4,15,0.75);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (4,20,1);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (4,35,1.07);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (4,110,1.68);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (4,220,2.1);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (5,6,0.27);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (5,10,0.44);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (5,15,0.65);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (5,20,0.87);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (5,35,0.92);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (5,110,1.46);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (5,220,1.82);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (6,6,0.22);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (6,10,0.35);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (6,15,0.52);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (6,20,0.68);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (6,35,0.73);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (6,110,1.15);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (6,220,1.44);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (7,6,0.16);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (7,10,0.26);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (7,15,0.39);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (7,20,0.51);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (7,35,0.55);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (7,110,0.86);
INSERT INTO "AddEqIsolatorsRef" ("Region","Unom","dW") VALUES (7,220,1.08);
COMMIT;

create view "AddEqNumbersView" as
select N."SampleDate", N.GUID, R."TypeEq",R."Param",N."Value" from "AddEqNumbers" N
inner join "AddEqReferences" R on R."Ident"=N."AddEqType";
COMMIT;

SET TERM ^ ;
CREATE TRIGGER "AddEqNumbersViewBI" FOR "AddEqNumbersView" BEFORE INSERT
AS
declare variable AValue1 decimal(18,3);
declare variable AddEqType smallint;
begin
 select "Ident" from "AddEqReferences"
 where "TypeEq"=NEW."TypeEq" and "Param"=NEW."Param"
 into :AddEqType;
 if (:AddEqType is not null) then
  begin
   select first 1 "Value"  from "AddEqNumbers"
   where GUID=NEW.guid and "AddEqType"=:AddEqType and "SampleDate"<NEW."SampleDate"
   order by "SampleDate" DESC
   into :AValue1;
   if (:AValue1 is null or NEW."Value"<>:AValue1) then
    insert into "AddEqNumbers" ("SampleDate","GUID","AddEqType","Value")
    values (NEW."SampleDate",NEW."GUID",:AddEqType,NEW."Value");
 end
end ^
SET TERM ; ^
COMMIT;

insert into "AddEqNumbersView" ("SampleDate","GUID","TypeEq","Param","Value")
select AD."SampleDate", AD."OwnerGUID",12,IR."Unom",IC."Qty"
from "AddEqData"  AD
inner join "IsolatorsCount" IC on IC."OwnerGUID"=AD.guid
inner join "IsolatorsReference" IR on IR."Ident"=IC."TypeIdent"
inner join "GUID" G ON G.GUID=AD."OwnerGUID"
order by 1;
COMMIT;

insert into "AddEqNumbersView" ("SampleDate","GUID","TypeEq","Param","Value")
select M."SampleDate",M."OwnerGUID",M."MeterType",M."Unom",
 cast(M."Count" as DECIMAL (18,3))
from "MeterCount" M
inner join "GUID" G ON G.GUID=M."OwnerGUID"
where M."MeterType"<0
order by 1;

insert into "AddEqNumbersView" ("SampleDate","GUID","TypeEq","Param","Value")
select M."SampleDate",M."OwnerGUID",M."MeterType", 0 as "Param",
 cast(M."Count" as DECIMAL (18,3))
from "MeterCount" M
inner join "GUID" G ON G.GUID=M."OwnerGUID"
where M."MeterType">0 and M."Unom" between 0 and 1
order by 1;
COMMIT;

insert into "AddEqNumbersView" ("SampleDate","GUID","TypeEq","Param","Value")
select AD."SampleDate", AD."OwnerGUID", AER."Type",COALESCE(AER."Unom",0.38),
 cast(AEC."Qty" as DECIMAL (18,3))
from "AddEqData" AD
inner join "AddEqCount" AEC on AEC."OwnerGUID"=AD.guid
inner join "AddEqReference" AER on AER."Ident"=AEC."TypeIdent"
inner join "GUID" G ON G.GUID=AD."OwnerGUID"
where AER."Type"<>8
order by 1;
COMMIT;

create view "AddEqSynchCondensersView" as
select "SampleDate","GUID","Unom","Power","Value" from "AddEqSynchCondensers";
COMMIT;

SET TERM ^ ;
CREATE TRIGGER "AddEqSynchCondensersViewBI" FOR "AddEqSynchCondensersView" BEFORE INSERT
AS
declare variable AValue1 decimal(18,3);
begin
 select first 1 "Value"  from "AddEqSynchCondensers"
 where GUID=NEW."GUID" and "Unom"=NEW."Unom" and "Power"=NEW."Power" and
  "SampleDate"<NEW."SampleDate"
 order by "SampleDate" DESC
 into :AValue1;
 if (:AValue1 is null or NEW."Value"<>:AValue1) then
  insert into "AddEqSynchCondensers" ("SampleDate", "GUID", "Unom", "Power", "Value")
  values (NEW."SampleDate",NEW."GUID",NEW."Unom",NEW."Power",NEW."Value");
end ^
SET TERM ; ^
COMMIT;

insert into "AddEqSynchCondensersView" ("SampleDate","GUID","Unom","Power","Value")
select AD."SampleDate",AD."OwnerGUID",0.38,AER.pck,AEC."Qty"
from "AddEqData" AD
inner join "AddEqCount" AEC on AEC."OwnerGUID"=AD.guid
inner join "AddEqReference" AER on AER."Ident"=AEC."TypeIdent"
inner join "GUID" G on G."GUID"=AD."OwnerGUID"
where AER."Type"=8
order by 1;
COMMIT;

drop TRIGGER "AddEqNumbersViewBI";
drop TRIGGER "AddEqSynchCondensersViewBI";
COMMIT;

RECONNECT;

DROP TABLE "AddEqCount";
DROP TABLE "CurrentLimitReactorsData";
DROP TABLE "CurrentLimitReactors";
DROP TABLE "IsolatorsCount";
DROP TABLE "MeterCount";
DROP TABLE "MeterRecords";
DROP TABLE "MeterTotal";
DROP TABLE "AddEqData";
DROP TABLE "AddEqReference";
DROP TABLE "IsolatorsReference";
DROP TABLE "MeterTransf";
COMMIT;

drop view "AddEqNumbersView";
drop view "AddEqSynchCondensersView";
COMMIT;

DROP GENERATOR "MeterRecords_Ident_GEN";
DROP GENERATOR "MeterCount_Ident_GEN";

COMMIT;

ALTER TRIGGER "WorkLogLVPSamplesDeleteTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (OLD."GUID"<>0 and
     exists (select * from "Fiders" where "GUID"=OLD."GUID")) THEN
  BEGIN
   SELECT ': '||"Fiders"."Name"||' :'||"Nodes"."Info" ||' :'||"LVFiders"."Name"
   FROM "LVFiders"
   INNER JOIN "Nodes" ON ("LVFiders"."OwnerGUID" = "Nodes".GUID)
   INNER JOIN "Fiders" ON ("Nodes"."OwnerGUID" = "Fiders".GUID)
   WHERE ("LVFiders".GUID = OLD.GUID)
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,105,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogLVPSamplesInsertTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Fiders"."Name"||' :'||"Nodes"."Info" ||' :'||"LVFiders"."Name"
   FROM "LVFiders"
   INNER JOIN "Nodes" ON ("LVFiders"."OwnerGUID" = "Nodes".GUID)
   INNER JOIN "Fiders" ON ("Nodes"."OwnerGUID" = "Fiders".GUID)
   WHERE ("LVFiders".GUID = NEW.GUID)
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,104,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogLVPSamplesUpdateTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Fiders"."Name"||' :'||"Nodes"."Info" ||' :'||"LVFiders"."Name"
   FROM "LVFiders"
   INNER JOIN "Nodes" ON ("LVFiders"."OwnerGUID" = "Nodes".GUID)
   INNER JOIN "Fiders" ON ("Nodes"."OwnerGUID" = "Fiders".GUID)
   WHERE ("LVFiders".GUID = NEW.GUID)
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,104,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogLVResultsDeleteTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
DECLARE VARIABLE AEvent Smallint;
BEGIN
 IF (OLD."GUID"<>0 and
     exists (select * from "Fiders" where "GUID"=OLD."GUID")) THEN
  BEGIN
   SELECT ': '||"Fiders"."Name"||' :'||"Nodes"."Info" ||' :'||"LVFiders"."Name"
   FROM "LVFiders"
   INNER JOIN "Nodes" ON ("LVFiders"."OwnerGUID" = "Nodes".GUID)
   INNER JOIN "Fiders" ON ("Nodes"."OwnerGUID" = "Fiders".GUID)
   WHERE ("LVFiders".GUID = OLD.GUID)
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   IF (OLD."CalcType"=1) THEN AEvent=111; ELSE
   IF (OLD."CalcType"=2) THEN AEvent=107;
   ELSE AEvent=113;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,:AEvent,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogLVResultsInsertTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
DECLARE VARIABLE AEvent Smallint;
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Fiders"."Name"||' :'||"Nodes"."Info" ||' :'||"LVFiders"."Name"
   FROM "LVFiders"
   INNER JOIN "Nodes" ON ("LVFiders"."OwnerGUID" = "Nodes".GUID)
   INNER JOIN "Fiders" ON ("Nodes"."OwnerGUID" = "Fiders".GUID)
   WHERE ("LVFiders".GUID = NEW.GUID)
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   IF (New."CalcType"=1) THEN AEvent=110; ELSE
   IF (New."CalcType"=2) THEN AEvent=106;
   ELSE AEvent=112;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,:AEvent,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogLVWSamplesDeleteTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (OLD."GUID"<>0 and
     exists (select * from "Fiders" where "GUID"=OLD."GUID")) THEN
  BEGIN
   SELECT ': '||"Fiders"."Name"||' :'||"Nodes"."Info" ||' :'||"LVFiders"."Name"
   FROM "LVFiders"
   INNER JOIN "Nodes" ON ("LVFiders"."OwnerGUID" = "Nodes".GUID)
   INNER JOIN "Fiders" ON ("Nodes"."OwnerGUID" = "Fiders".GUID)
   WHERE ("LVFiders".GUID = OLD.GUID)
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,109,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogLVWSamplesInsertTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Fiders"."Name"||' :'||"Nodes"."Info" ||' :'||"LVFiders"."Name"
   FROM "LVFiders"
   INNER JOIN "Nodes" ON ("LVFiders"."OwnerGUID" = "Nodes".GUID)
   INNER JOIN "Fiders" ON ("Nodes"."OwnerGUID" = "Fiders".GUID)
   WHERE ("LVFiders".GUID = NEW.GUID)
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,108,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogLVWSamplesUpdateTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Fiders"."Name"||' :'||"Nodes"."Info" ||' :'||"LVFiders"."Name"
   FROM "LVFiders"
   INNER JOIN "Nodes" ON ("LVFiders"."OwnerGUID" = "Nodes".GUID)
   INNER JOIN "Fiders" ON ("Nodes"."OwnerGUID" = "Fiders".GUID)
   WHERE ("LVFiders".GUID = NEW.GUID)
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,108,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogMVResultsDeleteTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
DECLARE VARIABLE AEvent Smallint;
BEGIN
 IF (OLD."GUID"<>0 and
     exists (select * from "Fiders" where "GUID"=OLD."GUID")) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=OLD."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   IF (OLD."CalcType"=0) THEN AEvent=11; ELSE
   IF (OLD."CalcType"=1) THEN AEvent=15; ELSE
   IF (OLD."CalcType"=1) THEN AEvent=7;
   ELSE AEvent=17;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,:AEvent,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogPSamplesDeleteTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (OLD."GUID"<>0 and
     exists (select * from "Fiders" where "GUID"=OLD."GUID")) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=OLD."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,5,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogPSamplesInsertTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=NEW."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,4,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogPSamplesUpdateTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=NEW."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,4,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogWResultsLCDelete"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (OLD."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=OLD."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,206,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogWResultsLCInsert"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=NEW."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,205,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogWSamplesDeleteTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (OLD."GUID"<>0 and
     exists (select * from "Fiders" where "GUID"=OLD."GUID")) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=OLD."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,9,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogWSamplesInsertTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=NEW."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,8,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogWSamplesUpdateTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=NEW."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,8,:ASampleDate);
 END
END;

ALTER TRIGGER "WorkLogMVResultsInsertTrigger"
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(52);
DECLARE VARIABLE AEvent Smallint;
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=NEW."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   IF (New."CalcType"=0) THEN AEvent=10; ELSE
   IF (New."CalcType"=1) THEN AEvent=14; ELSE
   IF (New."CalcType"=2) THEN AEvent=6;
   ELSE AEvent=16;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,:AEvent,:ASampleDate);
 END
END;

GRANT ALL ON "Manufacturers" TO "rtp3user";

COMMIT;

ALTER trigger "WorkLogLVPSamplesUpdateTrigger" inactive;
ALTER TABLE "LVPSamples" ALTER "Kdp" TO "KdpOLD";
ALTER TABLE "LVPSamples"ADD "Kdp" DECIMAL_6_5;
COMMIT;
UPDATE "LVPSamples" SET "Kdp"="KdpOLD";
COMMIT;
ALTER TABLE "LVPSamples" DROP "KdpOLD";
ALTER TABLE "LVPSamples" ALTER COLUMN "Kdp" POSITION 20;
ALTER trigger "WorkLogLVPSamplesUpdateTrigger" active;
COMMIT;

ALTER trigger "LVPTPInfoAfterUpdateTrigger" inactive;
ALTER TABLE "LVPTPInfo" ALTER "Kdp" TO "KdpOLD";
ALTER TABLE "LVPTPInfo" ADD "Kdp" DECIMAL_6_5;
COMMIT;
UPDATE "LVPTPInfo" SET "Kdp"="KdpOLD";
COMMIT;
ALTER TABLE "LVPTPInfo" DROP "KdpOLD";
ALTER TABLE "LVPTPInfo" ALTER COLUMN "Kdp" POSITION 17;
ALTER trigger "LVPTPInfoAfterUpdateTrigger" active;
COMMIT;

ALTER trigger "WorkLogLVWSamplesUpdateTrigger" inactive;
ALTER TABLE "LVWSamples" ALTER "Kdp" TO "KdpOLD";
ALTER TABLE "LVWSamples" ADD "Kdp" DECIMAL_6_5;
COMMIT;
UPDATE "LVWSamples" SET "Kdp"="KdpOLD";
COMMIT;
ALTER TABLE "LVWSamples" DROP "KdpOLD";
ALTER TABLE "LVWSamples" ALTER COLUMN "Kdp" POSITION 22;
ALTER trigger "WorkLogLVWSamplesUpdateTrigger" active;
COMMIT;

ALTER trigger "LVWTPInfoAfterUpdateTrigger" inactive;
ALTER TABLE "LVWTPInfo" ALTER "Kdp" TO "KdpOLD";
ALTER TABLE "LVWTPInfo" ADD "Kdp" DECIMAL_6_5;
COMMIT;
UPDATE "LVWTPInfo" SET "Kdp"="KdpOLD";
COMMIT;
ALTER TABLE "LVWTPInfo" DROP "KdpOLD";
ALTER TABLE "LVWTPInfo" ALTER COLUMN "Kdp" POSITION 17;
ALTER trigger "LVWTPInfoAfterUpdateTrigger" active;
COMMIT;

ALTER procedure "InsertMVResults" (
    CALCTYPE smallint,
    SAMPLEIDENT integer,
    GUID integer,
    T double precision,
    U double precision,
    IMAX double precision,
    KZAP double precision,
    SQRKFG double precision,
    SQRKFGCALC double precision,
    DUMAX double precision,
    DWDOP double precision,
    WEATHERCONDITIONS integer,
    TEMPERATURE double precision,
    FLAGS integer,
    CRC blob sub_type 0 segment size 48)
returns (
    IDENT integer)
as
BEGIN

END;

ALTER trigger "MVResultsBeforeUpdate" inactive
AS
BEGIN

END;

ALTER TABLE "MVResults" ALTER "dWdop" TO "dWdopOLD";
ALTER TABLE "MVResults" ADD "dWdop" DOUBLE_ABOVE_0;
COMMIT;
UPDATE "MVResults" SET "dWdop"="dWdopOLD";
COMMIT;
ALTER TABLE "MVResults" DROP "dWdopOLD";
ALTER TABLE "MVResults" ALTER COLUMN "dWdop" POSITION 6;
ALTER trigger "MVResultsBeforeUpdate" active
AS
BEGIN
 IF (NEW."CalcType"<>OLD."CalcType" OR
     NEW."T"<>NEW."T" OR
     NEW."U"<>NEW."U" OR
     NEW."Imax"<>NEW."Imax" OR
     NEW."Kzap"<>NEW."Kzap" OR
     NEW."sqrKfg"<>NEW."sqrKfg" OR
     NEW."sqrKfgCalc"<>NEW."sqrKfgCalc" OR
     NEW."dUmax"<>NEW."dUmax" OR
     NEW."dWdop"<>NEW."dWdop" OR
     NEW."Temperature"<>NEW."Temperature" OR
     NEW."Flags"<>NEW."Flags" OR
     NEW."CRC"<>NEW.crc)
 THEN EXCEPTION "NoRelease";
END;

alter procedure "InsertMVResults" (
    CALCTYPE smallint,
    SAMPLEIDENT integer,
    GUID integer,
    T double precision,
    U double precision,
    IMAX double precision,
    KZAP double precision,
    SQRKFG double precision,
    SQRKFGCALC double precision,
    DUMAX double precision,
    DWDOP double precision,
    WEATHERCONDITIONS integer,
    TEMPERATURE double precision,
    FLAGS integer,
    CRC blob sub_type 0 segment size 48)
returns (
    IDENT integer)
as
BEGIN
 DELETE FROM "MVResults"
 WHERE "CalcType"=:CalcType and "SampleIdent"=:SampleIdent and "GUID"=:GUID;
 Ident=GEN_ID("MVResultsIdent",1);
 INSERT INTO "MVResults" ("Ident","CalcType","SampleIdent","GUID",
  "T","U","Imax","Kzap","sqrKfg","sqrKfgCalc","dUmax","dWdop",
  "WeatherConditions","Temperature","Flags","CRC")
 VALUES (:Ident,:CalcType,:SampleIdent,:GUID,:T,:U,
  :Imax,:Kzap,:sqrKfg,:sqrKfgCalc,:dUmax,:dWdop,
  :WeatherConditions,:Temperature,:Flags,:CRC);
END;

COMMIT;

update "MeteragesByPeriod" set "Value"="Value"/1000;
COMMIT;

UPDATE "Version" SET "Major"=4, "Minor"=0, "Release"=24,"Build"=0, "VersionDate"='NOW';
COMMIT;

/*============================================================================= */


