Delete From "WResults" Where "GUID"=0;
COMMIT ;

ALTER TABLE "Fiders" ADD "fCircuit" "YesNo"; /* + fCircuit */

ALTER TABLE "Fiders" ALTER COLUMN GUID POSITION 1;
ALTER TABLE "Fiders" ALTER COLUMN "OwnerGUID" POSITION 2;
ALTER TABLE "Fiders" ALTER COLUMN "Name" POSITION 3;
ALTER TABLE "Fiders" ALTER COLUMN "fCircuit" POSITION 4;
ALTER TABLE "Fiders" ALTER COLUMN DBB POSITION 5;
ALTER TABLE "Fiders" ALTER COLUMN "Dkor" POSITION 6;

/*--   "Generators"   */
CREATE TABLE "Generators"(GUID "TIntegerIdent",
"BaseGenerator" "YesNo",
"Unom" DECIMAL_6_2_NOT_NULL,
"Qmin" NUMBER_9_3,
"Qmax" NUMBER_9_3);
ALTER TABLE "Generators" ADD CONSTRAINT "PK_Generators" PRIMARY KEY (GUID);
ALTER TABLE "Generators" ADD CONSTRAINT "FK_GeneratorsGUID" FOREIGN KEY (GUID)
 REFERENCES "Nodes" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "Generators" ADD CONSTRAINT "FK_GeneratorsUnom" FOREIGN KEY ("Unom")
 REFERENCES "Unom" ("Unom");
ALTER TABLE "Generators" ADD CONSTRAINT "CHECK_Generators" CHECK(
  (select "Transf" from "Nodes" where "Nodes"."GUID"="Generators"."GUID")=-1);
GRANT ALL ON "Generators" TO "rtp3user";

/*--   "PLoadsGenerators"  */
CREATE TABLE "PLoadsGenerators"("SampleIdent" "TIntegerIdent",
GUID "TIntegerIdent",
P DECIMAL_11_3,
Q NUMBER_11_3,
U DECIMAL_7_3);
ALTER TABLE "PLoadsGenerators" ADD CONSTRAINT "PK_PLoadsGenerators"
 PRIMARY KEY ("SampleIdent", GUID);
ALTER TABLE "PLoadsGenerators" ADD CONSTRAINT "FK_PLoadsGenerators_GUID"
 FOREIGN KEY (GUID)
 REFERENCES "Generators" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "PLoadsGenerators" ADD CONSTRAINT "FK_PLoadsGenerators_SampleIdent"
 FOREIGN KEY ("SampleIdent")
 REFERENCES "SamplesDates" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;
GRANT ALL ON "PLoadsGenerators" TO "rtp3user";

/*--   "WLoadsGenerators"  */
CREATE TABLE "WLoadsGenerators"("SampleIdent" "TIntegerIdent",
GUID "TIntegerIdent",
"Wa" NUMBER_11_3_NOT_NULL,
"Wr" NUMBER_11_3,
U DECIMAL_7_3,
"Imax" DECIMAL_9_3,
"Kzap" DECIMAL_5_4_1,
"sqrKfg" DECIMAL_6_5);
ALTER TABLE "WLoadsGenerators" ADD CONSTRAINT "PK_WLoadsGenerators"
 PRIMARY KEY ("SampleIdent", GUID);
ALTER TABLE "WLoadsGenerators" ADD CONSTRAINT "FK_WLoadsGenerators_GUID"
 FOREIGN KEY (GUID)
 REFERENCES "Generators" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "WLoadsGenerators" ADD CONSTRAINT "FK_WLoadsGenerators_SampleIdent"
 FOREIGN KEY ("SampleIdent")
 REFERENCES "SamplesDates" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;
GRANT ALL ON "WLoadsGenerators" TO "rtp3user";

/*--   */
ALTER TABLE "LVPResults" DROP "dPk_OnBalance";
ALTER TABLE "LVPResults" DROP "dPk_notBalance";
ALTER TABLE "LVPResults" DROP "dWak_OnBalance";
ALTER TABLE "LVPResults" DROP "dWak_notBalance";
COMMIT;

update "LVPResults" R set R."T"=
(select (S."SampleDate2"-S."SampleDate1")*24 from "SamplesDates" S
 where R."SampleIdent"=S."Ident");
COMMIT;

/*--     "LVPResults"   */
ALTER TABLE "LVPResults" ALTER COLUMN U2A TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN U2B TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN U2C TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Wa" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Wr" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVPResults" ALTER COLUMN T TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN P TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN Q TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVPResults" ALTER COLUMN "dP_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "dP_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "dQ_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "dQ_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "dWa_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "dWa_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "dWr_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "dWr_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Pcalc_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Pcalc_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Qcalc_OnBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVPResults" ALTER COLUMN "Qcalc_notBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVPResults" ALTER COLUMN "Pfakt_OnBalance" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Pfakt_notBalance" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Qfakt_OnBalance" TYPE DOUBLE PRECISION;
ALTER TABLE "LVPResults" ALTER COLUMN "Qfakt_notBalance" TYPE DOUBLE PRECISION;
ALTER TABLE "LVPResults" ALTER COLUMN "Wacalc_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Wacalc_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrcalc_OnBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrcalc_notBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVPResults" ALTER COLUMN "Wafakt_OnBalance" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Wafakt_notBalance" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrfakt_OnBalance" TYPE DOUBLE PRECISION;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrfakt_notBalance" TYPE DOUBLE PRECISION;
ALTER TABLE "LVPResults" ALTER COLUMN "Kdp" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVPResults" ALTER COLUMN "Krazv" TYPE DOUBLE_NOT_NULL_ABOVE_0;
Commit;
/*--     */
ALTER TABLE "LVPResults" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "LVPResults" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "LVPResults" ALTER COLUMN UA POSITION 3;
ALTER TABLE "LVPResults" ALTER COLUMN UB POSITION 4;
ALTER TABLE "LVPResults" ALTER COLUMN UC POSITION 5;
ALTER TABLE "LVPResults" ALTER COLUMN IA POSITION 6;
ALTER TABLE "LVPResults" ALTER COLUMN IB POSITION 7;
ALTER TABLE "LVPResults" ALTER COLUMN IC POSITION 8;
ALTER TABLE "LVPResults" ALTER COLUMN "CosFiA" POSITION 9;
ALTER TABLE "LVPResults" ALTER COLUMN "CosFiB" POSITION 10;
ALTER TABLE "LVPResults" ALTER COLUMN "CosFiC" POSITION 11;
ALTER TABLE "LVPResults" ALTER COLUMN U2A POSITION 12;
ALTER TABLE "LVPResults" ALTER COLUMN U2B POSITION 13;
ALTER TABLE "LVPResults" ALTER COLUMN U2C POSITION 14;
ALTER TABLE "LVPResults" ALTER COLUMN "Wa" POSITION 15;
ALTER TABLE "LVPResults" ALTER COLUMN "Wr" POSITION 16;
ALTER TABLE "LVPResults" ALTER COLUMN T POSITION 17;
ALTER TABLE "LVPResults" ALTER COLUMN P POSITION 18;
ALTER TABLE "LVPResults" ALTER COLUMN Q POSITION 19;
ALTER TABLE "LVPResults" ALTER COLUMN "dP_OnBalance" POSITION 20;
ALTER TABLE "LVPResults" ALTER COLUMN "dP_notBalance" POSITION 21;
ALTER TABLE "LVPResults" ALTER COLUMN "dQ_OnBalance" POSITION 22;
ALTER TABLE "LVPResults" ALTER COLUMN "dQ_notBalance" POSITION 23;
ALTER TABLE "LVPResults" ALTER COLUMN "dWa_OnBalance" POSITION 24;
ALTER TABLE "LVPResults" ALTER COLUMN "dWa_notBalance" POSITION 25;
ALTER TABLE "LVPResults" ALTER COLUMN "dWr_OnBalance" POSITION 26;
ALTER TABLE "LVPResults" ALTER COLUMN "dWr_notBalance" POSITION 27;
ALTER TABLE "LVPResults" ALTER COLUMN "Pcalc_OnBalance" POSITION 28;
ALTER TABLE "LVPResults" ALTER COLUMN "Pcalc_notBalance" POSITION 29;
ALTER TABLE "LVPResults" ALTER COLUMN "Qcalc_OnBalance" POSITION 30;
ALTER TABLE "LVPResults" ALTER COLUMN "Qcalc_notBalance" POSITION 31;
ALTER TABLE "LVPResults" ALTER COLUMN "Pfakt_OnBalance" POSITION 32;
ALTER TABLE "LVPResults" ALTER COLUMN "Pfakt_notBalance" POSITION 33;
ALTER TABLE "LVPResults" ALTER COLUMN "Qfakt_OnBalance" POSITION 34;
ALTER TABLE "LVPResults" ALTER COLUMN "Qfakt_notBalance" POSITION 35;
ALTER TABLE "LVPResults" ALTER COLUMN "Wacalc_OnBalance" POSITION 36;
ALTER TABLE "LVPResults" ALTER COLUMN "Wacalc_notBalance" POSITION 37;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrcalc_OnBalance" POSITION 38;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrcalc_notBalance" POSITION 39;
ALTER TABLE "LVPResults" ALTER COLUMN "Wafakt_OnBalance" POSITION 40;
ALTER TABLE "LVPResults" ALTER COLUMN "Wafakt_notBalance" POSITION 41;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrfakt_OnBalance" POSITION 42;
ALTER TABLE "LVPResults" ALTER COLUMN "Wrfakt_notBalance" POSITION 43;
ALTER TABLE "LVPResults" ALTER COLUMN "NAbonents_OnBalance" POSITION 44;
ALTER TABLE "LVPResults" ALTER COLUMN "NAbonents_NotBalance" POSITION 45;
ALTER TABLE "LVPResults" ALTER COLUMN "LsumP_OnBalance" POSITION 46;
ALTER TABLE "LVPResults" ALTER COLUMN "LsumP_NotBalance" POSITION 47;
ALTER TABLE "LVPResults" ALTER COLUMN "LsumC_OnBalance" POSITION 48;
ALTER TABLE "LVPResults" ALTER COLUMN "LsumC_NotBalance" POSITION 49;
ALTER TABLE "LVPResults" ALTER COLUMN "NLineP_OnBalance" POSITION 50;
ALTER TABLE "LVPResults" ALTER COLUMN "NLineP_NotBalance" POSITION 51;
ALTER TABLE "LVPResults" ALTER COLUMN "NLineC_OnBalance" POSITION 52;
ALTER TABLE "LVPResults" ALTER COLUMN "NLineC_NotBalance" POSITION 53;
ALTER TABLE "LVPResults" ALTER COLUMN "Lm" POSITION 54;
ALTER TABLE "LVPResults" ALTER COLUMN L23 POSITION 55;
ALTER TABLE "LVPResults" ALTER COLUMN L1 POSITION 56;
ALTER TABLE "LVPResults" ALTER COLUMN "Kdp" POSITION 57;
ALTER TABLE "LVPResults" ALTER COLUMN "Krazv" POSITION 58;
ALTER TABLE "LVPResults" ALTER COLUMN "Temperature" POSITION 59;
ALTER TABLE "LVPResults" ALTER COLUMN CRC POSITION 60;

/*--     "LVWResults"  */
ALTER TABLE "LVWResults" ADD "sqrKfg" DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Wa" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Wr" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVWResults" ALTER COLUMN T TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN U2A TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN U2B TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN U2C TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN P TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN Q TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVWResults" ALTER COLUMN "dP_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "dP_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "dQ_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "dQ_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "dWa_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "dWa_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "dWr_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "dWr_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Pcalc_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Pcalc_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Qcalc_OnBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVWResults" ALTER COLUMN "Qcalc_notBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVWResults" ALTER COLUMN "Pfakt_OnBalance" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Pfakt_notBalance" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Qfakt_OnBalance" TYPE DOUBLE PRECISION;
ALTER TABLE "LVWResults" ALTER COLUMN "Qfakt_notBalance" TYPE DOUBLE PRECISION;
ALTER TABLE "LVWResults" ALTER COLUMN "Wacalc_OnBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Wacalc_notBalance" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Wrcalc_OnBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVWResults" ALTER COLUMN "Wrcalc_notBalance" TYPE DOUBLE_NOT_NULL;
ALTER TABLE "LVWResults" ALTER COLUMN "Wafakt_OnBalance" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Wafakt_notBalance" TYPE DOUBLE_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Wrfakt_OnBalance" TYPE DOUBLE PRECISION;
ALTER TABLE "LVWResults" ALTER COLUMN "Wrfakt_notBalance" TYPE DOUBLE PRECISION;
ALTER TABLE "LVWResults" ALTER COLUMN "Kdp" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "Krazv" TYPE DOUBLE_NOT_NULL_ABOVE_0;
ALTER TABLE "LVWResults" ALTER COLUMN "dWdop" TYPE DOUBLE_ABOVE_0;
/*--   */
ALTER TABLE "LVWResults" DROP "IminA";
ALTER TABLE "LVWResults" DROP "IminB";
ALTER TABLE "LVWResults" DROP "IminC";
ALTER TABLE "LVWResults" DROP "dPk_OnBalance";
ALTER TABLE "LVWResults" DROP "dPk_notBalance";
ALTER TABLE "LVWResults" DROP "dWak_OnBalance";
ALTER TABLE "LVWResults" DROP "dWak_notBalance";
COMMIT;

Update "LVWResults" Set  "sqrKfg"="Kfg"*"Kfg";
COMMIT;

ALTER TABLE "LVWResults" DROP "Kfg";
/*--   */
ALTER TABLE "LVWResults" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "LVWResults" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "LVWResults" ALTER COLUMN UA POSITION 3;
ALTER TABLE "LVWResults" ALTER COLUMN UB POSITION 4;
ALTER TABLE "LVWResults" ALTER COLUMN UC POSITION 5;
ALTER TABLE "LVWResults" ALTER COLUMN IA POSITION 6;
ALTER TABLE "LVWResults" ALTER COLUMN IB POSITION 7;
ALTER TABLE "LVWResults" ALTER COLUMN IC POSITION 8;
ALTER TABLE "LVWResults" ALTER COLUMN "ImaxA" POSITION 9;
ALTER TABLE "LVWResults" ALTER COLUMN "ImaxB" POSITION 10;
ALTER TABLE "LVWResults" ALTER COLUMN "ImaxC" POSITION 11;
ALTER TABLE "LVWResults" ALTER COLUMN "CosFiA" POSITION 12;
ALTER TABLE "LVWResults" ALTER COLUMN "CosFiB" POSITION 13;
ALTER TABLE "LVWResults" ALTER COLUMN "CosFiC" POSITION 14;
ALTER TABLE "LVWResults" ALTER COLUMN "Wa" POSITION 15;
ALTER TABLE "LVWResults" ALTER COLUMN "Wr" POSITION 16;
ALTER TABLE "LVWResults" ALTER COLUMN T POSITION 17;
ALTER TABLE "LVWResults" ALTER COLUMN U2A POSITION 18;
ALTER TABLE "LVWResults" ALTER COLUMN U2B POSITION 19;
ALTER TABLE "LVWResults" ALTER COLUMN U2C POSITION 20;
ALTER TABLE "LVWResults" ALTER COLUMN P POSITION 21;
ALTER TABLE "LVWResults" ALTER COLUMN Q POSITION 22;
ALTER TABLE "LVWResults" ALTER COLUMN "dP_OnBalance" POSITION 23;
ALTER TABLE "LVWResults" ALTER COLUMN "dP_notBalance" POSITION 24;
ALTER TABLE "LVWResults" ALTER COLUMN "dQ_OnBalance" POSITION 25;
ALTER TABLE "LVWResults" ALTER COLUMN "dQ_notBalance" POSITION 26;
ALTER TABLE "LVWResults" ALTER COLUMN "dWa_OnBalance" POSITION 27;
ALTER TABLE "LVWResults" ALTER COLUMN "dWa_notBalance" POSITION 28;
ALTER TABLE "LVWResults" ALTER COLUMN "dWr_OnBalance" POSITION 29;
ALTER TABLE "LVWResults" ALTER COLUMN "dWr_notBalance" POSITION 30;
ALTER TABLE "LVWResults" ALTER COLUMN "Pcalc_OnBalance" POSITION 31;
ALTER TABLE "LVWResults" ALTER COLUMN "Pcalc_notBalance" POSITION 32;
ALTER TABLE "LVWResults" ALTER COLUMN "Qcalc_OnBalance" POSITION 33;
ALTER TABLE "LVWResults" ALTER COLUMN "Qcalc_notBalance" POSITION 34;
ALTER TABLE "LVWResults" ALTER COLUMN "Pfakt_OnBalance" POSITION 35;
ALTER TABLE "LVWResults" ALTER COLUMN "Pfakt_notBalance" POSITION 36;
ALTER TABLE "LVWResults" ALTER COLUMN "Qfakt_OnBalance" POSITION 37;
ALTER TABLE "LVWResults" ALTER COLUMN "Qfakt_notBalance" POSITION 38;
ALTER TABLE "LVWResults" ALTER COLUMN "Wacalc_OnBalance" POSITION 39;
ALTER TABLE "LVWResults" ALTER COLUMN "Wacalc_notBalance" POSITION 40;
ALTER TABLE "LVWResults" ALTER COLUMN "Wrcalc_OnBalance" POSITION 41;
ALTER TABLE "LVWResults" ALTER COLUMN "Wrcalc_notBalance" POSITION 42;
ALTER TABLE "LVWResults" ALTER COLUMN "Wafakt_OnBalance" POSITION 43;
ALTER TABLE "LVWResults" ALTER COLUMN "Wafakt_notBalance" POSITION 44;
ALTER TABLE "LVWResults" ALTER COLUMN "Wrfakt_OnBalance" POSITION 45;
ALTER TABLE "LVWResults" ALTER COLUMN "Wrfakt_notBalance" POSITION 46;
ALTER TABLE "LVWResults" ALTER COLUMN "NAbonents_OnBalance" POSITION 47;
ALTER TABLE "LVWResults" ALTER COLUMN "NAbonents_NotBalance" POSITION 48;
ALTER TABLE "LVWResults" ALTER COLUMN "LsumP_OnBalance" POSITION 49;
ALTER TABLE "LVWResults" ALTER COLUMN "LsumP_NotBalance" POSITION 50;
ALTER TABLE "LVWResults" ALTER COLUMN "LsumC_OnBalance" POSITION 51;
ALTER TABLE "LVWResults" ALTER COLUMN "LsumC_NotBalance" POSITION 52;
ALTER TABLE "LVWResults" ALTER COLUMN "NLineP_OnBalance" POSITION 53;
ALTER TABLE "LVWResults" ALTER COLUMN "NLineP_NotBalance" POSITION 54;
ALTER TABLE "LVWResults" ALTER COLUMN "NLineC_OnBalance" POSITION 55;
ALTER TABLE "LVWResults" ALTER COLUMN "NLineC_NotBalance" POSITION 56;
ALTER TABLE "LVWResults" ALTER COLUMN "Lm" POSITION 57;
ALTER TABLE "LVWResults" ALTER COLUMN L23 POSITION 58;
ALTER TABLE "LVWResults" ALTER COLUMN L1 POSITION 59;
ALTER TABLE "LVWResults" ALTER COLUMN "Kdp" POSITION 60;
ALTER TABLE "LVWResults" ALTER COLUMN "sqrKfg" POSITION 61;
ALTER TABLE "LVWResults" ALTER COLUMN "Krazv" POSITION 62;
ALTER TABLE "LVWResults" ALTER COLUMN "dWdop" POSITION 63;
ALTER TABLE "LVWResults" ALTER COLUMN "Temperature" POSITION 64;
ALTER TABLE "LVWResults" ALTER COLUMN CRC POSITION 65;

/*--  "LVWSamples"   */
ALTER TABLE "LVWSamples" DROP "IminA";
ALTER TABLE "LVWSamples" DROP "IminB";
ALTER TABLE "LVWSamples" DROP "IminC";
/*--      */
ALTER TABLE "LVWSamples" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "LVWSamples" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "LVWSamples" ALTER COLUMN "TypeCalc" POSITION 3;
ALTER TABLE "LVWSamples" ALTER COLUMN UA POSITION 4;
ALTER TABLE "LVWSamples" ALTER COLUMN UB POSITION 5;
ALTER TABLE "LVWSamples" ALTER COLUMN UC POSITION 6;
ALTER TABLE "LVWSamples" ALTER COLUMN IA POSITION 7;
ALTER TABLE "LVWSamples" ALTER COLUMN IB POSITION 8;
ALTER TABLE "LVWSamples" ALTER COLUMN IC POSITION 9;
ALTER TABLE "LVWSamples" ALTER COLUMN "ImaxA" POSITION 10;
ALTER TABLE "LVWSamples" ALTER COLUMN "ImaxB" POSITION 11;
ALTER TABLE "LVWSamples" ALTER COLUMN "ImaxC" POSITION 12;
ALTER TABLE "LVWSamples" ALTER COLUMN U2A POSITION 13;
ALTER TABLE "LVWSamples" ALTER COLUMN U2B POSITION 14;
ALTER TABLE "LVWSamples" ALTER COLUMN U2C POSITION 15;
ALTER TABLE "LVWSamples" ALTER COLUMN "CosFiA" POSITION 16;
ALTER TABLE "LVWSamples" ALTER COLUMN "CosFiB" POSITION 17;
ALTER TABLE "LVWSamples" ALTER COLUMN "CosFiC" POSITION 18;
ALTER TABLE "LVWSamples" ALTER COLUMN "Wa" POSITION 19;
ALTER TABLE "LVWSamples" ALTER COLUMN "Wr" POSITION 20;
ALTER TABLE "LVWSamples" ALTER COLUMN T POSITION 21;
ALTER TABLE "LVWSamples" ALTER COLUMN "Kdp" POSITION 22;
ALTER TABLE "LVWSamples" ALTER COLUMN "Kzap" POSITION 23;
ALTER TABLE "LVWSamples" ALTER COLUMN "sqrKfg" POSITION 24;
ALTER TABLE "LVWSamples" ALTER COLUMN "Temperature" POSITION 25;

/*--  "LVWTPInfo"    */
ALTER TABLE "LVWTPInfo" DROP "IminA";
ALTER TABLE "LVWTPInfo" DROP "IminB";
ALTER TABLE "LVWTPInfo" DROP "IminC";
/*--      */
ALTER TABLE "LVWTPInfo" ALTER COLUMN "SampleIdent" POSITION 1;
ALTER TABLE "LVWTPInfo" ALTER COLUMN GUID POSITION 2;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "TypeCalc" POSITION 3;
ALTER TABLE "LVWTPInfo" ALTER COLUMN UA POSITION 4;
ALTER TABLE "LVWTPInfo" ALTER COLUMN UB POSITION 5;
ALTER TABLE "LVWTPInfo" ALTER COLUMN UC POSITION 6;
ALTER TABLE "LVWTPInfo" ALTER COLUMN IA POSITION 7;
ALTER TABLE "LVWTPInfo" ALTER COLUMN IB POSITION 8;
ALTER TABLE "LVWTPInfo" ALTER COLUMN IC POSITION 9;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "ImaxA" POSITION 10;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "ImaxB" POSITION 11;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "ImaxC" POSITION 12;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "CosFiA" POSITION 13;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "CosFiB" POSITION 14;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "CosFiC" POSITION 15;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "Kdp" POSITION 16;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "Kzap" POSITION 17;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "sqrKfg" POSITION 18;
ALTER TABLE "LVWTPInfo" ALTER COLUMN "Temperature" POSITION 19;

/*--  "MeterComplexPeriods"     */
ALTER TABLE "MeterComplexPeriods" ALTER COLUMN "CounterCapacity" TYPE DOUBLE_ABOVE_0;

/*--  "WSamples"           */
ALTER TABLE "WSamples" ALTER COLUMN "Wa" TYPE NUMBER_11_3;
ALTER TABLE "WSamples" ALTER COLUMN "Wr" TYPE NUMBER_11_3;

/*--  "MeteragesByPeriod"   */
ALTER TABLE "MeteragesByPeriod" DROP CONSTRAINT "CHK_MeteragesByPeriod";
ALTER TABLE "MeteragesByPeriod" ADD CONSTRAINT "CHK_MeteragesByPeriod" CHECK(
("Scale"=7 AND "Value">=0 /* AND "Value"<=200*/) OR                    /* 7 */
(("Scale"=5 OR "Scale"=6) AND "Value">=0 AND "Value"<=1) AND           /* 5,6 */
(("Scale"=5) OR
(SELECT R."Reverse" FROM "MetersRef" R
 INNER JOIN "Meters" M ON (R."Ident"=M."Meter_Ident")
 WHERE M."Ident" = "MeteragesByPeriod"."Ident")=1) OR
("Scale" in (1,3) AND                                                 /* 1,3 */
(SELECT R."Power" FROM "MetersRef" R
 INNER JOIN "Meters" M ON (R."Ident"=M."Meter_Ident")
 WHERE M."Ident" = "MeteragesByPeriod"."Ident") in (1,3)
OR
"Scale" in (2,4) AND                                                  /* 2,4 */
(SELECT R."Power" FROM "MetersRef" R
 INNER JOIN "Meters" M ON (R."Ident"=M."Meter_Ident")
 WHERE M."Ident" = "MeteragesByPeriod"."Ident") in (2,3)));

/*--  "InitParams"    */
/*ALTER TABLE "InitParams" DROP CONSTRAINT "CHK_InitParams_Values"; */
ALTER TABLE "InitParams" ADD CONSTRAINT "CHK_InitParams_Values" CHECK(("Key"=1) and ("Value" between 0 and 1) or /* smCosFi */
 ("Key"=2 or "Key"=3) and ("Value" between "Param"*0.8 and "Param"*1.2) or /* smUcp, smUdop*/
 ("Key"=4) and ("Value" between 1/13 and 1) or /* smKzap */
 ("Key"=6) and ("Value" between 0.04 and 1) or /* smTau */

 ("Key" in (100,108,109,110,111) and "Value" between -2147483647 and 2147483647) or /*(smAOEnergoGUID,smVNCalc,smNNCalc,smStLoads,smMetrolog */
 ("Key"=101 and "Value" between 1 and 7) or /*smRegionIdent */
 ("Key"=102 and "Value" between 1 and 3) or /* smKdp */
 ("Key" in (103,105,112,113,114,115) and ("Value"=0 or "Value"=1)) or /* (smUseTemperature,smKuntp,smDotDisableLine,smShowPhases */
 ("Key"=104 and "Value" between -70 and 70) or /* smTemperature */
 ("Key" in (106,107,116) and ("Value" between 0 and 2)  or /* smSaveDetailed,smSaveDetailedHH,smShowArrowDirection */
 ("Key"=5 or "Key"=200 or "Key"=201) and ("Value" between -2147483.648 and 2147483.647) /* Colors */));

ALTER TABLE "InitParams" DROP CONSTRAINT "CHK_InitParams_Param";
ALTER TABLE "InitParams" ADD CONSTRAINT "CHK_InitParams_Param" CHECK(("Key" between 001 and 099) and
  exists (select * from "Unom" where "Unom"."Unom"="InitParams"."Param") or /* Unom */
("Key" between 100 and 199) and ("Param"=0) or
("Key"=200) and (("Param" between 0 and 16) or ("Param" between 100 and 108))  or
 ("Key"=201) and ("Param" between 0 and 150) /* smTrNodeByKzagColors */);

/*==============================================================================
/*     6-220
/*==============================================================================

/*--     "MVResults"  */
CREATE GENERATOR "GEN_MVResultsIdent";
/*--   "MVResults"
/*-- !  "MVResults","PResultsAdd","WResultsAdd" 
/*-- !  "PResults", "WResults"  "WResultsA" !
/* CalcType=0       .. 
   CalcType=1       .. 
   CalcType=2      
   CalcType=3    */
CREATE TABLE "MVResults"("Ident" "TIntegerIdent",
"CalcType" "TIdent",
"SampleIdent" "TIntegerIdent",
GUID "TIntegerIdent",
"Wa" DOUBLE_NOT_NULL_ABOVE_0,
"Wr" DOUBLE_NOT_NULL,
T DECIMAL_8_3,
U DOUBLE_NOT_NULL_ABOVE_0,
"Pgy" DOUBLE_NOT_NULL_ABOVE_0,
"Qgy" DOUBLE_NOT_NULL,
"Imax" DOUBLE_ABOVE_0,
"Kzap" DOUBLE_ABOVE_0,
"sqrKfg" DOUBLE_ABOVE_0,
"sqrKfgCalc" DOUBLE_ABOVE_0,
"dUmax" DOUBLE_NOT_NULL_ABOVE_0,
"dWdop" DECIMAL_10_3,
"WeatherConditions" INTEGER,
"Temperature" "DECIMAL_Temperature_NOT_NULL",
"Flags" INTEGER,
CRC BLOB SEGMENT SIZE 48);
ALTER TABLE "MVResults" ADD CONSTRAINT "PK_MVResults" PRIMARY KEY ("Ident");
ALTER TABLE "MVResults" ADD CONSTRAINT "FK_MVResults_GUID" FOREIGN KEY (GUID)
 REFERENCES "Fiders" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "MVResults" ADD CONSTRAINT "FK_MVResults_SampleIdent"
 FOREIGN KEY ("SampleIdent")
 REFERENCES "SamplesDates" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "MVResults" ADD CONSTRAINT "FK_MVResults_WeatherConditions"
 FOREIGN KEY ("WeatherConditions")
 REFERENCES "WeatherConditions" ("Ident") ON UPDATE CASCADE;
ALTER TABLE "MVResults" ADD CONSTRAINT "CHK_MVResults_CalcType"
 CHECK("CalcType" BETWEEN 0 AND 3);
CREATE UNIQUE INDEX "idxMVResults" ON "MVResults"("CalcType", "SampleIdent", GUID);
GRANT ALL ON "MVResults" TO "rtp3user";

/*--   "PResultsAdd"   */
CREATE TABLE "PResultsAdd"("Ident" "TIntegerIdent",
"Balance" "TIdent" NOT NULL,
"dP_line_cu" DOUBLE_NOT_NULL_ABOVE_0,
"dP_line_k" DOUBLE_NOT_NULL_ABOVE_0,
"dP_line_crown" DOUBLE_ABOVE_0,
"dQ_line_cu" DOUBLE_NOT_NULL_ABOVE_0,
"dP_tr_cu" DOUBLE_NOT_NULL_ABOVE_0,
"dQ_tr_cu" DOUBLE_NOT_NULL_ABOVE_0,
"dP_tr_xx" DOUBLE_NOT_NULL_ABOVE_0,
"dQ_tr_xx" DOUBLE_NOT_NULL_ABOVE_0,
"dP_clr" DOUBLE_NOT_NULL_ABOVE_0,
"dQ_clr" DOUBLE_NOT_NULL_ABOVE_0,
"Qc" DOUBLE_NOT_NULL_ABOVE_0,
"Ptrans" DOUBLE_NOT_NULL_ABOVE_0,
"Qtrans" DOUBLE_NOT_NULL,
"Pnagr" DOUBLE_NOT_NULL_ABOVE_0,
"Qnagr" DOUBLE_NOT_NULL,
"Ptrans_fact" DOUBLE_ABOVE_0,
"Qtrans_fact" DOUBLE PRECISION,
"Pnagr_fact" DOUBLE_ABOVE_0,
"Qnagr_fact" DOUBLE PRECISION,
"Kzagr" DOUBLE_NOT_NULL_ABOVE_0,
"Ssum_tr" DECIMAL_10_3_NOT_NULL,
"Ntr" "SmallInt0_NOT_NULL",
"Psum_motor" DECIMAL_10_3_NOT_NULL,
"Nmotor" "SmallInt0_NOT_NULL",
"Ssum_clr" DECIMAL_10_3_NOT_NULL,
"Nclr" "SmallInt0_NOT_NULL",
"LsumP" DECIMAL_9_3_NOT_NULL,
"LsumC" DECIMAL_9_3_NOT_NULL,
"NLineP" "SmallInt0_NOT_NULL",
"NLineC" "SmallInt0_NOT_NULL",
"NAbonents" "SmallInt0");
ALTER TABLE "PResultsAdd" ADD CONSTRAINT "PK_PResultsAdd"
 PRIMARY KEY ("Ident", "Balance");
ALTER TABLE "PResultsAdd" ADD CONSTRAINT "FK_PResultsAdd"
 FOREIGN KEY ("Ident") REFERENCES "MVResults" ("Ident")
 ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "PResultsAdd" ADD CONSTRAINT "FK_PResultsAddBalance"
 FOREIGN KEY ("Balance") REFERENCES "Owners" ("Ident");
GRANT ALL ON "PResultsAdd" TO "rtp3user";

/* --    "PResultsAdd"   */
CREATE TRIGGER "PResultsAddBeforeUpdate" FOR "PResultsAdd"
ACTIVE BEFORE UPDATE POSITION 0
AS
BEGIN
 EXCEPTION "NoRelease";
END ;

/* --   "WResultsAdd"   */
CREATE TABLE "WResultsAdd"("Ident" "TIntegerIdent",
"Balance" "TIdent" NOT NULL,
"DWa_line_cu" DOUBLE_NOT_NULL_ABOVE_0,
"DWa_line_k" DOUBLE_NOT_NULL_ABOVE_0,
"DWa_line_crown" DOUBLE_ABOVE_0,
"DWr_line_cu" DOUBLE_NOT_NULL_ABOVE_0,
"DWa_tr_cu" DOUBLE_NOT_NULL_ABOVE_0,
"DWr_tr_cu" DOUBLE_NOT_NULL_ABOVE_0,
"DWa_tr_xx" DOUBLE_NOT_NULL_ABOVE_0,
"DWr_tr_xx" DOUBLE_NOT_NULL_ABOVE_0,
"DWa_clr" DOUBLE_NOT_NULL_ABOVE_0,
"DWr_clr" DOUBLE_NOT_NULL_ABOVE_0,
"Wrc" DOUBLE_NOT_NULL_ABOVE_0,
"Wa_trans" DOUBLE_NOT_NULL_ABOVE_0,
"Wr_trans" DOUBLE_NOT_NULL,
"Wa_potr" DOUBLE_NOT_NULL_ABOVE_0,
"Wr_potr" DOUBLE_NOT_NULL,
"Wa_trans_fact" DOUBLE_ABOVE_0,
"Wr_trans_fact" DOUBLE PRECISION,
"Wa_potr_fact" DOUBLE_ABOVE_0,
"Wr_potr_fact" DOUBLE PRECISION);
ALTER TABLE "WResultsAdd" ADD CONSTRAINT "PK_WResultsAdd"
 PRIMARY KEY ("Ident", "Balance");
ALTER TABLE "WResultsAdd" ADD CONSTRAINT "FK_WResultsAddBalance"
 FOREIGN KEY ("Balance") REFERENCES "Owners" ("Ident") ON UPDATE CASCADE;
ALTER TABLE "WResultsAdd" ADD CONSTRAINT "FK_WResultsAddIdent"
 FOREIGN KEY ("Ident") REFERENCES "MVResults" ("Ident")
 ON UPDATE CASCADE ON DELETE CASCADE;
GRANT ALL ON "WResultsAdd" TO "rtp3user";

/* --    "WResultsAdd"     */
CREATE TRIGGER "WResultsAddBeforeUpdate" FOR "WResultsAdd"
ACTIVE BEFORE UPDATE POSITION 0
AS
BEGIN
 EXCEPTION "NoRelease";
END ;

/*--   "PResultsL"    */
/*-- !   "PResultsPL"  "WResultsPL" */
CREATE TABLE "PResultsL"("Ident" "TIntegerIdent",
GUID "TIntegerIdent",
P DECIMAL_9_3,
Q NUMBER_9_3,
I DECIMAL_9_3,
"deltaPcu" DECIMAL_9_3,
"deltaPk" DECIMAL_9_3,
"deltaPcrown" DECIMAL_9_3,
"deltaQ" DECIMAL_9_3,
"Qc_b" DECIMAL_9_3,
"Qc_e" DECIMAL_9_3,
"Kzag" DECIMAL_5_4);
ALTER TABLE "PResultsL" ADD CONSTRAINT "PK_PResultsL" PRIMARY KEY ("Ident", GUID);
ALTER TABLE "PResultsL" ADD CONSTRAINT "FK_PResultsL_GUID" FOREIGN KEY (GUID) REFERENCES "Lines" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "PResultsL" ADD CONSTRAINT "FK_PResultsL_Ident" FOREIGN KEY ("Ident") REFERENCES "MVResults" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;
GRANT ALL ON "PResultsL" TO "rtp3user";

/*--   "PResultsN"   */
/*-- !   "PResultsPN"  "WResultsPN"  */
CREATE TABLE "PResultsN"("Ident" "TIntegerIdent",
GUID "TIntegerIdent",
"Pn" DECIMAL_9_3,
"Qn" NUMBER_9_3,
UB DECIMAL_7_3,
UH DECIMAL_7_3,
"deltaPcu" DECIMAL_9_3,
"deltaQcu" DECIMAL_9_3,
"deltaPxx" DECIMAL_9_3,
"deltaQxx" DECIMAL_9_3,
"deltaUB" NUMBER_5_3,
"Kzag" DECIMAL_5_4);
ALTER TABLE "PResultsN" ADD CONSTRAINT "PK_PResultsN" PRIMARY KEY ("Ident", GUID);
ALTER TABLE "PResultsN" ADD CONSTRAINT "FK_PResultsN_GUID" FOREIGN KEY (GUID) REFERENCES "Nodes" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "PResultsN" ADD CONSTRAINT "FK_PResultsN_Ident" FOREIGN KEY ("Ident") REFERENCES "MVResults" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;
GRANT ALL ON "PResultsN" TO "rtp3user";

/*--   "PResultsN3"
-- !   "PResultsPN3"  "WResultsPN3"  */
CREATE TABLE "PResultsN3"("Ident" "TIntegerIdent",
GUID "TIntegerIdent",
"PCn" DECIMAL_9_3,
"QCn" NUMBER_9_3,
"PHn" DECIMAL_9_3,
"QHn" NUMBER_9_3,
UB DECIMAL_7_3,
UC DECIMAL_7_3,
UH DECIMAL_7_3,
"deltaPcu" DECIMAL_9_3,
"deltaQcu" DECIMAL_9_3,
"deltaPxx" DECIMAL_9_3,
"deltaQxx" DECIMAL_9_3,
"deltaUB" NUMBER_5_3,
"Kzag" DECIMAL_5_4);
ALTER TABLE "PResultsN3" ADD CONSTRAINT "PK_PResultsN3" PRIMARY KEY ("Ident", GUID);
ALTER TABLE "PResultsN3" ADD CONSTRAINT "FK_PResultsN3_GUID" FOREIGN KEY (GUID) REFERENCES "Nodes" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "PResultsN3" ADD CONSTRAINT "FK_PResultsN3_Ident" FOREIGN KEY ("Ident") REFERENCES "MVResults" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;
GRANT ALL ON "PResultsN3" TO "rtp3user";

/*--   "WResultsL"
-- !   "PResultsWL"  "WResultsWL" */
CREATE TABLE "WResultsL"("Ident" "TIntegerIdent",
GUID "TIntegerIdent",
"Wa" DECIMAL_11_3,
"Wr" NUMBER_11_3,
"deltaWa_cu" DECIMAL_10_3,
"deltaWa_k" DECIMAL_10_3,
"deltaWa_crown" DECIMAL_10_3,
"deltaWr" DECIMAL_10_3,
"Wrc_b" DECIMAL_9_3,
"Wrc_e" DECIMAL_9_3,
"sqrKfg" DECIMAL_6_5);
ALTER TABLE "WResultsL" ADD CONSTRAINT "PK_WResultsL" PRIMARY KEY ("Ident", GUID);
ALTER TABLE "WResultsL" ADD CONSTRAINT "FK_WResultsL_GUID" FOREIGN KEY (GUID) REFERENCES "Lines" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "WResultsL" ADD CONSTRAINT "FK_WResultsL_Ident" FOREIGN KEY ("Ident") REFERENCES "MVResults" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;
GRANT ALL ON "WResultsL" TO "rtp3user";

/*--   "WResultsN"
-- !   "PResultsWN"  "WResultsWN"     */
CREATE TABLE "WResultsN"("Ident" "TIntegerIdent",
GUID "TIntegerIdent",
"Wa" DECIMAL_11_3,
"Wr" NUMBER_11_3,
"deltaW_cu" DECIMAL_10_3,
"deltaWr_cu" DECIMAL_10_3,
"deltaW_xx" DECIMAL_10_3,
"deltaWr_xx" DECIMAL_10_3,
"sqrKfg" DECIMAL_6_5);
ALTER TABLE "WResultsN" ADD CONSTRAINT "PK_WResultsN" PRIMARY KEY ("Ident", GUID);
ALTER TABLE "WResultsN" ADD CONSTRAINT "FK_WResultsN_GUID" FOREIGN KEY (GUID) REFERENCES "Nodes" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "WResultsN" ADD CONSTRAINT "FK_WResultsN_Ident" FOREIGN KEY ("Ident") REFERENCES "MVResults" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;
GRANT ALL ON "WResultsN" TO "rtp3user";

/*--   "WResultsN3"
-- !   "PResultsWN3"  "WResultsWN3"  */
CREATE TABLE "WResultsN3"("Ident" "TIntegerIdent",
GUID "TIntegerIdent",
"WCa" DECIMAL_11_3,
"WCr" NUMBER_11_3,
"WHa" DECIMAL_11_3,
"WHr" NUMBER_11_3,
"deltaW_cu" DECIMAL_10_3,
"deltaWr_cu" DECIMAL_10_3,
"deltaW_xx" DECIMAL_10_3,
"deltaWr_xx" DECIMAL_10_3,
"sqrKfgC" DECIMAL_6_5,
"sqrKfgH" DECIMAL_6_5);
ALTER TABLE "WResultsN3" ADD CONSTRAINT "PK_WResultsN3" PRIMARY KEY ("Ident", GUID);
ALTER TABLE "WResultsN3" ADD CONSTRAINT "FK_WResultsN3_GUID" FOREIGN KEY (GUID) REFERENCES "Nodes" (GUID) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE "WResultsN3" ADD CONSTRAINT "FK_WResultsN3_Ident" FOREIGN KEY ("Ident") REFERENCES "MVResults" ("Ident") ON UPDATE CASCADE ON DELETE CASCADE;
GRANT ALL ON "WResultsN3" TO "rtp3user";

/*--   "InsertMVResults" */
CREATE PROCEDURE "InsertMVResults"(CALCTYPE SMALLINT,
 SAMPLEIDENT INTEGER,GUID INTEGER,
 WA DOUBLE PRECISION,WR DOUBLE PRECISION,T DECIMAL(8,3),U DOUBLE PRECISION,
 PGY DOUBLE PRECISION,QGY DOUBLE PRECISION,IMAX DOUBLE PRECISION,
 KZAP DOUBLE PRECISION, SQRKFG DOUBLE PRECISION,SQRKFGCALC DOUBLE PRECISION,
 DUMAX DOUBLE PRECISION,DWDOP DECIMAL(10,3),WEATHERCONDITIONS INTEGER,
 TEMPERATURE DECIMAL(6,3),FLAGS INTEGER,CRC BLOB SEGMENT SIZE 48)
RETURNS(IDENT INTEGER)
AS
BEGIN
 DELETE FROM "MVResults"
 WHERE "CalcType"=:CalcType and "SampleIdent"=:SampleIdent and "GUID"=:GUID;
 Ident=GEN_ID("GEN_MVResultsIdent",1);
 INSERT INTO "MVResults" ("Ident","CalcType","SampleIdent","GUID","Wa","Wr",
  "T","U","Pgy","Qgy","Imax","Kzap","sqrKfg","sqrKfgCalc","dUmax","dWdop",
  "WeatherConditions","Temperature","Flags","CRC")
 VALUES (:Ident,:CalcType,:SampleIdent,:GUID,:Wa,:Wr,:T,:U,:Pgy,:Qgy,
  :Imax,:Kzap,:sqrKfg,:sqrKfgCalc,:dUmax,:dWdop,
  :WeatherConditions,:Temperature,:Flags,:CRC);
END;
GRANT EXECUTE ON PROCEDURE "InsertMVResults" TO "rtp3user";

/*--    "MVResults"    */
CREATE TRIGGER "MVResultsBeforeUpdate" FOR "MVResults"
ACTIVE BEFORE UPDATE POSITION 0
AS
BEGIN
 EXCEPTION "NoRelease";
END;

/*-- !!!      !!!
--        */
update "Owners" set "Name"='' where "Ident"=1;
INSERT INTO "Owners" ("Name") VALUES ('');
INSERT INTO "Owners" ("Name") VALUES ('');


/*--       */
CREATE VIEW "TempPResults"("SampleIdent",GUID,"Wa","Wr",T,U,"Pgy","Qgy",
 "DWal_cu_onBalance","DWal_cu_notBalance","DWal_k_onBalance","DWal_k_notBalance",
 "DWal_crown_OnBalance","DWal_crown_notBalance","DWrl_cu_onBalance",
 "DWrl_cu_notBalance","DWcu_onBalance","DWcu_notBalance",
 "DWrcu_onBalance","DWrcu_notBalance","DWxx_onBalance",
 "DWxx_notBalance","DWrxx_onBalance","DWrxx_notBalance",
 "DWaclr_onBalance","DWaclr_notBalance","DWrclr_onBalance",
 "DWrclr_notBalance","Wrc_onBalance","Wrc_notBalance",
 "Wa_potr_onBalance","Wa_potr_notBalance","Wr_potr_onBalance",
 "Wr_potr_notBalance","Wa_potr_onBalance_fact","Wa_potr_notBalance_fact",
 "Wr_potr_onBalance_fact","Wr_potr_notBalance_fact","dPnlin_OnBalance",
 "dPnlin_notBalance","dPklin_OnBalance","dPklin_notBalance",
 "dPcrown_OnBalance","dPcrown_notBalance","dQnlin_OnBalance",
 "dQnlin_notBalance","dPntr_OnBalance","dPntr_notBalance",
 "dQntr_OnBalance","dQntr_notBalance","dPxx_OnBalance",
 "dPxx_notBalance","dQxx_OnBalance","dQxx_notBalance",
 "dPclr_OnBalance","dPclr_notBalance","dQclr_OnBalance",
 "dQclr_notBalance","Qc_onBalance","Qc_notBalance",
 "Ppotr_OnBalance","Ppotr_notBalance","Qpotr_OnBalance",
 "Qpotr_notBalance","Ppotr_OnBalance_fact","Ppotr_notBalance_fact",
 "Qpotr_OnBalance_fact","Qpotr_notBalance_fact","Kzag_OnBalance",
 "Kzag_notBalance","dU","Ssum_tr_OnBalance",
 "Ssum_tr_NotBalance","Ntr_OnBalance","Ntr_NotBalance",
 "LsumP_OnBalance","LsumP_NotBalance","LsumC_OnBalance",
 "LsumC_NotBalance","NLineP_OnBalance","NLineP_NotBalance",
 "NLineC_OnBalance","NLineC_NotBalance","WeatherConditions",
 "Temperature","Flags",CRC)
AS
select "SampleIdent","GUID","Wa","Wr","T","U","Pgy","Qgy",
 WResultsOnBalance."DWa_line_cu",Sum(WResultsNotBalance."DWa_line_cu"),
 WResultsOnBalance."DWa_line_k",Sum(WResultsNotBalance."DWa_line_k"),
 WResultsOnBalance."DWa_line_crown",Sum(WResultsNotBalance."DWa_line_crown"),
 WResultsOnBalance."DWr_line_cu",Sum(WResultsNotBalance."DWr_line_cu"),
 WResultsOnBalance."DWa_tr_cu",Sum(WResultsNotBalance."DWa_tr_cu"),
 WResultsOnBalance."DWr_tr_cu",Sum(WResultsNotBalance."DWr_tr_cu"),
 WResultsOnBalance."DWa_tr_xx",Sum(WResultsNotBalance."DWa_tr_xx"),
 WResultsOnBalance."DWr_tr_xx",Sum(WResultsNotBalance."DWr_tr_xx"),
 WResultsOnBalance."DWa_clr",Sum(WResultsNotBalance."DWa_clr"),
 WResultsOnBalance."DWr_clr",Sum(WResultsNotBalance."DWr_clr"),
 WResultsOnBalance."Wrc",Sum(WResultsNotBalance."Wrc"),
 WResultsOnBalance."Wa_potr"+WResultsOnBalance."Wa_trans",
 Sum(WResultsNotBalance."Wa_potr")+Sum(WResultsNotBalance."Wa_trans"),
 WResultsOnBalance."Wr_potr"+WResultsOnBalance."Wr_trans",
 Sum(WResultsNotBalance."Wr_potr")+Sum(WResultsNotBalance."Wr_trans"),
 COALESCE(WResultsOnBalance."Wa_potr_fact",0)+COALESCE(WResultsOnBalance."Wa_trans_fact",0),
 Sum(WResultsNotBalance."Wa_potr_fact")+Sum(WResultsNotBalance."Wa_trans_fact"),
 COALESCE(WResultsOnBalance."Wr_potr_fact",0)+COALESCE(WResultsOnBalance."Wr_trans_fact",0),
 Sum(WResultsNotBalance."Wr_potr_fact")+Sum(WResultsNotBalance."Wr_trans_fact"),

 PResultsOnBalance."dP_line_cu",Sum(PResultsNotBalance."dP_line_cu"),
 PResultsOnBalance."dP_line_k",Sum(PResultsNotBalance."dP_line_k"),
 PResultsOnBalance."dP_line_crown",Sum(PResultsNotBalance."dP_line_crown"),
 PResultsOnBalance."dQ_line_cu",Sum(PResultsNotBalance."dQ_line_cu"),
 PResultsOnBalance."dP_tr_cu",Sum(PResultsNotBalance."dP_tr_cu"),
 PResultsOnBalance."dQ_tr_cu",Sum(PResultsNotBalance."dQ_tr_cu"),
 PResultsOnBalance."dP_tr_xx",Sum(PResultsNotBalance."dP_tr_xx"),
 PResultsOnBalance."dQ_tr_xx",Sum(PResultsNotBalance."dQ_tr_xx"),
 PResultsOnBalance."dP_clr",Sum(PResultsNotBalance."dP_clr"),
 PResultsOnBalance."dQ_clr",Sum(PResultsNotBalance."dQ_clr"),
 PResultsOnBalance."Qc",Sum(PResultsNotBalance."Qc"),
 PResultsOnBalance."Pnagr"+PResultsOnBalance."Ptrans",
 Sum(PResultsNotBalance."Pnagr")+Sum(PResultsNotBalance."Ptrans"),
 PResultsOnBalance."Qnagr"+PResultsOnBalance."Qtrans",
 Sum(PResultsNotBalance."Qnagr")+Sum(PResultsNotBalance."Qtrans"),
 COALESCE(PResultsOnBalance."Pnagr_fact",0)+COALESCE(PResultsOnBalance."Ptrans_fact",0),
 Sum(PResultsNotBalance."Pnagr_fact")+Sum(PResultsNotBalance."Ptrans_fact"),
 COALESCE(PResultsOnBalance."Qnagr_fact",0)+COALESCE(PResultsOnBalance."Qtrans_fact",0),
 Sum(PResultsNotBalance."Qnagr_fact")+Sum(PResultsNotBalance."Qtrans_fact"),

 PResultsOnBalance."Kzagr",AVG(PResultsNotBalance."Kzagr"),"dUmax",

 PResultsOnBalance."Ssum_tr",Sum(PResultsNotBalance."Ssum_tr"),
 PResultsOnBalance."Ntr",Sum(PResultsNotBalance."Ntr"),
 PResultsOnBalance."LsumP",Sum(PResultsNotBalance."LsumP"),
 PResultsOnBalance."LsumC",Sum(PResultsNotBalance."LsumC"),
 PResultsOnBalance."NLineP",Sum(PResultsNotBalance."NLineP"),
 PResultsOnBalance."NLineC",Sum(PResultsNotBalance."NLineC"),

 "WeatherConditions","Temperature","Flags","CRC"

from "MVResults"

left outer join "WResultsAdd" WResultsOnBalance on
 ("MVResults"."Ident"=WResultsOnBalance."Ident") and (WResultsOnBalance."Balance"=0)
left outer join "WResultsAdd" WResultsNotBalance on
 ("MVResults"."Ident"=WResultsNotBalance."Ident") and (WResultsNotBalance."Balance"<>0)
left outer join "PResultsAdd" PResultsOnBalance on
 ("MVResults"."Ident"=PResultsOnBalance."Ident") and (PResultsOnBalance."Balance"=0)
left outer join "PResultsAdd" PResultsNotBalance on
 ("MVResults"."Ident"=PResultsNotBalance."Ident") and (PResultsNotBalance."Balance"<>0)

where "MVResults"."CalcType"=2

group by "SampleIdent","GUID","Wa","Wr","T","U","Pgy","Qgy",
 WResultsOnBalance."DWa_line_cu",WResultsOnBalance."DWa_line_k",
 WResultsOnBalance."DWa_line_crown",WResultsOnBalance."DWr_line_cu",
 WResultsOnBalance."DWa_tr_cu",WResultsOnBalance."DWr_tr_cu",
 WResultsOnBalance."DWa_tr_xx",WResultsOnBalance."DWr_tr_xx",
 WResultsOnBalance."DWa_clr",WResultsOnBalance."DWr_clr",
 WResultsOnBalance."Wrc",
 WResultsOnBalance."Wa_potr",WResultsOnBalance."Wa_trans",
 WResultsOnBalance."Wr_potr",WResultsOnBalance."Wr_trans",
 WResultsOnBalance."Wa_potr_fact",WResultsOnBalance."Wa_trans_fact",
 WResultsOnBalance."Wr_potr_fact",WResultsOnBalance."Wr_trans_fact",
 PResultsOnBalance."dP_line_cu",PResultsOnBalance."dP_line_k",
 PResultsOnBalance."dP_line_crown",PResultsOnBalance."dQ_line_cu",
 PResultsOnBalance."dP_tr_cu",PResultsOnBalance."dQ_tr_cu",
 PResultsOnBalance."dP_tr_xx",PResultsOnBalance."dQ_tr_xx",
 PResultsOnBalance."dP_clr",PResultsOnBalance."dQ_clr",
 PResultsOnBalance."Qc",
 PResultsOnBalance."Pnagr",PResultsOnBalance."Ptrans",
 PResultsOnBalance."Qnagr",PResultsOnBalance."Qtrans",
 PResultsOnBalance."Pnagr_fact",PResultsOnBalance."Ptrans_fact",
 PResultsOnBalance."Qnagr_fact",PResultsOnBalance."Qtrans_fact",
 PResultsOnBalance."Kzagr","dUmax",
 PResultsOnBalance."Ssum_tr",PResultsOnBalance."Ntr",
 PResultsOnBalance."LsumP",PResultsOnBalance."LsumC",
 PResultsOnBalance."NLineP",PResultsOnBalance."NLineC",
 "WeatherConditions","Temperature","Flags","CRC";

CREATE TRIGGER "PResultsBeforeUOrIns" FOR "TempPResults"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 EXECUTE PROCEDURE "InsertMVResults" (2,NEW."SampleIdent",NEW.GUID,
  NEW."Wa",NEW."Wr",NEW."T",NEW."U",NEW."Pgy",NEW."Qgy",
  null,null,null,null,NEW."dU",null,
  NEW."WeatherConditions",NEW."Temperature",NEW."Flags",NEW."CRC")
 RETURNING_VALUES :Ident;

 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,0,
  NEW."dPnlin_OnBalance",NEW."dPklin_OnBalance",NEW."dPcrown_OnBalance",NEW."dQnlin_OnBalance",
  NEW."dPntr_OnBalance",NEW."dQntr_OnBalance",NEW."dPxx_OnBalance",NEW."dQxx_OnBalance",
  NEW."dPclr_OnBalance",NEW."dQclr_OnBalance",NEW."Qc_onBalance",
  NEW."Ppotr_OnBalance",NEW."Qpotr_OnBalance",0,0,
  NEW."Ppotr_OnBalance_fact",NEW."Qpotr_OnBalance_fact",0,0,
  NEW."Kzag_OnBalance",NEW."Ssum_tr_OnBalance",NEW."Ntr_OnBalance",0,0,0,0,
  NEW."LsumP_OnBalance",NEW."LsumC_OnBalance",NEW."NLineP_OnBalance",NEW."NLineC_OnBalance",
  null);
 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,1,
  NEW."dPnlin_notBalance",NEW."dPklin_notBalance",NEW."dPcrown_notBalance",NEW."dQnlin_notBalance",
  NEW."dPntr_notBalance",NEW."dQntr_notBalance",NEW."dPxx_notBalance",NEW."dQxx_notBalance",
  NEW."dPclr_notBalance",NEW."dQclr_notBalance",NEW."Qc_notBalance",
  NEW."Ppotr_notBalance",NEW."Qpotr_notBalance",0,0,
  NEW."Ppotr_notBalance_fact",NEW."Qpotr_notBalance_fact",0,0,
  NEW."Kzag_notBalance",NEW."Ssum_tr_NotBalance",NEW."Ntr_NotBalance",0,0,0,0,
  NEW."LsumP_NotBalance",NEW."LsumC_NotBalance",NEW."NLineP_NotBalance",NEW."NLineC_NotBalance",
  null);
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,0,
  NEW."DWal_cu_onBalance",NEW."DWal_k_onBalance",NEW."DWal_crown_OnBalance",NEW."DWrl_cu_onBalance",
  NEW."DWcu_onBalance",NEW."DWrcu_onBalance",NEW."DWxx_onBalance",NEW."DWrxx_onBalance",
  NEW."DWaclr_onBalance",NEW."DWrclr_onBalance",NEW."Wrc_onBalance",
  NEW."Wa_potr_onBalance",NEW."Wr_potr_onBalance",0,0,
  NEW."Wa_potr_onBalance_fact",NEW."Wr_potr_onBalance_fact",0,0);
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,1,
   NEW."DWal_cu_notBalance",NEW."DWal_k_notBalance",
   NEW."DWal_crown_notBalance",NEW."DWrl_cu_notBalance",
   NEW."DWcu_notBalance",NEW."DWrcu_notBalance",
   NEW."DWxx_notBalance",NEW."DWrxx_notBalance",
   NEW."DWaclr_notBalance",NEW."DWrclr_notBalance",NEW."Wrc_notBalance",
   NEW."Wa_potr_notBalance",NEW."Wr_potr_notBalance",0,0,
   NEW."Wa_potr_notBalance_fact",NEW."Wr_potr_notBalance_fact",0,0);
END;

CREATE VIEW "TempPResultsPL"("SampleIdent",GUID,
 P,Q,I,"deltaPcu","deltaPk","deltaPcrown","deltaQ","Qc_b","Qc_e","Kzag")
AS
SELECT F."SampleIdent",L."GUID",
 L."P",L."Q",L."I",L."deltaPcu",L."deltaPk",L."deltaPcrown",L."deltaQ",
 L."Qc_b",L."Qc_e",L."Kzag"
FROM "PResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=2;

CREATE TRIGGER "TPResultsPLBeforeUpdateOrInsert" FOR "TempPResultsPL"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Lines"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;
if  (not Ident is null) then
BEGIN
 DELETE FROM "PResultsL" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "PResultsL"
  ("Ident","GUID","P","Q","I","deltaPcu","deltaPk",
   "deltaPcrown","deltaQ","Qc_b","Qc_e","Kzag")
 VALUES (:Ident,NEW."GUID",NEW."P",NEW."Q",NEW."I",NEW."deltaPcu",NEW."deltaPk",
  NEW."deltaPcrown",NEW."deltaQ",NEW."Qc_b",NEW."Qc_e",NEW."Kzag");
END
END;
/*-------------------------------------------*/

CREATE VIEW "TempPResultsPN"("SampleIdent",GUID,
 "Pn","Qn",UB,UH,"deltaPcu","deltaQcu","deltaPxx","deltaQxx","deltaUB","Kzag")
AS
SELECT F."SampleIdent",N."GUID",
 N."Pn",N."Qn",N."UB",N."UH",N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
 N."deltaUB",N."Kzag"
FROM "PResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=2;

CREATE TRIGGER "TPResultsPNBeforeUpdateOrInsert" FOR "TempPResultsPN"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;
if  (not Ident is null) then
BEGIN
 DELETE FROM "PResultsN" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "PResultsN"
  ("Ident","GUID","Pn","Qn","UB","UH",
   "deltaPcu","deltaQcu","deltaPxx","deltaQxx",
   "deltaUB","Kzag")
 VALUES (:Ident,NEW."GUID",NEW."Pn",NEW."Qn",NEW."UB",NEW."UH",
   NEW."deltaPcu",NEW."deltaQcu",NEW."deltaPxx",NEW."deltaQxx",
   NEW."deltaUB",NEW."Kzag");
END
END;
/*-------------------------------------------*/

CREATE VIEW "TempPResultsPN3"("SampleIdent",GUID,
 "PCn","QCn","PHn","QHn",UB,UC,UH,"deltaPcu","deltaQcu","deltaPxx","deltaQxx",
 "deltaUB","Kzag")
AS
SELECT F."SampleIdent",N."GUID",
 N."PCn",N."QCn",N."PHn",N."QHn",N."UB",N."UC",N."UH",
 N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
 N."deltaUB",N."Kzag"
FROM "PResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=2;

CREATE TRIGGER "TPResultsPN3BUOrInsert" FOR "TempPResultsPN3"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;
if  (not Ident is null) then
BEGIN
 DELETE FROM "PResultsN3" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "PResultsN3"
  ("Ident","GUID","PCn","QCn","PHn","QHn",
   "UB","UC","UH",
   "deltaPcu","deltaQcu","deltaPxx","deltaQxx",
   "deltaUB","Kzag")
 VALUES (:Ident,NEW."GUID",NEW."PCn",NEW."QCn",NEW."PHn",NEW."QHn",
   NEW."UB",NEW."UC",NEW."UH",
   NEW."deltaPcu",NEW."deltaQcu",NEW."deltaPxx",NEW."deltaQxx",
   NEW."deltaUB",NEW."Kzag");
END
END;
/*-------------------------------------------*/

CREATE VIEW "TempPResultsWL"(
    "SampleIdent",
    GUID,
    "Wa","Wr","deltaWa_cu","deltaWa_k","deltaWa_crown","deltaWr","Wrc_b","Wrc_e")
AS
SELECT F."SampleIdent",L."GUID",
 L."Wa",L."Wr",L."deltaWa_cu",L."deltaWa_k",L."deltaWa_crown",L."deltaWr",
 L."Wrc_b",L."Wrc_e"
FROM "WResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=2 ;

CREATE TRIGGER "TPResultsWLBeforeUpdateOrInsert" FOR "TempPResultsWL"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Lines"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

if  (not Ident is null) then
BEGIN
 DELETE FROM "WResultsL" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "WResultsL"
  ("Ident","GUID","Wa","Wr",
   "deltaWa_cu","deltaWa_k","deltaWa_crown","deltaWr",
   "Wrc_b","Wrc_e","sqrKfg")
 VALUES (:Ident,NEW."GUID",NEW."Wa",NEW."Wr",
  NEW."deltaWa_cu",NEW."deltaWa_k",NEW."deltaWa_crown",NEW."deltaWr",
  NEW."Wrc_b",NEW."Wrc_e",null);
END
END;
/*-------------------------------------------*/

CREATE VIEW "TempPResultsWN"("SampleIdent",GUID,
 "Wa","Wr","deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx")
AS
SELECT F."SampleIdent",N."GUID",
 N."Wa",N."Wr",N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx"
FROM "WResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=2;

CREATE TRIGGER "TPResultsWNUOrInsert" FOR "TempPResultsWN"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

if  (not Ident is null) then
BEGIN
 DELETE FROM "WResultsN" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "WResultsN"
  ("Ident","GUID","Wa","Wr",
   "deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx",
    "sqrKfg")
 VALUES (:Ident,NEW."GUID",NEW."Wa",NEW."Wr",
  NEW."deltaW_cu",NEW."deltaWr_cu",NEW."deltaW_xx",NEW."deltaWr_xx",
  null);
END
END;
 /*-------------------------------------------*/


CREATE VIEW "TempPResultsWN3"("SampleIdent",GUID,
 "WCa","WCr","WHa","WHr","deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx")
AS
SELECT F."SampleIdent",N."GUID",
 N."WCa",N."WCr",N."WHa",N."WHr",
 N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx"
FROM "WResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=2;

CREATE TRIGGER "TPResultsWN3BUOrInsert" FOR "TempPResultsWN3"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

if  (not Ident is null) then
BEGIN
 DELETE FROM "WResultsN3" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "WResultsN3"
  ("Ident","GUID","WCa","WCr","WHa","WHr",
   "deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx",
   "sqrKfgC","sqrKfgH")
 VALUES (:Ident,NEW."GUID",NEW."WCa",NEW."WCr",NEW."WHa",NEW."WHr",
  NEW."deltaW_cu",NEW."deltaWr_cu",NEW."deltaW_xx",NEW."deltaWr_xx",
  null,null);
END
END;

 /*-------------------------------------------*/
CREATE VIEW "TempWResults"("SampleIdent",GUID,
 "Wa","Wr",T,U,"Pgy","Qgy","Imax","Kzap","sqrKfg","sqrKfgCalc",
 "DWal_cu_onBalance","DWal_cu_notBalance","DWal_k_onBalance",
 "DWal_k_notBalance","DWal_crown_OnBalance","DWal_crown_notBalance",
 "DWrl_cu_onBalance","DWrl_cu_notBalance","DWcu_onBalance",
 "DWcu_notBalance","DWrcu_onBalance","DWrcu_notBalance",
 "DWxx_onBalance","DWxx_notBalance","DWrxx_onBalance",
 "DWrxx_notBalance","DWaclr_onBalance","DWaclr_notBalance",
 "DWrclr_onBalance","DWrclr_notBalance","Wrc_onBalance",
 "Wrc_notBalance","Wa_potr_onBalance","Wa_potr_notBalance",
 "Wr_potr_onBalance","Wr_potr_notBalance","Wa_potr_onBalance_fact",
 "Wa_potr_notBalance_fact","Wr_potr_onBalance_fact","Wr_potr_notBalance_fact",
 "dPnlin_OnBalance","dPnlin_notBalance","dPklin_OnBalance",
 "dPklin_notBalance","dPcrown_OnBalance","dPcrown_notBalance",
 "dQnlin_OnBalance","dQnlin_notBalance","dPntr_OnBalance",
 "dPntr_notBalance","dQntr_OnBalance","dQntr_notBalance",
 "dPxx_OnBalance","dPxx_notBalance","dQxx_OnBalance",
 "dQxx_notBalance","dPclr_OnBalance","dPclr_notBalance",
 "dQclr_OnBalance","dQclr_notBalance","Qc_onBalance",
 "Qc_notBalance","Ppotr_OnBalance","Ppotr_notBalance",
 "Qpotr_OnBalance","Qpotr_notBalance","Ppotr_OnBalance_fact",
 "Ppotr_notBalance_fact","Qpotr_OnBalance_fact","Qpotr_notBalance_fact",
 "Kzag_OnBalance","Kzag_notBalance","dU",
 "Ssum_tr_OnBalance","Ssum_tr_NotBalance","Ntr_OnBalance",
 "Ntr_NotBalance","LsumP_OnBalance","LsumP_NotBalance",
 "LsumC_OnBalance","LsumC_NotBalance","NLineP_OnBalance",
 "NLineP_NotBalance","NLineC_OnBalance","NLineC_NotBalance",
 "NAbonents_OnBalance","NAbonents_NotBalance","dWdop",
 "WeatherConditions","Temperature","Flags",CRC)
 AS
select "SampleIdent","GUID","Wa","Wr","T","U","Pgy","Qgy",
 "Imax","Kzap","sqrKfg","sqrKfgCalc",
 WResultsOnBalance."DWa_line_cu",Sum(WResultsNotBalance."DWa_line_cu"),
 WResultsOnBalance."DWa_line_k",Sum(WResultsNotBalance."DWa_line_k"),
 WResultsOnBalance."DWa_line_crown",Sum(WResultsNotBalance."DWa_line_crown"),
 WResultsOnBalance."DWr_line_cu",Sum(WResultsNotBalance."DWr_line_cu"),
 WResultsOnBalance."DWa_tr_cu",Sum(WResultsNotBalance."DWa_tr_cu"),
 WResultsOnBalance."DWr_tr_cu",Sum(WResultsNotBalance."DWr_tr_cu"),
 WResultsOnBalance."DWa_tr_xx",Sum(WResultsNotBalance."DWa_tr_xx"),
 WResultsOnBalance."DWr_tr_xx",Sum(WResultsNotBalance."DWr_tr_xx"),
 WResultsOnBalance."DWa_clr",Sum(WResultsNotBalance."DWa_clr"),
 WResultsOnBalance."DWr_clr",Sum(WResultsNotBalance."DWr_clr"),
 WResultsOnBalance."Wrc",Sum(WResultsNotBalance."Wrc"),
 WResultsOnBalance."Wa_potr"+WResultsOnBalance."Wa_trans",
 Sum(WResultsNotBalance."Wa_potr")+Sum(WResultsNotBalance."Wa_trans"),
 WResultsOnBalance."Wr_potr"+WResultsOnBalance."Wr_trans",
 Sum(WResultsNotBalance."Wr_potr")+Sum(WResultsNotBalance."Wr_trans"),
 COALESCE(WResultsOnBalance."Wa_potr_fact",0)+COALESCE(WResultsOnBalance."Wa_trans_fact",0),
 Sum(WResultsNotBalance."Wa_potr_fact")+Sum(WResultsNotBalance."Wa_trans_fact"),
 COALESCE(WResultsOnBalance."Wr_potr_fact",0)+COALESCE(WResultsOnBalance."Wr_trans_fact",0),
 Sum(WResultsNotBalance."Wr_potr_fact")+Sum(WResultsNotBalance."Wr_trans_fact"),

 PResultsOnBalance."dP_line_cu",Sum(PResultsNotBalance."dP_line_cu"),
 PResultsOnBalance."dP_line_k",Sum(PResultsNotBalance."dP_line_k"),
 PResultsOnBalance."dP_line_crown",Sum(PResultsNotBalance."dP_line_crown"),
 PResultsOnBalance."dQ_line_cu",Sum(PResultsNotBalance."dQ_line_cu"),
 PResultsOnBalance."dP_tr_cu",Sum(PResultsNotBalance."dP_tr_cu"),
 PResultsOnBalance."dQ_tr_cu",Sum(PResultsNotBalance."dQ_tr_cu"),
 PResultsOnBalance."dP_tr_xx",Sum(PResultsNotBalance."dP_tr_xx"),
 PResultsOnBalance."dQ_tr_xx",Sum(PResultsNotBalance."dQ_tr_xx"),
 PResultsOnBalance."dP_clr",Sum(PResultsNotBalance."dP_clr"),
 PResultsOnBalance."dQ_clr",Sum(PResultsNotBalance."dQ_clr"),
 PResultsOnBalance."Qc",Sum(PResultsNotBalance."Qc"),
 PResultsOnBalance."Pnagr"+PResultsOnBalance."Ptrans",
 Sum(PResultsNotBalance."Pnagr")+Sum(PResultsNotBalance."Ptrans"),
 PResultsOnBalance."Qnagr"+PResultsOnBalance."Qtrans",
 Sum(PResultsNotBalance."Qnagr")+Sum(PResultsNotBalance."Qtrans"),
 COALESCE(PResultsOnBalance."Pnagr_fact",0)+COALESCE(PResultsOnBalance."Ptrans_fact",0),
 Sum(PResultsNotBalance."Pnagr_fact")+Sum(PResultsNotBalance."Ptrans_fact"),
 COALESCE(PResultsOnBalance."Qnagr_fact",0)+COALESCE(PResultsOnBalance."Qtrans_fact",0),
 Sum(PResultsNotBalance."Qnagr_fact")+Sum(PResultsNotBalance."Qtrans_fact"),

 PResultsOnBalance."Kzagr",AVG(PResultsNotBalance."Kzagr"),"dUmax",

 PResultsOnBalance."Ssum_tr",Sum(PResultsNotBalance."Ssum_tr"),
 PResultsOnBalance."Ntr",Sum(PResultsNotBalance."Ntr"),
 PResultsOnBalance."LsumP",Sum(PResultsNotBalance."LsumP"),
 PResultsOnBalance."LsumC",Sum(PResultsNotBalance."LsumC"),
 PResultsOnBalance."NLineP",Sum(PResultsNotBalance."NLineP"),
 PResultsOnBalance."NLineC",Sum(PResultsNotBalance."NLineC"),

 PResultsOnBalance."NAbonents",Sum(PResultsNotBalance."NAbonents"),"dWdop",

 "WeatherConditions","Temperature","Flags","CRC"

from "MVResults"

left outer join "WResultsAdd" WResultsOnBalance on
 ("MVResults"."Ident"=WResultsOnBalance."Ident") and (WResultsOnBalance."Balance"=0)
left outer join "WResultsAdd" WResultsNotBalance on
 ("MVResults"."Ident"=WResultsNotBalance."Ident") and (WResultsNotBalance."Balance"<>0)
left outer join "PResultsAdd" PResultsOnBalance on
 ("MVResults"."Ident"=PResultsOnBalance."Ident") and (PResultsOnBalance."Balance"=0)
left outer join "PResultsAdd" PResultsNotBalance on
 ("MVResults"."Ident"=PResultsNotBalance."Ident") and (PResultsNotBalance."Balance"<>0)

where "MVResults"."CalcType"=0

group by "SampleIdent","GUID","Wa","Wr","T","U","Pgy","Qgy",
 "Imax","Kzap","sqrKfg","sqrKfgCalc",
 WResultsOnBalance."DWa_line_cu",WResultsOnBalance."DWa_line_k",
 WResultsOnBalance."DWa_line_crown",WResultsOnBalance."DWr_line_cu",
 WResultsOnBalance."DWa_tr_cu",WResultsOnBalance."DWr_tr_cu",
 WResultsOnBalance."DWa_tr_xx",WResultsOnBalance."DWr_tr_xx",
 WResultsOnBalance."DWa_clr",WResultsOnBalance."DWr_clr",
 WResultsOnBalance."Wrc",
 WResultsOnBalance."Wa_potr",WResultsOnBalance."Wa_trans",
 WResultsOnBalance."Wr_potr",WResultsOnBalance."Wr_trans",
 WResultsOnBalance."Wa_potr_fact",WResultsOnBalance."Wa_trans_fact",
 WResultsOnBalance."Wr_potr_fact",WResultsOnBalance."Wr_trans_fact",
 PResultsOnBalance."dP_line_cu",PResultsOnBalance."dP_line_k",
 PResultsOnBalance."dP_line_crown",PResultsOnBalance."dQ_line_cu",
 PResultsOnBalance."dP_tr_cu",PResultsOnBalance."dQ_tr_cu",
 PResultsOnBalance."dP_tr_xx",PResultsOnBalance."dQ_tr_xx",
 PResultsOnBalance."dP_clr",PResultsOnBalance."dQ_clr",
 PResultsOnBalance."Qc",
 PResultsOnBalance."Pnagr",PResultsOnBalance."Ptrans",
 PResultsOnBalance."Qnagr",PResultsOnBalance."Qtrans",
 PResultsOnBalance."Pnagr_fact",PResultsOnBalance."Ptrans_fact",
 PResultsOnBalance."Qnagr_fact",PResultsOnBalance."Qtrans_fact",
 PResultsOnBalance."Kzagr","dUmax",
 PResultsOnBalance."Ssum_tr",PResultsOnBalance."Ntr",
 PResultsOnBalance."LsumP",PResultsOnBalance."LsumC",
 PResultsOnBalance."NLineP",PResultsOnBalance."NLineC",
 PResultsOnBalance."NAbonents","dWdop",
 "WeatherConditions","Temperature","Flags","CRC";

CREATE TRIGGER "WResultsBeforeUpdateOrInsert" FOR "TempWResults"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 EXECUTE PROCEDURE "InsertMVResults" (0,NEW."SampleIdent",NEW.GUID,
  NEW."Wa",NEW."Wr",NEW."T",NEW."U",NEW."Pgy",NEW."Qgy",
  NEW."Imax",NEW."Kzap",NEW."sqrKfg",NEW."sqrKfgCalc",NEW."dU",NEW."dWdop",
  NEW."WeatherConditions",NEW."Temperature",NEW."Flags",NEW."CRC")
 RETURNING_VALUES :Ident;

 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,0,
  NEW."dPnlin_OnBalance",NEW."dPklin_OnBalance",NEW."dPcrown_OnBalance",NEW."dQnlin_OnBalance",
  NEW."dPntr_OnBalance",NEW."dQntr_OnBalance",NEW."dPxx_OnBalance",NEW."dQxx_OnBalance",
  NEW."dPclr_OnBalance",NEW."dQclr_OnBalance",NEW."Qc_onBalance",
  NEW."Ppotr_OnBalance",NEW."Qpotr_OnBalance",0,0,
  NEW."Ppotr_OnBalance_fact",NEW."Qpotr_OnBalance_fact",0,0,
  NEW."Kzag_OnBalance",NEW."Ssum_tr_OnBalance",NEW."Ntr_OnBalance",0,0,0,0,
  NEW."LsumP_OnBalance",NEW."LsumC_OnBalance",NEW."NLineP_OnBalance",NEW."NLineC_OnBalance",
  NEW."NAbonents_OnBalance");
 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,1,
  NEW."dPnlin_notBalance",NEW."dPklin_notBalance",NEW."dPcrown_notBalance",NEW."dQnlin_notBalance",
  NEW."dPntr_notBalance",NEW."dQntr_notBalance",NEW."dPxx_notBalance",NEW."dQxx_notBalance",
  NEW."dPclr_notBalance",NEW."dQclr_notBalance",NEW."Qc_notBalance",
  NEW."Ppotr_notBalance",NEW."Qpotr_notBalance",0,0,
  NEW."Ppotr_notBalance_fact",NEW."Qpotr_notBalance_fact",0,0,
  NEW."Kzag_notBalance",NEW."Ssum_tr_NotBalance",NEW."Ntr_NotBalance",0,0,0,0,
  NEW."LsumP_NotBalance",NEW."LsumC_NotBalance",NEW."NLineP_NotBalance",NEW."NLineC_NotBalance",
  NEW."NAbonents_NotBalance");
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,0,
  NEW."DWal_cu_onBalance",NEW."DWal_k_onBalance",NEW."DWal_crown_OnBalance",NEW."DWrl_cu_onBalance",
  NEW."DWcu_onBalance",NEW."DWrcu_onBalance",NEW."DWxx_onBalance",NEW."DWrxx_onBalance",
  NEW."DWaclr_onBalance",NEW."DWrclr_onBalance",NEW."Wrc_onBalance",
  NEW."Wa_potr_onBalance",NEW."Wr_potr_onBalance",0,0,
  NEW."Wa_potr_onBalance_fact",NEW."Wr_potr_onBalance_fact",0,0);
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,1,
   NEW."DWal_cu_notBalance",NEW."DWal_k_notBalance",
   NEW."DWal_crown_notBalance",NEW."DWrl_cu_notBalance",
   NEW."DWcu_notBalance",NEW."DWrcu_notBalance",
   NEW."DWxx_notBalance",NEW."DWrxx_notBalance",
   NEW."DWaclr_notBalance",NEW."DWrclr_notBalance",NEW."Wrc_notBalance",
   NEW."Wa_potr_notBalance",NEW."Wr_potr_notBalance",0,0,
   NEW."Wa_potr_notBalance_fact",NEW."Wr_potr_notBalance_fact",0,0);
END;

/*-------------------------------------------------------*/
CREATE VIEW "TempWResultsA"("SampleIdent",GUID,
 "Wa","Wr",T,U,"Pgy","Qgy","Imax","Kzap","sqrKfg","sqrKfgCalc",
 "DWal_cu_onBalance","DWal_cu_notBalance","DWal_k_onBalance",
 "DWal_k_notBalance","DWal_crown_OnBalance","DWal_crown_notBalance",
 "DWrl_cu_onBalance","DWrl_cu_notBalance","DWcu_onBalance",
 "DWcu_notBalance","DWrcu_onBalance","DWrcu_notBalance",
 "DWxx_onBalance","DWxx_notBalance","DWrxx_onBalance",
 "DWrxx_notBalance","DWaclr_onBalance","DWaclr_notBalance",
 "DWrclr_onBalance","DWrclr_notBalance","Wrc_onBalance",
 "Wrc_notBalance","Wa_potr_onBalance","Wa_potr_notBalance",
 "Wr_potr_onBalance","Wr_potr_notBalance","Wa_potr_onBalance_fact",
 "Wa_potr_notBalance_fact","Wr_potr_onBalance_fact","Wr_potr_notBalance_fact",
 "dPnlin_OnBalance","dPnlin_notBalance","dPklin_OnBalance",
 "dPklin_notBalance","dPcrown_OnBalance","dPcrown_notBalance",
 "dQnlin_OnBalance","dQnlin_notBalance","dPntr_OnBalance",
 "dPntr_notBalance","dQntr_OnBalance","dQntr_notBalance",
 "dPxx_OnBalance","dPxx_notBalance","dQxx_OnBalance",
 "dQxx_notBalance","dPclr_OnBalance","dPclr_notBalance",
 "dQclr_OnBalance","dQclr_notBalance","Qc_onBalance",
 "Qc_notBalance","Ppotr_OnBalance","Ppotr_notBalance",
 "Qpotr_OnBalance","Qpotr_notBalance","Ppotr_OnBalance_fact",
 "Ppotr_notBalance_fact","Qpotr_OnBalance_fact","Qpotr_notBalance_fact",
 "Kzag_OnBalance","Kzag_notBalance","dU",
 "Ssum_tr_OnBalance","Ssum_tr_NotBalance","Ntr_OnBalance",
 "Ntr_NotBalance","LsumP_OnBalance","LsumP_NotBalance",
 "LsumC_OnBalance","LsumC_NotBalance","NLineP_OnBalance",
 "NLineP_NotBalance","NLineC_OnBalance","NLineC_NotBalance",
 "NAbonents_OnBalance","NAbonents_NotBalance","dWdop",
 "WeatherConditions","Temperature","Flags",CRC)
 AS
select "SampleIdent","GUID","Wa","Wr","T","U","Pgy","Qgy",
 "Imax","Kzap","sqrKfg","sqrKfgCalc",
 WResultsOnBalance."DWa_line_cu",Sum(WResultsNotBalance."DWa_line_cu"),
 WResultsOnBalance."DWa_line_k",Sum(WResultsNotBalance."DWa_line_k"),
 WResultsOnBalance."DWa_line_crown",Sum(WResultsNotBalance."DWa_line_crown"),
 WResultsOnBalance."DWr_line_cu",Sum(WResultsNotBalance."DWr_line_cu"),
 WResultsOnBalance."DWa_tr_cu",Sum(WResultsNotBalance."DWa_tr_cu"),
 WResultsOnBalance."DWr_tr_cu",Sum(WResultsNotBalance."DWr_tr_cu"),
 WResultsOnBalance."DWa_tr_xx",Sum(WResultsNotBalance."DWa_tr_xx"),
 WResultsOnBalance."DWr_tr_xx",Sum(WResultsNotBalance."DWr_tr_xx"),
 WResultsOnBalance."DWa_clr",Sum(WResultsNotBalance."DWa_clr"),
 WResultsOnBalance."DWr_clr",Sum(WResultsNotBalance."DWr_clr"),
 WResultsOnBalance."Wrc",Sum(WResultsNotBalance."Wrc"),
 WResultsOnBalance."Wa_potr"+WResultsOnBalance."Wa_trans",
 Sum(WResultsNotBalance."Wa_potr")+Sum(WResultsNotBalance."Wa_trans"),
 WResultsOnBalance."Wr_potr"+WResultsOnBalance."Wr_trans",
 Sum(WResultsNotBalance."Wr_potr")+Sum(WResultsNotBalance."Wr_trans"),
 COALESCE(WResultsOnBalance."Wa_potr_fact",0)+COALESCE(WResultsOnBalance."Wa_trans_fact",0),
 Sum(WResultsNotBalance."Wa_potr_fact")+Sum(WResultsNotBalance."Wa_trans_fact"),
 COALESCE(WResultsOnBalance."Wr_potr_fact",0)+COALESCE(WResultsOnBalance."Wr_trans_fact",0),
 Sum(WResultsNotBalance."Wr_potr_fact")+Sum(WResultsNotBalance."Wr_trans_fact"),

 PResultsOnBalance."dP_line_cu",Sum(PResultsNotBalance."dP_line_cu"),
 PResultsOnBalance."dP_line_k",Sum(PResultsNotBalance."dP_line_k"),
 PResultsOnBalance."dP_line_crown",Sum(PResultsNotBalance."dP_line_crown"),
 PResultsOnBalance."dQ_line_cu",Sum(PResultsNotBalance."dQ_line_cu"),
 PResultsOnBalance."dP_tr_cu",Sum(PResultsNotBalance."dP_tr_cu"),
 PResultsOnBalance."dQ_tr_cu",Sum(PResultsNotBalance."dQ_tr_cu"),
 PResultsOnBalance."dP_tr_xx",Sum(PResultsNotBalance."dP_tr_xx"),
 PResultsOnBalance."dQ_tr_xx",Sum(PResultsNotBalance."dQ_tr_xx"),
 PResultsOnBalance."dP_clr",Sum(PResultsNotBalance."dP_clr"),
 PResultsOnBalance."dQ_clr",Sum(PResultsNotBalance."dQ_clr"),
 PResultsOnBalance."Qc",Sum(PResultsNotBalance."Qc"),
 PResultsOnBalance."Pnagr"+PResultsOnBalance."Ptrans",
 Sum(PResultsNotBalance."Pnagr")+Sum(PResultsNotBalance."Ptrans"),
 PResultsOnBalance."Qnagr"+PResultsOnBalance."Qtrans",
 Sum(PResultsNotBalance."Qnagr")+Sum(PResultsNotBalance."Qtrans"),
 COALESCE(PResultsOnBalance."Pnagr_fact",0)+COALESCE(PResultsOnBalance."Ptrans_fact",0),
 Sum(PResultsNotBalance."Pnagr_fact")+Sum(PResultsNotBalance."Ptrans_fact"),
 COALESCE(PResultsOnBalance."Qnagr_fact",0)+COALESCE(PResultsOnBalance."Qtrans_fact",0),
 Sum(PResultsNotBalance."Qnagr_fact")+Sum(PResultsNotBalance."Qtrans_fact"),

 PResultsOnBalance."Kzagr",AVG(PResultsNotBalance."Kzagr"),"dUmax",

 PResultsOnBalance."Ssum_tr",Sum(PResultsNotBalance."Ssum_tr"),
 PResultsOnBalance."Ntr",Sum(PResultsNotBalance."Ntr"),
 PResultsOnBalance."LsumP",Sum(PResultsNotBalance."LsumP"),
 PResultsOnBalance."LsumC",Sum(PResultsNotBalance."LsumC"),
 PResultsOnBalance."NLineP",Sum(PResultsNotBalance."NLineP"),
 PResultsOnBalance."NLineC",Sum(PResultsNotBalance."NLineC"),

 PResultsOnBalance."NAbonents",Sum(PResultsNotBalance."NAbonents"),"dWdop",

 "WeatherConditions","Temperature","Flags","CRC"

from "MVResults"

left outer join "WResultsAdd" WResultsOnBalance on
 ("MVResults"."Ident"=WResultsOnBalance."Ident") and (WResultsOnBalance."Balance"=0)
left outer join "WResultsAdd" WResultsNotBalance on
 ("MVResults"."Ident"=WResultsNotBalance."Ident") and (WResultsNotBalance."Balance"<>0)
left outer join "PResultsAdd" PResultsOnBalance on
 ("MVResults"."Ident"=PResultsOnBalance."Ident") and (PResultsOnBalance."Balance"=0)
left outer join "PResultsAdd" PResultsNotBalance on
 ("MVResults"."Ident"=PResultsNotBalance."Ident") and (PResultsNotBalance."Balance"<>0)

where "MVResults"."CalcType"=1

group by "SampleIdent","GUID","Wa","Wr","T","U","Pgy","Qgy",
 "Imax","Kzap","sqrKfg","sqrKfgCalc",
 WResultsOnBalance."DWa_line_cu",WResultsOnBalance."DWa_line_k",
 WResultsOnBalance."DWa_line_crown",WResultsOnBalance."DWr_line_cu",
 WResultsOnBalance."DWa_tr_cu",WResultsOnBalance."DWr_tr_cu",
 WResultsOnBalance."DWa_tr_xx",WResultsOnBalance."DWr_tr_xx",
 WResultsOnBalance."DWa_clr",WResultsOnBalance."DWr_clr",
 WResultsOnBalance."Wrc",
 WResultsOnBalance."Wa_potr",WResultsOnBalance."Wa_trans",
 WResultsOnBalance."Wr_potr",WResultsOnBalance."Wr_trans",
 WResultsOnBalance."Wa_potr_fact",WResultsOnBalance."Wa_trans_fact",
 WResultsOnBalance."Wr_potr_fact",WResultsOnBalance."Wr_trans_fact",
 PResultsOnBalance."dP_line_cu",PResultsOnBalance."dP_line_k",
 PResultsOnBalance."dP_line_crown",PResultsOnBalance."dQ_line_cu",
 PResultsOnBalance."dP_tr_cu",PResultsOnBalance."dQ_tr_cu",
 PResultsOnBalance."dP_tr_xx",PResultsOnBalance."dQ_tr_xx",
 PResultsOnBalance."dP_clr",PResultsOnBalance."dQ_clr",
 PResultsOnBalance."Qc",
 PResultsOnBalance."Pnagr",PResultsOnBalance."Ptrans",
 PResultsOnBalance."Qnagr",PResultsOnBalance."Qtrans",
 PResultsOnBalance."Pnagr_fact",PResultsOnBalance."Ptrans_fact",
 PResultsOnBalance."Qnagr_fact",PResultsOnBalance."Qtrans_fact",
 PResultsOnBalance."Kzagr","dUmax",
 PResultsOnBalance."Ssum_tr",PResultsOnBalance."Ntr",
 PResultsOnBalance."LsumP",PResultsOnBalance."LsumC",
 PResultsOnBalance."NLineP",PResultsOnBalance."NLineC",
 PResultsOnBalance."NAbonents","dWdop",
 "WeatherConditions","Temperature","Flags","CRC";

CREATE TRIGGER "TWResultsABUOrInsert" FOR "TempWResultsA"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 EXECUTE PROCEDURE "InsertMVResults" (1,NEW."SampleIdent",NEW.GUID,
  NEW."Wa",NEW."Wr",NEW."T",NEW."U",NEW."Pgy",NEW."Qgy",
  NEW."Imax",NEW."Kzap",NEW."sqrKfg",NEW."sqrKfgCalc",NEW."dU",NEW."dWdop",
  NEW."WeatherConditions",NEW."Temperature",NEW."Flags",NEW."CRC")
 RETURNING_VALUES :Ident;

 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,0,
  NEW."dPnlin_OnBalance",NEW."dPklin_OnBalance",NEW."dPcrown_OnBalance",NEW."dQnlin_OnBalance",
  NEW."dPntr_OnBalance",NEW."dQntr_OnBalance",NEW."dPxx_OnBalance",NEW."dQxx_OnBalance",
  NEW."dPclr_OnBalance",NEW."dQclr_OnBalance",NEW."Qc_onBalance",
  NEW."Ppotr_OnBalance",NEW."Qpotr_OnBalance",0,0,
  NEW."Ppotr_OnBalance_fact",NEW."Qpotr_OnBalance_fact",0,0,
  NEW."Kzag_OnBalance",NEW."Ssum_tr_OnBalance",NEW."Ntr_OnBalance",0,0,0,0,
  NEW."LsumP_OnBalance",NEW."LsumC_OnBalance",NEW."NLineP_OnBalance",NEW."NLineC_OnBalance",
  NEW."NAbonents_OnBalance");
 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,1,
  NEW."dPnlin_notBalance",NEW."dPklin_notBalance",NEW."dPcrown_notBalance",NEW."dQnlin_notBalance",
  NEW."dPntr_notBalance",NEW."dQntr_notBalance",NEW."dPxx_notBalance",NEW."dQxx_notBalance",
  NEW."dPclr_notBalance",NEW."dQclr_notBalance",NEW."Qc_notBalance",
  NEW."Ppotr_notBalance",NEW."Qpotr_notBalance",0,0,
  NEW."Ppotr_notBalance_fact",NEW."Qpotr_notBalance_fact",0,0,
  NEW."Kzag_notBalance",NEW."Ssum_tr_NotBalance",NEW."Ntr_NotBalance",0,0,0,0,
  NEW."LsumP_NotBalance",NEW."LsumC_NotBalance",NEW."NLineP_NotBalance",NEW."NLineC_NotBalance",
  NEW."NAbonents_NotBalance");
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,0,
  NEW."DWal_cu_onBalance",NEW."DWal_k_onBalance",NEW."DWal_crown_OnBalance",NEW."DWrl_cu_onBalance",
  NEW."DWcu_onBalance",NEW."DWrcu_onBalance",NEW."DWxx_onBalance",NEW."DWrxx_onBalance",
  NEW."DWaclr_onBalance",NEW."DWrclr_onBalance",NEW."Wrc_onBalance",
  NEW."Wa_potr_onBalance",NEW."Wr_potr_onBalance",0,0,
  NEW."Wa_potr_onBalance_fact",NEW."Wr_potr_onBalance_fact",0,0);
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,1,
   NEW."DWal_cu_notBalance",NEW."DWal_k_notBalance",
   NEW."DWal_crown_notBalance",NEW."DWrl_cu_notBalance",
   NEW."DWcu_notBalance",NEW."DWrcu_notBalance",
   NEW."DWxx_notBalance",NEW."DWrxx_notBalance",
   NEW."DWaclr_notBalance",NEW."DWrclr_notBalance",NEW."Wrc_notBalance",
   NEW."Wa_potr_notBalance",NEW."Wr_potr_notBalance",0,0,
   NEW."Wa_potr_notBalance_fact",NEW."Wr_potr_notBalance_fact",0,0);
END;


CREATE VIEW "TempWResultsPL" ("SampleIdent","GUID",
"P","Q","I","deltaPcu","deltaPk","deltaPcrown","deltaQ","Qc_b","Qc_e","Kzag")
AS
SELECT F."SampleIdent",L."GUID",
L."P",L."Q",L."I",L."deltaPcu",L."deltaPk",L."deltaPcrown",L."deltaQ",
L."Qc_b",L."Qc_e",L."Kzag"
FROM "PResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",L."GUID",
L."P",L."Q",L."I",L."deltaPcu",L."deltaPk",L."deltaPcrown",L."deltaQ",
L."Qc_b",L."Qc_e",L."Kzag"
FROM "PResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "PResultsL" L
   INNER JOIN "MVResults" F on F."Ident"=L."Ident"
   WHERE F."CalcType"=0);


CREATE TRIGGER "TWResultsPLBeforeUOrI" FOR "TempWResultsPL" BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Lines"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;
if  (not Ident is null) then
BEGIN
DELETE FROM "PResultsL" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "PResultsL"
  ("Ident","GUID","P","Q","I","deltaPcu","deltaPk",
   "deltaPcrown","deltaQ","Qc_b","Qc_e","Kzag")
VALUES (:Ident,NEW."GUID",NEW."P",NEW."Q",NEW."I",NEW."deltaPcu",NEW."deltaPk",
  NEW."deltaPcrown",NEW."deltaQ",NEW."Qc_b",NEW."Qc_e",NEW."Kzag");
END
END ;


CREATE VIEW "TempWResultsPN" ("SampleIdent","GUID",
"Pn","Qn","UB","UH","deltaPcu","deltaQcu","deltaPxx","deltaQxx",
"deltaUB","Kzag")
AS
SELECT F."SampleIdent",N."GUID",
N."Pn",N."Qn",N."UB",N."UH",N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
N."deltaUB",N."Kzag"
FROM "PResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",N."GUID",
N."Pn",N."Qn",N."UB",N."UH",N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
N."deltaUB",N."Kzag"
FROM "PResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "PResultsN" N
   INNER JOIN "MVResults" F on F."Ident"=N."Ident"
   WHERE F."CalcType"=0);

CREATE TRIGGER "TWResultsPNBUOrInsert" FOR "TempWResultsPN" ACTIVE BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

if  (not Ident is null) then
BEGIN
DELETE FROM "PResultsN" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "PResultsN"
  ("Ident","GUID","Pn","Qn","UB","UH",
   "deltaPcu","deltaQcu","deltaPxx","deltaQxx",
   "deltaUB","Kzag")
VALUES (:Ident,NEW."GUID",NEW."Pn",NEW."Qn",NEW."UB",NEW."UH",
   NEW."deltaPcu",NEW."deltaQcu",NEW."deltaPxx",NEW."deltaQxx",
   NEW."deltaUB",NEW."Kzag");
END
END ;


CREATE VIEW "TempWResultsPN3" ("SampleIdent","GUID",
   "PCn","QCn","PHn","QHn","UB","UC","UH",
   "deltaPcu","deltaQcu","deltaPxx","deltaQxx",
   "deltaUB","Kzag")
AS
SELECT F."SampleIdent",N."GUID",
N."PCn",N."QCn",N."PHn",N."QHn",N."UB",N."UC",N."UH",
N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
N."deltaUB",N."Kzag"
FROM "PResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",N."GUID",
N."PCn",N."QCn",N."PHn",N."QHn",N."UB",N."UC",N."UH",
N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
N."deltaUB",N."Kzag"
FROM "PResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "PResultsN3" N
   INNER JOIN "MVResults" F on F."Ident"=N."Ident"
   WHERE F."CalcType"=0);


CREATE TRIGGER "TWResultsPN3BUOrInsert" FOR "TempWResultsPN3"
BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

if  (not Ident is null) then
BEGIN
DELETE FROM "PResultsN3" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "PResultsN3"
  ("Ident","GUID","PCn","QCn","PHn","QHn",
   "UB","UC","UH",
   "deltaPcu","deltaQcu","deltaPxx","deltaQxx",
   "deltaUB","Kzag")
VALUES (:Ident,NEW."GUID",NEW."PCn",NEW."QCn",NEW."PHn",NEW."QHn",
   NEW."UB",NEW."UC",NEW."UH",
   NEW."deltaPcu",NEW."deltaQcu",NEW."deltaPxx",NEW."deltaQxx",
   NEW."deltaUB",NEW."Kzag");
END
END ;


CREATE VIEW "TempWResultsWL" ("SampleIdent","GUID",
"Wa","Wr","deltaWa_cu","deltaWa_k","deltaWa_crown","deltaWr",
"Wrc_b","Wrc_e","sqrKfg")
AS
SELECT F."SampleIdent",L."GUID",
L."Wa",L."Wr",L."deltaWa_cu",L."deltaWa_k",L."deltaWa_crown",L."deltaWr",
L."Wrc_b",L."Wrc_e",L."sqrKfg"
FROM "WResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",L."GUID",
L."Wa",L."Wr",L."deltaWa_cu",L."deltaWa_k",L."deltaWa_crown",L."deltaWr",
L."Wrc_b",L."Wrc_e",L."sqrKfg"
FROM "WResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "WResultsL" L
   INNER JOIN "MVResults" F on F."Ident"=L."Ident"
   WHERE F."CalcType"=0);


CREATE TRIGGER "TWResultsWLBUOrInsert" FOR "TempWResultsWL"
ACTIVE BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Lines"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

if  (not Ident is null) then
BEGIN
DELETE FROM "WResultsL" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "WResultsL"
  ("Ident","GUID","Wa","Wr",
   "deltaWa_cu","deltaWa_k","deltaWa_crown","deltaWr",
   "Wrc_b","Wrc_e","sqrKfg")
VALUES (:Ident,NEW."GUID",NEW."Wa",NEW."Wr",
  NEW."deltaWa_cu",NEW."deltaWa_k",NEW."deltaWa_crown",NEW."deltaWr",
  NEW."Wrc_b",NEW."Wrc_e",NEW."sqrKfg");
END
END ;



CREATE VIEW "TempWResultsWN" ("SampleIdent","GUID",
  "Wa","Wr","deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx","sqrKfg")
AS
SELECT F."SampleIdent",N."GUID",
N."Wa",N."Wr",N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx",
N."sqrKfg"
FROM "WResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",N."GUID",
N."Wa",N."Wr",N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx",
N."sqrKfg"
FROM "WResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "WResultsN" N
   INNER JOIN "MVResults" F on F."Ident"=N."Ident"
   WHERE F."CalcType"=0);


CREATE TRIGGER "TWResultsWNBUOrInsert" FOR "TempWResultsWN"
 BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;
if  (not Ident is null) then
BEGIN
DELETE FROM "WResultsN" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "WResultsN"
  ("Ident","GUID","Wa","Wr",
   "deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx",
   "sqrKfg")
VALUES (:Ident,NEW."GUID",NEW."Wa",NEW."Wr",
  NEW."deltaW_cu",NEW."deltaWr_cu",NEW."deltaW_xx",NEW."deltaWr_xx",
  NEW."sqrKfg");
End
END ;


CREATE VIEW "TempWResultsWN3" ("SampleIdent","GUID",
  "WCa","WCr","WHa","WHr","deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx",
  "sqrKfgC","sqrKfgH")
AS
SELECT F."SampleIdent",N."GUID",
N."WCa",N."WCr",N."WHa",N."WHr",
N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx",N."sqrKfgC",N."sqrKfgH"
FROM "WResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",N."GUID",
N."WCa",N."WCr",N."WHa",N."WHr",
N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx",N."sqrKfgC",N."sqrKfgH"
FROM "WResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "WResultsN3" N
   INNER JOIN "MVResults" F on F."Ident"=N."Ident"
   WHERE F."CalcType"=0);


CREATE TRIGGER "TWResultsWN3BUOrInsert" FOR "TempWResultsWN3"
ACTIVE BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;
if  (not Ident is null) then
BEGIN
DELETE FROM "WResultsN3" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "WResultsN3"
  ("Ident","GUID","WCa","WCr","WHa","WHr",
   "deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx",
   "sqrKfgC","sqrKfgH")
VALUES (:Ident,NEW."GUID",NEW."WCa",NEW."WCr",NEW."WHa",NEW."WHr",
  NEW."deltaW_cu",NEW."deltaWr_cu",NEW."deltaW_xx",NEW."deltaWr_xx",
  NEW."sqrKfgC",NEW."sqrKfgH");
END
END ;

Commit;
RECONNECT;

INSERT INTO "TempPResults"
("SampleIdent", GUID, "Wa", "Wr", T, U,"Pgy", "Qgy", "DWal_cu_onBalance",
"DWal_cu_notBalance","DWal_k_onBalance", "DWal_k_notBalance", "DWal_crown_OnBalance",
"DWal_crown_notBalance", "DWrl_cu_onBalance", "DWrl_cu_notBalance",
"DWcu_onBalance", "DWcu_notBalance", "DWrcu_onBalance", "DWrcu_notBalance",
"DWxx_onBalance", "DWxx_notBalance", "DWrxx_onBalance", "DWrxx_notBalance",
"DWaclr_onBalance", "DWaclr_notBalance", "DWrclr_onBalance", "DWrclr_notBalance",
"Wrc_onBalance", "Wrc_notBalance", "Wa_potr_onBalance", "Wa_potr_notBalance",
"Wr_potr_onBalance", "Wr_potr_notBalance", "Wa_potr_onBalance_fact", "Wa_potr_notBalance_fact",
"Wr_potr_onBalance_fact", "Wr_potr_notBalance_fact", "dPnlin_OnBalance", "dPnlin_notBalance",
"dPklin_OnBalance", "dPklin_notBalance", "dPcrown_OnBalance", "dPcrown_notBalance", "dQnlin_OnBalance",
"dQnlin_notBalance", "dPntr_OnBalance", "dPntr_notBalance", "dQntr_OnBalance", "dQntr_notBalance",
"dPxx_OnBalance", "dPxx_notBalance", "dQxx_OnBalance", "dQxx_notBalance", "dPclr_OnBalance",
"dPclr_notBalance", "dQclr_OnBalance", "dQclr_notBalance", "Qc_onBalance", "Qc_notBalance",
"Ppotr_OnBalance", "Ppotr_notBalance", "Qpotr_OnBalance", "Qpotr_notBalance",
"Ppotr_OnBalance_fact", "Ppotr_notBalance_fact", "Qpotr_OnBalance_fact",
"Qpotr_notBalance_fact", "Kzag_OnBalance", "Kzag_notBalance", "dU",
"Ssum_tr_OnBalance", "Ssum_tr_NotBalance", "Ntr_OnBalance", "Ntr_NotBalance", "LsumP_OnBalance",
"LsumP_NotBalance", "LsumC_OnBalance", "LsumC_NotBalance", "NLineP_OnBalance", "NLineP_NotBalance",
"NLineC_OnBalance", "NLineC_NotBalance", "WeatherConditions", "Temperature", "Flags", CRC)
Select * From "PResults" Where "GUID"<>0;


INSERT INTO "TempWResults"
("SampleIdent", GUID, "Wa", "Wr", T, U, "Pgy", "Qgy", "Imax", "Kzap", "sqrKfg",
 "sqrKfgCalc", "DWal_cu_onBalance", "DWal_cu_notBalance", "DWal_k_onBalance",
 "DWal_k_notBalance", "DWal_crown_OnBalance", "DWal_crown_notBalance",
 "DWrl_cu_onBalance", "DWrl_cu_notBalance", "DWcu_onBalance", "DWcu_notBalance",
 "DWrcu_onBalance", "DWrcu_notBalance", "DWxx_onBalance", "DWxx_notBalance",
 "DWrxx_onBalance", "DWrxx_notBalance", "DWaclr_onBalance", "DWaclr_notBalance",
 "DWrclr_onBalance", "DWrclr_notBalance", "Wrc_onBalance", "Wrc_notBalance",
 "Wa_potr_onBalance", "Wa_potr_notBalance", "Wr_potr_onBalance",
 "Wr_potr_notBalance", "Wa_potr_onBalance_fact", "Wa_potr_notBalance_fact",
 "Wr_potr_onBalance_fact", "Wr_potr_notBalance_fact", "dPnlin_OnBalance",
 "dPnlin_notBalance", "dPklin_OnBalance", "dPklin_notBalance", "dPcrown_OnBalance",
 "dPcrown_notBalance", "dQnlin_OnBalance", "dQnlin_notBalance", "dPntr_OnBalance",
 "dPntr_notBalance", "dQntr_OnBalance", "dQntr_notBalance", "dPxx_OnBalance",
 "dPxx_notBalance", "dQxx_OnBalance", "dQxx_notBalance", "dPclr_OnBalance",
 "dPclr_notBalance", "dQclr_OnBalance", "dQclr_notBalance", "Qc_onBalance",
 "Qc_notBalance", "Ppotr_OnBalance", "Ppotr_notBalance", "Qpotr_OnBalance",
 "Qpotr_notBalance", "Ppotr_OnBalance_fact", "Ppotr_notBalance_fact",
 "Qpotr_OnBalance_fact", "Qpotr_notBalance_fact", "Kzag_OnBalance",
 "Kzag_notBalance", "dU", "Ssum_tr_OnBalance", "Ssum_tr_NotBalance",
 "Ntr_OnBalance", "Ntr_NotBalance", "LsumP_OnBalance", "LsumP_NotBalance",
 "LsumC_OnBalance", "LsumC_NotBalance", "NLineP_OnBalance", "NLineP_NotBalance",
 "NLineC_OnBalance", "NLineC_NotBalance", "NAbonents_OnBalance",
 "NAbonents_NotBalance", "dWdop", "WeatherConditions", "Temperature", "Flags", CRC)
Select * From "WResults" Where "GUID"<>0;

INSERT INTO "TempPResultsPL" ("SampleIdent", GUID, P, Q, I, "deltaPcu", "deltaPk",
 "deltaPcrown", "deltaQ", "Qc_b", "Qc_e", "Kzag")
 Select * From "PResultsPL";

INSERT INTO "TempPResultsPN" ("SampleIdent", GUID, "Pn", "Qn", UB, UH, "deltaPcu",
 "deltaQcu", "deltaPxx", "deltaQxx", "deltaUB", "Kzag")
  Select * From "PResultsPN";

INSERT INTO "TempPResultsPN3" ("SampleIdent", GUID, "PCn", "QCn", "PHn", "QHn", UB,
UC, UH, "deltaPcu", "deltaQcu", "deltaPxx", "deltaQxx", "deltaUB", "Kzag")
 Select * From "PResultsPN3";

INSERT INTO "TempPResultsWL" ("SampleIdent", GUID, "Wa", "Wr", "deltaWa_cu",
"deltaWa_k", "deltaWa_crown", "deltaWr", "Wrc_b", "Wrc_e")
 Select * From "PResultsWL";

INSERT INTO "TempPResultsWN" ("SampleIdent", GUID, "Wa", "Wr", "deltaW_cu",
"deltaWr_cu", "deltaW_xx", "deltaWr_xx")
 Select * From "PResultsWN";

INSERT INTO "TempPResultsWN3" ("SampleIdent", GUID, "WCa", "WCr", "WHa", "WHr",
"deltaW_cu", "deltaWr_cu", "deltaW_xx", "deltaWr_xx")
 Select * From "PResultsWN3";


INSERT INTO "TempWResultsA" ("SampleIdent", GUID, "Wa", "Wr", T, U, "Pgy", "Qgy",
 "Imax", "Kzap", "sqrKfg", "sqrKfgCalc", "DWal_cu_onBalance", "DWal_cu_notBalance",
  "DWal_k_onBalance", "DWal_k_notBalance", "DWal_crown_OnBalance",
  "DWal_crown_notBalance", "DWrl_cu_onBalance", "DWrl_cu_notBalance",
  "DWcu_onBalance", "DWcu_notBalance", "DWrcu_onBalance", "DWrcu_notBalance",
  "DWxx_onBalance", "DWxx_notBalance", "DWrxx_onBalance", "DWrxx_notBalance",
  "DWaclr_onBalance", "DWaclr_notBalance", "DWrclr_onBalance", "DWrclr_notBalance",
  "Wrc_onBalance", "Wrc_notBalance", "Wa_potr_onBalance", "Wa_potr_notBalance",
  "Wr_potr_onBalance", "Wr_potr_notBalance", "Wa_potr_onBalance_fact",
  "Wa_potr_notBalance_fact", "Wr_potr_onBalance_fact", "Wr_potr_notBalance_fact",
  "dPnlin_OnBalance", "dPnlin_notBalance", "dPklin_OnBalance", "dPklin_notBalance",
  "dPcrown_OnBalance", "dPcrown_notBalance", "dQnlin_OnBalance",
  "dQnlin_notBalance", "dPntr_OnBalance", "dPntr_notBalance", "dQntr_OnBalance",
  "dQntr_notBalance", "dPxx_OnBalance", "dPxx_notBalance", "dQxx_OnBalance",
  "dQxx_notBalance", "dPclr_OnBalance", "dPclr_notBalance", "dQclr_OnBalance",
  "dQclr_notBalance", "Qc_onBalance", "Qc_notBalance", "Ppotr_OnBalance",
  "Ppotr_notBalance", "Qpotr_OnBalance", "Qpotr_notBalance",
  "Ppotr_OnBalance_fact", "Ppotr_notBalance_fact", "Qpotr_OnBalance_fact",
  "Qpotr_notBalance_fact", "Kzag_OnBalance", "Kzag_notBalance", "dU",
  "Ssum_tr_OnBalance", "Ssum_tr_NotBalance", "Ntr_OnBalance", "Ntr_NotBalance",
  "LsumP_OnBalance", "LsumP_NotBalance", "LsumC_OnBalance", "LsumC_NotBalance",
  "NLineP_OnBalance", "NLineP_NotBalance", "NLineC_OnBalance", "NLineC_NotBalance",
  "NAbonents_OnBalance", "NAbonents_NotBalance", "dWdop", "WeatherConditions",
  "Temperature", "Flags", CRC)
  Select * From "WResultsA";

INSERT INTO "TempWResultsPL" ("SampleIdent", GUID, P, Q, I, "deltaPcu", "deltaPk",
 "deltaPcrown", "deltaQ", "Qc_b", "Qc_e", "Kzag")
 Select * From "WResultsPL";

INSERT INTO "TempWResultsPN" ("SampleIdent", GUID, "Pn", "Qn", UB, UH, "deltaPcu",
 "deltaQcu", "deltaPxx", "deltaQxx", "deltaUB", "Kzag")
 Select * From "WResultsPN";

INSERT INTO "TempWResultsPN3" ("SampleIdent", GUID, "PCn", "QCn", "PHn", "QHn", UB,
 UC, UH, "deltaPcu", "deltaQcu", "deltaPxx", "deltaQxx", "deltaUB", "Kzag")
 Select * From "WResultsPN3";

INSERT INTO "TempWResultsWL" ("SampleIdent", GUID, "Wa", "Wr", "deltaWa_cu",
 "deltaWa_k", "deltaWa_crown", "deltaWr", "Wrc_b", "Wrc_e")
 Select * From "WResultsWL";

INSERT INTO "TempWResultsWN" ("SampleIdent", GUID, "Wa", "Wr", "deltaW_cu",
  "deltaWr_cu", "deltaW_xx", "deltaWr_xx", "sqrKfg")
 Select * From "WResultsWN";

INSERT INTO "TempWResultsWN3" ("SampleIdent", GUID, "WCa", "WCr", "WHa", "WHr",
 "deltaW_cu", "deltaWr_cu", "deltaW_xx", "deltaWr_xx", "sqrKfgC", "sqrKfgH")
 Select * From "WResultsWN3";

COMMIT;
RECONNECT;

DROP View "TempPResults";
DROP View "TempWResults";
DROP View "TempPResultsPL";
DROP View "TempPResultsPN3";
DROP View "TempPResultsPN";
DROP View "TempPResultsWL";
DROP View "TempPResultsWN";
DROP View "TempPResultsWN3";
DROP View "TempWResultsA";
DROP View "TempWResultsPL";
DROP View "TempWResultsPN";
DROP View "TempWResultsPN3";
DROP View "TempWResultsWL";
DROP View "TempWResultsWN";
DROP View "TempWResultsWN3";

/*--   */

DROP TRIGGER "NodePResultsDeleteTrigger";
DROP TRIGGER "NodePResultsUpdateTrigger";
DROP TRIGGER "NodeWResultsUpdateTrigger";

Commit;
RECONNECT;
/*DROP TRIGGER "PResultsPLBeforeDelete" */

DROP TABLE "PResults";
DROP TABLE "PResultsPL";
DROP TABLE "PResultsPN";
DROP TABLE "PResultsPN3";
DROP TABLE "PResultsWL";
DROP TABLE "PResultsWN";
DROP TABLE "PResultsWN3";
Commit;
RECONNECT;

DROP TABLE "WResults";
DROP TABLE "WResultsA";
DROP TABLE "WResultsPL";
DROP TABLE "WResultsPN";
DROP TABLE "WResultsPN3";
DROP TABLE "WResultsWL";
DROP TABLE "WResultsWN";
DROP TABLE "WResultsWN3";
Commit;
RECONNECT;
/*--   */
CREATE VIEW "PResults"("SampleIdent",GUID,"Wa","Wr",T,U,"Pgy","Qgy",
 "DWal_cu_onBalance","DWal_cu_notBalance","DWal_k_onBalance","DWal_k_notBalance",
 "DWal_crown_OnBalance","DWal_crown_notBalance","DWrl_cu_onBalance",
 "DWrl_cu_notBalance","DWcu_onBalance","DWcu_notBalance",
 "DWrcu_onBalance","DWrcu_notBalance","DWxx_onBalance",
 "DWxx_notBalance","DWrxx_onBalance","DWrxx_notBalance",
 "DWaclr_onBalance","DWaclr_notBalance","DWrclr_onBalance",
 "DWrclr_notBalance","Wrc_onBalance","Wrc_notBalance",
 "Wa_potr_onBalance","Wa_potr_notBalance","Wr_potr_onBalance",
 "Wr_potr_notBalance","Wa_potr_onBalance_fact","Wa_potr_notBalance_fact",
 "Wr_potr_onBalance_fact","Wr_potr_notBalance_fact","dPnlin_OnBalance",
 "dPnlin_notBalance","dPklin_OnBalance","dPklin_notBalance",
 "dPcrown_OnBalance","dPcrown_notBalance","dQnlin_OnBalance",
 "dQnlin_notBalance","dPntr_OnBalance","dPntr_notBalance",
 "dQntr_OnBalance","dQntr_notBalance","dPxx_OnBalance",
 "dPxx_notBalance","dQxx_OnBalance","dQxx_notBalance",
 "dPclr_OnBalance","dPclr_notBalance","dQclr_OnBalance",
 "dQclr_notBalance","Qc_onBalance","Qc_notBalance",
 "Ppotr_OnBalance","Ppotr_notBalance","Qpotr_OnBalance",
 "Qpotr_notBalance","Ppotr_OnBalance_fact","Ppotr_notBalance_fact",
 "Qpotr_OnBalance_fact","Qpotr_notBalance_fact","Kzag_OnBalance",
 "Kzag_notBalance","dU","Ssum_tr_OnBalance",
 "Ssum_tr_NotBalance","Ntr_OnBalance","Ntr_NotBalance",
 "LsumP_OnBalance","LsumP_NotBalance","LsumC_OnBalance",
 "LsumC_NotBalance","NLineP_OnBalance","NLineP_NotBalance",
 "NLineC_OnBalance","NLineC_NotBalance","WeatherConditions",
 "Temperature","Flags",CRC)
AS
select "SampleIdent","GUID","Wa","Wr","T","U","Pgy","Qgy",
 WResultsOnBalance."DWa_line_cu",WResultsNotBalance."DWa_line_cu",
 WResultsOnBalance."DWa_line_k",WResultsNotBalance."DWa_line_k",
 WResultsOnBalance."DWa_line_crown",WResultsNotBalance."DWa_line_crown",
 WResultsOnBalance."DWr_line_cu",WResultsNotBalance."DWr_line_cu",
 WResultsOnBalance."DWa_tr_cu",WResultsNotBalance."DWa_tr_cu",
 WResultsOnBalance."DWr_tr_cu",WResultsNotBalance."DWr_tr_cu",
 WResultsOnBalance."DWa_tr_xx",WResultsNotBalance."DWa_tr_xx",
 WResultsOnBalance."DWr_tr_xx",WResultsNotBalance."DWr_tr_xx",
 WResultsOnBalance."DWa_clr",WResultsNotBalance."DWa_clr",
 WResultsOnBalance."DWr_clr",WResultsNotBalance."DWr_clr",
 WResultsOnBalance."Wrc",WResultsNotBalance."Wrc",
 WResultsOnBalance."Wa_potr"+WResultsOnBalance."Wa_trans",
 WResultsNotBalance."Wa_potr"+WResultsNotBalance."Wa_trans",
 WResultsOnBalance."Wr_potr"+WResultsOnBalance."Wr_trans",
 WResultsNotBalance."Wr_potr"+WResultsNotBalance."Wr_trans",
 COALESCE(WResultsOnBalance."Wa_potr_fact",0)+COALESCE(WResultsOnBalance."Wa_trans_fact",0),
 COALESCE(WResultsNotBalance."Wa_potr_fact",0)+COALESCE(WResultsNotBalance."Wa_trans_fact",0),
 COALESCE(WResultsOnBalance."Wr_potr_fact",0)+COALESCE(WResultsOnBalance."Wr_trans_fact",0),
 COALESCE(WResultsNotBalance."Wr_potr_fact",0)+COALESCE(WResultsNotBalance."Wr_trans_fact",0),

 PResultsOnBalance."dP_line_cu",PResultsNotBalance."dP_line_cu",
 PResultsOnBalance."dP_line_k",PResultsNotBalance."dP_line_k",
 PResultsOnBalance."dP_line_crown",PResultsNotBalance."dP_line_crown",
 PResultsOnBalance."dQ_line_cu",PResultsNotBalance."dQ_line_cu",
 PResultsOnBalance."dP_tr_cu",PResultsNotBalance."dP_tr_cu",
 PResultsOnBalance."dQ_tr_cu",PResultsNotBalance."dQ_tr_cu",
 PResultsOnBalance."dP_tr_xx",PResultsNotBalance."dP_tr_xx",
 PResultsOnBalance."dQ_tr_xx",PResultsNotBalance."dQ_tr_xx",
 PResultsOnBalance."dP_clr",PResultsNotBalance."dP_clr",
 PResultsOnBalance."dQ_clr",PResultsNotBalance."dQ_clr",
 PResultsOnBalance."Qc",PResultsNotBalance."Qc",
 PResultsOnBalance."Pnagr"+PResultsOnBalance."Ptrans",
 PResultsNotBalance."Pnagr"+PResultsNotBalance."Ptrans",
 PResultsOnBalance."Qnagr"+PResultsOnBalance."Qtrans",
 PResultsNotBalance."Qnagr"+PResultsNotBalance."Qtrans",
 COALESCE(PResultsOnBalance."Pnagr_fact",0)+COALESCE(PResultsOnBalance."Ptrans_fact",0),
 COALESCE(PResultsNotBalance."Pnagr_fact",0)+COALESCE(PResultsNotBalance."Ptrans_fact",0),
 COALESCE(PResultsOnBalance."Qnagr_fact",0)+COALESCE(PResultsOnBalance."Qtrans_fact",0),
 COALESCE(PResultsNotBalance."Qnagr_fact",0)+COALESCE(PResultsNotBalance."Qtrans_fact",0),

 PResultsOnBalance."Kzagr",PResultsNotBalance."Kzagr","dUmax",

 PResultsOnBalance."Ssum_tr",PResultsNotBalance."Ssum_tr",
 PResultsOnBalance."Ntr",PResultsNotBalance."Ntr",
 PResultsOnBalance."LsumP",PResultsNotBalance."LsumP",
 PResultsOnBalance."LsumC",PResultsNotBalance."LsumC",
 PResultsOnBalance."NLineP",PResultsNotBalance."NLineP",
 PResultsOnBalance."NLineC",PResultsNotBalance."NLineC",

 "WeatherConditions","Temperature","Flags","CRC"

from "MVResults"

left outer join "WResultsAdd" WResultsOnBalance on
 ("MVResults"."Ident"=WResultsOnBalance."Ident") and (WResultsOnBalance."Balance"=0)
left outer join "WResultsAdd" WResultsNotBalance on
 ("MVResults"."Ident"=WResultsNotBalance."Ident") and (WResultsNotBalance."Balance"=1)
left outer join "PResultsAdd" PResultsOnBalance on
 ("MVResults"."Ident"=PResultsOnBalance."Ident") and (PResultsOnBalance."Balance"=0)
left outer join "PResultsAdd" PResultsNotBalance on
 ("MVResults"."Ident"=PResultsNotBalance."Ident") and (PResultsNotBalance."Balance"=1)

where "MVResults"."CalcType"=2;

CREATE VIEW "PResultsPL"("SampleIdent",GUID,
 P,Q,I,"deltaPcu","deltaPk","deltaPcrown","deltaQ","Qc_b","Qc_e","Kzag")
AS
SELECT F."SampleIdent",L."GUID",
 L."P",L."Q",L."I",L."deltaPcu",L."deltaPk",L."deltaPcrown",L."deltaQ",
 L."Qc_b",L."Qc_e",L."Kzag"
FROM "PResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=2;

CREATE VIEW "PResultsPN"("SampleIdent",GUID,
 "Pn","Qn",UB,UH,"deltaPcu","deltaQcu","deltaPxx","deltaQxx","deltaUB","Kzag")
AS
SELECT F."SampleIdent",N."GUID",
 N."Pn",N."Qn",N."UB",N."UH",N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
 N."deltaUB",N."Kzag"
FROM "PResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=2;

CREATE VIEW "PResultsPN3"("SampleIdent",GUID,
 "PCn","QCn","PHn","QHn",UB,UC,UH,"deltaPcu","deltaQcu","deltaPxx","deltaQxx",
 "deltaUB","Kzag")
AS
SELECT F."SampleIdent",N."GUID",
 N."PCn",N."QCn",N."PHn",N."QHn",N."UB",N."UC",N."UH",
 N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
 N."deltaUB",N."Kzag"
FROM "PResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=2;

CREATE VIEW "PResultsWN"("SampleIdent",GUID,
 "Wa","Wr","deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx")
AS
SELECT F."SampleIdent",N."GUID",
 N."Wa",N."Wr",N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx"
FROM "WResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=2;

CREATE VIEW "PResultsWN3"("SampleIdent",GUID,
 "WCa","WCr","WHa","WHr","deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx")
AS
SELECT F."SampleIdent",N."GUID",
 N."WCa",N."WCr",N."WHa",N."WHr",
 N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx"
FROM "WResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=2;

CREATE VIEW "WResults"("SampleIdent",GUID,
 "Wa","Wr",T,U,"Pgy","Qgy","Imax","Kzap","sqrKfg","sqrKfgCalc",
 "DWal_cu_onBalance","DWal_cu_notBalance","DWal_k_onBalance",
 "DWal_k_notBalance","DWal_crown_OnBalance","DWal_crown_notBalance",
 "DWrl_cu_onBalance","DWrl_cu_notBalance","DWcu_onBalance",
 "DWcu_notBalance","DWrcu_onBalance","DWrcu_notBalance",
 "DWxx_onBalance","DWxx_notBalance","DWrxx_onBalance",
 "DWrxx_notBalance","DWaclr_onBalance","DWaclr_notBalance",
 "DWrclr_onBalance","DWrclr_notBalance","Wrc_onBalance",
 "Wrc_notBalance","Wa_potr_onBalance","Wa_potr_notBalance",
 "Wr_potr_onBalance","Wr_potr_notBalance","Wa_potr_onBalance_fact",
 "Wa_potr_notBalance_fact","Wr_potr_onBalance_fact","Wr_potr_notBalance_fact",
 "dPnlin_OnBalance","dPnlin_notBalance","dPklin_OnBalance",
 "dPklin_notBalance","dPcrown_OnBalance","dPcrown_notBalance",
 "dQnlin_OnBalance","dQnlin_notBalance","dPntr_OnBalance",
 "dPntr_notBalance","dQntr_OnBalance","dQntr_notBalance",
 "dPxx_OnBalance","dPxx_notBalance","dQxx_OnBalance",
 "dQxx_notBalance","dPclr_OnBalance","dPclr_notBalance",
 "dQclr_OnBalance","dQclr_notBalance","Qc_onBalance",
 "Qc_notBalance","Ppotr_OnBalance","Ppotr_notBalance",
 "Qpotr_OnBalance","Qpotr_notBalance","Ppotr_OnBalance_fact",
 "Ppotr_notBalance_fact","Qpotr_OnBalance_fact","Qpotr_notBalance_fact",
 "Kzag_OnBalance","Kzag_notBalance","dU",
 "Ssum_tr_OnBalance","Ssum_tr_NotBalance","Ntr_OnBalance",
 "Ntr_NotBalance","LsumP_OnBalance","LsumP_NotBalance",
 "LsumC_OnBalance","LsumC_NotBalance","NLineP_OnBalance",
 "NLineP_NotBalance","NLineC_OnBalance","NLineC_NotBalance",
 "NAbonents_OnBalance","NAbonents_NotBalance","dWdop",
 "WeatherConditions","Temperature","Flags",CRC)
 AS
select "SampleIdent","GUID","Wa","Wr","T","U","Pgy","Qgy",
 "Imax","Kzap","sqrKfg","sqrKfgCalc",
 WResultsOnBalance."DWa_line_cu",WResultsNotBalance."DWa_line_cu",
 WResultsOnBalance."DWa_line_k",WResultsNotBalance."DWa_line_k",
 WResultsOnBalance."DWa_line_crown",WResultsNotBalance."DWa_line_crown",
 WResultsOnBalance."DWr_line_cu",WResultsNotBalance."DWr_line_cu",
 WResultsOnBalance."DWa_tr_cu",WResultsNotBalance."DWa_tr_cu",
 WResultsOnBalance."DWr_tr_cu",WResultsNotBalance."DWr_tr_cu",
 WResultsOnBalance."DWa_tr_xx",WResultsNotBalance."DWa_tr_xx",
 WResultsOnBalance."DWr_tr_xx",WResultsNotBalance."DWr_tr_xx",
 WResultsOnBalance."DWa_clr",WResultsNotBalance."DWa_clr",
 WResultsOnBalance."DWr_clr",WResultsNotBalance."DWr_clr",
 WResultsOnBalance."Wrc",WResultsNotBalance."Wrc",
 WResultsOnBalance."Wa_potr"+WResultsOnBalance."Wa_trans",
 WResultsNotBalance."Wa_potr"+WResultsNotBalance."Wa_trans",
 WResultsOnBalance."Wr_potr"+WResultsOnBalance."Wr_trans",
 WResultsNotBalance."Wr_potr"+WResultsNotBalance."Wr_trans",
 COALESCE(WResultsOnBalance."Wa_potr_fact",0)+COALESCE(WResultsOnBalance."Wa_trans_fact",0),
 COALESCE(WResultsNotBalance."Wa_potr_fact",0)+COALESCE(WResultsNotBalance."Wa_trans_fact",0),
 COALESCE(WResultsOnBalance."Wr_potr_fact",0)+COALESCE(WResultsOnBalance."Wr_trans_fact",0),
 COALESCE(WResultsNotBalance."Wr_potr_fact",0)+COALESCE(WResultsNotBalance."Wr_trans_fact",0),

 PResultsOnBalance."dP_line_cu",PResultsNotBalance."dP_line_cu",
 PResultsOnBalance."dP_line_k",PResultsNotBalance."dP_line_k",
 PResultsOnBalance."dP_line_crown",PResultsNotBalance."dP_line_crown",
 PResultsOnBalance."dQ_line_cu",PResultsNotBalance."dQ_line_cu",
 PResultsOnBalance."dP_tr_cu",PResultsNotBalance."dP_tr_cu",
 PResultsOnBalance."dQ_tr_cu",PResultsNotBalance."dQ_tr_cu",
 PResultsOnBalance."dP_tr_xx",PResultsNotBalance."dP_tr_xx",
 PResultsOnBalance."dQ_tr_xx",PResultsNotBalance."dQ_tr_xx",
 PResultsOnBalance."dP_clr",PResultsNotBalance."dP_clr",
 PResultsOnBalance."dQ_clr",PResultsNotBalance."dQ_clr",
 PResultsOnBalance."Qc",PResultsNotBalance."Qc",
 PResultsOnBalance."Pnagr"+PResultsOnBalance."Ptrans",
 PResultsNotBalance."Pnagr"+PResultsNotBalance."Ptrans",
 PResultsOnBalance."Qnagr"+PResultsOnBalance."Qtrans",
 PResultsNotBalance."Qnagr"+PResultsNotBalance."Qtrans",
 COALESCE(PResultsOnBalance."Pnagr_fact",0)+COALESCE(PResultsOnBalance."Ptrans_fact",0),
 COALESCE(PResultsNotBalance."Pnagr_fact",0)+COALESCE(PResultsNotBalance."Ptrans_fact",0),
 COALESCE(PResultsOnBalance."Qnagr_fact",0)+COALESCE(PResultsOnBalance."Qtrans_fact",0),
 COALESCE(PResultsNotBalance."Qnagr_fact",0)+COALESCE(PResultsNotBalance."Qtrans_fact",0),

 PResultsOnBalance."Kzagr",PResultsNotBalance."Kzagr","dUmax",

 PResultsOnBalance."Ssum_tr",PResultsNotBalance."Ssum_tr",
 PResultsOnBalance."Ntr",PResultsNotBalance."Ntr",
 PResultsOnBalance."LsumP",PResultsNotBalance."LsumP",
 PResultsOnBalance."LsumC",PResultsNotBalance."LsumC",
 PResultsOnBalance."NLineP",PResultsNotBalance."NLineP",
 PResultsOnBalance."NLineC",PResultsNotBalance."NLineC",

 PResultsOnBalance."NAbonents",PResultsNotBalance."NAbonents","dWdop",

 "WeatherConditions","Temperature","Flags","CRC"

from "MVResults"

left outer join "WResultsAdd" WResultsOnBalance on
 ("MVResults"."Ident"=WResultsOnBalance."Ident") and (WResultsOnBalance."Balance"=0)
left outer join "WResultsAdd" WResultsNotBalance on
 ("MVResults"."Ident"=WResultsNotBalance."Ident") and (WResultsNotBalance."Balance"=1)
left outer join "PResultsAdd" PResultsOnBalance on
 ("MVResults"."Ident"=PResultsOnBalance."Ident") and (PResultsOnBalance."Balance"=0)
left outer join "PResultsAdd" PResultsNotBalance on
 ("MVResults"."Ident"=PResultsNotBalance."Ident") and (PResultsNotBalance."Balance"=1)

where "MVResults"."CalcType"=0;

CREATE VIEW "WResultsA"("SampleIdent",GUID,
 "Wa","Wr",T,U,"Pgy","Qgy","Imax","Kzap","sqrKfg","sqrKfgCalc",
 "DWal_cu_onBalance","DWal_cu_notBalance","DWal_k_onBalance",
 "DWal_k_notBalance","DWal_crown_OnBalance","DWal_crown_notBalance",
 "DWrl_cu_onBalance","DWrl_cu_notBalance","DWcu_onBalance",
 "DWcu_notBalance","DWrcu_onBalance","DWrcu_notBalance",
 "DWxx_onBalance","DWxx_notBalance","DWrxx_onBalance",
 "DWrxx_notBalance","DWaclr_onBalance","DWaclr_notBalance",
 "DWrclr_onBalance","DWrclr_notBalance","Wrc_onBalance",
 "Wrc_notBalance","Wa_potr_onBalance","Wa_potr_notBalance",
 "Wr_potr_onBalance","Wr_potr_notBalance","Wa_potr_onBalance_fact",
 "Wa_potr_notBalance_fact","Wr_potr_onBalance_fact","Wr_potr_notBalance_fact",
 "dPnlin_OnBalance","dPnlin_notBalance","dPklin_OnBalance",
 "dPklin_notBalance","dPcrown_OnBalance","dPcrown_notBalance",
 "dQnlin_OnBalance","dQnlin_notBalance","dPntr_OnBalance",
 "dPntr_notBalance","dQntr_OnBalance","dQntr_notBalance",
 "dPxx_OnBalance","dPxx_notBalance","dQxx_OnBalance",
 "dQxx_notBalance","dPclr_OnBalance","dPclr_notBalance",
 "dQclr_OnBalance","dQclr_notBalance","Qc_onBalance",
 "Qc_notBalance","Ppotr_OnBalance","Ppotr_notBalance",
 "Qpotr_OnBalance","Qpotr_notBalance","Ppotr_OnBalance_fact",
 "Ppotr_notBalance_fact","Qpotr_OnBalance_fact","Qpotr_notBalance_fact",
 "Kzag_OnBalance","Kzag_notBalance","dU",
 "Ssum_tr_OnBalance","Ssum_tr_NotBalance","Ntr_OnBalance",
 "Ntr_NotBalance","LsumP_OnBalance","LsumP_NotBalance",
 "LsumC_OnBalance","LsumC_NotBalance","NLineP_OnBalance",
 "NLineP_NotBalance","NLineC_OnBalance","NLineC_NotBalance",
 "NAbonents_OnBalance","NAbonents_NotBalance","dWdop",
 "WeatherConditions","Temperature","Flags",CRC)
 AS
select "SampleIdent","GUID","Wa","Wr","T","U","Pgy","Qgy",
 "Imax","Kzap","sqrKfg","sqrKfgCalc",
 WResultsOnBalance."DWa_line_cu",WResultsNotBalance."DWa_line_cu",
 WResultsOnBalance."DWa_line_k",WResultsNotBalance."DWa_line_k",
 WResultsOnBalance."DWa_line_crown",WResultsNotBalance."DWa_line_crown",
 WResultsOnBalance."DWr_line_cu",WResultsNotBalance."DWr_line_cu",
 WResultsOnBalance."DWa_tr_cu",WResultsNotBalance."DWa_tr_cu",
 WResultsOnBalance."DWr_tr_cu",WResultsNotBalance."DWr_tr_cu",
 WResultsOnBalance."DWa_tr_xx",WResultsNotBalance."DWa_tr_xx",
 WResultsOnBalance."DWr_tr_xx",WResultsNotBalance."DWr_tr_xx",
 WResultsOnBalance."DWa_clr",WResultsNotBalance."DWa_clr",
 WResultsOnBalance."DWr_clr",WResultsNotBalance."DWr_clr",
 WResultsOnBalance."Wrc",WResultsNotBalance."Wrc",
 WResultsOnBalance."Wa_potr"+WResultsOnBalance."Wa_trans",
 WResultsNotBalance."Wa_potr"+WResultsNotBalance."Wa_trans",
 WResultsOnBalance."Wr_potr"+WResultsOnBalance."Wr_trans",
 WResultsNotBalance."Wr_potr"+WResultsNotBalance."Wr_trans",
 COALESCE(WResultsOnBalance."Wa_potr_fact",0)+COALESCE(WResultsOnBalance."Wa_trans_fact",0),
 COALESCE(WResultsNotBalance."Wa_potr_fact",0)+COALESCE(WResultsNotBalance."Wa_trans_fact",0),
 COALESCE(WResultsOnBalance."Wr_potr_fact",0)+COALESCE(WResultsOnBalance."Wr_trans_fact",0),
 COALESCE(WResultsNotBalance."Wr_potr_fact",0)+COALESCE(WResultsNotBalance."Wr_trans_fact",0),

 PResultsOnBalance."dP_line_cu",PResultsNotBalance."dP_line_cu",
 PResultsOnBalance."dP_line_k",PResultsNotBalance."dP_line_k",
 PResultsOnBalance."dP_line_crown",PResultsNotBalance."dP_line_crown",
 PResultsOnBalance."dQ_line_cu",PResultsNotBalance."dQ_line_cu",
 PResultsOnBalance."dP_tr_cu",PResultsNotBalance."dP_tr_cu",
 PResultsOnBalance."dQ_tr_cu",PResultsNotBalance."dQ_tr_cu",
 PResultsOnBalance."dP_tr_xx",PResultsNotBalance."dP_tr_xx",
 PResultsOnBalance."dQ_tr_xx",PResultsNotBalance."dQ_tr_xx",
 PResultsOnBalance."dP_clr",PResultsNotBalance."dP_clr",
 PResultsOnBalance."dQ_clr",PResultsNotBalance."dQ_clr",
 PResultsOnBalance."Qc",PResultsNotBalance."Qc",
 PResultsOnBalance."Pnagr"+PResultsOnBalance."Ptrans",
 PResultsNotBalance."Pnagr"+PResultsNotBalance."Ptrans",
 PResultsOnBalance."Qnagr"+PResultsOnBalance."Qtrans",
 PResultsNotBalance."Qnagr"+PResultsNotBalance."Qtrans",
 COALESCE(PResultsOnBalance."Pnagr_fact",0)+COALESCE(PResultsOnBalance."Ptrans_fact",0),
 COALESCE(PResultsNotBalance."Pnagr_fact",0)+COALESCE(PResultsNotBalance."Ptrans_fact",0),
 COALESCE(PResultsOnBalance."Qnagr_fact",0)+COALESCE(PResultsOnBalance."Qtrans_fact",0),
 COALESCE(PResultsNotBalance."Qnagr_fact",0)+COALESCE(PResultsNotBalance."Qtrans_fact",0),

 PResultsOnBalance."Kzagr",PResultsNotBalance."Kzagr","dUmax",

 PResultsOnBalance."Ssum_tr",PResultsNotBalance."Ssum_tr",
 PResultsOnBalance."Ntr",PResultsNotBalance."Ntr",
 PResultsOnBalance."LsumP",PResultsNotBalance."LsumP",
 PResultsOnBalance."LsumC",PResultsNotBalance."LsumC",
 PResultsOnBalance."NLineP",PResultsNotBalance."NLineP",
 PResultsOnBalance."NLineC",PResultsNotBalance."NLineC",

 PResultsOnBalance."NAbonents",PResultsNotBalance."NAbonents","dWdop",

 "WeatherConditions","Temperature","Flags","CRC"

from "MVResults"

left outer join "WResultsAdd" WResultsOnBalance on
 ("MVResults"."Ident"=WResultsOnBalance."Ident") and (WResultsOnBalance."Balance"=0)
left outer join "WResultsAdd" WResultsNotBalance on
 ("MVResults"."Ident"=WResultsNotBalance."Ident") and (WResultsNotBalance."Balance"=1)
left outer join "PResultsAdd" PResultsOnBalance on
 ("MVResults"."Ident"=PResultsOnBalance."Ident") and (PResultsOnBalance."Balance"=0)
left outer join "PResultsAdd" PResultsNotBalance on
 ("MVResults"."Ident"=PResultsNotBalance."Ident") and (PResultsNotBalance."Balance"=1)

where "MVResults"."CalcType"=1;

/*--    */
ALTER TRIGGER "NodesBeforeUpdateTrigger"
AS
DECLARE VARIABLE ReferenceType Smallint;
DECLARE VARIABLE MaxPositionOtp Smallint;
DECLARE VARIABLE MaxPositionOtpC Smallint;
BEGIN
 MaxPositionOtp=0;
 IF (NEW."Transf"<>OLD."Transf") THEN
  BEGIN
   IF (OLD."Transf"=-1) THEN
    DELETE FROM "Generators" WHERE "GUID"=OLD."GUID";
   IF (NEW."Transf"<=0) THEN NEW."PositionOtp"=0;
   ELSE
    BEGIN
     SELECT "ReferenceType" FROM "References" WHERE "Ident"=OLD."Transf"
     INTO :ReferenceType;
     IF (ReferenceType IN (6,7)) THEN
      BEGIN
       IF (ReferenceType=6) THEN
        SELECT "NumberOtpB","NumberOtpC" FROM "Transforms3" WHERE "Ident"=NEW."Transf"
        INTO :MaxPositionOtp,:MaxPositionOtpC;  ELSE
       IF (ReferenceType=7) THEN
        SELECT "NumberOtpB","NumberOtpC" FROM "TransformsA" WHERE "Ident"=NEW."Transf"
        INTO :MaxPositionOtp,:MaxPositionOtpC;

       IF ("Mask"(NEW."PositionOtp",127)>MaxPositionOtp)
        THEN NEW."PositionOtp"="Mask"(NEW."PositionOtp",65408)+MaxPositionOtp;
       IF ("Mask"("ShiftR"(NEW."PositionOtp",8),127)>MaxPositionOtpC)
        THEN NEW."PositionOtp"="Mask"(NEW."PositionOtp",-32513)+"ShiftL"(MaxPositionOtp,8);
      END
     ELSE
      BEGIN
       IF (ReferenceType=4) THEN
        SELECT "NumberOtp" FROM "Transforms2" WHERE "Ident"=NEW."Transf" INTO :MaxPositionOtp;
       ELSE
        SELECT "NumberOtp" FROM "TransformsSS" WHERE "Ident"=NEW."Transf" INTO :MaxPositionOtp;
       IF (NEW."PositionOtp">MaxPositionOtp) THEN NEW."PositionOtp"=MaxPositionOtp; ELSE
       IF (NEW."PositionOtp"<-MaxPositionOtp) THEN NEW."PositionOtp"=-MaxPositionOtp;
     END
   END
 END
END;

/*--   */
CREATE TRIGGER "NodeResultsUpdateTrigger" FOR "Nodes"
ACTIVE BEFORE UPDATE POSITION 0
AS
DECLARE VARIABLE ReferenceType Smallint;
BEGIN
 IF (NEW."Transf"<>OLD."Transf") THEN BEGIN
  SELECT "ReferenceType" FROM "References" WHERE "Ident"=OLD."Transf"
  INTO :ReferenceType;
  IF (EXISTS(SELECT "ReferenceType" FROM "References"
             WHERE "Ident"=NEW."Transf" AND "ReferenceType"<>:ReferenceType))
  THEN
   IF (ReferenceType IN (5,6,7)) THEN
    BEGIN
     DELETE FROM "PResultsN3" WHERE "GUID"=OLD."GUID";
     DELETE FROM "WResultsN3" WHERE "GUID"=OLD."GUID";
    END
   ELSE BEGIN
    DELETE FROM "PResultsN" WHERE "GUID"=OLD."GUID";
    DELETE FROM "WResultsN" WHERE "GUID"=OLD."GUID";
   END
 END
END;

CREATE TRIGGER "WorkLogMVResultsDeleteTrigger" FOR "MVResults"
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(50);
DECLARE VARIABLE AEvent Smallint;
BEGIN
 IF (OLD."GUID"<>0 and
     exists (select * from "Fiders" where "GUID"=OLD."GUID")) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=OLD."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=OLD."SampleIdent"
   INTO ASampleDate;

   IF (OLD."CalcType"=0) THEN AEvent=11; ELSE
   IF (OLD."CalcType"=1) THEN AEvent=15;
   ELSE AEvent=7;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,:AEvent,:ASampleDate);
 END
END;

CREATE TRIGGER "WorkLogMVResultsInsertTrigger" FOR "MVResults"
ACTIVE AFTER INSERT POSITION 0
AS
DECLARE VARIABLE AFiderName VARCHAR(130);
DECLARE VARIABLE ASampleDate VARCHAR(50);
DECLARE VARIABLE AEvent Smallint;
BEGIN
 IF (NEW."GUID"<>0) THEN
  BEGIN
   SELECT ': '||"Centers"."Name"||' : '||"Fiders"."Name" FROM "Fiders"
   INNER JOIN "Sections" ON ("Sections"."GUID"="Fiders"."OwnerGUID")
   INNER JOIN "Centers" ON ("Centers"."GUID"="Sections"."OwnerGUID")
   WHERE "Fiders"."GUID"=NEW."GUID"
   INTO AFiderName;

   SELECT "Name" FROM "SamplesDates"
   WHERE "Ident"=NEW."SampleIdent"
   INTO ASampleDate;

   IF (New."CalcType"=0) THEN AEvent=10; ELSE
   IF (New."CalcType"=1) THEN AEvent=14;
   ELSE AEvent=6;

   INSERT INTO "WorkLog" ("FiderName","EventIdent","SampleDate")
   VALUES (:AFiderName,:AEvent,:ASampleDate);
 END
END;

CREATE VIEW "WResultsPL" ("SampleIdent","GUID",
"P","Q","I","deltaPcu","deltaPk","deltaPcrown","deltaQ","Qc_b","Qc_e","Kzag")
AS
SELECT F."SampleIdent",L."GUID",
L."P",L."Q",L."I",L."deltaPcu",L."deltaPk",L."deltaPcrown",L."deltaQ",
L."Qc_b",L."Qc_e",L."Kzag"
FROM "PResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",L."GUID",
L."P",L."Q",L."I",L."deltaPcu",L."deltaPk",L."deltaPcrown",L."deltaQ",
L."Qc_b",L."Qc_e",L."Kzag"
FROM "PResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "PResultsL" L
   INNER JOIN "MVResults" F on F."Ident"=L."Ident"
   WHERE F."CalcType"=0);


CREATE VIEW "WResultsPN" ("SampleIdent","GUID",
"Pn","Qn","UB","UH","deltaPcu","deltaQcu","deltaPxx","deltaQxx",
"deltaUB","Kzag")
AS
SELECT F."SampleIdent",N."GUID",
N."Pn",N."Qn",N."UB",N."UH",N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
N."deltaUB",N."Kzag"
FROM "PResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",N."GUID",
N."Pn",N."Qn",N."UB",N."UH",N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
N."deltaUB",N."Kzag"
FROM "PResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "PResultsN" N
   INNER JOIN "MVResults" F on F."Ident"=N."Ident"
   WHERE F."CalcType"=0);


CREATE VIEW "WResultsPN3" ("SampleIdent","GUID",
   "PCn","QCn","PHn","QHn","UB","UC","UH",
   "deltaPcu","deltaQcu","deltaPxx","deltaQxx",
   "deltaUB","Kzag")
AS
SELECT F."SampleIdent",N."GUID",
N."PCn",N."QCn",N."PHn",N."QHn",N."UB",N."UC",N."UH",
N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
N."deltaUB",N."Kzag"
FROM "PResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",N."GUID",
N."PCn",N."QCn",N."PHn",N."QHn",N."UB",N."UC",N."UH",
N."deltaPcu",N."deltaQcu",N."deltaPxx",N."deltaQxx",
N."deltaUB",N."Kzag"
FROM "PResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "PResultsN3" N
   INNER JOIN "MVResults" F on F."Ident"=N."Ident"
   WHERE F."CalcType"=0);


CREATE VIEW "WResultsWL" ("SampleIdent","GUID",
"Wa","Wr","deltaWa_cu","deltaWa_k","deltaWa_crown","deltaWr",
"Wrc_b","Wrc_e","sqrKfg")
AS
SELECT F."SampleIdent",L."GUID",
L."Wa",L."Wr",L."deltaWa_cu",L."deltaWa_k",L."deltaWa_crown",L."deltaWr",
L."Wrc_b",L."Wrc_e",L."sqrKfg"
FROM "WResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",L."GUID",
L."Wa",L."Wr",L."deltaWa_cu",L."deltaWa_k",L."deltaWa_crown",L."deltaWr",
L."Wrc_b",L."Wrc_e",L."sqrKfg"
FROM "WResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "WResultsL" L
   INNER JOIN "MVResults" F on F."Ident"=L."Ident"
   WHERE F."CalcType"=0);


CREATE VIEW "WResultsWN" ("SampleIdent","GUID",
  "Wa","Wr","deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx","sqrKfg")
AS
SELECT F."SampleIdent",N."GUID",
N."Wa",N."Wr",N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx",
N."sqrKfg"
FROM "WResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",N."GUID",
N."Wa",N."Wr",N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx",
N."sqrKfg"
FROM "WResultsN" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "WResultsN" N
   INNER JOIN "MVResults" F on F."Ident"=N."Ident"
   WHERE F."CalcType"=0);


CREATE VIEW "WResultsWN3" ("SampleIdent","GUID",
  "WCa","WCr","WHa","WHr","deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx",
  "sqrKfgC","sqrKfgH")
AS
SELECT F."SampleIdent",N."GUID",
N."WCa",N."WCr",N."WHa",N."WHr",
N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx",N."sqrKfgC",N."sqrKfgH"
FROM "WResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=0
UNION
SELECT F."SampleIdent",N."GUID",
N."WCa",N."WCr",N."WHa",N."WHr",
N."deltaW_cu",N."deltaWr_cu",N."deltaW_xx",N."deltaWr_xx",N."sqrKfgC",N."sqrKfgH"
FROM "WResultsN3" N
INNER JOIN "MVResults" F on F."Ident"=N."Ident"
WHERE F."CalcType"=1
AND NOT EXISTS
  (SELECT * FROM "WResultsN3" N
   INNER JOIN "MVResults" F on F."Ident"=N."Ident"
   WHERE F."CalcType"=0);


COMMIT;
RECONNECT;

CREATE TRIGGER "PResultsBeforeDelete" FOR "PResults"
ACTIVE BEFORE DELETE POSITION 0
AS
BEGIN
 DELETE FROM "MVResults"
 WHERE ("CalcType"=2) AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=OLD."GUID";
END;

CREATE TRIGGER "PResultsBeforeUpdateOrInsert" FOR "PResults"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 EXECUTE PROCEDURE "InsertMVResults" (2,NEW."SampleIdent",NEW.GUID,
  NEW."Wa",NEW."Wr",NEW."T",NEW."U",NEW."Pgy",NEW."Qgy",
  null,null,null,null,NEW."dU",null,
  NEW."WeatherConditions",NEW."Temperature",NEW."Flags",NEW."CRC")
 RETURNING_VALUES :Ident;

 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,0,
  NEW."dPnlin_OnBalance",NEW."dPklin_OnBalance",NEW."dPcrown_OnBalance",NEW."dQnlin_OnBalance",
  NEW."dPntr_OnBalance",NEW."dQntr_OnBalance",NEW."dPxx_OnBalance",NEW."dQxx_OnBalance",
  NEW."dPclr_OnBalance",NEW."dQclr_OnBalance",NEW."Qc_onBalance",
  NEW."Ppotr_OnBalance",NEW."Qpotr_OnBalance",0,0,
  NEW."Ppotr_OnBalance_fact",NEW."Qpotr_OnBalance_fact",0,0,
  NEW."Kzag_OnBalance",NEW."Ssum_tr_OnBalance",NEW."Ntr_OnBalance",0,0,0,0,
  NEW."LsumP_OnBalance",NEW."LsumC_OnBalance",NEW."NLineP_OnBalance",NEW."NLineC_OnBalance",
  null);
 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,1,
  NEW."dPnlin_notBalance",NEW."dPklin_notBalance",NEW."dPcrown_notBalance",NEW."dQnlin_notBalance",
  NEW."dPntr_notBalance",NEW."dQntr_notBalance",NEW."dPxx_notBalance",NEW."dQxx_notBalance",
  NEW."dPclr_notBalance",NEW."dQclr_notBalance",NEW."Qc_notBalance",
  NEW."Ppotr_notBalance",NEW."Qpotr_notBalance",0,0,
  NEW."Ppotr_notBalance_fact",NEW."Qpotr_notBalance_fact",0,0,
  NEW."Kzag_notBalance",NEW."Ssum_tr_NotBalance",NEW."Ntr_NotBalance",0,0,0,0,
  NEW."LsumP_NotBalance",NEW."LsumC_NotBalance",NEW."NLineP_NotBalance",NEW."NLineC_NotBalance",
  null);
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,0,
  NEW."DWal_cu_onBalance",NEW."DWal_k_onBalance",NEW."DWal_crown_OnBalance",NEW."DWrl_cu_onBalance",
  NEW."DWcu_onBalance",NEW."DWrcu_onBalance",NEW."DWxx_onBalance",NEW."DWrxx_onBalance",
  NEW."DWaclr_onBalance",NEW."DWrclr_onBalance",NEW."Wrc_onBalance",
  NEW."Wa_potr_onBalance",NEW."Wr_potr_onBalance",0,0,
  NEW."Wa_potr_onBalance_fact",NEW."Wr_potr_onBalance_fact",0,0);
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,1,
   NEW."DWal_cu_notBalance",NEW."DWal_k_notBalance",
   NEW."DWal_crown_notBalance",NEW."DWrl_cu_notBalance",
   NEW."DWcu_notBalance",NEW."DWrcu_notBalance",
   NEW."DWxx_notBalance",NEW."DWrxx_notBalance",
   NEW."DWaclr_notBalance",NEW."DWrclr_notBalance",NEW."Wrc_notBalance",
   NEW."Wa_potr_notBalance",NEW."Wr_potr_notBalance",0,0,
   NEW."Wa_potr_notBalance_fact",NEW."Wr_potr_notBalance_fact",0,0);
END;

CREATE TRIGGER "PResultsPLBeforeDelete" FOR "PResultsPL"
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Lines"
 WHERE "GUID"=OLD.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "PResultsL" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END;

COMMIT;
RECONNECT;

CREATE TRIGGER "PResultsPLBeforeUpdateOrInsert" FOR "PResultsPL"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Lines"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "PResultsL" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "PResultsL"
  ("Ident","GUID","P","Q","I","deltaPcu","deltaPk",
   "deltaPcrown","deltaQ","Qc_b","Qc_e","Kzag")
 VALUES (:Ident,NEW."GUID",NEW."P",NEW."Q",NEW."I",NEW."deltaPcu",NEW."deltaPk",
  NEW."deltaPcrown",NEW."deltaQ",NEW."Qc_b",NEW."Qc_e",NEW."Kzag");
END;

CREATE TRIGGER "PResultsPNBeforeDelete" FOR "PResultsPN"
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=OLD.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "PResultsN" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END;

CREATE TRIGGER "PResultsPNBeforeUpdateOrInsert" FOR "PResultsPN"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "PResultsN" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "PResultsN"
  ("Ident","GUID","Pn","Qn","UB","UH",
   "deltaPcu","deltaQcu","deltaPxx","deltaQxx",
   "deltaUB","Kzag")
 VALUES (:Ident,NEW."GUID",NEW."Pn",NEW."Qn",NEW."UB",NEW."UH",
   NEW."deltaPcu",NEW."deltaQcu",NEW."deltaPxx",NEW."deltaQxx",
   NEW."deltaUB",NEW."Kzag");
END;

CREATE TRIGGER "PResultsPN3BeforeDelete" FOR "PResultsPN3"
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=OLD.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "PResultsN3" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END;

CREATE TRIGGER "PResultsPN3BeforeUpdateOrInsert" FOR "PResultsPN3"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "PResultsN3" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "PResultsN3"
  ("Ident","GUID","PCn","QCn","PHn","QHn",
   "UB","UC","UH",
   "deltaPcu","deltaQcu","deltaPxx","deltaQxx",
   "deltaUB","Kzag")
 VALUES (:Ident,NEW."GUID",NEW."PCn",NEW."QCn",NEW."PHn",NEW."QHn",
   NEW."UB",NEW."UC",NEW."UH",
   NEW."deltaPcu",NEW."deltaQcu",NEW."deltaPxx",NEW."deltaQxx",
   NEW."deltaUB",NEW."Kzag");
END;

CREATE VIEW "PResultsWL"(
    "SampleIdent",
    GUID,
    "Wa","Wr","deltaWa_cu","deltaWa_k","deltaWa_crown","deltaWr","Wrc_b","Wrc_e")
AS
SELECT F."SampleIdent",L."GUID",
 L."Wa",L."Wr",L."deltaWa_cu",L."deltaWa_k",L."deltaWa_crown",L."deltaWr",
 L."Wrc_b",L."Wrc_e"
FROM "WResultsL" L
INNER JOIN "MVResults" F on F."Ident"=L."Ident"
WHERE F."CalcType"=2 ;

CREATE TRIGGER "PResultsWLBeforeDelete" FOR "PResultsWL"
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Lines"
 WHERE "GUID"=OLD.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "WResultsL" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END;

CREATE TRIGGER "PResultsWLBeforeUpdateOrInsert" FOR "PResultsWL"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Lines"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "WResultsL" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "WResultsL"
  ("Ident","GUID","Wa","Wr",
   "deltaWa_cu","deltaWa_k","deltaWa_crown","deltaWr",
   "Wrc_b","Wrc_e","sqrKfg")
 VALUES (:Ident,NEW."GUID",NEW."Wa",NEW."Wr",
  NEW."deltaWa_cu",NEW."deltaWa_k",NEW."deltaWa_crown",NEW."deltaWr",
  NEW."Wrc_b",NEW."Wrc_e",null);
END;

CREATE TRIGGER "PResultsWNBeforeDelete" FOR "PResultsWN"
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=OLD.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "WResultsN" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END;

CREATE TRIGGER "PResultsWNBeforeUpdateOrInsert" FOR "PResultsWN"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "WResultsN" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "WResultsN"
  ("Ident","GUID","Wa","Wr",
   "deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx",
    "sqrKfg")
 VALUES (:Ident,NEW."GUID",NEW."Wa",NEW."Wr",
  NEW."deltaW_cu",NEW."deltaWr_cu",NEW."deltaW_xx",NEW."deltaWr_xx",
  null);
END;

CREATE TRIGGER "PResultsWN3BeforeDelete" FOR "PResultsWN3"
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=OLD.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "WResultsN3" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END;

CREATE TRIGGER "PResultsWN3BeforeUpdateOrInsert" FOR "PResultsWN3"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 SELECT "OwnerGUID" FROM "Nodes"
 WHERE "GUID"=NEW.GUID
 INTO :OwnerGUID;

 SELECT "Ident" from "MVResults"
 WHERE "CalcType"=2 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
 INTO :Ident;

 DELETE FROM "WResultsN3" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

 INSERT INTO "WResultsN3"
  ("Ident","GUID","WCa","WCr","WHa","WHr",
   "deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx",
   "sqrKfgC","sqrKfgH")
 VALUES (:Ident,NEW."GUID",NEW."WCa",NEW."WCr",NEW."WHa",NEW."WHr",
  NEW."deltaW_cu",NEW."deltaWr_cu",NEW."deltaW_xx",NEW."deltaWr_xx",
  null,null);
END;

CREATE TRIGGER "WResultsBeforeDelete" FOR "WResults"
ACTIVE BEFORE DELETE POSITION 0
AS
BEGIN
 DELETE FROM "MVResults"
 WHERE ("CalcType"=0) AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=OLD."GUID";
END;

CREATE TRIGGER "WResultsBeforeUpdateOrInsert" FOR "WResults"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 EXECUTE PROCEDURE "InsertMVResults" (0,NEW."SampleIdent",NEW.GUID,
  NEW."Wa",NEW."Wr",NEW."T",NEW."U",NEW."Pgy",NEW."Qgy",
  NEW."Imax",NEW."Kzap",NEW."sqrKfg",NEW."sqrKfgCalc",NEW."dU",NEW."dWdop",
  NEW."WeatherConditions",NEW."Temperature",NEW."Flags",NEW."CRC")
 RETURNING_VALUES :Ident;

 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,0,
  NEW."dPnlin_OnBalance",NEW."dPklin_OnBalance",NEW."dPcrown_OnBalance",NEW."dQnlin_OnBalance",
  NEW."dPntr_OnBalance",NEW."dQntr_OnBalance",NEW."dPxx_OnBalance",NEW."dQxx_OnBalance",
  NEW."dPclr_OnBalance",NEW."dQclr_OnBalance",NEW."Qc_onBalance",
  NEW."Ppotr_OnBalance",NEW."Qpotr_OnBalance",0,0,
  NEW."Ppotr_OnBalance_fact",NEW."Qpotr_OnBalance_fact",0,0,
  NEW."Kzag_OnBalance",NEW."Ssum_tr_OnBalance",NEW."Ntr_OnBalance",0,0,0,0,
  NEW."LsumP_OnBalance",NEW."LsumC_OnBalance",NEW."NLineP_OnBalance",NEW."NLineC_OnBalance",
  NEW."NAbonents_OnBalance");
 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,1,
  NEW."dPnlin_notBalance",NEW."dPklin_notBalance",NEW."dPcrown_notBalance",NEW."dQnlin_notBalance",
  NEW."dPntr_notBalance",NEW."dQntr_notBalance",NEW."dPxx_notBalance",NEW."dQxx_notBalance",
  NEW."dPclr_notBalance",NEW."dQclr_notBalance",NEW."Qc_notBalance",
  NEW."Ppotr_notBalance",NEW."Qpotr_notBalance",0,0,
  NEW."Ppotr_notBalance_fact",NEW."Qpotr_notBalance_fact",0,0,
  NEW."Kzag_notBalance",NEW."Ssum_tr_NotBalance",NEW."Ntr_NotBalance",0,0,0,0,
  NEW."LsumP_NotBalance",NEW."LsumC_NotBalance",NEW."NLineP_NotBalance",NEW."NLineC_NotBalance",
  NEW."NAbonents_NotBalance");
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,0,
  NEW."DWal_cu_onBalance",NEW."DWal_k_onBalance",NEW."DWal_crown_OnBalance",NEW."DWrl_cu_onBalance",
  NEW."DWcu_onBalance",NEW."DWrcu_onBalance",NEW."DWxx_onBalance",NEW."DWrxx_onBalance",
  NEW."DWaclr_onBalance",NEW."DWrclr_onBalance",NEW."Wrc_onBalance",
  NEW."Wa_potr_onBalance",NEW."Wr_potr_onBalance",0,0,
  NEW."Wa_potr_onBalance_fact",NEW."Wr_potr_onBalance_fact",0,0);
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,1,
   NEW."DWal_cu_notBalance",NEW."DWal_k_notBalance",
   NEW."DWal_crown_notBalance",NEW."DWrl_cu_notBalance",
   NEW."DWcu_notBalance",NEW."DWrcu_notBalance",
   NEW."DWxx_notBalance",NEW."DWrxx_notBalance",
   NEW."DWaclr_notBalance",NEW."DWrclr_notBalance",NEW."Wrc_notBalance",
   NEW."Wa_potr_notBalance",NEW."Wr_potr_notBalance",0,0,
   NEW."Wa_potr_notBalance_fact",NEW."Wr_potr_notBalance_fact",0,0);
END;

CREATE TRIGGER "WResultsABeforeDelete" FOR "WResultsA"
ACTIVE BEFORE DELETE POSITION 0
AS
BEGIN
 DELETE FROM "MVResults"
 WHERE ("CalcType"=1) AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=OLD."GUID";
END;

CREATE TRIGGER "WResultsABeforeUpdateOrInsert" FOR "WResultsA"
ACTIVE BEFORE UPDATE OR INSERT POSITION 0
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
 EXECUTE PROCEDURE "InsertMVResults" (1,NEW."SampleIdent",NEW.GUID,
  NEW."Wa",NEW."Wr",NEW."T",NEW."U",NEW."Pgy",NEW."Qgy",
  NEW."Imax",NEW."Kzap",NEW."sqrKfg",NEW."sqrKfgCalc",NEW."dU",NEW."dWdop",
  NEW."WeatherConditions",NEW."Temperature",NEW."Flags",NEW."CRC")
 RETURNING_VALUES :Ident;

 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,0,
  NEW."dPnlin_OnBalance",NEW."dPklin_OnBalance",NEW."dPcrown_OnBalance",NEW."dQnlin_OnBalance",
  NEW."dPntr_OnBalance",NEW."dQntr_OnBalance",NEW."dPxx_OnBalance",NEW."dQxx_OnBalance",
  NEW."dPclr_OnBalance",NEW."dQclr_OnBalance",NEW."Qc_onBalance",
  NEW."Ppotr_OnBalance",NEW."Qpotr_OnBalance",0,0,
  NEW."Ppotr_OnBalance_fact",NEW."Qpotr_OnBalance_fact",0,0,
  NEW."Kzag_OnBalance",NEW."Ssum_tr_OnBalance",NEW."Ntr_OnBalance",0,0,0,0,
  NEW."LsumP_OnBalance",NEW."LsumC_OnBalance",NEW."NLineP_OnBalance",NEW."NLineC_OnBalance",
  NEW."NAbonents_OnBalance");
 INSERT INTO "PResultsAdd" ("Ident","Balance",
  "dP_line_cu","dP_line_k","dP_line_crown","dQ_line_cu",
  "dP_tr_cu","dQ_tr_cu","dP_tr_xx","dQ_tr_xx",
  "dP_clr","dQ_clr","Qc",
  "Ptrans","Qtrans","Pnagr","Qnagr",
  "Ptrans_fact","Qtrans_fact","Pnagr_fact","Qnagr_fact",
  "Kzagr","Ssum_tr","Ntr","Psum_motor","Nmotor","Ssum_clr","Nclr",
  "LsumP","LsumC","NLineP","NLineC","NAbonents")
 VALUES (:Ident,1,
  NEW."dPnlin_notBalance",NEW."dPklin_notBalance",NEW."dPcrown_notBalance",NEW."dQnlin_notBalance",
  NEW."dPntr_notBalance",NEW."dQntr_notBalance",NEW."dPxx_notBalance",NEW."dQxx_notBalance",
  NEW."dPclr_notBalance",NEW."dQclr_notBalance",NEW."Qc_notBalance",
  NEW."Ppotr_notBalance",NEW."Qpotr_notBalance",0,0,
  NEW."Ppotr_notBalance_fact",NEW."Qpotr_notBalance_fact",0,0,
  NEW."Kzag_notBalance",NEW."Ssum_tr_NotBalance",NEW."Ntr_NotBalance",0,0,0,0,
  NEW."LsumP_NotBalance",NEW."LsumC_NotBalance",NEW."NLineP_NotBalance",NEW."NLineC_NotBalance",
  NEW."NAbonents_NotBalance");
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,0,
  NEW."DWal_cu_onBalance",NEW."DWal_k_onBalance",NEW."DWal_crown_OnBalance",NEW."DWrl_cu_onBalance",
  NEW."DWcu_onBalance",NEW."DWrcu_onBalance",NEW."DWxx_onBalance",NEW."DWrxx_onBalance",
  NEW."DWaclr_onBalance",NEW."DWrclr_onBalance",NEW."Wrc_onBalance",
  NEW."Wa_potr_onBalance",NEW."Wr_potr_onBalance",0,0,
  NEW."Wa_potr_onBalance_fact",NEW."Wr_potr_onBalance_fact",0,0);
 INSERT INTO "WResultsAdd" ("Ident","Balance",
  "DWa_line_cu","DWa_line_k","DWa_line_crown","DWr_line_cu",
  "DWa_tr_cu","DWr_tr_cu","DWa_tr_xx","DWr_tr_xx",
  "DWa_clr","DWr_clr","Wrc",
  "Wa_trans","Wr_trans","Wa_potr","Wr_potr",
  "Wa_trans_fact","Wr_trans_fact","Wa_potr_fact","Wr_potr_fact")
 VALUES (:Ident,1,
   NEW."DWal_cu_notBalance",NEW."DWal_k_notBalance",
   NEW."DWal_crown_notBalance",NEW."DWrl_cu_notBalance",
   NEW."DWcu_notBalance",NEW."DWrcu_notBalance",
   NEW."DWxx_notBalance",NEW."DWrxx_notBalance",
   NEW."DWaclr_notBalance",NEW."DWrclr_notBalance",NEW."Wrc_notBalance",
   NEW."Wa_potr_notBalance",NEW."Wr_potr_notBalance",0,0,
   NEW."Wa_potr_notBalance_fact",NEW."Wr_potr_notBalance_fact",0,0);
END;

CREATE TRIGGER "WResultsPLBeforeDelete" FOR "WResultsPL" BEFORE DELETE
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Lines"
WHERE "GUID"=OLD.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "PResultsL" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END ;


CREATE TRIGGER "WResultsPLBeforeUpdateOrInsert" FOR "WResultsPL" BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Lines"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "PResultsL" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "PResultsL"
  ("Ident","GUID","P","Q","I","deltaPcu","deltaPk",
   "deltaPcrown","deltaQ","Qc_b","Qc_e","Kzag")
VALUES (:Ident,NEW."GUID",NEW."P",NEW."Q",NEW."I",NEW."deltaPcu",NEW."deltaPk",
  NEW."deltaPcrown",NEW."deltaQ",NEW."Qc_b",NEW."Qc_e",NEW."Kzag");
END ;


CREATE TRIGGER "WResultsPNBeforeDelete" FOR "WResultsPN" BEFORE DELETE
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=OLD.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "PResultsN" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END ;


CREATE TRIGGER "WResultsPNBeforeUpdateOrInsert" FOR "WResultsPN" BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "PResultsN" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "PResultsN"
  ("Ident","GUID","Pn","Qn","UB","UH",
   "deltaPcu","deltaQcu","deltaPxx","deltaQxx",
   "deltaUB","Kzag")
VALUES (:Ident,NEW."GUID",NEW."Pn",NEW."Qn",NEW."UB",NEW."UH",
   NEW."deltaPcu",NEW."deltaQcu",NEW."deltaPxx",NEW."deltaQxx",
   NEW."deltaUB",NEW."Kzag");
END ;


CREATE TRIGGER "WResultsPN3BeforeDelete" FOR "WResultsPN3" BEFORE DELETE
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=OLD.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "PResultsN3" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END ;


CREATE TRIGGER "WResultsPN3BeforeUpdateOrInsert" FOR "WResultsPN3"
ACTIVE BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "PResultsN3" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "PResultsN3"
  ("Ident","GUID","PCn","QCn","PHn","QHn",
   "UB","UC","UH",
   "deltaPcu","deltaQcu","deltaPxx","deltaQxx",
   "deltaUB","Kzag")
VALUES (:Ident,NEW."GUID",NEW."PCn",NEW."QCn",NEW."PHn",NEW."QHn",
   NEW."UB",NEW."UC",NEW."UH",
   NEW."deltaPcu",NEW."deltaQcu",NEW."deltaPxx",NEW."deltaQxx",
   NEW."deltaUB",NEW."Kzag");
END ;


CREATE TRIGGER "WResultsWLBeforeDelete" FOR "WResultsWL" BEFORE DELETE
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Lines"
WHERE "GUID"=OLD.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "WResultsL" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END ;


CREATE TRIGGER "WResultsWLBeforeUpdateOrInsert" FOR "WResultsWL"
ACTIVE BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Lines"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "WResultsL" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "WResultsL"
  ("Ident","GUID","Wa","Wr",
   "deltaWa_cu","deltaWa_k","deltaWa_crown","deltaWr",
   "Wrc_b","Wrc_e","sqrKfg")
VALUES (:Ident,NEW."GUID",NEW."Wa",NEW."Wr",
  NEW."deltaWa_cu",NEW."deltaWa_k",NEW."deltaWa_crown",NEW."deltaWr",
  NEW."Wrc_b",NEW."Wrc_e",NEW."sqrKfg");
END ;

CREATE TRIGGER "WResultsWN3BeforeDelete" FOR "WResultsWN3" BEFORE DELETE
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=OLD.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "WResultsN3" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END ;

CREATE TRIGGER "WResultsWNBeforeUpdateOrInsert" FOR "WResultsWN" BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "WResultsN" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "WResultsN"
  ("Ident","GUID","Wa","Wr",
   "deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx",
   "sqrKfg")
VALUES (:Ident,NEW."GUID",NEW."Wa",NEW."Wr",
  NEW."deltaW_cu",NEW."deltaWr_cu",NEW."deltaW_xx",NEW."deltaWr_xx",
  NEW."sqrKfg");
END ;

CREATE TRIGGER "WResultsWNBeforeDelete" FOR "WResultsWN" BEFORE DELETE
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=OLD.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=OLD."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "WResultsN" WHERE "Ident"=:Ident AND "GUID"=OLD.GUID;
END ;

CREATE TRIGGER "WResultsWN3BeforeUpdateOrInsert" FOR "WResultsWN3"
ACTIVE BEFORE UPDATE OR INSERT
AS
DECLARE VARIABLE OwnerGUID INTEGER;
DECLARE VARIABLE Ident INTEGER;
BEGIN
SELECT "OwnerGUID" FROM "Nodes"
WHERE "GUID"=NEW.GUID
INTO :OwnerGUID;

SELECT "Ident" from "MVResults"
WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
UNION
SELECT "Ident" from "MVResults"
WHERE "CalcType"=1 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID
  AND NOT EXISTS
(SELECT * from "MVResults"
  WHERE "CalcType"=0 AND "SampleIdent"=NEW."SampleIdent" AND "GUID"=:OwnerGUID)
INTO :Ident;

DELETE FROM "WResultsN3" WHERE "Ident"=:Ident AND "GUID"=NEW.GUID;

INSERT INTO "WResultsN3"
  ("Ident","GUID","WCa","WCr","WHa","WHr",
   "deltaW_cu","deltaWr_cu","deltaW_xx","deltaWr_xx",
   "sqrKfgC","sqrKfgH")
VALUES (:Ident,NEW."GUID",NEW."WCa",NEW."WCr",NEW."WHa",NEW."WHr",
  NEW."deltaW_cu",NEW."deltaWr_cu",NEW."deltaW_xx",NEW."deltaWr_xx",
  NEW."sqrKfgC",NEW."sqrKfgH");
END ;

/*DROP PROCEDURE "GetNewPeriodIdent";
COMMIT;       */

ALTER procedure "GetNewLVFidersBIdent"
returns ("Ident" Integer)
as
BEGIN
 "Ident"=GEN_ID("LVFidersBIdent",1) ;
END;

COMMIT;
RECONNECT;
/*
ALTER SEQUENCE "LVFidersBIdent"
 RESTART WITH (Select MAX("LVFidersB"."Ident") from "LVFidersB");


COMMIT;  */

UPDATE "IsolatorsReference" SET DW = 1.49 WHERE "Ident" = 20  ;

DROP INDEX "idxSectionName";
COMMIT;
CREATE UNIQUE INDEX "idxSectionName" ON "Sections" ("OwnerGUID","Name","Unom");
COMMIT;

ALTER TABLE "LVWResultsB" ADD "Wa_bus" DOUBLE_ABOVE_0;
ALTER TABLE "LVWTPInfo" ADD "Wa_bus" DOUBLE_ABOVE_0;

CREATE TRIGGER "LVWResultsBAfterInsert" FOR "LVWResultsB" AFTER INSERT
AS
begin
 update "LVWTPInfo" set "Wa_bus"=new."Wa_bus"
 where "SampleIdent"=NEW."SampleIdent" and "GUID"=NEW."GUID";
end;

CREATE TRIGGER "LVWTPInfoAfterInsert" FOR "LVWTPInfo" AFTER INSERT 
AS
begin
 update "LVWResultsB" set "Wa_bus"=new."Wa_bus"
 where "SampleIdent"=NEW."SampleIdent" and "GUID"=NEW."GUID";
end;

ALTER TRIGGER "LVWResultsBAfterUpdateTrigger"
AS
DECLARE VARIABLE ACount INTEGER;
BEGIN
 if (new."GUID"=old."GUID" and (new."Wa_bus"=old."Wa_bus" or (new."Wa_bus" is null and old."Wa_bus" is null)))
 then begin end
 else
  update "LVWTPInfo" set "Wa_bus"=new."Wa_bus"
  where "SampleIdent"=NEW."SampleIdent" and "GUID"=NEW."GUID";

 select count(*) from "LVWResultsB" where "Info"=OLD."Info" into ACount;
 if (ACount=0) then delete from "LVFidersB" where "Ident"=OLD."Info";
END;

ALTER TRIGGER "LVWTPInfoAfterUpdateTrigger"
AS
BEGIN
 if (new."GUID"=old."GUID" and (new."Wa_bus"=old."Wa_bus" or (new."Wa_bus" is null and old."Wa_bus" is null)))
 then begin end
 else
  update "LVWResultsB" set "Wa_bus"=new."Wa_bus"
  where "SampleIdent"=NEW."SampleIdent" and "GUID"=NEW."GUID";

 if (NEW."UA" is null and NEW."UB" is null and NEW."UC" is null and
     NEW."IA" is null and NEW."IB" is null and NEW."IC" is null and
     NEW."CosFiA" is null and NEW."CosFiB" is null and NEW."CosFiC" is null)
 then
  delete from "LVWTPInfo"
  where "SampleIdent"=NEW."SampleIdent" and "GUID"=NEW."GUID";
END;

ALTER TABLE "InitParams" DROP CONSTRAINT "CHK_InitParams_Values";
ALTER TABLE "InitParams" ADD CONSTRAINT "CHK_InitParams_Values" CHECK(("Key"=1) and ("Value" between 0 and 1) or /* smCosFi */
 ("Key"=2 or "Key"=3) and ("Value" between "Param"*0.8 and "Param"*1.2) or /* smUcp, smUdop*/
 ("Key"=4) and ("Value" between 1/13 and 1) or /* smKzap */
 ("Key"=6) and ("Value" between 0.04 and 1) or /* smTau */
 ("Key"=7) and ("Value">0) or /* smCurrentDensityLimit */

  ("Key" in (100,108,109,110,111) and "Value" between -2147483647 and 2147483647) or /*(smAOEnergoGUID,smVNCalc,smNNCalc,smStLoads,smMetrolog */
 ("Key"=101 and "Value" between 1 and 7) or /*smRegionIdent */
 ("Key"=102 and "Value" between 1 and 3) or /* smKdp */
 ("Key" in (103,105,112,113,114,115) and ("Value"=0 or "Value"=1)) or /* (smUseTemperature,smKuntp,smDotDisableLine,smShowPhases */
 ("Key"=104 and "Value" between -70 and 70) or /* smTemperature */
 ("Key" in (106,107,116) and ("Value" between 0 and 2)  or /* smSaveDetailed,smSaveDetailedHH,smShowArrowDirection */
 ("Key"=5 or "Key"=200 or "Key"=201) and ("Value" between -2147483.648 and 2147483.647) /* Colors */));

COMMIT;
/*--     */
GRANT ALL ON "PResults" TO "rtp3user";
GRANT ALL ON "PResultsPL" TO "rtp3user";
GRANT ALL ON "PResultsPN" TO "rtp3user";
GRANT ALL ON "PResultsPN3" TO "rtp3user";
GRANT ALL ON "PResultsWL" TO "rtp3user";
GRANT ALL ON "PResultsWN" TO "rtp3user";
GRANT ALL ON "PResultsWN3" TO "rtp3user";

GRANT ALL ON "WResults" TO "rtp3user";
GRANT ALL ON "WResultsA" TO "rtp3user";
GRANT ALL ON "WResultsPL" TO "rtp3user";
GRANT ALL ON "WResultsPN" TO "rtp3user";
GRANT ALL ON "WResultsPN3" TO "rtp3user";
GRANT ALL ON "WResultsWL" TO "rtp3user";
GRANT ALL ON "WResultsWN" TO "rtp3user";
GRANT ALL ON "WResultsWN3" TO "rtp3user";


COMMIT;

 UPDATE "Version" SET "Major"=3, "Minor"=0, "Release"=22,"Build"=0, "VersionDate"='NOW';
COMMIT;
